﻿/**************************************
*        表格控件插件
***************************************/

/**
* 注册表格插件
*/
RO.GridAdapter.widgetReg = function (grid, widgetConfig) {
    var widgetManager = widgetConfig ? widgetConfig : { Editor: { dateEditor: "defaultDateEditor", inputEditor: "defaultInputEditor", timeEditor: "defaultTimeEditor" }, Filter: { baseFilter: ["defaultFilter"],autoNo: ["autoNoFilter"], formatData: ["attachFile", "imgShow", "imt4Control"], theme: ["baseTheme"] }, ExtFunction: ["ilegalWarning","rowInsertCtrl", "colInsertCtrl", "selectionChange", "selectEditor", "btn2Menu", "shortcutSolutions"] };
    var editBridge = new RO.GridAdapter.EditorBridge(grid, widgetManager.Editor);
    var filterBridge = new RO.GridAdapter.FilterBridge(grid, widgetManager.Filter);
    var extFuncBridge = new RO.GridAdapter.ExtFuncBridge(grid, widgetManager.ExtFunction);
    grid.widgetConfig = widgetManager;
    grid.widgetManager = { "GridEvent_doEdit": editBridge, "GridEvent_doFilter": filterBridge, "GridEvent_ExtFunction": extFuncBridge };
};
/**
* 卸载表格插件
*/
RO.GridAdapter.widgetUnReg = function (grid) {
    delete grid.widgetManager;
    delete grid.widgetConfig;
};

/**
* 编辑器适配器
* data格式：{ type：编辑器类型,cell：编辑单元格,gridModel：表格处理器,filter: {cellSize：编辑单元格尺寸,editText：编辑器初始值},result：用于存放返回值}
*/
RO.GridAdapter.EditorBridge = function (grid, editorWidget) {
    this.execute = function (data) {
        var type = data.type;
        var action = null;
        var isDefault = false;
        switch (type) {
           // case "8":
               // action = editorWidget.timeEditor;
               // break;
            case "2":
            case "18":
            case "17":
            	action = editorWidget.selectEditor;
            	break;
            case "3":
                // action = editorWidget.selectEditor;
                break;
            case "8":
            case "10":
                action = editorWidget.dateEditor;
                break;
            case "11":
                break;
            case "1":
            default:
                action = editorWidget.inputEditor;
                isDefault = true;
                break;
        }
        var hasKeybord = document.activeElement.tagName == 'TEXTAREA' || document.activeElement.tagName == 'INPUT' // 用焦点是否在文本框上来判断当前是否有键盘
        if(isDefault || !hasKeybord){
        	// 当前为文本输入或者没有键盘时，正常调出插件
        	grid[action](data);
        } else{
        	// 当前键盘为显示状态且需要调出非文本编辑插件时，先把键盘收回，然后延迟调出插件，避免键盘和其他插件同时显示
        	// 普通浏览器中，部分手机此处键盘弹出后通过document.activeElement.blur()收不回去，此处使用特殊方式
        	var str = '<input id="tmpInput" disabled="disabled" style="width:0; height:0; opacity:0" type="text" />';
			$("body").append(str);
			$("#tmpInput").removeAttr("disabled").focus().blur().attr("disabled", "disabled");
			$("#tmpInput").remove();
			//document.activeElement.blur();
	        setTimeout(function(){
	        	grid[action](data);
	        }, 400);  
        }              
    };
};

/**
* 过滤器适配器
* 事件名称：GridEvent_doFilter
* 数据格式：{ type：过滤器类型,cell：编辑单元格,cells: 待处理单元格列表, gridModel：表格处理器,filter: {dataType:过滤条件},result：用于存放返回值}
*/
RO.GridAdapter.FilterBridge = function (grid, filterWidget) {
    this.execute = function (data) {
        var type = data.type;
        var action = null;
        switch (type) {
            case "formatData":
                data.result = [];
                data.result.push(grid.formatData(data));//, filterWidget.formatData));
                break;
            case "theme":
                data.result = [];
                for (var i = 0, themeCount = filterWidget.theme.length; i < themeCount; i++) {
                    action = grid[filterWidget.theme[i]](data);//, filterWidget.formatData);
                    if (action)
                        data.result.push(action);
                }
                break;
            case "baseFilter":
                data.result = [];
                for (var i = 0, baseFilterCount = filterWidget.baseFilter.length; i < baseFilterCount; i++) {
                    action = grid[filterWidget.baseFilter](data);
                    if (action)
                        data.result.push(action);
                }
                break;
                //case "formatStyle":
                //    data.result = [];
                //    for (var i = 0, styleFilterCount = filterWidget.formatStyle.length; i < styleFilterCount; i++) {
                //        action = grid[filterWidget.formatStyle](data);
                //        if (action)
                //            data.result.push(action);
                //    }
                case "autoNo":
                data.result = [];
                for (var i = 0,autoNoCount = filterWidget.autoNo.length; i<autoNoCount; i++) {
                    action = grid[filterWidget.autoNo](data);
                    if (action)
                        data.result.push(action);
                }
                break;
            case "extFormatData":
                for (var i = 0, formatCount = filterWidget.formatData.length; i < formatCount; i++) {
                    grid[filterWidget.formatData[i]](data);
                }
                break;
            default:
                break;
        }
    };
};

/**
* 功能扩展适配器
* 事件名称：GridEvent_ExtFunction
* 数据格式：{ type：扩展功能类型,cell：编辑单元格, gridModel：表格处理器,filter: {},result：用于存放返回值}
*/
RO.GridAdapter.ExtFuncBridge = function (grid, extFuncWidget) {
    this.execute = function (data) {
        var action = null;
        data.result = [];
        for (var i = 0, dataCount = extFuncWidget.length; i < dataCount; i++) {
            action = grid[extFuncWidget[i]](data);
            if (action)
                data.result.push(action);
        }
    };
};














/****************************GridWidget*****************************************/


///////GridHtml5Editor扩展///////////////
RO.GridAdapter.extend(RO.GridAdapter, {
    defaultDateEditor: function (data) {
        var dateEditor = $(".gridEditor", data.gridModel.entry);
        var gridModel = data.gridModel;
        var gridData = gridModel.gridData;

        data.gridModel.editorOpened = true;
        var onChangeDateTime = function (curTime, inputData) {
            gridModel.setValue(data.cell, inputData.val());
            gridModel.editorOpened = false;
            gridModel.gridData.closeActiveEditor();
        };

        dateEditor.on("value", function (e) {
            e.stopPropagation();
            var editText = data.filter && data.filter.editText;
            var editor = $(this);
            editor.focus();
            if (!editText) {
                editor.val(data.cell.getEditText());
            }
            editor.click();
        }).on("destroy", function (e) {
            e.stopPropagation();
            if (data.gridModel.editorOpened) {
                gridModel.setValue(data.cell, $(this).val());
                gridModel.editorOpened = false;
                gridModel.gridData.closeActiveEditor();
            }
        }).datetimepicker({ lang: "ch", timepicker: false, format: 'Y/m/d', onClose: onChangeDateTime }).on("blur", function (e) {
            e.stopPropagation();
            gridModel.gridData.closeActiveEditor();
            //onChangeDateTime(null, $(this));

        }).on("dispose", function () {
            $(this).datetimepicker("destroy");
        });

        var filter = data.filter;
        var cellSize = filter && filter.cellSize || { width: 0, height: 0 };


        var width = cellSize.width;
        var entryWidth = $(gridModel.entry).width();
        var lockColWidth = 0;
        var lockColCount = gridData.getColHeaderCount();
        if (lockColCount > 1 && data.cell.getColIndex() >= lockColCount) {
            for (var i = 0; i < lockColCount; i++) {
                lockColWidth += gridData.getColWidth(i);
            }
        }
        var maxWidth = entryWidth - lockColWidth - (gridData.getDataHeight() > $(gridModel.entry).height() ? 16 : 0);
        if (maxWidth < width) {
            width = maxWidth;
            if (width < 0) {
                width = 0;
            }
        }

        dateEditor.css("word-wrap", "normal");
        dateEditor.css("overflow", "hidden");
        dateEditor.css("font-size", data.cell.getRealFontSize() + "px");
        dateEditor.css("font-family", data.cell.getFontName());
        dateEditor.css("color", data.cell.getFontColor());
        var bold = data.cell.getFontBold();
        if (bold) {
            dateEditor.css("fontWeight", "bold");
        }
        var isUnderline = data.cell.isUnderline();
        var isStrikeout = data.cell.isStrikeout();
        if (isUnderline && isStrikeout) {
            dateEditor.css("text-decoration", "line-through underline");
        }
        else if (isUnderline) {
            dateEditor.css("text-decoration", "underline");
        } else if (isStrikeout) {
            dateEditor.css("text-decoration", "line-through");
        }
        var isItalic = data.cell.getFontItalic();
        if (isItalic) {
            dateEditor.css("font-style", "italic");
        }

        var align = data.cell.getHorzAlign();
        dateEditor.css("textAlign", align == COM.widget.Grid.Cell.ALIGN.CENTER ? "center" : align == COM.widget.Grid.Cell.ALIGN.BACK ? "right" : "left");

        var cellfigure = data.cell.cell.getFigure();
        var offset = cellfigure.getBounds().getCopy();
        cellfigure.translateToAbsolute(offset);
        dateEditor.css("top", offset.y - 1);
        dateEditor.css("left", offset.x - 1);
        dateEditor.css("width", width + 2);
        dateEditor.css("height", cellSize.height + 2);

        data.result = dateEditor[0];
    },

    defaultTimeEditor: function (data) {
        var dateEditor = $("#timeEditor");
        if (dateEditor.length > 0) {
            dateEditor.remove();
        }
        var gridModel = data.gridModel;
        var gridData = gridModel.gridData;

        dateEditor = $("<input id='timeEditor' type='text'/>").gridHtml5Editor();
        $(document.body).append(dateEditor);
        data.gridModel.editorOpened = true;

        var onChangeDateTime = function (curTime, inputData) {
            gridModel.setValue(data.cell, inputData.val());
            gridModel.editorOpened = false;
            gridModel.gridData.closeActiveEditor();
        };
        dateEditor.bind("value", function (e) {
            e.stopPropagation();
            var textObj = $("#timeEditor");
            var editText = data.filter && data.filter.editText;
            textObj.focus().val(editText ? editText : data.cell.getEditText() || "").click();
        }).bind("edited", function (e) {
            e.stopPropagation();
            onChangeDateTime(null, $("#timeEditor"));
        }).bind("destroy", function (e) {
            e.stopPropagation();
            data.gridModel.setValue(data.cell, $("#timeEditor").val());
            data.gridModel.editorOpened = false;
            data.gridModel.gridData.closeActiveEditor();
        }).datetimepicker({ lang: "ch", step: 10, format: 'Y-m-d H:i:s', onClose: onChangeDateTime });//.datepicker({ altFormat: 'yy-mm-dd', dateFormat: 'yy-mm-dd', changeMonth: true, changeYear: true });

        var filter = data.filter;
        var cellSize = filter && filter.cellSize || { width: 0, height: 0 };

        var width = cellSize.width;
        var entryWidth = $(gridModel.entry).width();
        var lockColWidth = 0;
        var lockColCount = gridData.getColHeaderCount();
        if (lockColCount > 1 && data.cell.getColIndex() >= lockColCount) {
            for (var i = 0; i < lockColCount; i++) {
                lockColWidth += gridData.getColWidth(i);
            }
        }
        var maxWidth = entryWidth - lockColWidth - (gridData.getDataHeight() > $(gridModel.entry).height() ? 16 : 0);
        if (maxWidth < width) {
            width = maxWidth;
            if (width < 0) {
                width = 0;
            }
        }

        var control = document.getElementById("timeEditor");
        control.style.fontSize = data.cell.getRealFontSize() + "px";
        control.style.fontFamily = data.cell.getFontName();
        control.style.overflow = "hidden";
        control.style.width = (width + 2) + "px";
        control.style.height = (cellSize.height + 2) + "px";
        control.style.zIndex = 1000;
        control.style.verticalAlign = "top";
        control.style.overflowY = 'scroll';
        control.style.display = 'none';
        control.style.position = 'absolute';
        control.style.border = "2px solid rgba(0,180,0,1)";
        control.style.outline = "none";

        var align = data.cell.getHorzAlign();
        // var valign = data.cell.getVertAlign();
        var bold = data.cell.getFontBold();
        control.style.textAlign = align == COM.widget.Grid.Cell.ALIGN.CENTER ? "center" : align == COM.widget.Grid.Cell.ALIGN.BACK ? "right" : "left";
        if (bold) {
            control.style.fontWeight = "bold";
        }

        var cellfigure = data.cell.cell.getFigure();
        var offset = cellfigure.getBounds().getCopy();
        cellfigure.translateToAbsolute(offset);
        control.style.top = (offset.y - 1) + "px";
        control.style.left = (offset.x - 1) + "px";

        data.result = control;
    },

    defaultInputEditor: function (data) {

        var inputEditor = $(".gridEditor", data.gridModel.entry);
        data.gridModel.editorOpened = true;
        var isup = false;

        var setInputValue = function (editor) {
            editor.select();
            var eid = data.cell.getAttrByName(RO.Enum.EnumID);
            if (eid != null && eid > 0) {
                data.cell.setValue(editor.val(), "");
            } else {
                data.gridModel.setValue(data.cell, editor.val());
            }
        };

        inputEditor.on("value", function (e) {
            e.stopPropagation();
            var editor = $(this);
            var editText = data.filter && data.filter.editText;
            editor.focus();
            if (!editText) {
                var eid = data.cell.getAttrByName(RO.Enum.EnumID);
                if (eid != null && eid > 0) {
                    editor.val(data.cell.getShowText() || "");
                } else {
                    editor.val(data.cell.getEditText() || "");
                }

            }
        }).on("destroy", function (e) {
            e.stopPropagation();
            if (data.gridModel.editorOpened) {
                setInputValue($(this));
                data.gridModel.editorOpened = false;
                data.gridModel.gridData.closeActiveEditor();
            }
        }).on("blur", function (e) {
            e.stopPropagation();
            //setInputValue($(this));
            //data.gridModel.editorOpened = false;
            data.gridModel.gridData.closeActiveEditor();
        }).on("mousedown", function (e) {
            var curcellsize = data.cell.getPosition().y;
            isup = false;
            $(this).unbind("mousemove").bind("mousemove", function (ev) {
                if (!isup) {
                    var editor = $(this);
                    var cellsize = filter && filter.cellSize || { width: 0, height: 0 };
                    var height = cellsize.height - 2;
                    var oldtop = editor.scrollTop();
                    if (ev.pageY < curcellsize + 2) {
                        editor.scrollTop(oldtop - 3);
                    } else if (ev.pageY >= curcellsize + height - 2) {
                        editor.scrollTop(oldtop + 3);
                    }
                }
            }).unbind("mouseup").bind("mouseup", function () {
                isup = true;
            });

        });

        var filter = data.filter;
        var cellSize = filter && filter.cellSize || { width: 0, height: 0 };

        var gridModel = data.gridModel;
        var gridData = gridModel.gridData;
        var width = cellSize.width;
        var entryWidth = $(".gridHtml5", gridModel.entry).width();
        var lockColWidth = 0;
        var lockColCount = gridData.getColHeaderCount();
        if (lockColCount > 1 && data.cell.getColIndex() >= lockColCount) {
            for (var i = 0; i < lockColCount; i++) {
                lockColWidth += gridData.getColWidth(i);
            }
        }
        var maxWidth = entryWidth - lockColWidth - (gridData.getDataHeight() > $(".gridHtml5", gridModel.entry).height() ? 16 : 0);
        if (maxWidth < width) {
            width = maxWidth;
            if (width < 0) {
                width = 0;
            }
        }

        var ua = navigator.userAgent.toLowerCase();
        var webkit = !!ua.match(/applewebkit/);
        inputEditor.css("font-size", data.cell.getRealFontSize() + "px");
        inputEditor.css("font-family", data.cell.getFontName());
        inputEditor.css("color", data.cell.getFontColor());
        var bold = data.cell.getFontBold();
        if (bold) {
            inputEditor.css("fontWeight", "bold");
        }
        var isUnderline = data.cell.isUnderline();
        var isStrikeout = data.cell.isStrikeout();
        if (isUnderline && isStrikeout) {
            inputEditor.css("text-decoration", "line-through underline");
        }
        else if (isUnderline) {
            inputEditor.css("text-decoration", "underline");
        } else if (isStrikeout) {
            inputEditor.css("text-decoration", "line-through");
        }
        var isItalic = data.cell.getFontItalic();
        if (isItalic) {
            inputEditor.css("font-style", "italic");
        }
        //编辑框背景色与表单背景色保持一致
        inputEditor.css("background-color", data.cell.getBackColor());
        var align = data.cell.getHorzAlign();
        var dt = data.cell.getAttrByName("dt");
        inputEditor.css("text-align", webkit || dt == "2" || dt == "3" ? "left" : align == COM.widget.Grid.Cell.ALIGN.BACK ? "right" : align == COM.widget.Grid.Cell.ALIGN.CENTER ? "center" : "left");

        var cellfigure = data.cell.cell.getFigure();
        var offset = cellfigure.getBounds().getCopy();
        cellfigure.translateToAbsolute(offset);
        inputEditor.css("top", offset.y - 1);
        inputEditor.css("left", offset.x - 1);
        inputEditor.css("width", width + 2);
        inputEditor.attr("minHeight", cellSize.height + 2);
        inputEditor.css("height", cellSize.height + 2);
        data.result = inputEditor[0];
    },

    defaultSelectEditor: function (data) {
        var selectEditor = $("#selectEditor");
        if (selectEditor.length > 0) {
            selectEditor.remove();
        }

        var gridModel = data.gridModel;
        var gridData = gridModel.gridData;
        var cell = data.cell;
        selectEditor = $("<div id='selectEditor'><select id='selector'></select></div>").gridHtml5Editor();
        $(document.body).append(selectEditor);
        data.gridModel.editorOpened = true;

        var setInputValue = function (val) {
            cell.setValue(val.text, val.id);
            gridModel.editorOpened = false;
            gridModel.gridData.closeActiveEditor();
        };

        var cellFigure = cell.cell.getFigure();
        var offset = cellFigure.getBounds().getCopy();
        cellFigure.translateToAbsolute(offset);
        var filter = data.filter;
        var cellSize = filter && filter.cellSize || { width: 0, height: 0 };

        var width = cellSize.width;
        var entryWidth = $(gridModel.entry).width();
        var lockColWidth = 0;
        var lockColCount = gridData.getColHeaderCount();
        if (lockColCount > 1 && data.cell.getColIndex() >= lockColCount) {
            for (var i = 0; i < lockColCount; i++) {
                lockColWidth += gridData.getColWidth(i);
            }
        }
        var maxWidth = entryWidth - lockColWidth - (gridData.getDataHeight() > $(gridModel.entry).height() ? 16 : 0);
        if (maxWidth < width) {
            width = maxWidth;
            if (width < 0) {
                width = 0;
            }
        }

        $("#selector").combobox({
            url: "data/combobox_data.json",
            valueField: "id",
            textField: "text",
            width: offset.width,
            height: offset.height,
            noBorder: true,
            transparent: false,
            onLoadSuccess: function () {
                $("#selector").combobox("select", cell.getEditText());
            },
            onSelect: setInputValue
        }).combobox("showPanel");

        selectEditor.bind("value", function (e) {
            e.stopPropagation();
            $("#selector").combobox("textbox").css("text-align", data.cell.getAttrByName("dT") == "2" ? "right" : "left").focus();
        }).bind("edited change", function (e) {
            e.stopPropagation();
            setInputValue();
        }).bind("destroy", function (e) {
            e.stopPropagation();
            setInputValue();
        });

        var control = document.getElementById("selectEditor");
        control.style.width = (width - 2) + "px";
        control.style.height = (cellSize.height - 2) + "px";
        control.style.top = (offset.y - 1) + "px";
        control.style.left = (offset.x - 1) + "px";
        control.style.display = 'none';
        control.style.position = 'absolute';
        control.style.border = "2px solid #000";
        control.style.zIndex = 1000;
        data.result = control;
    }
});

//////GridHtml5Filter扩展 - baseFilter//////////
RO.GridAdapter.extend(RO.GridAdapter, {
    defaultFilter: function (data) {
        var cell = data.cell;

        var getOrigDt = function (origCell, rowList, self) {
            var clientData = origCell.clientData;
            var dTobject = {};
            var dT = clientData && clientData["dt"];
            if (!dT) {
                var col = origCell.colIndex, row = origCell.rowIndex;
                var reg = clientData && clientData[RO.Enum.RegId];
                if (reg) {
                    var region = self.dataRegions[reg];
                    if (region.RegionKind === 3) //行浮动
                    {
                        row = region.RegionTop;

                    }
                }
                var tmplClientData = rowList && rowList[row] && rowList[row][col] && rowList[row][col].clientData;
                if (tmplClientData) {
                    clientData = tmplClientData;
                }
            }
            if (clientData["dt"])
                dTobject["dt"] = clientData["dt"];
            if (clientData["ft"])
                dTobject['ft'] = clientData["ft"]; // 格式化类型
            if (clientData["ths"])
                dTobject['ths'] = clientData['ths']; // 是否千分位
            if (clientData["dcm"])
                dTobject['dcm'] = clientData['dcm']; // 小数的位数
            if (clientData["im"])
                dTobject['im'] = clientData['im'];//编辑模式
            return dTobject;
        };

        var getCellDt = function (origCell) {
            var dTobject = {};
            var item;
            item = origCell.getAttrByName('im'); //编辑模式
            if (item)
                dTobject['im'] = item;
            item = origCell.getAttrByName("dt"); //数据类型
            if (item)
                dTobject['dt'] = item;
            item = origCell.getAttrByName('ft'); // 格式化类型
            if (item)
                dTobject['ft'] = item;
            item = origCell.getAttrByName('ths'); // 是否千分位
            if (item)
                dTobject['ths'] = item;
            item = origCell.getAttrByName('dcm'); // 小数的位数
            if (item)
                dTobject['dcm'] = item;
            item = origCell.getAttrByName('imt'); // 
            if (item)
                dTobject['imt'] = item;
            return dTobject;
        };

        return cell.gridModel ? getCellDt(cell) : getOrigDt(cell, data.filter && data.filter.dataType, data.gridModel);
    }
});
///////GridHtml5Filter扩展 - theme///////////////
RO.GridAdapter.extend(RO.GridAdapter, {
    baseTheme: function (data, filterArray) {
        // 控件底层字体居中没处理好，表头部分先用padding来调整
        var ua = navigator.userAgent.toLowerCase(),
            rv = ua.match(/rv:([\d.]+)/),
            isIe11 = ua.match(/trident/) != null && rv && rv[1] == "11.0" ? true : false,
            isIe = /msie/.test(ua),
            webkit = !!ua.match(/applewebkit/),
            headerPadding = isIe11 ? [0, 2, 1, 2] : isIe || webkit ? [0, 2, 2, 2] : [3, 2, 0, 2],
            cells = data.cells,
            from = data.filter && data.filter.from || 0,
            to = cells.length - 1 || from,
            model = data.gridModel,
            floatRegList = model._floatRegList,
            dataRegs = model.dataRegions,
            r,
            c,
            mergeCells = data.filter.mergeCells,
            mergeCount = data.filter.mergeCells.length,
            self = this,
            firstLoad = from == 0,
            firstLoadCount = model._firstLoadCount;

        var setGridTitleCell = function (curCell, gridModel) {
            r = curCell.rowIndex;
            c = curCell.colIndex;
            if (r == 0 || c == 0) {
                curCell.backColor = "#e3ffe3";
                curCell.fontName = "微软雅黑";
                curCell.fontColor = '#0';
                curCell.padding = headerPadding;
                curCell.wrapLine = false;
                curCell.borderColor = [RO.Enum.DefaultBorderColor, RO.Enum.DefaultBorderColor];
                curCell.showText = c == 0 && r == 0 ? "" : c == 0 ? r : gridModel.getTitleColIndex(c);
                curCell.fitFontSize = false;
                if (c == 0 && r != 0) {
                    curCell.fontSize = 12;
                }
                if (r == 0) {
                    curCell.fontSize = 14;
                }
            }
        };

        var initPartCellStyle = function (curCell, template) {
            if (curCell.title === undefined) {
                curCell.title = template.title === undefined ? "" : template.title;
            }
            if (curCell.editable === undefined) {
                curCell.editable = template.editable === undefined ? true : template.editable;
            }
            //背景样式
            if (curCell.backStyle === undefined) {
                curCell.backStyle = template.backStyle === undefined ? 1 : template.backStyle;
            }
            //背景颜色
            if (curCell.backColor === undefined) {
                curCell.backColor = template.backColor || "white";
            }
            //边框相关
            //[右，下，对角线，反对角线]
            if (curCell.border === undefined) {
                curCell.border = template.border || [-1, -1, 0, 0];
            }
            if (curCell.borderColor === undefined) {
                curCell.borderColor = template.borderColor || [RO.Enum.DefaultBorderColor, RO.Enum.DefaultBorderColor, "black", "black"];
            }
            if (curCell.fontItalic === undefined) {
                curCell.fontItalic = !!template.fontItalic;
            }
            if (curCell.fontColor === undefined) {
                curCell.fontColor = template.fontColor || "#0";
            }
            //下划线和删除线，没有就设为null
            if (curCell.decoration === undefined) {
                curCell.decoration = template.decoration || COM.widget.Grid.Cell.DECORATION.NONE;
            }
            if (curCell.foreColor === undefined) {
                curCell.foreColor = template.foreColor || "white";
            }
            curCell.multiLine = true; //curCell.multiLine;
            curCell.padding = RO.Enum.DefaultCellPadding; // 默认不设置padding，否则单元格大小和字体大小接近时文字会有被遮挡的情况
            if (template.clientData !== undefined) {
                var clientData = template.clientData;
                var curClientData = curCell.clientData;

                for (var item in clientData) {
                    curClientData[item] = clientData[item];
                }
            }
        }

        var initCellData = function (curCell, col, row, template) {
            if (!template) {
                template = {};
            }

            if (firstLoad) {
                //列号
                curCell.colIndex = col;
                //行号
                curCell.rowIndex = row;
                curCell.editorId = curCell.editorId || 1;
                if (curCell.showText === undefined) {
                    curCell.showText = template.showText === undefined ? "" : template.showText;
                }
                if (curCell.editText === undefined) {
                    curCell.editText = template.editText === undefined ? "" : template.editText;
                }
                if (curCell.selectable === undefined) {
                    curCell.selectable = template.selectable === undefined ? true : template.selectable;
                }
                if (curCell.checkable === undefined) {
                    curCell.checkable = template.checkable === undefined ? false : template.checkable;
                }
                if (curCell.cellMode === undefined) {
                    curCell.cellMode = template.cellMode === undefined ? COM.widget.Grid.Cell.Cell_MODE_NORMAL : template.cellMode;
                }
                if (curCell.html === undefined) {
                    curCell.html = template.html;
                }
                curCell.control = null;
                //合并单元格相关
                if (curCell.rowSpan === undefined) {
                    curCell.rowSpan = template.rowSpan || 1;
                }
                if (curCell.colSpan === undefined) {
                    curCell.colSpan = template.colSpan || 1;
                }
                if (curCell.merged === undefined) {
                    curCell.merged = !!template.merged;
                }

                if (curCell.fontName === undefined) {
                    curCell.fontName = template.fontName || "宋体";
                }
                if (curCell.fontSize === undefined) {
                    curCell.fontSize = template.fontSize || 14;
                }
                if (curCell.fontBold === undefined) {
                    curCell.fontBold = !!template.fontBold;
                }
                //描边
                //textStroke = curCell.textStroke || null;
                //阴影
                //textShadow = curCell.textShadow || null;
                if (curCell.wrapLine === undefined) {
                    curCell.wrapLine = template.wrapLine === undefined ? true : template.wrapLine;
                }
                if (curCell.indent === undefined) {
                    curCell.indent = template.indent || 0;
                }
                if (curCell.horzAlign === undefined) {
                    curCell.horzAlign = template.horzAlign || 0;
                }
                if (curCell.vertAlign === undefined) {
                    curCell.vertAlign = template.vertAlign || 0;
                }
                if (curCell.vertText === undefined) {
                    curCell.vertText = !!template.vertText;
                }
                if (curCell.fitFontSize === undefined) {
                    curCell.fitFontSize = !!template.fitFontSize;
                }
                //其他数据存储点
                if (curCell.clientData === undefined) {
                    curCell.clientData = {};
                }
                firstLoadCount > row && initPartCellStyle(curCell, template);
            } else if (!firstLoad && firstLoadCount <= row) {
                initPartCellStyle(curCell, template);
            }
        };

        var formatCell = function (curCell) {

            var getOrigDt = function (origCell) {
                var clientData = origCell.clientData;
                var dTobject = {};
                if (clientData["dt"])
                    dTobject["dt"] = clientData["dt"];
                if (clientData["ft"])
                    dTobject['ft'] = clientData["ft"]; // 格式化类型
                if (clientData["ths"])
                    dTobject['ths'] = clientData['ths']; // 是否千分位
                if (clientData["dcm"])
                    dTobject['dcm'] = clientData['dcm']; // 小数的位数
                //if (clientData["sj"])
                //    dTobject['sj'] = clientData['sj']; // 缩进
                if (clientData["im"])
                    dTobject['im'] = clientData['im'];//编辑模式
                return dTobject;
            };

            var dTObj = curCell.clientData;// getOrigDt(curCell);
            var rValue = curCell.editText || "";
            var dValue = curCell.showText || "";
            var control = null;
            var row = curCell.rowIndex;
            var col = curCell.colIndex;
            var dt = dTObj[RO.Enum.DataType];

            if (dt == 0 && dValue != "" && !self.designMode) {
                model.formatAlignByCell(curCell, dValue);
                //if (!isNaN(dValue)) {
                //    curCell.showText = data.gridModel.regularFloat(dValue);
                //}
            } else if (dt == 2) {
                if (rValue && isNaN(rValue)) {
                    curCell.clientData[RO.Enum.cellDataErrorFlag] = "1";
                }
            } else if (dt == 3) {
                if (rValue && (isNaN(rValue) || parseInt(rValue) != rValue)) {
                    curCell.clientData[RO.Enum.cellDataErrorFlag] = "1";
                }
            } else if (dt == 15) {
                if (rValue && !rValue.match(/^(\d{4})(-|\/)(\d{1,2})\2(\d{1,2})$/)) {
                    curCell.clientData[RO.Enum.cellDataErrorFlag] = "1";
                }
            }
            
            if (curCell.checkable) {
                curCell.editText = rValue > 0 ? 1 : 0;
                curCell.showText = "";
                curCell.checked = rValue > 0;
                curCell.clientData[RO.Enum.EditMode] = "5";
                curCell.horzAlign = COM.widget.Grid.Cell.ALIGN.CENTER;
            }

        };

        var initRowsData = function (begin, end, templateCells) {
            for (var index = begin; index <= end; index++) {
                var cols = cells[index];
                for (c = cols.length - 1; c >= 0; c--) {
                    var cell = cols[c];

                    initCellData(cell, c, index, templateCells && templateCells[0][c]);
                    firstLoad && initMergeCell(cell);
                    if (cell.colIndex == 0 || cell.rowIndex == 0) {
                        firstLoad && setGridTitleCell(cell, model);
                    }
                    if ((firstLoad && firstLoadCount > index) || (!firstLoad && firstLoadCount <= index)) {
                        formatCell(cell);
                    }
                    cols[c] = cell;
                }
            }
        };

        var doMergeCell = function () {
            for (var m = mergeCount, mcount = mergeCells.length; m < mcount; m++) {
                var merge = mergeCells[m], mc = merge.col, mr = merge.row;

                for (var y = 0, ycount = merge.height; y < ycount; y++) {
                    for (var x = 0, xcount = merge.width; x < xcount; x++) {
                        if (x === 0 && y === 0) {
                            continue;
                        }
                        var mergeCell = cells[mr + y][mc + x];
                        mergeCell.merged = true;
                        mergeCell.mergeInfo = { "col": mc, "row": mr };
                    }
                }
            }
        };

        var initMergeCell = function (tmpCell) {
            if (tmpCell.rowSpan > 1 || tmpCell.colSpan > 1) {
                mergeCells.push({ "col": tmpCell.colIndex, "row": tmpCell.rowIndex, "width": tmpCell.colSpan, "height": tmpCell.rowSpan });
            }
        };

        r = from;
        for (var i = 0, count = floatRegList.length; i < count; i++) {
            var region = dataRegs[floatRegList[i].id], top = region.RegionTop, bottom = top + region.FloatDataCount;
            if (r < top) {
                if (to < top) {
                    initRowsData(r, to);
                    r = to + 1;
                    break;
                }
                initRowsData(r, top - 1);
            }
            if (to < bottom) {
                initRowsData(top, to, region.RegionTemplate);
                r = to + 1;
                break;
            } else {
                initRowsData(top, bottom - 1, region.RegionTemplate);
            }
            r = bottom;
        }

        for (; r <= to; r++) {
            initRowsData(r, to);
        }

        firstLoad && doMergeCell();

        return cells;
    }
});
///////GridHtml5Filter扩展 - formatData//////////
RO.GridAdapter.extend(RO.GridAdapter, {
    formatData: function (data, filterArray) {
        var value, title, row, col, editText = null, showText = null;
        var cell = data.cell;
        row = cell.getRowIndex();
        col = cell.getColIndex();

        if (data.filter) {
            editText = data.filter.editText;
            showText = data.filter.showText;
        }

        var dbc2sbc = function (str) {
            //全角转半角,全角空格为12288，半角空格为32,其他字符半角(33-126)与全角(65281-65374)的对应关系是：均相差65248（只过滤数字与字母，不过滤字符）
            str = str === null || str === undefined ? "" : String(str);
            return str.replace(/[\uff10-\uff19|\uff21-\uff3a|\uff41-\uff5b]/g, function (a) { return String.fromCharCode(a.charCodeAt(0) - 65248); }).replace(/\u3000/g, " ");
        };

        value = String(editText === null || editText === undefined ? "" : editText);
        title = String(showText === null || showText === undefined ? value : showText);
        if (row == 0 || col == 0) {
            return { "editText": editText, "showText": showText };
        }
        var clientData = cell.cell.getClientData();
        if (clientData && clientData[RO.Enum.EmptyCell] == 1) {
            return { "editText": value, "showText": title };
        }

        var getCellDt = function (origCell) {
            var dTobject = {};
            var item;
            //item = origCell.getAttrByName('im'); //编辑模式
            item = clientData["im"];
            if (item)
                dTobject['im'] = item;
            //item = origCell.getAttrByName("dt"); //数据类型
            item = clientData["dt"];
            if (item)
                dTobject['dt'] = item;
            //item = origCell.getAttrByName('ft'); // 格式化类型
            item = clientData["ft"];
            if (item)
                dTobject['ft'] = item;
            //item = origCell.getAttrByName('ths'); // 是否千分位
            item = clientData["ths"];
            if (item)
                dTobject['ths'] = item;
            //item = origCell.getAttrByName('dcm'); // 小数的位数
            item = clientData["dcm"];
            if (item)
                dTobject['dcm'] = item;
            //item = origCell.getAttrByName('imt'); // 
            //if (item)
            //    dTobject['imt'] = item;
            return dTobject;
        };

        var dTObj = clientData;// getCellDt(cell);

        var dT = dTObj[RO.Enum.DataType]; //数据类型
        if (data.designMode || dT == undefined || dTObj[RO.Enum.EnumID]) {
            return { "editText": value, "showText": title };
        }


        var fT = dTObj['ft']; // 格式化类型
        var ths = dTObj[RO.Enum.ThoundsMark]; // 是否千分位
        var dcm = parseInt(dTObj[RO.Enum.Decimal], 10); // 小数的位数
        if (isNaN(dcm)) {
            dcm = 2;
        }

        var rValue = null; // 真实值
        var dValue = null; // 显示值

        var dateFormatAdjust = function (val) {
            var date = val.split(/[^0-9]/g);
            if (date.length != 3) {
                return null;
            }

            if (date[0].length != 4 || date[0] < 1000 || date[0] > 9999) {
                return null;
            }
            if (date[1] < 1) {
                return null;
            }
            else if (date[1].length == 1) {
                date[1] = "0" + date[1];
            } else if (date[1].length > 2 || date[1] > 12) {
                return null;
            }
            if (date[2] < 1) {
                return null;
            }
            if (date[2].length == 1) {
                date[2] = "0" + date[2];
            } else if (date[2].length > 2 || date[2] > 31) {
                return null;
            } else {
                if (date[1] == 2) {
                    var leapYear = date[0] % 4 == 0;
                    if (leapYear && date[2] > 29 || !leapYear && date[1] > 28) {
                        return null;
                    }
                } else if ($.inArray(date[1], [2, 4, 6, 9, 11]) != -1 && date[2] > 30) {
                    return null;
                }
            }
            return date;
        };
    var timeFormatAdjust = function (val) {
            var adjustVal = function (valAdjust, max) {
                if (valAdjust < 0) {
                    return null;
                }
                else if (valAdjust.length == 1) {
                    valAdjust = "0" + valAdjust;
                } else if (valAdjust.length > 2 || valAdjust > max) {
                    return null;
                }
                if (valAdjust < 0) {
                    return null;
                }
                return valAdjust;
            }
            var time = val.split(/[^0-9]/g);
            if (time.length != 3 && time.length != 2) {
                return null;
            }
            time[0] = adjustVal(time[0], 23);
            if (time[0] == null) return null;
            time[1] = adjustVal(time[1], 59);
            if (time[1] == null) return null; 
            if(time.length==2){
            	time.push('00');
            }else{
            	time[2] = adjustVal(time[2], 59);
                if (time[2] == null) return null;
            }
            return time;
        }
        var dateTimeFormatAdjust = function (val) {
            var dateTimeCommon = val.split(' ');
            var dateTimeothers = val.split(/[^0-9]/g);
            if (dateTimeCommon.length != 2 && dateTimeothers.length!=3) {
                return null;
            }
            if (dateTimeCommon.length == 2) {
                dateTimeCommon[0] = dateFormatAdjust(dateTimeCommon[0]);
                if (dateTimeCommon[0] == null) return null;
                dateTimeCommon[1] = timeFormatAdjust(dateTimeCommon[1]);
                if (dateTimeCommon[1] == null) return null;
                return dateTimeCommon;
            } if (dateTimeothers.length == 3) {//自动补全
                var date = dateFormatAdjust(val);
                var time = timeFormatAdjust(val);
                if (date == time == null) {
                    return null;
                } else if (date) {
                    var dateTime = []; time = [];
                    dateTime.push(date);
                    var timeNow = new Date();
                    var hour = timeNow.getHours(),
                        minutes = timeNow.getMinutes(),
                        seconds = timeNow.getSeconds();

                    time.push(hour > 9 ? hour : '0' + hour);
                    time.push(minutes > 9 ? minutes : '0' + minutes);
                    time.push(seconds > 9 ? seconds : '0' + seconds);
                    dateTime.push(time);
                    return dateTime;
                } else if (time) {
                    var dateTime = []; date = [];
                    var timeNow = new Date();
                    var year = timeNow.getFullYear(),
                        month = timeNow.getMonth()+1,
                        date = timeNow.getDate();

                    date.push(year);
                    date.push(month > 9 ? month : '0' + month);
                    date.push(date > 9 ? date : '0' + date);
                    dateTime.push(date);
                    dateTime.push(time);
                    return dateTime;
                }
            }
        }
        /**
        * 检查数值类型数据
        * 非标准科学计数法格式数值格式化时规避掉计算机浮点运算精度问题
        */
        var numChecker = function (val, decimal) {
            var isNum = false, numValue = val;
            val = $.trim(val);

            /**
            * 获取科学计数法实数部分格式化调整系数，及实数长度
            */
            var getAdjustFactor = function (num) {
                var numStr = String(num);
                var numLen = numStr.length;
                var dotIndex = numStr.indexOf(".");
                var factor;
                var newLen = numLen;

                if (dotIndex == -1) {
                    factor = -(numLen - 1);
                } else {
                    var dotOffset = numLen - dotIndex - 1;
                    var newNum = parseInt(num * Math.pow(10, dotOffset));
                    newLen = String(newNum).length;
                    factor = dotOffset - (newLen - 1);
                }

                return { "factor": factor, "numLength": newLen };
            };

            if (decimal < 0) {
                decimal = undefined;
            }
            
            val = dbc2sbc(val);

            if (RO.BasicFun.isNumber(val)) {
                isNum = true;
                
                if (val.match(/[eE]/g)) {
                    var datas = val.split(/[eE]/);
                    var preExp = parseFloat(datas[0]);
                    var nexExp = parseInt(datas[1]);

                    var negative = false;
                    if (preExp < 0) {
                        negative = true;
                        preExp = Math.abs(preExp);
                    }

                    var adjustFactor = getAdjustFactor(preExp);
                    nexExp -= adjustFactor.factor;
                    preExp *= Math.pow(10, adjustFactor.factor);
                    preExp = decimal >= 0 ? preExp.toFixed(decimal) : preExp.toFixed(adjustFactor.numLength - 1);

                    numValue = (negative ? -preExp : preExp) + (nexExp < 0 ? "E" : "E+") + nexExp;
                } else {
                    val = parseFloat(val);
                    numValue = decimal >= 0 ? val.toFixed(decimal) : val;
                }

            } else {
                //带千分位及逗号字符串处理
                var numString = val.replace(/,/g, '');
                if (RO.BasicFun.isNumber(numString) && !numString.match(/eE/)) {
                    var numbers = val.split(',');
                    var ncount = 0;
                    for (var k = 0; k < numbers.length; k++) {
                        if (k == 0) {
                            if (numbers[k].length > 3 || numbers[k] == "" || parseInt(numbers[k]) == 0) {
                                break;
                            }
                        } else if (k == numbers.length - 1) {
                            var temp = numbers[k].split('.');
                            if (temp[0].length != 3) {
                                break;
                            }
                        } else {
                            if (numbers[k].length != 3) {
                                break;
                            }
                        }
                        ncount++;
                    }
                    if (ncount == numbers.length) {
                        isNum = true;
                        numValue = decimal >= 0 ? parseFloat(numString).toFixed(decimal) : numString;
                    }
                }
            }
            
            return { "value": String(numValue), "isNum": isNum };
        };

        if (cell.cell.getCheckable()) {
            rValue = cell.cell.isChecked() ? 1 : 0;
            dValue = "";
        }
        
        if (value.match(/^ *$/g) != null) {
            // 输入空串
            rValue = "";
            dValue = "";
            if (clientData[RO.Enum.cellDataErrorFlag]) {
                cell.setAttrByName(RO.Enum.cellDataErrorFlag, null);
            }
        } else if (dT == '0') {
            // 常规类型
            var newData = numChecker(value);
            
            data.gridModel.formatDataByCell(cell, newData.value);

            if (newData.isNum) {
                //数值类型
                rValue = newData.value;
                dValue = rValue;
            } else if (value.match(/^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})$/)) {
                //时间类型
                var datetime = dateFormatAdjust(value);
                if (datetime) {
                    dValue = datetime[0] + '/' + datetime[1] + '/' + datetime[2];
                    rValue = dValue;
                } else {
                    rValue = dValue = "";
                }
            } else {
                //字符串---暂不处理      
                rValue = value;
                dValue = title;
            }
        } else if (dT == '1') {
            // 字符串类型
            rValue = value;
            dValue = title;
        } else if (dT == '3') {
            // 整数类型
            var newInt = numChecker(value, 0);

            if (newInt.isNum) {
                //数值类型
                if (clientData[RO.Enum.cellDataErrorFlag]) {
                    cell.setAttrByName(RO.Enum.cellDataErrorFlag, null);
                }
                rValue = newInt.value;
                dValue = rValue;
                dValue = ths == '1' ? data.gridModel.regularFloat(rValue) : rValue;
            } else {
                rValue = cell.getEditText();
                dValue = cell.getShowText();
            }
        } else if (dT == '2') {
            // 浮点类型
            var newFloat = numChecker(value, dcm);

            if (newFloat.isNum) {
                //数值类型
                if (clientData[RO.Enum.cellDataErrorFlag]) {
                    cell.setAttrByName(RO.Enum.cellDataErrorFlag, null);
                }
                rValue = newFloat.value;
                dValue = rValue;
                dValue = ths == '1' ? data.gridModel.regularFloat(rValue) : rValue;
            } else {
                rValue = cell.getEditText();
                dValue = cell.getShowText();
            }

        } else if (dT == '15') {
            // 日期类型
            if (!value) {
                rValue = dValue = "";
                if (clientData[RO.Enum.cellDataErrorFlag]) {
                    cell.setAttrByName(RO.Enum.cellDataErrorFlag, null);
                }
            } else {
                var datetime = dateFormatAdjust(value);
                if (datetime) {
                    if (clientData[RO.Enum.cellDataErrorFlag]) {
                        cell.setAttrByName(RO.Enum.cellDataErrorFlag, null);
                    }
                    if (fT == '6') {
                        // 日期用“-”区分
                        dValue = (datetime[0]) + '/' + datetime[1] + '/' + datetime[2];
                    } else if (fT == '7') {
                        // 日期用“年”“月”来区分
                        dValue = (datetime[0]) + '年' + datetime[1] + '月' + datetime[2] + '日';
                    } else {
                        // 不格式化
                        dValue = (datetime[0]) + '/' + datetime[1] + '/' + datetime[2];
                    }
                    rValue = dValue;
                } else {
                    rValue = cell.getEditText();
                    dValue = cell.getShowText();
                }
            }
        }else if (dT == '5') {
            if (!value) {
                rValue = dValue = "";
                if (clientData[RO.Enum.cellDataErrorFlag]) {
                    cell.setAttrByName(RO.Enum.cellDataErrorFlag, null);
                }
            } else {
                var datetime = dateTimeFormatAdjust(value);
                if (datetime) {
                    if (clientData[RO.Enum.cellDataErrorFlag]) {
                        cell.setAttrByName(RO.Enum.cellDataErrorFlag, null);
                    }
                    var date, time;
                    if (fT == '6') {
                        // 日期用“-”区分
                        date = datetime[0][0] + '/' + datetime[0][1] + '/' + datetime[0][2];
                    } else if (fT == '7') {
                        // 日期用“年”“月”来区分
                        date = datetime[0][0] + '年' + datetime[0][1] + '月' + datetime[0][2] + '日';
                    } else {
                        // 不格式化
                        date = datetime[0][0] + '/' + datetime[0][1] + '/' + datetime[0][2];
                    }
                    time = datetime[1][0] + ':' + datetime[1][1] + ':' + datetime[1][2]
                    rValue = date + ' ' + time;
                    dValue = date + ' ' + time;
                } else {
                    rValue = cell.getEditText();
                    dValue = cell.getShowText();
                }
            }
        }

        return { "editText": rValue, "showText": dValue };
    }
});
///////GridHtml5Filter扩展 - ordernumber///////////////自动生成序号
RO.GridAdapter.extend(RO.GridAdapter, {
      autoNoFilter: function (Data) {
        var regiondata, gridModel = Data.gridModel, aotoNoRowChange = {};
        var data = Data.filter;
        if (Data.gridModel.dataRegions) {
            regiondata = Data.gridModel.dataRegions;
        } else {
            regiondata = data.Region;
        }
        var rowIndex = data.rowIndex, rowCount = data.rowCount, filterType = data.filterType == undefined ? 1 : data.filterType;
        var rowEndIndex =gridModel.gridData.getDrawAreaInfo().endRow;
        var getRegonId = function (row) {
            var regonId;
            for (var i in regiondata) {
                if (regiondata[i].RegionTop <= row && (regiondata[i].RegionTop + regiondata[i].FloatDataCount - 1) >= row) {
                    regonId = i;
                    break;
                }
            }
            return regonId;
        }
        var realDelCount = 0, delRegID = getRegonId(rowIndex), canDelCount,nextReg=false;
        if (filterType == "2") {
            if (!delRegID) delRegID = getRegonId(rowIndex - 1);
            canDelCount = regiondata[delRegID].FloatDataCount - regiondata[delRegID].DefaultCount-1;
            realDelCount = canDelCount >= rowCount ? rowCount : canDelCount;
            if (rowIndex > regiondata[delRegID].FloatDataCount + regiondata[delRegID].RegionTop - 1) nextReg = true;
        }
       
        if (filterType == "2" || filterType == "3") {
            for (var key in regiondata) {
                if (regiondata[key].detailRowStrart && regiondata[key].detailRowStrart > rowIndex) {
                    if (filterType == "3") {
                        regiondata[key].detailRowStrart = regiondata[key].detailRowStrart + rowCount;
                        if (!delRegID) delRegID = getRegonId(rowIndex - 1);
                        if (delRegID == key)
                        regiondata[key].detailRowStrart = regiondata[key].FloatDataCount + rowCount;
                    }else if (filterType == "2") {                      
                        regiondata[key].detailRowStrart = regiondata[key].detailRowStrart - realDelCount;
                    }
                }
            }
        }
       
        for (var i = rowIndex; i <= rowEndIndex + 50 ; i++) {
            var regonId = getRegonId(i);
            if (filterType == '3') {
                if (i < rowIndex + rowCount) {
                    var compareCell = gridModel.gridData.getCell(1, rowIndex - 1);
                    var expandable = false, detailFlag = false, hasRegId = false;
                    if (compareCell.cell) {
                        expandable = compareCell.cell.expandable ? true : false;
                        detailFlag = new RO.GridHtml5.Cell(compareCell, gridModel).getDataRowAttr(RO.Enum.extendAttrs) == "1" ? true : false;
                        hasRegId = getRegonId(rowIndex - 1) ? true : false;
                        if (!expandable && !detailFlag && hasRegId) {
                            regonId = getRegonId(rowIndex - 1);
                        } else {
                            regonId = getRegonId(rowIndex);
                        }
                    }
                } else {
                    regonId = getRegonId(i - rowCount);
                }
                if (!regonId)continue;
            }
            if ((filterType == '2' && i == rowIndex && !data.initFlag)) {
                
                	   var compareCell = gridModel.gridData.getCell(1, rowIndex - 1);
                var expandable = false, detailFlag = false, hasRegId = false;
                if (compareCell.cell) {
                    expandable = compareCell.cell.expandable ? true : false;
                    detailFlag = new RO.GridHtml5.Cell(compareCell, gridModel).getDataRowAttr(RO.Enum.extendAttrs) == "1" ? true : false;
                    hasRegId = getRegonId(rowIndex - 1) ? true : false;
                    if (expandable || detailFlag || !hasRegId) {
                        continue;
                    } else {
                        regonId = getRegonId(rowIndex - 1);
                    }
                }
                if (nextReg) regonId = getRegonId(rowIndex + realDelCount);
            } else if (filterType == '2') {
                regonId = getRegonId(i + realDelCount);
                }
            if (!regonId)continue;
            var Regionjson =regiondata[regonId]? regiondata[regonId].RegionExtension:undefined;
            if (!Regionjson) continue;
            var colchange = $.parseJSON(Regionjson).OrderIndex;
            var cell = gridModel.gridData.getCell(colchange, i);
            if (!regiondata[regonId].detailRowStrart) {
                var detailRowStrart = -1;
                for (var k = regiondata[regonId].RegionTop; k < regiondata[regonId].RegionTop + regiondata[regonId].FloatDataCount ; k++) {
                    var dCell = gridModel.gridData.getCell(1, k);
                    if (dCell.cell.expandable) {
                        detailRowStrart = k;
                    } else if (detailRowStrart==-1) {
                        detailRowStrart = regiondata[regonId].RegionTop;
                        break;
                    } else if (detailRowStrart>=0) {
                        detailRowStrart = k;
                        break;
                    }
                }

                regiondata[regonId].detailRowStrart = detailRowStrart;
            }
            if (i >= regiondata[regonId].detailRowStrart) {
                var dCell = gridModel.gridData.getCell(1, i);
                if (dCell.cell.expandable) continue;
                if ((new RO.GridHtml5.Cell(dCell, Data.gridModel).getDataRowAttr(RO.Enum.extendAttrs) == "1")) continue;
                var parentIndexes = regiondata[regonId].RecordRelations;
                var parentIndexesSize = 0, showText;
                for (key in parentIndexes) {
                    if (parentIndexes.hasOwnProperty(key)) parentIndexesSize++;
                }
                if (parentIndexesSize == 0) {
                 
                    showText = i - regiondata[regonId].detailRowStrart + 1;
                } else {
                    showText = i - parentIndexes[i]-1 + 1;
                }
                var cell = gridModel.gridData.getCell(colchange, i);
                var htmlCell = new RO.GridHtml5.Cell(cell, gridModel);
                htmlCell.getDataRowAttr(RO.Enum.State)!="9" && cell && cell.setShowText(showText);
            }
           
        }
        if (filterType ==3) {
            var regonId = data.regid;          
            var Regionjson = regiondata[regonId].RegionExtension;
            var colchange = $.parseJSON(Regionjson).OrderIndex;
            for (var i = rowIndex; i < rowIndex + rowCount; i++) {
                if (aotoNoRowChange[regonId]) {
                    aotoNoRowChange[regonId].push({ "row": i, "state": "0", "col": colchange });
                } else {
                    aotoNoRowChange[regonId] = [];
                    aotoNoRowChange[regonId].push({ "row": i, "state": "0", "col": colchange });
                }
            }
        }
        //if (filterType == 2 ) {
        //    var regonId = getRegonId(rowIndex),delFlag=false;
        //    if (!regonId) {
        //        regonId = getRegonId(rowIndex - 1);
        //        delFlag = true;
        //    }
        //    var Regionjson = regiondata[regonId].RegionExtension;
        //    var colchange = $.parseJSON(Regionjson).OrderIndex; count = regiondata[regonId].FloatDataCount + regiondata[regonId].RegionTop - 1 < rowIndex
        //    for (var i = rowIndex; i < rowIndex + rowCount; i++) {
        //        if (i > regiondata[regonId].FloatDataCount + regiondata[regonId].DefaultCount - 1) {
        //            if (aotoNoRowChange[regonId]) {
        //                aotoNoRowChange[regonId].push({ "row": i, "state": "1", "col": colchange });
        //            } else {
        //                aotoNoRowChange[regonId] = [];
        //                aotoNoRowChange[regonId].push({ "row": i, "state": "1", "col": colchange });
        //            }
        //        }
        //    }

        //}
       gridModel.dataRegions = regiondata;

        $(Data.gridModel.entry).trigger(RO.Enum.Event.AutoNORowChange, { "aotoNoRowChange": aotoNoRowChange });
    }
});
//////GridHtml5Filter扩展 - 控件formatData////////
RO.GridAdapter.extend(RO.GridAdapter, {
   
    imgShow: function (data, dTObj, value, title, row, col) {
        return null; // 暂时未支持图片类型
        var dT = dTObj["dt"];
        //if (dT == '6' || dT == '9') {
        //    var gridModel = data.gridModel;

        //    // 图片类型 链接类型
        //    var slideOptions = {
        //        effect: "scroolX",
        //        autoPlay: false,
        //        speed: "normal",
        //        timer: 3000,
        //        steps: 1
        //    };


        //    var control = $("<div class='imgShow' style='display:inline;' row=" + row + " col=" + col + "></div>").imageshow(slideOptions);
        //    var entry = $(gridModel.entry).unbind("gridInitData").bind("gridInitData", function (event) {
        //        event.stopPropagation();
        //        var imgShows = $(".imgShow").on("valuechange", function (e) {
        //            e.stopPropagation();
        //            var curCell = gridModel.gridData.getCurrentCell();
        //            var changeValues = [{ row: curCell.getRow(), col: curCell.getCol(), floatData: null, fkey: null }];
        //            entry.trigger(RO.Enum.Event.valuechange, { "changeValues": changeValues });
        //        });
        //        imgShows.each(function () {
        //            var item = $(this);
        //            var curRow = parseInt(item.attr("row"));
        //            var curCol = parseInt(item.attr("col"));
        //            var curCell = gridModel.gridData.getCell(curCol, curRow);
        //            var jsonValue = eval(curCell.getEditText() || "");
        //            if (jsonValue) {
        //                for (var k = 0; k < jsonValue.length; k++) {
        //                    var fileType = jsonValue[k].FileName.split('.')[1];
        //                    var imageSrc = "data:image/" + fileType + ";base64,";
        //                    jsonValue[k].src = imageSrc + jsonValue[k].Base64Data;
        //                }
        //            } else {
        //                jsonValue = [];
        //            }

        //            item.imageshow("refresh", jsonValue).data("w", gridModel.gridData.getColWidth(curCol)).data("h", gridModel.gridData.getRowHeight(curRow));
        //        });
        //    });
        //    return { control: control[0] };
        //}
        //return null;
    },
    imt4Control: function (data, dTObj, value, title, row, col) {
        return null;
        if (dTObj['im'] == "4") {
            var gridModel = data.gridModel;

            //设置大文本编辑框单元格显示内容
            var setiM4CellHtml = function (imt, dValue) {
                var html;
                var windowconfig = window.GridConfig;
                var config = imt ? windowconfig[imt] : windowconfig['im4'];
                if (config.showtype == "1") {
                    var showText = config.key == "im4" && dValue;
                    var content = $("<table style='width:100%;height:100%;table-layout:fixed;'><tr><td style='width:auto;overflow: hidden; text-overflow: ellipsis; white-space: nowrap; '><a class='" + config.showclass + "' style='" + config.showstyle + "' onclick='" + config.showclick + "'>" + showText + "</a></td><td class='imt4Btn' onclick='" + config.showclick + "'><span>...</span></td></tr></table>");
                    html = content;
                } else {
                    html = config.showhtml;
                }
                return html;
            };

            var control = setiM4CellHtml(dTObj['imt'], value);
            $(data.gridModel.entry).unbind("gridInitData").bind("gridInitData", function (event) {
                event.stopPropagation();
                gridModel.editWindowManager = new $.EditWindowManager();

                $(".windowEditor").on("dblclick", function (e) {
                    e.stopPropagation();
                    var curRow = parseInt($(this).attr("row"));
                    var curCol = parseInt($(this).attr("col"));
                    var ccell = gridModel.gridData.getCell(curCol, curRow);
                    if (!ccell.cell) return;
                    var curCell = new RO.GridHtml5.Cell(ccell, gridModel);
                    var adapterCell = gridModel.editWindowManager.getAdapterCellForHtml5(curCell);
                    var windowEditor = gridModel.editWindowManager.getWindowEditor(adapterCell, gridModel, curCell.getAttrByName("imt"));
                    if (windowEditor) {
                        windowEditor.Show({
                            cell: adapterCell,
                            grid: gridModel
                        });
                    }
                });
            });
            return { control: control[0] };
        }
        return null;
    }
});


///////GridHtml5ExtMenu扩展 - ExtFunction//////
RO.GridAdapter.extend(RO.GridAdapter, {
	ilegalWarning: function (data) {
        var self = this, gridModel = data.gridModel, entry = data.gridModel.entry, grid = data.gridModel.gridData;

        var _doWorning = function (sender,e) {
            if (e == null) {
                return;
            }
            var worningText;
            var cell = grid.getCell(e.col, e.row);
            var curCell = new RO.GridHtml5.Cell(cell, data.gridModel);
            var worningText = e.worningText, flag;
            if (worningText == '' || worningText == undefined) {
                if ((curCell.cell.getClientData().worningText && curCell.cell.getClientData().worningText != '')) {
                    curCell.setAttrByName("worningText", "");
                    flag = 1;
                } else {
                    return;
                }
            } else {
                curCell.setAttrByName("worningText", worningText);
            }   
            showWorningFlag(cell, worningText, flag);
        };
        grid.addListener('currentCellChanged', function (){      
            var cell = data.gridModel.gridData.getCurrentCell();
            var worningText = cell.getClientData().worningText;
            if (worningText != null && worningText != "") {
                mui.toast(worningText);
            }
        });
        $(entry).off(RO.Enum.Event.WorningFlag).on(RO.Enum.Event.WorningFlag, _doWorning);
     	function showWorningFlag(cell, worningText, flag) {
            var curCell = new RO.GridHtml5.Cell(cell, data.gridModel);
            if (flag) {
                curCell.setAttrByName(RO.Enum.cellErrorCheckType, '');
                if (curCell.cell.getFigure() == undefined) {
                    return;
                }
                curCell.cell.getFigure().repaint();
            }
            if (worningText == "" || worningText == undefined) {
                return;
            }        
            curCell.setAttrByName(RO.Enum.cellErrorCheckType, '1');
            if (curCell.cell.getFigure() == undefined) {
                return;
            }
            curCell.cell.getFigure().repaint();
        }
    },
    btn2Menu: function (data) {

    },

    insertCtrl: function (data) {

    },

    rowInsertCtrl: function (data) {
        var self = this;
        var gridModel = data.gridModel;
        var entry = data.gridModel.entry;
        var grid = data.gridModel.gridData;
        var theme = this.widgetConfig && this.widgetConfig.Filter && this.widgetConfig.Filter.theme;
        var themeColor = theme && theme[0] == "lightTheme" ? "lightgray" : "skyblue";
        var ctrlKey = false;
        $(document).keydown(function (e) {
            ctrlKey = e.ctrlKey;
        }).keyup(function (e) {
            ctrlKey = e.ctrlKey;
        });
        grid.addListener("cellMouseMove", function (event) {
            var locationX = event.x;
            var locationY = event.y;
            var top, left;
            var cell = grid.getCellByPoint(locationX, locationY);
            var curCell = grid.getCell(cell.col, cell.row);
            if (!curCell.cell) return;
            var bounds = curCell.getFigure().getBounds().getCopy();
            var maxRow = grid.getRowCount() - 1;
            while (grid.isRowHidden(maxRow) && maxRow > 1) {
                maxRow--;
            }

            var newRow = cell.row;
            var span = curCell.getRowSpan();
            if (span > 1) {
                newRow += span - 1;
            }
            if (newRow == maxRow) {
                if (bounds.y < locationY) {
                    var rowInsertCtrl = $(".rowInsertCtrl", entry);
                    if (rowInsertCtrl.length == 0) {
                        rowInsertCtrl = $("<div class='rowInsertCtrl'><div class='btnBack gg-button-icon-insertCtrl'></div></div>");
                        $(".gridHtml5", entry).append(rowInsertCtrl);
                        $(".btnBack", rowInsertCtrl).css("border-color", "transparent transparent " + themeColor + " transparent");
                        rowInsertCtrl.on("click", function (e) {
                            e.stopPropagation();
                            var callBack = { doAction: true };
                            $(entry).trigger(RO.Enum.Event.beforeAppendRow, callBack);
                            if (callBack.doAction) {
                                if (self.getFormRegionKind() == RO.Enum.FormRegionKind.ROW || self.designMode) {
                                    //if (ctrlKey) {
                                    //    var index = grid.getRowCount();
                                    //    if (index > 2) {
                                    //        self.delete(1, index - 1, RO.Enum.OperationMode.ROW);
                                    //    }
                                    //} else {
                                    gridModel._curColIndexCache = grid.getCurrentCell().getCol();
                                    var row = grid.getRowCount();
                                    gridModel._curRowIndexCache = row;
                                    self.insert(1, row, RO.Enum.OperationMode.ROW);
                                    //}
                                    $(this).hide();
                                }
                            }
                        });
                    }
                    top = bounds.y + bounds.height - 10;
                    var dataWidth = grid.getDataWidth();
                    var clientWidth = grid.getWidth();
                    left = clientWidth > dataWidth ? dataWidth / 2 : clientWidth / 2;
                    var dataHeight = grid.getDataHeight();
                    var cliengHeight = $(".viewer", entry).height();
                    if (cliengHeight >= dataHeight + 20) {
                        top += 11;
                    } else {
                        top -= 11;
                    }
                    left += 11;
                    $(".btnBack", rowInsertCtrl).css("left", left - 25).css("top", top);
                    $(".btnValue", rowInsertCtrl).css("left", ctrlKey ? left - 2 : left).css("top", top - 2).text(ctrlKey ? "—" : "+");
                    rowInsertCtrl.show();
                }
            } else {
                $(".rowInsertCtrl", entry).hide();
            }
        });
    },

    colInsertCtrl: function (data) {
        var self = this;
        var gridModel = data.gridModel;
        var entry = data.gridModel.entry;
        var grid = data.gridModel.gridData;
        var theme = this.widgetConfig && this.widgetConfig.Filter && this.widgetConfig.Filter.theme;
        var themeColor = theme && theme[0] == "lightTheme" ? "lightgray" : "skyblue";
        var ctrlKey = false;
        $(document).keydown(function (e) {
            ctrlKey = e.ctrlKey;
        }).keyup(function (e) {
            ctrlKey = e.ctrlKey;
        });
        grid.addListener("cellMouseMove", function (event) {
            var locationX = event.x;
            var locationY = event.y;
            var top, left;
            var cell = grid.getCellByPoint(locationX, locationY);
            var curCell = grid.getCell(cell.col, cell.row);
            if (!curCell.cell) return;
            var bounds = curCell.getFigure().getBounds().getCopy();
            var maxCol = grid.getColCount() - 1;
            while (grid.isColHidden(maxCol) && maxCol > 1) {
                maxCol--;
            }
            var newCol = cell.col;
            var span = curCell.getColSpan();
            if (span > 1) {
                newCol += span - 1;
            }
            if (newCol == maxCol) {
                if (bounds.x < locationX) {
                    var colInsertCtrl = $(".colInsertCtrl", entry);
                    if (colInsertCtrl.length == 0) {
                        colInsertCtrl = $("<div class='colInsertCtrl'><div class='btnBack gg-button-icon-insertCtrl'></div></div>");
                        $(".gridHtml5", entry).append(colInsertCtrl);
                        $(".btnBack", colInsertCtrl).css("border-color", "transparent " + themeColor + " transparent transparent");
                        colInsertCtrl.off("click").on("click", function (e) {
                            e.stopPropagation();
                            var callBack = { doAction: true };
                            $(entry).trigger(RO.Enum.Event.beforeAppendCol, callBack);
                            if (callBack.doAction) {
                                if (self.getFormRegionKind() == RO.Enum.FormRegionKind.COL || self.designMode) {
                                    //if (ctrlKey) {
                                    //    var index = grid.getColCount();
                                    //    if (index > 2) {
                                    //        self.delete(1, index - 1, RO.Enum.OperationMode.COL);
                                    //    }
                                    //} else {
                                    gridModel._curRowIndexCache = grid.getCurrentCell().getRow();
                                    var col = grid.getColCount();
                                    gridModel._curColIndexCache = col;
                                    self.insert(1, col, RO.Enum.OperationMode.COL);
                                    //}
                                    $(this).hide();
                                }
                            }
                        });
                    }
                    left = bounds.x + bounds.width - 10;
                    var dataHeight = grid.getDataHeight();
                    var clientHeight = grid.getHeight();
                    top = clientHeight > dataHeight ? dataHeight / 2 : clientHeight / 2;
                    var dataWidth = grid.getDataWidth();
                    var clientWidth = $(".viewer", entry).width();

                    if (clientWidth >= dataWidth + 20) {
                        left += 11;
                    } else {
                        left -= 11;
                    }
                    top += 11;
                    $(".btnBack", colInsertCtrl).css("left", left).css("top", top - 23);
                    $(".btnValue", colInsertCtrl).css("left", ctrlKey ? left + 6 : left + 2).css("top", top).text(ctrlKey ? "|" : "+");
                    colInsertCtrl.show();
                }
            } else {
                $(".colInsertCtrl", entry).hide();
            }
        });
    },

    selectionChange: function (data) {
        var entry = data.gridModel.entry;
        var ctrlKeyFlag = false;

        data.gridModel.onKeyDown = function (e) {
            ctrlKeyFlag = e.ctrlKey;
        };
        data.gridModel.onkeyup = function (e) {
            ctrlKeyFlag = e.ctrlKey;
        };
        $(".gridHtml5", data.gridModel.entry).on("keydown", data.gridModel.onKeyDown).on("keyup", data.gridModel.onkeyup);
        var self = this;
        var grid = data.gridModel.gridData;
        var editMode = grid.getEditMode();

        var exceptRectangle = function (bigRect, smalRect) {
            if (bigRect.x < smalRect.x) {
                return new Rectangle(bigRect.x, bigRect.y, bigRect.width - smalRect.width, bigRect.height);
            } else if (bigRect.y < smalRect.y) {
                return new Rectangle(bigRect.x, bigRect.y, bigRect.width, bigRect.height - smalRect.height);
            } else if (bigRect.width == smalRect.width) {
                return new Rectangle(bigRect.x, bigRect.y + smalRect.height, bigRect.width, bigRect.height - smalRect.height);
            } else if (bigRect.height == smalRect.height) {
                return new Rectangle(bigRect.x + smalRect.width, bigRect.y, bigRect.width - smalRect.width, bigRect.height);
            }
            return null;
        };
        var eachEditableCellInSelection = function (selectionRect, func) {
            if (!selectionRect || typeof func != "function") return;
            for (var dy = 0; dy < selectionRect.height; dy++) {
                var rowIndex = dy + selectionRect.y;
                if (rowIndex == 0) continue;
                for (var dx = 0; dx < selectionRect.width; dx++) {
                    var colIndex = dx + selectionRect.x;
                    if (colIndex == 0) continue;
                    var gridCell = self.getCell(colIndex, rowIndex);
                    if (gridCell && (editMode == COM.widget.Grid.EDIT_MODE_EDIT || gridCell.getCanEdit())) {
                        func(gridCell, dx, dy);
                    }
                }
            }
        };

        var getIncreaseSeed = function (oldRec, newRec) {
            var increaseVect = [], direct, curVectIndex, c, r, lastCell, curCell, incre;
            var getMinDistInCircle = function (start, end, cur, last) {
                var max = Math.abs(end - start) + 1; // 周长
                var tempDist = cur - last;
                var anotherDist = max - Math.abs(tempDist);
                if (Math.abs(tempDist) <= anotherDist)
                    return tempDist;
                return anotherDist * (tempDist / Math.abs(tempDist) * (-1)); // 方向和tempDist相反
            };
            var calcSeed = function (vIndex, curC, lastC) {
                if (lastC && curC) {
                    var lastType = lastC.cell.getAttrByName("im");
                    var curType = curC.cell.getAttrByName("im");
                    var lastVal = lastType == '2' ? lastC.getShowText() : lastC.getEditText(); // 枚举单元格使用showtext
                    var curVal = curType == '2' ? curC.getShowText() : curC.getEditText();
                    lastVal = lastVal === undefined || lastVal === null ? '' : lastVal;
                    curVal = curVal === undefined || curVal === null ? '' : curVal;
                    if (GridWeekIter.WeekToNum[lastVal] !== undefined && GridWeekIter.WeekToNum[curVal] !== undefined) {
                        // 星期
                        incre = getMinDistInCircle(0, 6, GridWeekIter.WeekToNum[curVal], GridWeekIter.WeekToNum[lastVal]);
                        if (increaseVect[vIndex] === undefined) {
                            increaseVect[vIndex] = new GridWeekIter(incre);
                        } else if (increaseVect[vIndex].incre !== incre) {
                            increaseVect[vIndex] = undefined;
                            return false;
                        }

                    } else if (GridMonthIter.MonthToNum[lastVal] !== undefined && GridMonthIter.MonthToNum[curVal] !== undefined) {
                        // 月份
                        incre = getMinDistInCircle(0, 11, GridMonthIter.MonthToNum[curVal], GridMonthIter.MonthToNum[lastVal]);
                        if (increaseVect[vIndex] === undefined) {
                            increaseVect[vIndex] = new GridMonthIter(incre);
                        } else if (increaseVect[vIndex].incre !== incre) {
                            increaseVect[vIndex] = undefined;
                            return false;
                        }
                    } else if (GridLetterIter.LetterToNum[curVal.toString().toUpperCase()] !== undefined && GridLetterIter.LetterToNum[lastVal.toString().toUpperCase()] !== undefined) {
                        // 字母
                        incre = getMinDistInCircle(0, 25, GridLetterIter.LetterToNum[curVal.toString().toUpperCase()], GridLetterIter.LetterToNum[lastVal.toString().toUpperCase()]);
                        if (increaseVect[vIndex] === undefined) {
                            increaseVect[vIndex] = new GridLetterIter(incre);
                        } else if (increaseVect[vIndex].incre !== incre) {
                            increaseVect[vIndex] = undefined;
                            return false;
                        }
                    } else if (lastVal !== "" && curVal !== "" && !isNaN(lastVal) && !isNaN(curVal)) {
                        // 纯数字
                        incre = parseFloat((curVal - lastVal).toFixed(10));
                        if (increaseVect[vIndex] === undefined) {
                            increaseVect[vIndex] = new GridNumIter(incre);
                        } else if (increaseVect[vIndex].incre !== incre) {
                            increaseVect[vIndex] = undefined;
                            return false;
                        }
                    } else if (lastVal !== "" && curVal !== "" && lastVal.match(/^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})$/) && curVal.match(/^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})$/)) {
                        // 年月日
                        curVal = new Date(curVal);
                        lastVal = new Date(lastVal);
                        incre = parseInt((curVal - lastVal) / 1000 / 60 / 60 / 24);
                        if (increaseVect[vIndex] === undefined) {
                            increaseVect[vIndex] = new GridYMDIter(incre);
                        } else if (increaseVect[vIndex].incre !== incre) {
                            increaseVect[vIndex] = undefined;
                            return false;
                        }
                    } else {
                        var lastNumIdx = lastVal.toString().search(/\d+/);
                        var curNumIdx = curVal.toString().search(/\d+/);
                        if (lastNumIdx === curNumIdx && curNumIdx !== -1 && lastVal.toString().replace(/\d+/, "") === curVal.toString().replace(/\d+/, "")) {
                            // 数字字符组合：从左往右首个数字位置相同且除该数字外其他字符相同。
                            incre = curVal.toString().match(/\d+/) - lastVal.toString().match(/\d+/);
                            if (increaseVect[vIndex] === undefined) {
                                increaseVect[vIndex] = new GridNumCompoIter(incre);
                            } else if (increaseVect[vIndex].incre !== incre) {
                                increaseVect[vIndex] = undefined;
                                return false;
                            }
                        } else {
                            increaseVect[vIndex] = undefined;
                            return false;
                        }
                    }
                    return true;
                }
                return false;
            };
            if (newRec.x < oldRec) { // 向左
                direct = "left";
            } else if (newRec.y < oldRec.y) { // 向上
                direct = "up";
            } else if (newRec.width == oldRec.width) { // 向下
                direct = "down";
                for (c = oldRec.x; c < oldRec.x + oldRec.width; c++) {
                    curVectIndex = c - oldRec.x;
                    for (r = oldRec.y + 1; r < oldRec.y + oldRec.height; r++) {
                        lastCell = self.getCell(c, r - 1);
                        curCell = self.getCell(c, r);
                        if (!calcSeed(curVectIndex, curCell, lastCell)) {
                            break;
                        }
                    }
                }
            } else if (newRec.height == oldRec.height) { // 向右
                direct = "right";
                for (r = oldRec.y; r < oldRec.y + oldRec.height; r++) {
                    curVectIndex = r - oldRec.y;
                    for (c = oldRec.x + 1; c < oldRec.x + oldRec.width; c++) {
                        lastCell = self.getCell(c - 1, r);
                        curCell = self.getCell(c, r);
                        if (!calcSeed(curVectIndex, curCell, lastCell)) {
                            break;
                        }
                    }
                }
            }
            return { "direct": direct, "vector": increaseVect };
        };

        grid.addListener("selectionChange", function (event) {
        	var Data = data;
            var modify = false, oldValue, fkey, iter, isSelectionChange = false;
            var changeValues = [];
            var oldSelection = event.oldSelection;
            var newSelection = event.newSelection;
            var oldRect = oldSelection;//new Rectangle(oldSelection.x, oldSelection.y, oldSelection.width, oldSelection.height);
            var newRect = newSelection;//new Rectangle(newSelection.x, newSelection.y, newSelection.width, newSelection.height);
             var selectrowindex = newRect.y;
            var selectrowcount =newRect.height;
            if (newRect.equals(oldRect)) {
                return; // 新旧区域没变化时不做处理
            }
            if (newRect.contains(oldRect) || oldRect.contains(newRect)) {
                var changeRect;
                var enlarge = true;
                if (newRect.contains(oldRect)) { // 填充
                    enlarge = true;
                    changeRect = exceptRectangle(newRect, oldRect);
                    var seeds = getIncreaseSeed(oldRect, newRect);
                    if (changeRect) {
                        eachEditableCellInSelection(changeRect, function (gridCell, dx, dy) {
                            var lastCell;
                            var oldDx = dx % oldRect.width, oldDy = dy % oldRect.height;
                            var oldCol = oldRect.x + oldDx, oldRow = oldRect.y + oldDy;
                            var oldCell = self.getCell(oldCol, oldRow);
                            var newValue = oldCell.getShowText();
                            var curRow = gridCell.getRowIndex(), curCol = gridCell.getColIndex();
                            if (seeds.direct == "down" && seeds.vector[dx] !== undefined) {
                                iter = seeds.vector[dx];
                                lastCell = self.getCell(curCol, curRow - 1);
                                newValue = iter.next(lastCell.getEditText());

                            } else if (seeds.direct == "right" && seeds.vector[dy] !== undefined) {
                                iter = seeds.vector[dy];
                                lastCell = self.getCell(curCol - 1, curRow);
                                newValue = iter.next(lastCell.getEditText());
                            }

                            oldValue = gridCell.getEditText();
                            fkey = gridCell.cell.getDataRowAttr(RO.Enum.FloatRowKey);
                            var eid = gridCell.cell.getAttrByName(RO.Enum.EnumID);
                            if (eid != null && parseInt(eid) > 0) {
                                modify = self.grid.gridModel.setValue(gridCell.cell, "", newValue, true, false);
                            } else {
                                modify = self.grid.gridModel.setValue(gridCell.cell, newValue, newValue, true, false);
                            }
                            if (modify) {
                                isSelectionChange = true;
                                changeValues.push({ "row": gridCell.getRowIndex(), "col": gridCell.getColIndex(), "oldValue": oldValue, "newValue": newValue, "fKey": fkey });
                            }
                        });
                    }
                } else { // 清除
                    enlarge = false;
                    changeRect = exceptRectangle(oldRect, newRect);
                    if (changeRect) {
                        eachEditableCellInSelection(changeRect, function (gridCell) {
                            oldValue = gridCell.getEditText(), oldTitle = gridCell.getShowText();
                            fkey = gridCell.cell.getDataRowAttr(RO.Enum.FloatRowKey);
                            if (oldValue != "") {
                                modify = self.grid.gridModel.setValue(gridCell.cell, "", "", true, true);
                                if (modify) {
                                    isSelectionChange = true;
                                    changeValues.push({ "row": gridCell.getRowIndex(), "col": gridCell.getColIndex(), "oldValue": oldValue, "newValue": "", "fKey": fkey, "oldTitle": oldTitle,"newTitle":"" });
                                }
                            }
                        });
                    }
                }
                if (isSelectionChange) {
                    $(data.gridModel.entry).trigger(RO.Enum.Event.valuechange, { "changeValues": changeValues, "operationType": "selectionChange" });
                }
                $(entry).trigger(RO.Enum.Event.crossSelectionChange, { "oldSelection": event.oldSelection, "newSelection": event.newSelection, "enlarge": enlarge, "changedSelection": changeRect });
//           var filterflag =false;
//              var region = Data.gridModel.dataRegions;
//              for (var regid in region) {
//                  if (region[regid].RegionExtension && $.parseJSON(region[regid].RegionExtension).OrderIndex) {
//                      filterflag = true;
//                  }
//              }
//              if (filterflag) {
//                  var autofilter = { "selectrowindex": selectrowindex, "selectrowcount": selectrowcount };
//                      Data.gridModel.filterAutoNoData(autofilter);
//              }
            } else {
                modify = false;
                event.grid.select(oldSelection);
                RO.GridHtml5.prototype.copy.call(self.grid);
                if (!ctrlKeyFlag) {
                    // grid.clearText(oldSelection);
                    changeValues = [];

                    for (var r = 0; r < oldSelection.height; r++) {
                        for (var c = 0; c < oldSelection.width; c++) {
                            var row = r + oldSelection.y, col = c + oldSelection.x;
                            var cell = self.getCell(col, row);

                            oldValue = cell.getEditText(),oldTitle=cell.getShowText();
                            fkey = cell.cell.getDataRowAttr(RO.Enum.FloatRowKey);
                            if (oldValue != "") {
                                modify = self.grid.gridModel.setValue(cell.cell, "", "", true, true);
                                if (modify) {
                                    isSelectionChange = true;
                                    changeValues.push({ "row": row, "col": col, oldValue: oldValue, newValue: "",oldTitle:oldTitle,newTitle:"", fKey: fkey });
                                }
                            }
                        }
                    }
                    if (isSelectionChange) {
                        $(data.gridModel.entry).trigger(RO.Enum.Event.valuechange, { "changeValues": changeValues, "operationType": "cut" });
                    }
                }
                event.grid.select(newSelection);
                event.grid.setCurrentCell(newSelection.x, newSelection.y);
                RO.GridHtml5.prototype.paste.call(self.grid);
//               var filterflag = false;
//              var region = Data.gridModel.dataRegions;
//              var oldindex = oldRect.y, oldcount = oldRect.height, newindex = newRect.y, newcount = newRect.height;
//              for (var regid in region) {
//                  if (region[regid].RegionExtension && $.parseJSON(region[regid].RegionExtension).OrderIndex) {
//                      filterflag = true;
//                  }
//              }
//              if (filterflag) {
//                 
//                  if (!ctrlKeyFlag) {
//                      var autofilter = { "oldindex": oldindex, "oldcount": oldcount, "newindex": newindex, "newcount": newcount };
//                      this.timeOutId = window.setTimeout(function () {
//                          var formatValue = Data.gridModel.filterAutoNoData(autofilter);
//                      }, 10);
//                  } else if (ctrlKeyFlag) {
//                      var autofilter = { "oldindex": 0, "oldcount": 0, "newindex": newindex, "newcount": newcount };
//                      Data.gridModel.filterAutoNoData(autofilter);
//                  }
//              }
            }
        });
    },

    selectEditor: function (data) {
        var me = this;
        var curActiveSelEditor = null;
        var curDelete = null;
        var curArrow = null;
        var curAutocomplete = null;
        var curActiveTreeEditor = null;
        var grid = data.gridModel.gridData;
        var selectEditorCurRow = -1;
        var selectEditorCurCol = -1;

        this._cellChanged = function (e) {
            if (curArrow != null) {
                curArrow.hide();
                curDelete.hide();
            }
            if (curAutocomplete != null) {
                curAutocomplete.hide();
            }
            $(data.gridModel.entry).trigger("grid_EnumEditor");
        };
        grid.addListener("scrolled", function (e) {
            $(".gridHtml5", data.gridModel.entry).trigger("grid_closeEditor");
            data.gridModel.gridData.getCurrentCell();
            //处理下拉框显示            
            var curcell = data.gridModel.gridData.getCurrentCell();
            if (curcell.cell == undefined) {
                $("#autoarrow").hide();
                $("#delete_enum").hide();
                return;
            }
            var row = curcell.cell.rowIndex;
            var col = curcell.cell.colIndex;
            var offset = curcell.getFigure().getBounds().getCopy();
            var info = data.gridModel.gridData.getDrawAreaInfo();
            var zIndex = data.gridModel.gridData.gridModel.editPart.getZIndex(col, row);
            var htmlCell = new RO.GridHtml5.Cell(curcell, data.gridModel.gridData.gridModel);
            var type = htmlCell.getAttrByName(RO.Enum.EditMode) || curcell.getEditorId();
            var designMOde = data.gridModel.designMode;

            var oldArrow = $("#autoarrow");
            var oldAutocomplete = $("#autocomplete");
            var oldDelete = $("#delete_enum");

            var lilength = $("#autocomplete li").length * 21;
            var celltop = offset.y;
            var cellbottom = data.gridModel.gridData.getHeight() - (offset.y + offset.height);
            var isTop = cellbottom < lilength;

            if (row < info.startRow || row > info.endRow || col < info.startCol || col > info.endCol) {
                oldArrow.hide();
                oldDelete.hide();
            } else if (type == "2") {
                var eid = htmlCell.getAttrByName(RO.Enum.EnumID);
                var deleteEnumIDs = me.getOptionByName(RO.Enum.DeleteEnumIDs);
                if (deleteEnumIDs != null && deleteEnumIDs.indexOf(eid) >= 0) {
                    return;
                }
                oldArrow.show();
                if (designMOde) {
                    oldDelete.show();
                }
            }

            oldArrow.css("left", offset.x + 1 + offset.width);
            oldArrow.css("top", offset.y + offset.height - 17);
            oldArrow.css("width", 16);
            oldArrow.css("height", 15);
            oldArrow.css("z-index", zIndex);

            oldDelete.css("left", offset.x + 1 + offset.width + 18);
            oldDelete.css("top", offset.y + offset.height - 17);
            oldDelete.css("border", "none");
            oldDelete.css("width", 16);
            oldDelete.css("height", 15);

            if (oldAutocomplete != null) {
                if (oldAutocomplete.is(":visible")) {
                    oldAutocomplete.hide();
                }
                oldAutocomplete.css("left", offset.x - 1);
                if (celltop < lilength && cellbottom < lilength) {
                    var maxsize = Math.max(celltop, cellbottom) - 2;
                    oldAutocomplete.css("max-height", maxsize);
                    lilength = maxsize;
                    isTop = celltop - cellbottom > 0;
                }
                oldAutocomplete.css("top", isTop ? offset.y - lilength - 2 : offset.y + offset.height + 1);
                oldAutocomplete.css("width", offset.width + 19);
            }

        });

        grid.addListener("currentCellChanged", this._cellChanged);
        
        $(data.gridModel.entry).off("grid_HideEnumEditor").on("grid_HideEnumEditor", function () {
            $(this).trigger(RO.Enum.Event.deleteEnum);
            if (curAutocomplete != null && curAutocomplete.is(":visible")) {
                curAutocomplete.hide();
            }

            $(".autoarrow_enum", this).hide();
            $(".delete_enum", this).hide();
        });

        $(data.gridModel.entry).off("grid_EnumEditor").on("grid_EnumEditor", function () {
            // editorData.cell.isEditable() 方法有问题，暂时用grid上的只读控制处理
            var cell = data.gridModel.gridData.getCurrentCell();
            if (!cell.isEditable())
                return;

            var curCellRow = cell.getRow();
            var curCellCol = cell.getCol();
            selectEditorCurCol = curCellCol;
            selectEditorCurRow = curCellRow;
            var htmlCell = new RO.GridHtml5.Cell(cell, data.gridModel);
            //var lid = htmlCell.getAttrByName(RO.Enum.DataLinkId);
            //var type = htmlCell.getAttrByName(RO.Enum.EditMode) || cell.getEditorId();
            var vm = htmlCell.getAttrByName(RO.Enum.ViewMode);
            var eid = htmlCell.getAttrByName(RO.Enum.EnumID);
            var etid = null;
            var self = $(this);

            //showFlag:0-编码；1-标题；2:-编码|标题
            var getShowText = function (showFlag, id, name) {
                var text = "";
                switch (showFlag) {
                    case "0":
                        text = id;
                        break;
                    case "2":
                        if (name.indexOf("|") > 0) {
                            text = name;
                        } else {
                            text = id + "|" + name;
                        }
                        break;
                    case "1":
                    default:
                        var i = name.indexOf("|");
                        if (i > 0) {
                            text = $.trim(name.substring(i + 1, name.length));
                        } else {
                            text = name;
                        }
                        break;
                }
                return text;
            };

            var sourceUrl = data.gridModel.enumDataSourceUrl;
            //switch (parseInt(type)) {
            //case RO.Enum.DataLinkEditMode.dl_Default:

            //    case RO.Enum.DataLinkEditMode.dl_DropDown:
            //     break;
                    

            if (eid != null && parseInt(eid) > 0) {
                //修复建模删除枚举时界面不刷新导致下拉显示的问题
                var deleteEnumIDs = me.getOptionByName(RO.Enum.DeleteEnumIDs);
                if (deleteEnumIDs != null && deleteEnumIDs.indexOf(eid) >= 0) {
                    return;
                }

                curArrow = $("#autoarrow");
                curDelete = $("#delete_enum");
                if (!curArrow || curArrow.length == 0) {
                    curArrow = $("<span class='ui-toolbar-icon ui-toolbar-components-icon ui-toolbar-icon-triangle-1-s autoarrow_enum' id='autoarrow'  style='text-align:center;vertical-align:middle;overflow:hidden;position:absolute;z-index:900;opacity: 1;background-color:  #d6e3e9;background-position: -65px -16px;'></span>").gridHtml5Editor();
                    $(".gridHtml5", self).append(curArrow);
                    curArrow.show();
                    curArrow.attr("tabindex", 0);

                    curDelete = $("<span class='delete_enum' id='delete_enum'  style='text-align:center;vertical-align:middle;overflow:hidden;position:absolute;z-index:900;opacity: 1'></span>").gridHtml5Editor();
                    $(".gridHtml5", self).append(curDelete);

                    if (data.gridModel.designMode) {
                        curDelete.show();
                    } else {
                        curDelete.hide();
                    }                   

                } else {
                    setTimeout(function () {
                        curArrow.show();
                        if (data.gridModel.designMode) {
                            curDelete.show();
                        } else {
                            curDelete.hide();
                        }
                    }, 50);
                }
                //根据枚举类型扩展不同下拉样式
                //etid = 0;
                curArrow.unbind("click").bind("click", function () {

                    var curcell = new RO.GridHtml5.Cell(data.gridModel.gridData.getCurrentCell(), data.gridModel);
                    eid = curcell.getAttrByName(RO.Enum.EnumID);

                    me._requestEnumNodes(eid);

                    $(data.gridModel.entry).off("LoadEnumData").on("LoadEnumData", function () {

                        //枚举类型、枚举数据源
                        etid = RO.Enum.EnumNodesCache.EnumType;
                        var arr = RO.Enum.EnumNodesCache.DataSource;

                        if (etid == undefined || arr == undefined || arr.length == 0) {
                            return;
                        }

                        switch (parseInt(etid)) {
                            case RO.Enum.EnumType.List:
                                if (!curAutocomplete) {
                                    curAutocomplete = $("#autocomplete");
                                }
                                if (curAutocomplete.length == 0) {
                                    curAutocomplete = $("<ul id='autocomplete' style='vertical-align: middle; position: absolute; z-index: 900; border: solid 1px #84C2EE;background: none repeat scroll 0 0 #FFFFFF;border: 1px solid #CCCCCC;border-radius: 2px 2px 2px 2px;color: #333333;max-height: 299px;overflow-y: auto;overflow-x: hidden;'></ul>").gridHtml5Editor();
                                    $(document.body).append(curAutocomplete);// 添加到body上，否则鼠标滚动时会被表格的滚动抢断
                                    curAutocomplete.hide();
                                    $(document).unbind('mouseup.enumautocomplete').bind('mouseup.enumautocomplete', function(e) {
                                        curAutocomplete.hide();
                                    });
                                    curAutocomplete.unbind('mouseup.enumautocomplete').bind('mouseup.enumautocomplete', function(e) {
                                        return false;
                                    });
                                }

                                if (curAutocomplete.is(":visible")) {
                                    curAutocomplete.hide();
                                } else {
                                    var liList = $("#autocomplete li");
                                    if (liList.length != 0) {
                                        liList.remove();
                                    }
                                    if (arr) {
                                        $.each(arr, function (index, term) {

                                            var dropdata = $("<li unselectable='on' onselectstart='return false;' style='height: 22px;'></li>");
                                            dropdata.attr("title", term.name);
                                            $("<span ></span>").html(term.name).appendTo(dropdata);
                                            dropdata.appendTo(curAutocomplete);
                                            if (!data.gridModel.designMode) {
                                                dropdata.mouseover(function () {
                                                    var keyindex = $("#autocomplete li").index($(".LiMouseOn")[0]);
                                                    $($("#autocomplete li")[keyindex]).removeClass('LiMouseOn');
                                                    $(this).addClass('LiMouseOn');
                                                }).mouseout(function () {
                                                    $(this).removeClass('LiMouseOn');
                                                    $($("#autocomplete li")[0]).removeClass('LiMouseOn');
                                                });
                                            }
                                            dropdata.click(function () {
                                                if (!data.gridModel.designMode) {
                                                    var title = dropdata.attr('title');
                                                    var curCell = new RO.GridHtml5.Cell(data.gridModel.gridData.getCurrentCell(), data.gridModel);
                                                    curCell.setValue(title, term && term.id || "");
                                                    grid.focus();
                                                    curAutocomplete.hide();
                                                } else {
                                                    window.jNoty("模板中下拉项仅供预览");
                                                }

                                            });
                                        });
                                    }
                                    curAutocomplete.show();

                                    var gridOffset = $('.gridHtml5', data.gridModel.entry).offset(); // curAutocomplete添加到body上后位置需要加上grid的位置偏移
                                    var tempcellFigure = data.gridModel.gridData.getCurrentCell().getFigure();
                                    var tempoffset = tempcellFigure.getBounds().getCopy();

                                    var lilength = $("#autocomplete li").length * 22;
                                    var celltop = tempoffset.y;
                                    var cellbottom = data.gridModel.gridData.getHeight() - (tempoffset.y + tempoffset.height);
                                    var isTop = cellbottom < lilength, hasScroll = false

                                    curAutocomplete.css("left", gridOffset.left + tempoffset.x - 1);
                                    if (celltop < lilength && cellbottom < lilength) {
                                        var maxsize = Math.max(celltop, cellbottom) - 2;
                                        curAutocomplete.css("max-height", maxsize);
                                        lilength = maxsize - 2;
                                        hasScroll = true;
                                        isTop = celltop - cellbottom > 0;
                                    } else {
                                        curAutocomplete.css("max-height", 296);
                                        if (lilength > 296) {
                                            lilength = 296;
                                            hasScroll = true;
                                        }
                                    }
                                    curAutocomplete.css("top", isTop ? gridOffset.top + tempoffset.y - lilength - 3 : gridOffset.top + tempoffset.y + tempoffset.height + 1);

                                    //兼容IE9浏览器下，在有滚动条的情况下，显示的宽度不对的问题
                                    if (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.match(/9./i) == "9." && hasScroll) {
                                        curAutocomplete.css("width", isTop ? tempoffset.width + 20 : tempoffset.width + 39);
                                    } else {
                                        curAutocomplete.css("width", isTop ? tempoffset.width : tempoffset.width + 19);
                                    }
                                }

                                curArrow.off("keydown").on("keydown", function (event) {

                                    if (!data.gridModel.designMode) {
                                        var myEvent = event || window.event;
                                        var keyCode = myEvent.keyCode;
                                        //下键操作
                                        if (keyCode == 40) {
                                            var oldtop = curAutocomplete.scrollTop();

                                            if ($("#autocomplete").is(":visible")) {
                                                var downindex = 0;
                                                var firstLiClass = $($("#autocomplete li")[0]).attr('class');
                                                if ($("#autocomplete li").index($(".LiMouseOn")[0]) == 0 && (firstLiClass == undefined || firstLiClass.length == 0)) {
                                                    downindex = -1;
                                                } else {
                                                    downindex = $("#autocomplete li").index($(".LiMouseOn")[0]);
                                                }
                                                $($("#autocomplete li")[downindex]).removeClass('LiMouseOn');
                                                downindex++;
                                                if (downindex < $("#autocomplete li").length) {
                                                    $($("#autocomplete li")[downindex]).addClass('LiMouseOn');
                                                    if ($(".LiMouseOn").offset().top > $("#autocomplete").offset().top + 296 - 21) {
                                                        curAutocomplete.scrollTop(oldtop + 21);
                                                    }
                                                } else if (downindex == $("#autocomplete li").length) {
                                                    $($("#autocomplete li")[0]).addClass('LiMouseOn');
                                                    curAutocomplete.scrollTop(0);
                                                }
                                            }
                                        }
                                            //上键操作
                                        else if (keyCode == 38) {
                                            var oldtopup = curAutocomplete.scrollTop();

                                            if ($("#autocomplete").is(":visible")) {
                                                var upindex = $("#autocomplete li").index($(".LiMouseOn")[0]);
                                                $($("#autocomplete li")[upindex]).removeClass('LiMouseOn');
                                                upindex--;
                                                if (upindex > -1) {
                                                    $($("#autocomplete li")[upindex]).addClass('LiMouseOn');
                                                    if ($(".LiMouseOn").offset().top < $("#autocomplete").offset().top) {
                                                        curAutocomplete.scrollTop(oldtopup - 21);
                                                    }
                                                } else if (upindex == -1) {
                                                    $($("#autocomplete li")[$("#autocomplete li").length - 1]).addClass('LiMouseOn');
                                                    var high = $("#autocomplete li").length * 21 - 294;
                                                    curAutocomplete.scrollTop(high);
                                                }
                                            }
                                        }
                                            //回车操作  
                                        else if (keyCode == 13) {
                                            //为可见状态才执行
                                            if ($("#autocomplete").is(":visible")) {
                                                //$("#TopSearch").bind("change", function () {
                                                var enterindex = 0;
                                                if ($($("#autocomplete li")[0]).attr('class').length == 0 && $("#autocomplete li").index($(".LiMouseOn")[0]) == 0) {
                                                    enterindex = -1;
                                                } else {
                                                    enterindex = $("#autocomplete li").index($(".LiMouseOn")[0]);
                                                }

                                                var term = $($("#autocomplete li")[enterindex]).attr('title');
                                                data.gridModel.setValue(data.cell, term);
                                                $("#autocomplete").hide();
                                            }
                                        }
                                        else if (keyCode == 8 || keyCode == 46) {
                                            data.gridModel.setValue(data.cell, "");
                                        }
                                    }
                                });

                                break;
                            case RO.Enum.EnumType.Tree:

                                //$("#treeUl").remove();
                                //if (!curActiveTreeEditor) {
                                //    curActiveTreeEditor = $("<div id='treeEditor' style='text-align:center;vertical-align:middle;overflow:hidden;position:absolute;z-index:900;'><input id='ztreeInput'/></div>").gridHtml5Editor();
                                //    self.append(curActiveTreeEditor);
                                //    $("#ztreeInput").combobox({
                                //        onSelect: function (val) {
                                //            var parent = $(this).parent();
                                //            var col = parseInt(parent.attr("col"));
                                //            var row = parseInt(parent.attr("row"));
                                //            var curCell = new RO.GridHtml5.Cell(grid.getCell(col, row), editorData.gridModel);
                                //            curCell.setValue(val && val.text || "", val && val.id || "");
                                //            grid.select({ x: col, y: row, width: 1, height: 1 });
                                //            grid.focus();
                                //        },
                                //        selectCurr: function () {
                                //            var parent = $(this).parent();
                                //            var tr = $.fn.zTree.getZTreeObj("treeUl");
                                //            var val = $(this).combobox("textbox").val();
                                //            var node = tr.getNodeByParam("id", "treeUl_" + val);
                                //            if (node)
                                //                $(this).combobox("select", "treeUl_" + val);
                                //            var col = parseInt(parent.attr("col"));
                                //            var row = parseInt(parent.attr("row"));
                                //            grid.select({ x: col, y: row, width: 1, height: 1 });
                                //            grid.focus();
                                //        }
                                //    });
                                //    curActiveTreeEditor.unbind("click").bind("click", function (e) {
                                //        grid.setCurrentCell(selectEditorCurCol, selectEditorCurRow);
                                //        grid.select({ x: selectEditorCurCol, y: selectEditorCurRow, width: 1, height: 1 });
                                //    });
                                //} else {
                                //    $("#ztreeInput").combobox("hidePanel");
                                //    var zTree = $.fn.zTree.getZTreeObj("treeUl");
                                //    zTree && zTree.destroy();
                                //    $("#ztreeInput").combobox("panel").empty();
                                //    $("#ztreeInput").combobox("setText", value);
                                //}

                                //var cellFigure = cell.getFigure();
                                //var offset = cellFigure.getBounds().getCopy();
                                //cellFigure.translateToAbsolute(offset);
                                //curActiveTreeEditor.css("left", offset.x + 1);
                                //curActiveTreeEditor.css("top", offset.y + 1);
                                //curActiveTreeEditor.css("border", "none");
                                //curActiveTreeEditor.css("width", offset.width - 2);
                                //curActiveTreeEditor.css("height", offset.height - 2);
                                //curActiveTreeEditor.attr("row", selectEditorCurRow);
                                //curActiveTreeEditor.attr("col", selectEditorCurCol);
                                //$("#ztreeInput").css("font-size", cell.getFontSize());

                                //var loadTreeData = function (treeNodes) {
                                //    if (!treeNodes || treeNodes.length && treeNodes.length == 0) {
                                //        return;
                                //    }

                                //    var onTreeClick = function (event, treeId, treeNode) {
                                //        $("#ztreeInput").combobox("setText", treeNode.name).combobox("hidePanel");
                                //        var col = parseInt(curActiveTreeEditor.attr("col"));
                                //        var row = parseInt(curActiveTreeEditor.attr("row"));
                                //        var curCell = new RO.GridHtml5.Cell(grid.getCell(col, row), editorData.gridModel);
                                //        var showText = getShowText(vm, treeNode && treeNode.id || "", treeNode && treeNode.name || "");
                                //        curCell.setValue(showText, treeNode && treeNode.id || "");
                                //        grid.select({ x: col, y: row, width: 1, height: 1 });
                                //        grid.focus();
                                //    };

                                //    var treeSetting = {
                                //        view: {
                                //            showLine: false,
                                //            showIcon: false
                                //        },
                                //        data: { simpleData: { enable: true } },
                                //        callback: { onClick: onTreeClick }
                                //    };

                                //    var treeUl = $("<ul id='treeUl' class='ztree'></ul>").appendTo($("#ztreeInput").combobox("panel"));
                                //    $.fn.zTree.init(treeUl, treeSetting, treeNodes);
                                //    var zTree = $.fn.zTree.getZTreeObj("treeUl");
                                //    var node = zTree.getNodeByParam("id", value);
                                //    if (node) {
                                //        var parentNode = node.getParentNode();
                                //        zTree.expandNode(parentNode, true);
                                //        zTree.selectNode(node);
                                //    }
                                //};

                                //loadTreeData(attr);

                                //$("#ztreeInput").combobox({
                                //    url: "",
                                //    valueField: "id",
                                //    textField: "name",
                                //    width: offset.width,
                                //    height: offset.height,
                                //    noBorder: true,
                                //    transparent: true,
                                //    hideParent: false,
                                //    panelWidth: 150,
                                //    onLoadSuccess: function () {
                                //        $(this).combobox("setValue", value);
                                //    },
                                //    onClickArrow: function () {
                                //        grid.setCurrentCell(selectEditorCurCol, selectEditorCurRow);
                                //        grid.select({ x: selectEditorCurCol, y: selectEditorCurRow, width: 1, height: 1 });
                                //        grid.focus();
                                //    }
                                //});
                                //curActiveTreeEditor.show();
                                //if (editorData.action) {
                                //    $("#ztreeInput").combobox("textbox").trigger(editorData.action);
                                //}

                            default:
                        }
                    });
                });

                curDelete.unbind("click").bind("click", function () {
                    $(data.gridModel.entry).trigger(RO.Enum.Event.deleteEnum);
                    if (curAutocomplete != null && curAutocomplete.is(":visible")) {
                        curAutocomplete.hide();
                    }

                    curArrow.hide();
                    curDelete.hide();

                });

                var cellFigure = cell.getFigure();
                var offset = cellFigure.getBounds().getCopy();
                cellFigure.translateToAbsolute(offset);

                curArrow.css("left", offset.x + 1 + offset.width);
                curArrow.css("top", offset.y + offset.height - 17);
                curArrow.css("border", "none");
                curArrow.css("width", 16);
                curArrow.css("height", 15);

                curDelete.css("left", offset.x + 1 + offset.width + 18);
                curDelete.css("top", offset.y + offset.height - 17);
                curDelete.css("border", "none");
                curDelete.css("width", 16);
                curDelete.css("height", 15);
            }

            //    case RO.Enum.DataLinkEditMode.dl_DropDownEdit:
            //        if (!curActiveSelEditor) {
            //            curActiveSelEditor = $("<div id='selectEditor' style='text-align:center;vertical-align:middle;overflow:hidden;position:absolute;z-index:900;'><input id='selector'/></div>").gridHtml5Editor();
            //            $(".gridHtml5").append(curActiveSelEditor);
            //            $("#selector").combobox({
            //                onSelect: function (val) {
            //                    var parent = $(this).parent();
            //                    var col = parseInt(parent.attr("col"));
            //                    var row = parseInt(parent.attr("row"));
            //                    var curCell = new RO.GridHtml5.Cell(grid.getCell(col, row), editorData.gridModel);
            //                    curCell.setValue(val && val.text || "", val && val.id || "");
            //                    grid.select({ x: col, y: row, width: 1, height: 1 });
            //                    grid.focus();
            //                },
            //                selectCurr: function () {
            //                    var parent = $(this).parent();
            //                    var val = $("#selector").combobox("textbox").val();
            //                    if (val)
            //                        $("#selector").combobox("select", val);
            //                    var col = parseInt(parent.attr("col"));
            //                    var row = parseInt(parent.attr("row"));
            //                    grid.select({ x: col, y: row, width: 1, height: 1 });
            //                    grid.focus();
            //                }
            //            });
            //            curActiveSelEditor.unbind("click").bind("click", function (e) {
            //                grid.setCurrentCell(selectEditorCurCol, selectEditorCurRow);
            //                grid.select({ x: selectEditorCurCol, y: selectEditorCurRow, width: 1, height: 1 });
            //            });
            //        }
            //        var value = cell.getEditText();
            //        var cellFigure = cell.getFigure();
            //        var offset = cellFigure.getBounds().getCopy();
            //        cellFigure.translateToAbsolute(offset);
            //        curActiveSelEditor.css("left", offset.x + 1);
            //        curActiveSelEditor.css("top", offset.y + 1);
            //        curActiveSelEditor.css("border", "none");
            //        curActiveSelEditor.css("width", offset.width - 2);
            //        curActiveSelEditor.css("height", offset.height - 2);
            //        curActiveSelEditor.attr("row", selectEditorCurRow);
            //        curActiveSelEditor.attr("col", selectEditorCurCol);
            //        $("#selector").c("font-size", cell.getFontSize());

            //        $("#selector").combobox({
            //            url: sourceUrl,
            //            parameters: JSON.stringify({ "lid": lid, cellValue: cell.getEditText() || cell.getShowText() }),
            //            valueField: "id",
            //            textField: "text",
            //            width: offset.width,
            //            height: offset.height,
            //            noBorder: true,
            //            transparent: true,
            //            hidePanel: true,
            //            onLoadSuccess: function () {
            //                $(this).combobox("setValue", value);
            //            }
            //        });
            //        $("#selector").combobox("hidePanel");
            //        curActiveSelEditor.show();
            //        if (editorData.action) {
            //            $("#selector").combobox("textbox").trigger(editorData.action);
            //        }
            //        break;
            //    default:
            //        break;
            //}
        });
    },

    shortcutSolutions: function (data) {
        //var gridData = data.gridModel.gridData;
        var keydownFunction = function(event) {
            if (event.ctrlKey && event.shiftKey) {
                switch (event.which) {
                    case 186:
                        //;:==186.
                        event.preventDefault();
                        shortcurInputTime();
                        return false;
                }
            } else if (event.ctrlKey || event.metaKey) {
                switch (event.which) {
                case 32:
                    //Ctrl+Spacebar.
                    event.preventDefault();
                    shortcutSelectRowColumn(true);
                    break;
                case 70:
                //f==70.
                case 72:
                    //h==72.
                    event.preventDefault();
                    shortcutFindAndReplace();
                    return false;
                case 71:
                    //g==71.
                    event.preventDefault();
                    shortcutGotoLine();
                    return false;
                case 186:
                    //;:==186.
                    event.preventDefault();
                    shortcutInputDate();
                    return false;
                case 35:
                    //End 回到表格的最后个单元格.
                    event.preventDefault();
                    shortcutGotoEnd();
                    break;
                case 36:
                    //Home 回到表格的第一个单元格.
                    event.preventDefault();
                    shortcutGotoHome();
                    break;
                }

            } else if (event.shiftKey) {
                switch (event.which) {
                    case 32:
                        //SHIFT+Spacebar.
                        event.preventDefault();
                        shortcutSelectRowColumn(false);
                        break;
                }
            } else {
                switch (event.which) {
                case 27:
                    //ESC 退出编辑状态.
                    data.gridModel.editorOpened && data.gridModel.gridData.closeActiveEditor();
                    break;
                case 35:
                    //End 回到表格的最后个单元格.
                    var gridData = data.gridModel.gridData;
                    var colCount = gridData.getColCount();
                    var rowCount = gridData.getRowCount();
                    var gridCell = gridData.getCell(colCount - 1, rowCount - 1);
                    var _roCell = new RO.GridHtml5.Cell(gridCell, data.gridMode);
                    gridData.setCurrentCell(colCount - 1, rowCount - 1);
                    gridData.select({ x: colCount - 1, y: rowCount - 1, width: _roCell.getColSpan(), height: _roCell.getRowSpan() }, false);
                    break;
                case 36:
                    //Home 回到表格的第一个单元格.
                    var gridData = data.gridModel.gridData;
                    var gridCell = gridData.getCell(1, 1);
                    var _roCell = new RO.GridHtml5.Cell(gridCell, data.gridMode);
                    gridData.setCurrentCell(1, 1);
                    gridData.select({ x: 1, y: 1, width: _roCell.getColSpan(), height: _roCell.getRowSpan() }, false);
                    break;
                }
            }
            return true;
        };

        var shortcutFindAndReplace = function() {
            var dlg = $("#FindAndReplace_dialog");
            if (dlg.length == 0) {
                var dlgContent = $("<div id='findandreplaceDlg' style='width: 100%; height: 100%;'><div id='findandreplace'><div style='display:none;margin-left: 10px;' id='searchNoDataMsg' align='center'><span style='color: red;width'>没有找到数据。</span></div><div style='display:none;margin-left: 10px;' id='searchStatusMsg' align='center'><span id='statusMsg' style='color: red'>完成1处替换。</span></div><div style='display: none;margin-left: 10px;' id='searchEndOfAreaMsg' align='center'><span id='searchEndMsg' style='color: red'>到达工作表末尾，从头开始继续。</span></div><div style='table-layout:fixed;'><div style='margin-left: 10px;margin-top: 10px;'><label for='find'>查找：</label><div style='margin-top: 3px;'><input type='text' style='width:95%;height: 30px;padding-left:5px' name='searchText' id='searchText'></div></div><div style='margin-left: 10px;margin-top: 10px;'><label style='white-space:nowrap;' for='sColumn'>替换为：</label><div style='margin-top: 3px;'><input type='text' style='width:95%;height: 30px;padding-left:5px' name='replaceText' id='replaceText'></div></div><div style='clear:both;'></div><div style='margin-left: 10px;margin-top: 10px;'><label class='label1'>查找选项：</label><div style='margin-top: 3px;padding-left:0px !important;'><input style='display: none;' type='radio' name='radUp' value='1' id='radUp'></input><label style='display: none;' for='radUp'>向上</label><input style='display: none;' type='radio' style='margin-left:8px' name='radUp' value='1' id='radDown'></input><label style='display: none;' for='radDown'>向下</label><span align='right'><input type='checkbox' name='exactMatch' id='exactMatch'></input><label for='exactMatch'>全字匹配</label></span></div></div><div id='div_toolbar' align='right' class='bottomLineSep' style='margin-top: 40px; padding-top: 15px;border-top:1px solid #C0C0C0'><span id='findBtn' class='gg-button-color-blue-dark'>查找下一个</span><span id='replaceBtn' class='gg-button-color-blue-dark' style='margin-left:5px'>替换</span><span id='replaceAllBtn' class='gg-button-color-blue-dark' style='margin-left:5px'>全部替换</span><span id='find_closeBtn' class='gg-button-color-grey' style='margin-left:5px'>关闭</span></div></div></div></div></div>").gridHtml5Editor();
                $("<div/>").attr("id", "FindAndReplace_dialog").dialog({
                    closeOnEscape: true,
                    width: 450,
                    height: 310,
                    modal: true,
                    closeText: "关闭",
                    title: "查找和替换",
                    open: function (e, ui) {
                        $(this).append(dlgContent);
                        dlgContent.show();
                    }
                });

                $("#findBtn").button();
                $("#replaceBtn").button();
                $("#replaceAllBtn").button();
                $("#find_closeBtn").button();
                $("#radDown").attr("checked", true);

                $("#findBtn").on("click", findNextFunction);
                $("#replaceBtn").on("click", replaceFunction);
                $("#replaceAllBtn").on("click", replaceAllFunction);

                $("#find_closeBtn").on("click", function () {
                    $("#FindAndReplace_dialog").dialog("close");
                });
            } else {
                dlg.on("dialogopen", function () {

                }).dialog('open');
            }

            $("#searchText").focus().select();

            _hideMsg();
        };

        var shortcutGotoLine = function() {

            var gridData = data.gridModel.gridData;
            var dlg = $("#Goto_dialog");
            if (dlg.length == 0) {
                var dlgContent = $("<div id='gotodialog'><div style='margin-left: 10px;margin-top: 10px;' id='gotoLabel'>行号(1-40)(L):</div><div style='margin-left: 10px;margin-top: 5px;' style='width:100%;'><input type='text' style='width:95%;height: 30px;padding-left:5px' class='textField' id='lineNumber'></div> <div id='div_gotoToolbar' align='right' style='margin-top: 20px; padding-top: 15px;border-top:1px solid #C0C0C0'><span id='confirmBtn' class='gg-button-color-blue-dark'>确定</span><span id='goto_closeBtn' class='gg-button-color-grey' style='margin-left:5px'>取消</span></div></div>").gridHtml5Editor();
                $("<div/>").attr("id", "Goto_dialog").dialog({
                    closeOnEscape: true,
                    width: 300,
                    height: 180,
                    modal: true,
                    closeText: "关闭",
                    title: "转到行",
                    open: function (e, ui) {
                        $(this).append(dlgContent);
                        dlgContent.show();
                    }
                });

                $("#confirmBtn").button();
                $("#goto_closeBtn").button();

                $("#confirmBtn").on("click", gotoLineFunction);

                $("#goto_closeBtn").on("click", function () {
                    $("#Goto_dialog").dialog("close");
                });
            } else {
                dlg.on("dialogopen", function () {

                }).dialog('open');
            }

            var rowCount = gridData.getRowCount();
            var msg = "行号（ 1 - " + (rowCount - 1) + " ）：";
            $("#gotoLabel").html(msg);

            var currentCell = gridData.getCurrentCell();
            if (currentCell) {
                var roCell = new RO.GridHtml5.Cell(currentCell, data.gridModel);
                $("#lineNumber").val(roCell.getRowIndex());
            }
            $("#lineNumber").focus().select();
        };

        var shortcutInputDate = function() {
            var gridData = data.gridModel.gridData;
            var currentCell = gridData.getCurrentCell();
            if (currentCell) {
                var roCell = new RO.GridHtml5.Cell(currentCell, data.gridModel);
                var cellText = roCell.getEditText() || roCell.getShowText();

                var curDate = new Date();
                var formattedString = curDate.getFullYear() + "/" + (curDate.getMonth() + 1) + "/" + curDate.getDate();
                if (cellText != formattedString) {
                    var modified = data.gridModel.setValue(roCell, formattedString, formattedString, true, true);
                    if (modified) {
                        var changeValues = [];
                        changeValues.push({ row: roCell.getRowIndex(), col: roCell.getColIndex(), oldValue: cellText, newValue: formattedString, fKey: null });
                        $(data.gridModel.entry).trigger(RO.Enum.Event.valuechange, { "changeValues": changeValues });
                    }
                }
            }
        };

        var shortcurInputTime = function() {
            var gridData = data.gridModel.gridData;
            var currentCell = gridData.getCurrentCell();
            if (currentCell) {
                var roCell = new RO.GridHtml5.Cell(currentCell, data.gridModel);
                var cellText = roCell.getEditText() || roCell.getShowText();

                var curDate = new Date();
                var formattedString = curDate.getHours() + ":" + curDate.getMinutes();
                if (cellText != formattedString) {
                    var modified = data.gridModel.setValue(roCell, formattedString, formattedString, true, true);
                    if (modified) {
                        var changeValues = [];
                        changeValues.push({ row: roCell.getRowIndex(), col: roCell.getColIndex(), oldValue: cellText, newValue: formattedString, fKey: null });
                        $(data.gridModel.entry).trigger(RO.Enum.Event.valuechange, { "changeValues": changeValues });
                    }
                }
            }
        };

        var shortcutGotoHome = function() {
            var gridData = data.gridModel.gridData;
            var gridCell = gridData.getCell(1, 1);
            var _roCell = new RO.GridHtml5.Cell(gridCell, data.gridMode);
            gridData.setCurrentCell(1, 1);
            gridData.select({ x: 1, y: 1, width: _roCell.getColSpan(), height: _roCell.getRowSpan() }, false);
        };

        var shortcutGotoEnd = function() {
            var gridData = data.gridModel.gridData;
            var colCount = gridData.getColCount();
            var rowCount = gridData.getRowCount();
            var gridCell = gridData.getCell(colCount - 1, rowCount - 1);
            var _roCell = new RO.GridHtml5.Cell(gridCell, data.gridMode);
            gridData.setCurrentCell(colCount - 1, rowCount - 1);
            gridData.select({ x: colCount - 1, y: rowCount - 1, width: _roCell.getColSpan(), height: _roCell.getRowSpan() }, false);
        };

        var shortcutSelectRowColumn = function (isColumn) {
            var gridData = data.gridModel.gridData;
            var currentCell = gridData.getCurrentCell();
            if (currentCell == null) return; 

            var roCell = new RO.GridHtml5.Cell(currentCell, data.gridModel);
            var rowIndex = roCell.getRowIndex();
            var colIndex = roCell.getColIndex();

            var rowCount = gridData.getRowCount();
            var colCount = gridData.getColCount();
            if (isColumn) {
                gridData.select({ x: colIndex, y: 1, width: roCell.getColSpan(), height: rowCount - 1 }, false);
            } else {
                gridData.select({ x: 1, y: rowIndex, width: colCount - 1, height: roCell.getRowSpan() }, false);
            }
        };

        var gotoLineFunction = function() {
            var lineNum = $("#lineNumber").val();
            var result = parseInt(lineNum);
            var gridView = data.gridModel.gridData;
            var rowCount = gridView.getRowCount();
            if (!isNaN(result) && result < rowCount) {
                var colIndex = 1;
                var currentCell = gridView.getCurrentCell();
                if (currentCell != null) {
                    var roCell = new RO.GridHtml5.Cell(currentCell, data.gridModel);
                    colIndex = roCell.getColIndex();
                }
                var targetCell = gridView.getCell(colIndex, result);
                if (targetCell != null) {
                    var roTargetCell = new RO.GridHtml5.Cell(currentCell, data.gridModel);
                    var colSpan = roTargetCell.getColSpan();
                    var rowSpan = roTargetCell.getRowSpan();

                    gridView.setCurrentCell(colIndex, result);
                    gridView.select({ x: colIndex, y: result, width: colSpan, height: rowSpan }, false);
                    $("#Goto_dialog").dialog("close");
                }
            }
        };

        var findNextFunction = function() {
            var pattern = $("#searchText").val();
            var matchWhole = $("#exactMatch").prop("checked");
            //var up = $("#radUp").attr("checked");
            //var direction = ((up == true) ? -1 : 1);
            var findResult = _findNextSymbol(data.gridModel, pattern, matchWhole);
            if (findResult == -1) {
                _showSearchNoDataMsg("待查找字符串为空。");
            } else if (findResult > 0) {
                _showSearchEndOfAreaMsg();
            } else if (findResult == 0) {
                //_showSearchStatusMsg();
                _hideMsg();
            }
        };

        var replaceFunction = function() {
            var pattern = $("#searchText").val();
            var targetText = $("#replaceText").val();
            var matchWhole = $("#exactMatch").prop("checked");
            var result = _replace(data.gridModel, pattern, targetText, matchWhole);
            if (result == 0) {
                _showSearchEndOfAreaMsg();
            }
        };

        var replaceAllFunction = function() {
            var pattern = $("#searchText").val();
            var targetText = $("#replaceText").val();
            var matchWhole = $("#exactMatch").attr("checked");
            var replacedCount = _replaceAll(data.gridModel, pattern, targetText, matchWhole);
            _showSearchStatusMsg("完成 " + replacedCount + " 处替换。");
        };

        $(data.gridModel.entry).off("keydown").on("keydown", keydownFunction);

        var _findNextSymbol = function(gridModel, pattern, matchWhole) {
            if (pattern == null || pattern == "") {
                return -1;
            }
            var grid = gridModel.gridData;
            var colIndex = 0;
            var rowIndex = 0;
            var currentCell = grid.getCurrentCell();
            if (currentCell) {
                colIndex = currentCell.cell.colIndex;
                rowIndex = currentCell.cell.rowIndex;
            }

            var colCount = grid.getColCount();
            var rowCount = grid.getRowCount();

            for (var col = colIndex + 1; col < colCount; col++) {
                var gridCell = grid.getCell(col, rowIndex);
                var roCell = new RO.GridHtml5.Cell(gridCell, gridModel);
                var mergeInfo = roCell.getMergedInfo();
                if (mergeInfo != null)
                    continue; //跳过合并单元格.

                var cellText = roCell.getEditText() || roCell.getShowText();
                if (cellText == null) continue;

                if (!matchWhole && cellText.indexOf(pattern) >= 0) {
                    grid.setCurrentCell(col, rowIndex);
                    grid.select({ x: col, y: rowIndex, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                    return 0;
                } else if (matchWhole && cellText == pattern) {
                    grid.setCurrentCell(col, rowIndex);
                    grid.select({ x: col, y: rowIndex, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                    return 0;
                }
            }


            for (var row = rowIndex + 1; row < rowCount; row++) {
                for (var col = 1; col < colCount; col++) {
                    if (col > colIndex || row > rowIndex) {
                        var gridCell = grid.getCell(col, row);
                        var roCell = new RO.GridHtml5.Cell(gridCell, gridModel);
                        var mergeInfo = roCell.getMergedInfo();
                        if (mergeInfo != null)
                            continue; //跳过合并单元格.

                        var cellText = roCell.getEditText() || roCell.getShowText();
                        if (cellText == null) continue;

                        if (!matchWhole && cellText.indexOf(pattern) >= 0) {
                            grid.setCurrentCell(col, row);
                            grid.select({ x: col, y: row, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                            return 0;
                        } else if (matchWhole && cellText == pattern) {
                            grid.setCurrentCell(col, row);
                            grid.select({ x: col, y: row, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                            return 0;
                        }
                    }
                }
            }
            
            var cell0 = grid.getCell(1, 1);
            var roCell0 = new RO.GridHtml5.Cell(cell0, gridModel);
            grid.setCurrentCell(1, 1);
            grid.select({ x: 1, y: 1, width: roCell0.getColSpan(), height: roCell0.getRowSpan() }, false);
            return 1;
        };

        var _replace = function (gridModel, pattern, targetText, matchWhole) {

            var grid = gridModel.gridData;

            var colCount = grid.getColCount();
            var rowCount = grid.getRowCount();

            for (var row = 1; row < rowCount; row++) {
                for (var col = 1; col < colCount; col++) {
                    var gridCell = grid.getCell(col, row);
                    var roCell = new RO.GridHtml5.Cell(gridCell, gridModel);
                    var mergeInfo = roCell.getMergedInfo();
                    if (mergeInfo != null)
                        continue; //跳过合并单元格.

                    var cellText = roCell.getEditText() || roCell.getShowText();
                    if (cellText == null) continue;

                    if (!matchWhole && cellText.indexOf(pattern) >= 0) {
                        var finalStr = cellText.replace(new RegExp(pattern, "gm"), targetText);
                        //gridCell.setValue(finalStr, finalStr, true, null, true);
                        gridModel.setValue(roCell, finalStr, finalStr, true, true);
                        grid.setCurrentCell(col, row);
                        grid.select({ x: col, y: row, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                        var changeValues = [];
                        changeValues.push({ row: row, col: col, oldValue: cellText, newValue: targetText, fKey: null });
                        $(gridModel.entry).trigger(RO.Enum.Event.valuechange, { "changeValues": changeValues });
                        return 1;
                    } else if (matchWhole && cellText == pattern) {
                        //gridCell.setValue(targetText, targetText, true, null, true);
                        gridModel.setValue(roCell, targetText, targetText, true, true);
                        grid.setCurrentCell(col, row);
                        grid.select({ x: col, y: row, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                        var changeValues = [];
                        changeValues.push({ row: row, col: col, oldValue: cellText, newValue: targetText, fKey: null });
                        $(gridModel.entry).trigger(RO.Enum.Event.valuechange, { "changeValues": changeValues });
                        return 1;
                    }
                }
            }

            return 0;
        };

        //全部替换.
        var _replaceAll = function (gridModel, pattern, targetText, matchWhole) {
            var grid = gridModel.gridData;
            var changeValues = [];
            var modified = false;
            var replacedCount = 0;
            var colCount = grid.getColCount();
            var rowCount = grid.getRowCount();

            for (var row = 1; row < rowCount; row++) {
                for (var col = 1; col < colCount; col++) {
                    var gridCell = grid.getCell(col, row);
                    var roCell = new RO.GridHtml5.Cell(gridCell, gridModel);
                    var mergeInfo = roCell.getMergedInfo();
                    if (mergeInfo != null)
                        continue; //跳过合并单元格.

                    var cellText = gridCell.cell.editText || gridCell.cell.showText;
                    if (cellText == null) continue;

                    if (!matchWhole && cellText.indexOf(pattern) >= 0) {
                        var finalStr = cellText.replace(new RegExp(pattern, "gm"), targetText);
                        modified = gridModel.setValue(roCell, finalStr, finalStr, true, true);
                        if (modified)
                            changeValues.push({ row: row, col: col, oldValue: cellText, newValue: finalStr, fKey: null });
                        replacedCount++;
                    } else if (matchWhole && cellText == pattern) {
                        modified = gridModel.setValue(roCell, targetText, targetText, true, true);
                        if (modified)
                            changeValues.push({ row: row, col: col, oldValue: cellText, newValue: pattern, fKey: null });
                        replacedCount++;
                    }
                }
            }
            
            if (changeValues.length > 0) {
                $(gridModel.entry).trigger(RO.Enum.Event.valuechange, { "changeValues": changeValues });
            }
            
            return replacedCount;
        };

        var _hideMsg = function () {
            $("#div_toolbar").css("margin-top", "40px");
            $("#searchNoDataMsg").hide();
            $("#searchStatusMsg").hide();
            $("#searchEndOfAreaMsg").hide();
        };

        //显示查找无数据或者字符串为空.
        var _showSearchNoDataMsg = function (msg) {
            $("#div_toolbar").css("margin-top", "24px");
            if (msg) {
                $($("#searchNoDataMsg").children()[0]).html(msg);
            }
            $("#searchNoDataMsg").show();
            $("#searchStatusMsg").hide();
            $("#searchEndOfAreaMsg").hide();
        };

        //显示查找状态.
        var _showSearchStatusMsg = function (msg) {
            $("#div_toolbar").css("margin-top", "24px");
            $("#searchNoDataMsg").hide();
            if (msg) {
                $("#statusMsg").html(msg);
            }
            $("#searchStatusMsg").show();
            $("#searchEndOfAreaMsg").hide();
        };

        //显示查找到表格末尾.
        var _showSearchEndOfAreaMsg = function () {
            $("#div_toolbar").css("margin-top", "24px");
            $("#searchNoDataMsg").hide();
            $("#searchStatusMsg").hide();
            $("#searchEndOfAreaMsg").show();
        };
    }
});

///////填充序列//////
///纯数字序列///
function GridNumIter(incre) {
    this.incre = incre;

    if (typeof GridNumIter._initialized == "undefined") {
        GridNumIter.prototype.next = function (last) {
            var lastStr = last.toString();
            var result = +last + this.incre;
            result = parseFloat(result.toFixed(10));
            var resultLength = result.toString().length;
            if (lastStr.charAt(0) == "0" && result > 0 && resultLength < lastStr.length) {
                result = new Array(lastStr.length - resultLength).join("0") + "0" + result; // 开头填充0
            }
            return result;
        };

        GridNumIter._initialized = true;
    }
}

///年月日序列///
function GridYMDIter(incre) {
    this.incre = incre;

    if (typeof GridYMDIter._initialized == "undefined") {
        GridYMDIter.prototype.next = function (last) {
            var lastStr = new Date(last.toString());
            var result = new Date(lastStr.getTime() + this.incre * 24 * 3600 * 1000);
            var year = result.getFullYear();
            var month = result.getMonth() + 1;
            if (month < 10) {
                month = "0" + month;
            }
            var day = result.getDate();
            if (day < 10) {
                day = "0" + day;
            }
            result = year + "/" + month + "/" + day;
            return result;
        };

        GridYMDIter._initialized = true;
    }
}

///星期序列///
GridWeekIter.WeekToNum = { "星期一": 1, "星期二": 2, "星期三": 3, "星期四": 4, "星期五": 5, "星期六": 6, "星期日": 0 };
function GridWeekIter(incre) {
    this.incre = incre;

    if (typeof GridWeekIter._initialized == "undefined") {
        GridWeekIter.prototype.WeekToNum = GridWeekIter.WeekToNum;
        GridWeekIter.prototype.NumToWeek = { 1: "星期一", 2: "星期二", 3: "星期三", 4: "星期四", 5: "星期五", 6: "星期六", 0: "星期日" };
        GridWeekIter.prototype.next = function (last) {
            if (last === undefined || this.WeekToNum[last] === undefined) {
                return last;
            }
            var num = (this.WeekToNum[last] + this.incre) % 7;
            if (num < 0) {
                num = 7 + num;
            }
            return this.NumToWeek[num];
        };

        GridWeekIter._initialized = true;
    }
}

///月份序列///
GridMonthIter.MonthToNum = { "一月": 1, "二月": 2, "三月": 3, "四月": 4, "五月": 5, "六月": 6, "七月": 7, "八月": 8, "九月": 9, "十月": 10, "十一月": 11, "十二月": 0 };
function GridMonthIter(incre) {
    this.incre = incre;

    if (typeof GridMonthIter._initialized == "undefined") {
        GridMonthIter.prototype.MonthToNum = GridMonthIter.MonthToNum;
        GridMonthIter.prototype.NumToMonth = { 1: "一月", 2: "二月", 3: "三月", 4: "四月", 5: "五月", 6: "六月", 7: "七月", 8: "八月", 9: "九月", 10: "十月", 11: "十一月", 0: "十二月" };
        GridMonthIter.prototype.next = function (last) {
            if (last === undefined || this.MonthToNum[last] === undefined) {
                return last;
            }
            var num = (this.MonthToNum[last] + this.incre) % 12;
            if (num < 0) {
                num = 12 + num;
            }
            return this.NumToMonth[num];
        };

        GridMonthIter._initialized = true;
    }
}

///字母序列///
GridLetterIter.LetterToNum = { "A": 1, "B": 2, "C": 3, "D": 4, "E": 5, "F": 6, "G": 7, "H": 8, "I": 9, "J": 10, "K": 11, "L": 12, "M": 13, "N": 14, "O": 15, "P": 16, "Q": 17, "R": 18, "S": 19, "T": 20, "U": 21, "V": 22, "W": 23, "X": 24, "Y": 25, "Z": 0 };
function GridLetterIter(incre) {
    this.incre = incre;

    if (typeof GridLetterIter._initialized == "undefined") {
        GridLetterIter.prototype.LetterToNum = GridLetterIter.LetterToNum;
        GridLetterIter.prototype.NumToLetter = { 1: "A", 2: "B", 3: "C", 4: "D", 5: "E", 6: "F", 7: "G", 8: "H", 9: "I", 10: "J", 11: "K", 12: "L", 13: "M", 14: "N", 15: "O", 16: "P", 17: "Q", 18: "R", 19: "S", 20: "T", 21: "U", 22: "V", 23: "W", 24: "X", 25: "Y", 0: "Z" };
        GridLetterIter.prototype.next = function (last) {
            var upperV = last === undefined ? '' : last.toString().toUpperCase();
            if (this.LetterToNum[upperV] === undefined) {
                return last;
            }
            var num = (this.LetterToNum[upperV] + this.incre) % 26;
            if (num < 0) {
                num = 26 + num;
            }
            if (last === upperV) {
                return this.NumToLetter[num];
            }
            return this.NumToLetter[num].toLowerCase();
        };

        GridLetterIter._initialized = true;
    }
}

///字符数字组合序列///
function GridNumCompoIter(incre) {
    this.incre = incre;

    if (typeof GridNumCompoIter._initialized == "undefined") {
        GridNumCompoIter.prototype.next = function (last) {
            var lastStr = last.toString();
            var lstNumStr = last.match(/\d+/).toString();
            var resultNum = +lstNumStr + this.incre;
            if (resultNum < 0) {
                resultNum = +last.match(/\d+/) - this.incre;
                this.incre = -this.incre;
            }
            var resultNumLength = resultNum.toString().length;
            if (lstNumStr.charAt(0) == "0" && resultNum > 0 && resultNumLength < lstNumStr.length) {
                resultNum = new Array(lstNumStr.length - resultNumLength).join("0") + "0" + resultNum; // 开头填充0
            }
            var result = lastStr.replace(/\d+/, resultNum);
            return result;
        };

        GridNumCompoIter._initialized = true;
    }
}
