﻿(function ($) {
    $.startLayout = function () {
        $.bodyLoaded = true;
        //$.layout.defaults.panes.closable = false;
        $.layout.defaults.panes.resizable = false;
        $.layout.defaults.panes.slidable = false;
        $.layout.defaults.panes.spacing_open = 0;
        $.layout.defaults.panes.spacing_closed = 0;
        $.layout.defaults.showErrorMessages = false;
        $("body").JcpLayout();
    };
    
    function buildOption(el, opt) {
        opt.north__paneSelector = "[top]";
        opt.south__paneSelector = "[bottom]";
        opt.west__paneSelector = "[left]";
        opt.east__paneSelector = "[right]";
        opt.center__paneSelector = "[center]";

        var children = el.children(), elWidth = parseInt(el.css("width")), elCWidth;
        for (var i = 0; i < children.length; i++) {
            var child = children.eq(i);
            var tmp = null;
            if (child.attr("top")) {
                opt.north__size = parseInt(child.css("height"));
                tmp = "north__childOptions";
            }
            else if (child.attr("bottom")) {
                opt.south__size = parseInt(child.css("height"));
                tmp = "south__childOptions";

            }
            else if (child.attr("left")) {
                elCWidth = parseInt(child.css("width"));
                if (elCWidth && elCWidth < elWidth) {
                    opt.west__size = elCWidth;
                   tmp = "west__childOptions";
               }

            }
            else if (child.attr("right")) {
                elCWidth = parseInt(child.css("width"));
                if (elCWidth && elCWidth < elWidth) {
                    opt.east__size = elCWidth;
                    tmp = "east__childOptions";
                }

            }
            else if (child.attr("center")) {
                tmp = "center__childOptions";
            }
            
            if (tmp && child.attr("layout")) {
                opt[tmp] = {};
                buildOption(child, opt[tmp]);
            }
        }
    }

    $.fn.JcpLayout = function () {
        if (!$.bodyLoaded)
            return this;

       if (this.attr("layout")) {
           var opt = {};
           buildOption(this, opt);

           if (this.data("layout")) {
               this.data("layout").destroy();
           }
           this.layout(opt);
       }

        return this;
    };
})(jQuery);