$.Class("ChangePswByCheckCode", {
	construct: function() {},

	onEntry: function() {
		var me = this;
		var isFirstShow = true,
			isClose = false,
			clickCheck = false;
		mui.plusReady(function() {
			plus.webview.currentWebview().setStyle({
			    softinputMode: "adjustResize"  // 弹出软键盘时自动改变webview的高度，解决header跟着内容滚动的问题
			});
			var phone = localStorage.getItem("currentUserLoginName");
			document.getElementById("telphone").value = phone;

			var curView = plus.webview.currentWebview();
			curView.addEventListener("close", function() {
				isClose = true;
			});

			document.getElementById("btnSendCheckCode").addEventListener('tap', function() {
				var phonenum = $.trim($("#telphone").val());
				me.onCheckPhone(phonenum);
				if (me._check) {
					var url = $.BaseUrl + "MyAccount/Account/SendPhoneCheckCode";
					var data = {
						phoneNumber: phonenum
					};
					$.doAction(url, data, function(result) {
						if (result == "Success") {
							plus.nativeUI.toast("验证码发送成功");
							me.onResend();
						}
					}, true, function() {
						plus.nativeUI.closeWaiting();
					}, {
						"jcpDoReLogin": true
					}, true);
				}
			});

			$("#newpsw").blur(function() {
				if (isClose)
					return;
				$("#newpsw").val($.trim($("#newpsw").val()));
				var newpsw = $("#newpsw").val();
				me.onCheckNewPsw(newpsw, $("#oldpsw").val());
			});

			$("#Confirmpsw").blur(function() {
				if (isClose)
					return;
				$("#Confirmpsw").val($.trim($("#Confirmpsw").val()));
				me.onCheckNewPswTwo($("#newpsw").val());
			});

			document.getElementById('btnChangePsw').addEventListener('tap', function(e) {
				var phonenum = $.trim($("#telphone").val());
				var telcode = $.trim($("#telcode").val());
				me.onCheckPhone(phonenum);
				if (me._check) {
					if (clickCheck){
						return;
					}
					clickCheck = true;
					var url = $.BaseUrl + "MyAccount/Account/CheckPhoneCheckCode";
					$.doAction(url, {
						inputnum: phonenum,
						inputcode: telcode
					}, function(result) {
						if (result == "Success") {
							var newpsw = $("#newpsw").val();
							me.onCheckNewPswTwo(newpsw);
							if (me._check) {
								me.onDoChangePsw(phonenum, newpsw);
							}
							setTimeout(function(){
									clickCheck = false;
							}, 1000);
						} else {
							mui.toast(result);
							clickCheck = false;
						}
					}, null, null, null, true);
				}
			});
		}); //plusReady
	}, //onEntry

	//被调用的函数
	onCheckPhone: function(phonenum) {
		if (phonenum == "") {
			plus.nativeUI.toast("手机号码不能为空！");
		} else {
			if (!IsPhoneNumber(phonenum)) {
				plus.nativeUI.toast("请输入正确的手机号！");
				this._check = false;
			} else {
				this._check = true;
			}
		}
	},

	onResend: function() {
		var remainTime = 59;
		$("#btnSendCheckCode").attr("disabled", "true");
		document.getElementById("btnSendCheckCode").innerHTML = remainTime + " 秒后重新发送";
		timeInterval = window.setInterval(function() {
			if (remainTime == 0) {
				$("#btnSendCheckCode").removeAttr("disabled");
				document.getElementById("btnSendCheckCode").innerHTML = "重新发送";
				$("#btnSendCheckCode").val("重新发送");
				window.clearInterval(timeInterval);
			} else {
				remainTime--;
				document.getElementById("btnSendCheckCode").innerHTML = remainTime + " 秒后重新发送";
			}
		}, 1000);
	},

	onCheckNewPsw: function(newpsw, oldpsw) {
		if (newpsw === '') {
			plus.nativeUI.toast("新密码不能为空！");
			this._check = false;
		} else if (newpsw.length < 8) {
			plus.nativeUI.toast("新密码长度少于8个字符！");
			this._check = false;
		} else {
			var regex = new RegExp('^([0-9]{8,80}|[a-zA-Z]{8,80})$');
			if(regex.test(newpsw)) {				
            	plus.nativeUI.toast("新密码应至少包含数字和英文字母");
            	this._check = false;
            }else {
				this._check = true;
				}
		}
	},

	onCheckNewPswTwo: function(newpsw) {
		if (!newpsw.replace(/(^s*)|(s*$)/g, "").length == 0) {
			var checkpsw = $("#Confirmpsw").val();
			if (newpsw != checkpsw) {
				plus.nativeUI.toast("两次输入的密码不一致!");
				this._check = false;
			} else {
				this._check = true;
			}
		}
	},

	onDoChangePsw: function(account, newpsw) {
		var url = $.BaseUrl + "Account/RemoteSetPassword";
		$.doAction(url, {
			Account: account,
			newPsw: newpsw
		}, function(result) {
			if (result.message == "Success") {
				plus.nativeUI.toast("修改密码成功");
				mui.back();
			} else {
				plus.nativeUI.toast("修改密码失败");
			}
		});
	}
});