BM_ServiceName_FormHelper = 'formHelper';
MSG_PeriodSelector_AfterSelect = 'msg_periodselector_afterselect';
$.Class("BM_TotalResultShow", MvcModel, {
	//当前任务.
    _taskObject: {},
    //当前激活的表单对象.
    _activedFormObject: {},    
    _formHelper: {},
    _taskId: 0, 
    _dataInput: null,   
    _allNumDataFields:[],
    _isRefreshing: false,
    Context: {
        UserId: null,
        TaskId: 0,
        Period: null,
        PeriodTitle: null,
        PeriodType: null,
        EntityKey: null,
        TaskType: null,
        TaskCreater: null,
        FormId: 0,
        FormType: null,
        IsLeafNode: false,
        IsExperTask: false,
        ShareToken: null,
        PeriodCount: 0,
        EntityNodes: {},
        EntityFilledPeriods: null,
        AllPeriods: [],
        SharedPeriods: [],
        SelectedEntityExtInfo: null,
        IsTempPeriod: false
    },
    
    Status: {
        ReadOnly: false,
        GatherType: null,
        IsModified: false,
        IsTaskOwner: false
    },
    
    construct: function() {
    	this._super().construct.call(this);
    },
    
    onEntry: function() {
    	var self = this;
    	this._super().onEntry.call(this); 
  		this.addListener(MSG_PeriodSelector_AfterSelect, this.onPeriodSelected, this);
    	
		this.PeriodSelector = $.New(PeriodSelector);
    	
    	mui.init({
			pullRefresh: {
				container: '#resultcontent',
				down: {
					callback: pulldownRefresh
				}
			}
		});
		
		function pulldownRefresh(){
			setTimeout(function(){
				self._isRefreshing = true;
				var url = $.BaseUrl + "FillResult/LoadTotalResultData?period=" + self.Context.Period +"&entityKey=" + self.Context.EntityKey +"&_taskId_=" + self.Context.TaskId;
				self._action(url, {}, function(result) {
					if (result.errorMsg && result.errorMsg.length > 0) {
						mui.toast(result.errorMsg );					
					} else {	
						self._renderData(result.summaryResult);	
					}
					self._isRefreshing = false;
					mui('#resultcontent').pullRefresh().endPulldownToRefresh();
				}, true, function (xhr, type, errorThrown) {
		            self._isRefreshing = false;
					mui('#resultcontent').pullRefresh().endPulldownToRefresh();
		       });
			},1500);
			
		};
		
    	document.addEventListener(mui.readyEvt_Jcp, function() {
    		/*self._taskId = mui.currentWebview.taskId;
    		self.Context.TaskId = mui.currentWebview.taskId;
    		self.Context.TaskType = mui.currentWebview.taskType;
    		self.Context.SelectedEntityExtInfo = mui.currentWebview.selectedEntityExtInfo;
	        self.Context.EntityKey = mui.currentWebview.entityKey;
	        self.Context.ShareToken = mui.currentWebview.shareToken;
	        self.Context.IsLeafNode = mui.currentWebview.isLeafNode;          
	        self.Context.PeriodCount = mui.currentWebview.periodCount;
	        self.Context.Period = mui.currentWebview.period;
	        self.Context.PeriodTitle = mui.currentWebview.periodTitle;
	        self.Context.PeriodType = mui.currentWebview.periodType;
	        self.Context.IsTempPeriod = mui.currentWebview.isTempPeriod;
	        self.Context.EntityNodes = mui.currentWebview.entityNodes;
	        
	        self._init();  	
    		self._bindEvent();*/
    		$("#detailresultbtn").unbind("click").bind("click",function() {
    			self._goToDatainput(self._taskId);
    		});
    	}); 
    	
    	window.addEventListener('datashow', function(event){
    		self._taskId = event.detail.taskId;
    		self.Context.TaskId = event.detail.taskId;
    		self.Context.TaskType = event.detail.taskType;
    		self.Context.SelectedEntityExtInfo = event.detail.selectedEntityExtInfo;
	        self.Context.EntityKey = event.detail.entityKey;
	        self.Context.ShareToken = event.detail.shareToken;
	        self.Context.IsLeafNode = event.detail.isLeafNode;          
	        self.Context.PeriodCount = event.detail.periodCount;
	        self.Context.Period = event.detail.period;
	        self.Context.PeriodTitle = event.detail.periodTitle;
	        self.Context.PeriodType = event.detail.periodType;
	        self.Context.IsTempPeriod = event.detail.isTempPeriod;
	        self.Context.EntityNodes = event.detail.entityNodes;	        
	        self._init();  	
    		self._bindEvent();
    	});	
    },
    
    _action: function (path, _data, callback, async, onError, headers) {
        $.doAction(path, _data, callback, async, onError, headers);
    },

    _getPath: function (action, withPeriod, withEntity, withForm) {
        var path = action + "?taskId=" + this.Context.TaskId;
        if (withPeriod && this.Context.Period)
            path += "&period=" + this.Context.Period;
        if (withEntity && this.Context.EntityKey)
            path += "&entityKey=" + this.Context.EntityKey;
        if (withForm && this.Context.FormId)
            path += "&formId=" + this.Context.FormId;
        if (this.Context.CurrenUserId)
            path += "&_userId_=" + this.Context.CurrenUserId;
        if (this.Context.ShareToken)
            path += "&shareToken=" + this.Context.ShareToken;
        path += "&_taskId_=" + this.Context.TaskId;
        return path;
    },

    _doUrl: function (fullUrl) {
        var taskIdIndex = fullUrl.search.indexOf("_taskId_"),
			userIdIndex = fullUrl.search.indexOf("_userId_");
        if (taskIdIndex !== -1) {
            var reg = new RegExp('(^|&)' + "_taskId_" + '=([^&]*)(&|$)', 'i'),
				reg2 = new RegExp('(^|&)' + "_userId_" + '=([^&]*)(&|$)', 'i'),
				reg3 = new RegExp('(^|&)' + "shareToken" + '=([^&]*)(&|$)', 'i'),
				reg4 = new RegExp('(^|&)' + "period" + '=([^&]*)(&|$)', 'i'),
				r = window.location.search.substr(1).match(reg),
				r2 = window.location.search.substr(1).match(reg2),
				r3 = window.location.search.substr(1).match(reg3),
				r4 = window.location.search.substr(1).match(reg4);
            if (r != null)
                $._taskId_ = unescape(r[2]) - 0;
            if (r2 != null)
                $._userId_ = unescape(r2[2]);
            if (r3 != null)
                $.shareToken = unescape(r3[2]);
            if (r3 != null)
                $.period = unescape(r4[2]);
        }
    },
    
    _bindEvent: function() {
    	var self = this;
    	var container = $(".container .billform-content");
    	container.off("click", ".field-detail-btn").on("click", ".field-detail-btn", function(){
    		var data = {
    			taskId: self.Context.TaskId,
    			period: self.Context.Period,
    			entityKey: self.Context.EntityKey,
    			periodType: self.Context.PeriodType,
    			periodCount: self.Context.PeriodCount,
    			index: $(this).parent().parent().attr('index'),
    			dataLink: $(this).parent().parent().attr('datalink'),
    			allNumDataLinks: self._allNumDataFields,
    			fieldId: $(this).parent().parent().attr('fieldid'),
    			type: $(this).parent().parent().attr('fieldtype'),
    			questionTitle: $(this).parent().parent().children('.field-title-item').children('.field-title-input').text()
    		}; 
    		
	    	mui.openWindow({
	    		url:'_www/tasks/businessmodel/questionresultdetail.html',
	    		id:'questionresultdetail',
	    		createNew:true,
	    		extras:data,
	    		show:{
	    			autoShow: true
	    		},
	    		waiting:{
	    			autoShow: true,
	    			title:'正在努力加载数据……'
	    		}
	    	});

			    		
    	});
    	
    	document.addEventListener('onEntitySelect', function (event) {
            self._setEntityTitle(event.detail.entityTitle);
            self.Context.EntityKey = event.detail.entityKey;
            self.Context.IsLeafNode = event.detail.isLeaf;
            self.Context.ShareToken = event.detail.shareToken;
            self.Context.SelectedEntityExtInfo = event.detail.extInfo;

            self._AfterEntitySelected();
        });
        
        document.addEventListener('onReloadPeriod', function (event) {
            self._afterSelectPeriod(event.detail.code, event.detail.title, event.detail.isTempPeriod, function () {
                self.PeriodSelector.onReset(event.detail.code, event.detail.title, event.detail.isTempPeriod);
            });

        });
        
        mui('.mui-bar').on("tap", '#back_index', function () {
            mui.back();
        });
        
        /*mui('.mui-bar').on("tap", '#entity_current', function () {
            if (self.Context.IsAnonymous)
                return;
            mui.showWaiting('小伙伴加载中……');
            self._loadEntityData();
        });*/
                
    },       
       
    _loadResultData: function(taskId, period, entityKey){
		var self = this;		
		var url = $.BaseUrl + "FillResult/LoadTotalResultData?period=" + period +"&entityKey=" + entityKey +"&_taskId_=" + taskId;
		self._action(url, {}, function(result) {
			if (result.errorMsg && result.errorMsg.length > 0) {
				mui.toast(result.errorMsg );		
			} else {	
				self._renderData(result.summaryResult);	
			}
			mui.closeWaiting(); 
		}, true, function (xhr, type, errorThrown) {
            mui.closeWaiting();
       });
	},
	
	_init: function () {
	    var self = this;
//	    $("#period_cur_title").text(self.Context.PeriodTitle);
        //当前用户仅被共享，没有时期范围这种场景还得再考虑重新设置
        /*var hasPeriodDrop = self.Context.PeriodType != "8" || (self.Context.PeriodType == "8" && self.Context.PeriodCount > 1);
        if (!self.Context.IsAnonymous && hasPeriodDrop) {
            self.PeriodSelector.onInit(self.Context, self.Status, $("#period_current"), '2', self.Context.IsTempPeriod);
        } */           
//      self._setEntityTitle(self.Context.EntityTitle);
	    mui.showWaiting('正在加载中...');
	    self._loadResultData(self.Context.TaskId, self.Context.Period, self.Context.EntityKey);	        
    },
    
	_renderData: function(data) {
		
		var me = this;
		var billformtitle = this._taskObject.Title;
		var contentContainer = $('.container .billform-content').empty();
		var titleContainer = $('.container .billform-title').empty();

		var billformtitleStr = '<span>' + data.FilledEntitys.length + '家单位已填报，共收到' + data.DataRecordCount + '条数据。</span>';		
		titleContainer.append(billformtitleStr);
		me._allNumDataFields.length = 0;
		for(var index = 0; index < data.SummaryResultItems.length; index++){
			
			var fieldItem = data.SummaryResultItems[index];
			var qType = BM.Enum.FieldType2QuestionType[fieldItem.FieldType];
			var question = {
				ID:"question_" + fieldItem.Index,
				type:qType,		
				dataItem:fieldItem,
				billPeriod: me.Context.PeriodType
			};
			
			if(qType === "integer" || qType == "float") {
				me._allNumDataFields.push({dataLink:fieldItem.DataLinkId, title:fieldItem.Title});
			}
			var enumItem = [];
			var enumValue = [];
			if(fieldItem.EnumResult != null ) 
			{
				question.type = 'singleChoice';
				var dataCount = Object.getOwnPropertyNames(fieldItem.EnumResult).length;				
				$.each(fieldItem.EnumResult, function(key, value) {
//					enumItem.push(key.length <= 6 ? key : key.substring(0,6));
					var title = me.getEchartBarXAxisTitle(key,dataCount,null,window.innerWidth,300,80,80,80,80,null,false);
					enumItem.push(title);
					enumValue.push(value);
				});
				question.organizations = enumItem;
				question.value = enumValue;
			}
			var questionCreator = $.QuestionCreator[question.type];
 			questionCreator.renderTotalResult(contentContainer,question);
		}
				
		$("#detailresultbtn").show();			
	},
				
    _goToDatainput: function(taskId){
		var me = this;
		var datainputView = mui.getWebviewById('datainput');
		datainputView.hide();
		mui.openWindow({
			url: 'datainput/index.html',
			id: 'datainput',
			show: {
				autoShow:false,
			},
			waiting: {
				autoShow: true,
				title: '正在加载数据……'
			}
		});					
		datainputView.hide();
		plus.nativeUI.showWaiting('正在加载数据……');
		mui.fire(datainputView, "datainputshow", {
			taskId: taskId,
			peroid: me.Context.Period,
			entityKey: me.Context.EntityKey,
			taskType: me.Context.TaskType
		});	
				
	},
	
	_loadEntityData: function () {
        if (!this.Context.EntityNodes) this.Context.EntityNodes = {};
        if (this.Context.EntityNodes[this.Context.Period]) {
            this._selectEntity();
            return;
        }

        var self = this;
        var path = self._getPath($.BaseUrl + 'DataInput/Home/LoadEntityData', true);
        path += "&isMobile=true";
        self._action(path, {}, function (data) {
            self.Context.EntityNodes[self.Context.Period] = data;
            self._selectEntity();
        }, true, function (xhr, type, errorThrown) {
            mui.closeWaiting();
        });
    },

	_AfterEntitySelected: function () {
        var self = this;
        self.refreshMarkedFilledPeriods();
        self.refreshSelectedEntityExtInfo();
        self._init();
    },
    
    _selectEntity: function () {
        var self = this;
        if (self.Context.IsAnonymous)
            return;
        mui.openWindow({
            url: '../datainput/entity.html',
            id: 'entity_select',
            createNew: true,
            extras: {
                userId: self.Context.UserId,
                taskId: self.Context.TaskId,
                period: self.Context.Period,
                entityKey: self.Context.EntityKey,
                entityNodes: self.Context.EntityNodes[self.Context.Period],
                sourcePage: 'totalresult'
            },
            show: {
                autoShow: true
            },
            waiting: {
                autoShow: false
            }
        });
    },
	
	_setEntityTitle: function (title) {
        if (!title) return;
        $("#entity_cur_title").attr("title", title);
        var overlong = title && title.length > 6;
        title = overlong ? (title.substring(0, 6) + "...") : title;
        $("#entity_cur_title").text(title);
    },

    getEntityTitle: function () {
        return $("#entity_cur_title").attr("title");
    },
    
	refreshMarkedFilledPeriods: function () {
        this.PeriodSelector.refreshMarkedFilled();
    },

    refreshSelectedEntityExtInfo: function () {
        this.PeriodSelector.refreshSelectedEntityExtInfo(this.Context.SelectedEntityExtInfo);
    },
    
	onPeriodSelected: function (sender, msg) {
        if (!msg || !msg.code || !msg.title)
            return;
        this._afterSelectPeriod(msg.code, msg.title, msg.isTemp);
    },
    
    _afterSelectPeriod: function (code, title, isTemp, callback) {
        this.Context.Period = code;
        this.Context.PeriodTitle = title;
        this.Context.IsTempPeriod = isTemp;
        mui.showWaiting('数据加载中……');
        this._init();
        $("#period_cur_title").text(title);
        callback && callback();
    },
    
    /*时期*/
    _setPeriod: function () {
        var self = this;
        $("#period_cur_title").text(self.Context.PeriodTitle);
        var hasPeriodDrop = self.Context.PeriodType != "8" || (self.Context.PeriodType == "8" && self.Context.PeriodCount > 1);
        if (!self.Context.IsAnonymous && hasPeriodDrop) {
            self.PeriodSelector.onInit(self.Context, self.Status, $("#period_current"), '2', self.Context.IsTempPeriod);
        }
    },
    
    /**
	 * <li>Echarts 中axisLabel中值太长自动换行处理；经测试：360、IE7-IE11、google、火狐  * 均能正常换行显示</li>
	 * <li>处理echarts 柱状图 x 轴数据显示根据柱子间隔距离自动换行显示</li>
	 * @param title             将要换行处理x轴值
	 * @param data              
	 * @param fontSize          x轴数据字体大小，根据图片字体大小设置而定，此处内部默认为12 
	 * @param barContainerWidth         柱状图初始化所在的外层容器的宽度
	 * @param barContainerHeight        柱状图初始化所在的外层容器的高度
	 * @param xWidth            柱状图x轴左边的空白间隙 x 的值，详见echarts文档中grid属性，默认80
	 * @param x2Width           柱状图x轴邮编的空白间隙 x2 的值，详见echarts文档中grid属性，默认80
	 * @param yWidth            柱状图y轴左边的空白间隙 y 的值，详见echarts文档中grid属性，默认80
	 * @param y2Width           柱状图y轴邮编的空白间隙 y2 的值，详见echarts文档中grid属性，默认80
	 * @param insertContent     每次截取后要拼接插入的内容， 不传则默认为换行符：\n
	 * @returns titleStr        截取拼接指定内容后的完整字符串
	 * @author lixin
	 */
	getEchartBarXAxisTitle: function(title, datas, fontSize, barContainerWidth,barContainerHeight, xWidth, x2Width, yHeight, y2Height, insertContent, isXaxis){
     
	    if(!title || title.length == 0) {
	        mui.toast("截取拼接的参数值不能为空！");return false;
	    }
	    if(datas == null || datas <= 0) {
	        mui.toast("用于计算柱状图柱子个数的参数datas不合法！"); return false;
	    }
	    if(isNaN(barContainerWidth) || isNaN(barContainerHeight)) {
	        mui.toast("柱状图初始化所在的容器的宽度或高度不是一个数字");return false;
	    }
	    if(!fontSize){
	        fontSize = 12;
	    }
	    if(xWidth == null || isNaN(xWidth)) {
	        xWidth = 80;//默认与echarts的默认值一致
	    }
	    if(x2Width == null || isNaN(x2Width)) {
	        xWidth = 80;//默认与echarts的默认值一致
	    }
	    if(yHeight == null || isNaN(yHeight)) {
	        yHeight = 80;//默认与echarts的默认值一致
	    }
	    if(y2Height == null || isNaN(y2Height)) {
	        y2Height = 80;//默认与echarts的默认值一致
	    }
	    if(!insertContent) {
	        insertContent = "\n";
	    }
	    var xAxisWidth =  parseInt(barContainerWidth) - (parseInt(xWidth) + parseInt(x2Width));//柱状图x轴宽度=统计页面宽度-柱状图x轴的空白间隙(x + x2)
	    var yAxisHeight =  parseInt(barContainerHeight) - (parseInt(yHeight) + parseInt(y2Height));//柱状图y轴宽度=统计图形高度-柱状图y轴的空白间隙(y + y2)
	    var barCount = datas;                                //x轴单元格的个数（即为获取x轴的数据的条数）
	    var preBarWidth = Math.floor(xAxisWidth / barCount);        //统计x轴每个单元格的间隔	  
	    var fontCountOneRow = Math.floor(y2Height / fontSize);       //每行最多显示多少个字
	   	if(!isXaxis) {
	    	preBarWidth = Math.floor(yAxisHeight / barCount);        //统计y轴每个柱子的间隔
	    	fontCountOneRow = Math.floor(xWidth / fontSize);
	    }
	   	var preBarFontCount = Math.floor(preBarWidth / fontSize) == 0 ? 1 : Math.floor(preBarWidth / fontSize) ;  //柱状图每个柱最多可以显示几行/列字
	    /*if(preBarFontCount > 3) {    //为了x轴标题显示美观，每个标题显示留两个字的间隙，如：原本一个格能一样显示5个字，处理后一行就只显示3个字
	        preBarFontCount -= 2;
	    } else if(preBarFontCount <= 3 && preBarFontCount >= 2) {//若每个间隔距离刚好能放两个或者字符时，则让其只放一个字符
	        preBarFontCount -= 1;
	    }*/	    
	     
	    var newTitle = "";      //拼接每次截取的内容，直到最后为完整的值
	    var titleSuf = "";      //用于存放每次截取后剩下的部分
	    var rowCount = Math.ceil(title.length / fontCountOneRow);   //标题显示需要换行的次数 
	    if(rowCount > 1) {       //标题字数大于柱状图每个柱子x轴间隔所能容纳的字数，则将标题换行
	        for(var j = 1; j <= rowCount; j++) {	        	
	            if(j == 1) {	                 	                
	                if( j == preBarFontCount) {
	                	newTitle += title.substring(0, fontCountOneRow - 1) + "…";
	                	break;
	                } else {
	                	newTitle += title.substring(0, fontCountOneRow) + insertContent;
	                	titleSuf = title.substring(fontCountOneRow);    //存放将截取后剩下的部分，便于下次循环从这剩下的部分中又从头截取固定长度
	                }
	            }else {
	                var startIndex = 0;
	                var endIndex = fontCountOneRow;
	                if(titleSuf.length > fontCountOneRow) {  //检查截取后剩下的部分的长度是否大于柱状图单个柱子间隔所容纳的字数	                     
	                    if( j == preBarFontCount) {
	                    	newTitle += titleSuf.substring(startIndex, endIndex - 1) + "…";
			            	break;
			            }else {
			            	newTitle += titleSuf.substring(startIndex, endIndex) + insertContent;
	                    	titleSuf = titleSuf.substring(endIndex);    //更新截取后剩下的部分，便于下次继续从这剩下的部分中截取固定长度
			            }	                    
	                } else if(titleSuf.length > 0){
	                    newTitle += titleSuf.substring(startIndex);
	                }
	            }
	             
	        }
	    } else {
	        newTitle = title;
	    }	    
	    return newTitle;
	},
    
    _preLoadPage: function () {
        if (this.entityPage) return;

        var self = this;
        self.entityPage = mui.preload({
            url: '../datainput/entity.html',
            id: 'entity_select',
            extras: {
                userId: self.Context.UserId,
                taskId: self.Context.TaskId,
                period: self.Context.Period
            }
        });
    },
    
    onDestroy: function(){
    	this._allNumDataFields = [];
    	this._super().onDestroy.call(this);
    }
});
