﻿BM.EnumNodeObject = function (enumNodeObj) {
    BM.UndoBase.call(this);
    
    this.IsNew = (enumNodeObj && enumNodeObj.IsNew) || false;
    this.IsDirty = (enumNodeObj &&enumNodeObj.IsDirty )|| false;
    this.IsDeleted = (enumNodeObj &&enumNodeObj.IsDeleted )|| false;

    this.Code = (enumNodeObj && enumNodeObj.Code) || "";
    this.ParentCode = (enumNodeObj && enumNodeObj.ParentCode) || "";
    this.Title = (enumNodeObj && enumNodeObj.Title) || "";
    if (enumNodeObj && enumNodeObj.Order) {
        this.Order = parseInt(enumNodeObj.Order);
    } else {
        this.Order = -1;
    }
    this.Mnemonic = (enumNodeObj && enumNodeObj.Mnemonic) || "";
};

BM.EnumNodeObject.prototype = new BM.UndoBase();

BM.EnumNodeObject.prototype.markDirty = function () {
    if (this.IsNew == false) {
        if (this.IsDirty != true) {
            this.beforePropertyChanged("IsDirty", this.IsDirty, true);
            this.IsDirty = true;
            this.propertyHasChanged("IsDirty");
        }
    }
    return this;
};

BM.EnumNodeObject.prototype.markNew = function () {
    if (this.IsNew != true) {
        this.beforePropertyChanged("IsNew", this.IsNew, true);
        this.IsNew = true;
        this.propertyHasChanged("IsNew");
    }
    if (this.IsDirty != false) {
        this.beforePropertyChanged("IsDirty", this.IsDirty, false);
        this.IsDirty = false;
        this.propertyHasChanged("IsDirty");
    }
    if (this.IsDeleted != false) {
        this.beforePropertyChanged("IsDeleted", this.IsDeleted, false);
        this.IsDeleted = false;
        this.propertyHasChanged("IsDeleted");
    }
    return this;
};

BM.EnumNodeObject.prototype.markDeleted = function () {
    if (this.IsNew != false) {
        this.beforePropertyChanged("IsNew", this.IsNew, false);
        this.IsNew = false;
        this.propertyHasChanged("IsNew");
    }
    if (this.IsDirty != false) {
        this.beforePropertyChanged("IsDirty", this.IsDirty, false);
        this.IsDirty = false;
        this.propertyHasChanged("IsDirty");
    }
    if (this.IsDeleted != true) {
        this.beforePropertyChanged("IsDeleted", this.IsDeleted, true);
        this.IsDeleted = true;
        this.propertyHasChanged("IsDeleted");
    }
    return this;
};

BM.EnumNodeObject.prototype.setCode = function (newCode) {
    if (newCode == null || newCode === "")
        return null;

    if (this.Code != newCode) {
        this.beforePropertyChanged("Code", this.Code, newCode);
        this.Code = newCode;
        this.markDirty();
        this.propertyHasChanged("Code");
    }
    return this;
};

BM.EnumNodeObject.prototype.setParentCode = function (newParentCode) {
    if (newParentCode == null)
        newParentCode = "";
    
    if (this.ParentCode != newParentCode) {
        this.beforePropertyChanged("ParentCode", this.ParentCode, newParentCode);
        this.ParentCode = newParentCode;
        this.markDirty();
        this.propertyHasChanged("ParentCode");
    }
    return this;
};

BM.EnumNodeObject.prototype.setTitle = function (newTitle) {
    if (newTitle == null || newTitle === "")
        return null;

    if (this.Title != newTitle) {
        this.beforePropertyChanged("Title", this.Title, newTitle);
        this.Title = newTitle;
        this.markDirty();
        this.propertyHasChanged("Title");
    }
    return this;
};

BM.EnumNodeObject.prototype.setMnemonic = function (newMnemonic) {
    if (newMnemonic == null)
        newMnemonic = "";
    
    if (this.Mnemonic != newMnemonic) {
        this.beforePropertyChanged("Mnemonic", this.Mnemonic, newMnemonic);
        this.Mnemonic = newMnemonic;
        this.markDirty();
        this.propertyHasChanged("Mnemonic");
    }
    return this;
};

BM.EnumNodeObject.prototype.setOrder = function (newOrder) {
    if (newOrder == null)
        newOrder = "";
    if (this.Order != newOrder) {
        this.beforePropertyChanged("Order", this.Order, newOrder);
        this.Order = newOrder;
        this.markDirty();
        this.propertyHasChanged("Order");
    }
    return this;
};