﻿BM.EnumObject = function (enumObj) {
    BM.UndoBase.call(this);
    
    this.IsNew = enumObj.IsNew || false;
    this.IsDirty = enumObj.IsDirty || false;
    this.IsDeleted = enumObj.IsDeleted || false;

    this.ID = enumObj.ID;
    this.Title = enumObj.Title;
    this.Order = (enumObj && enumObj.Order) || "";
    this.TableName = (enumObj && enumObj.TableName) || "";
    this.EnumType = enumObj.EnumType;
    this.EnumDataList = new BM.BusinessList("枚举项列表");
    
    var nodes = enumObj.EnumNodeObjects || enumObj.EnumDataList;
    if(nodes){
    	for(nodeCode in nodes){
    		var tmpEnumNode = nodes[nodeCode];
    		var enumNodeObj = new BM.EnumNodeObject(tmpEnumNode);
    		this.EnumDataList.add(enumNodeObj.Code, enumNodeObj);
    	}
    }
};

BM.EnumObject.prototype = new BM.UndoBase();

BM.EnumObject.prototype.markDirty = function () {
    if (this.IsNew == false) {
        if (this.IsDirty != true) {
            this.beforePropertyChanged("IsDirty", this.IsDirty, true);
            this.IsDirty = true;
            this.propertyHasChanged("IsDirty");
        }
    }
    return this;
};

BM.EnumObject.prototype.markNew = function () {
    if (this.IsNew != true) {
        this.beforePropertyChanged("IsNew", this.IsNew, true);
        this.IsNew = true;
        this.propertyHasChanged("IsNew");
    }
    if (this.IsDirty != false) {
        this.beforePropertyChanged("IsDirty", this.IsDirty, false);
        this.IsDirty = false;
        this.propertyHasChanged("IsDirty");
    }
    if (this.IsDeleted != false) {
        this.beforePropertyChanged("IsDeleted", this.IsDeleted, false);
        this.IsDeleted = false;
        this.propertyHasChanged("IsDeleted");
    }
    return this;
};

BM.EnumObject.prototype.markDeleted = function () {
    if (this.IsNew != false) {
        this.beforePropertyChanged("IsNew", this.IsNew, false);
        this.IsNew = false;
        this.propertyHasChanged("IsNew");
    }
    if (this.IsDirty != false) {
        this.beforePropertyChanged("IsDirty", this.IsDirty, false);
        this.IsDirty = false;
        this.propertyHasChanged("IsDirty");
    }
    if (this.IsDeleted != true) {
        this.beforePropertyChanged("IsDeleted", this.IsDeleted, true);
        this.IsDeleted = true;
        this.propertyHasChanged("IsDeleted");
    }
    return this;
};

BM.EnumObject.prototype.markClean = function () {
    this.IsNew = false;
    this.IsDirty = false;
    this.IsDeleted = false;
    return this;
};

BM.EnumObject.prototype.setTitle = function (newTitle) {
    if (newTitle == null || newTitle.trim() === "")
        return null;
    newTitle = newTitle.trim();

    if (newTitle.length > 50)
        return null;

    if (this.Title != newTitle) {
        this.beforePropertyChanged("Title", this.Title, newTitle);
        this.Title = newTitle;
        this.markDirty();
        this.propertyHasChanged("Title");
    }
    return this;
};

BM.EnumObject.prototype.setEnumType = function (newEnumType) {
    if (newEnumType == null)
        return null;

    if (this.EnumType != newEnumType) {
        this.beforePropertyChanged("EnumType", this.EnumType, newEnumType);
        this.EnumType = newEnumType;
        this.markDirty();
        this.propertyHasChanged("EnumType");
    }
    return this;
};

BM.EnumObject.prototype.isDataChanged = function () {
    if (this.IsNew || this.IsDirty || this.IsDirty)
        return true;
    return false;
};