﻿BM.FormGroupObject = function (formGroupObj) {
    BM.UndoBase.call(this);

    this.ID = formGroupObj.ID;
    this.TaskId = formGroupObj.TaskId;
    this.ParentGroupID = formGroupObj.ParentGroupID ? formGroupObj.ParentGroupID : 0;

    this.IsDeleted = formGroupObj.IsDeleted;
    this.IsDirty = formGroupObj.IsDirty;
    this.IsNew = formGroupObj.IsNew;

    this.Order = formGroupObj.Order;
    this.Title = formGroupObj.Title;
};

BM.FormGroupObject.prototype = new BM.UndoBase();

BM.FormGroupObject.prototype.isDataChanged = function () {
    return this.IsNew === true||this.IsDirty === true;
};

//保存时，重新复制一份数据，以免原有数据状态被破坏.
BM.FormGroupObject.prototype.getCopyToSave = function () {
    var result = {};

    result.ID = this.ID;
    result.IsNew = this.IsNew;
    result.IsDeleted = this.IsDeleted;
    result.IsDirty = this.IsDirty;
    if (this.IsNew === true || this.IsDeleted === true || this.IsDirty === true) {
        result.TaskId = this.TaskId;
        result.ParentGroupID = this.ParentGroupID;
        result.Order = this.Order;
        result.Title = this.Title;
    }
    return result;
};

//对表单进行重命名，默认表单分组不允许编辑.
BM.FormGroupObject.prototype.setTitle = function (newName) {
    if (newName == null || newName.trim() === "")
        return null;

    newName = newName.trim();

    var mainFrame = $.m("BM_MainFrameModel");
    var currentTask = mainFrame.getCurrentTask();
    if (currentTask.isExistFormGroupByTitle(this.ID, newName))
        return null;

    if (this.Title != newName) {
        this.Title = newName;
        this.markDirty();
        this.beforePropertyChanged("Title", this.Title, newName);
        this.propertyHasChanged("Title");
    }
    return this;
};

BM.FormGroupObject.prototype.setOrder = function (newOrder) {
    if (newOrder == null || newOrder === "")
        return null;

    if (this.onInitializingReservedCount === true)
        return this;

    if (this.Order != newOrder) {
        this.beforePropertyChanged("Order", this.Order, newOrder);
        this.Order = newOrder;
        this.markDirty();
        this.propertyHasChanged("Order");
    }
    return this;
};

BM.FormGroupObject.prototype.markDirty = function () {
    if (!this.IsNew)
        this.IsDirty = true;

    return this;
};

BM.FormGroupObject.prototype.markNew = function () {
    this.IsNew = true;
    this.IsDirty = false;
    this.IsDeleted = false;
    return this;
};

BM.FormGroupObject.prototype.markDeleted = function () {
    this.IsNew = false;
    this.IsDirty = false;
    this.IsDeleted = true;
    return this;
};
