﻿//-------------------------------------------------------------------------------------------------------------------------------链接.
BM.LinkObject = function (linkObj) {
    BM.UndoBase.call(this);

    this.ID = linkObj.ID;
    this.Title = linkObj.Title ? linkObj.Title : "";
    this.Order = linkObj.Order;

    this.IsNew = linkObj.IsNew;
    this.IsDirty = linkObj.IsDirty;
    this.IsDeleted = linkObj.IsDeleted;
    this.IsHidden = linkObj.IsHidden;

    this.PosX = (linkObj.PosX == null || linkObj.PosX === "") ? 0 : linkObj.PosX;
    this.PosY = (linkObj.PosY == null || linkObj.PosY === "") ? 0 : linkObj.PosY;
    this.DataRegionID = (linkObj.DataRegionID == null || linkObj.DataRegionID === "") ? 0 : linkObj.DataRegionID;

    this.LinkExpression = linkObj.LinkExpression ? linkObj.LinkExpression : "";
    this.EditMode = (linkObj.EditMode == null || linkObj.EditMode === "") ? BM.Enum.DataLinkEditMode.dl_Default : linkObj.EditMode;
    this.EnumStyle = (linkObj.EnumStyle == null || linkObj.EnumStyle === "") ? BM.Enum.DataLinkEnumStyle.de_Code : linkObj.EnumStyle;
    this.UniqueCode = linkObj.UniqueCode;
    this.EnumSourceType = (linkObj.EnumSourceType == null) ? BM.Enum.EnumSourceType.st_Immutable : linkObj.EnumSourceType;
    this.EnumExpression = linkObj.EnumExpression ? linkObj.EnumExpression : "";
    this.DisplayMode = (linkObj.DisplayMode == null) ? BM.Enum.DataLinkDisplayMode.dm_Default : linkObj.DisplayMode;

    this.DataValidation = new BM.UndoList("审核列表");
    //if (linkObj.DataValidation != null && linkObj.DataValidation != "" && $.trim(linkObj.DataValidation) != "") {
    //var validationArray = linkObj.DataValidation.split(";");
    for (var idx in linkObj.DataValidation) {

        var tmpValidation = linkObj.DataValidation[idx];
        var validationObj = new BM.ValidationObject(tmpValidation);
        this.DataValidation.add(validationObj.ValidationType, validationObj);
    }
    //}

    this.DelDataValidation = new BM.UndoList("删除审核列表");
};

BM.LinkObject.prototype = new BM.UndoBase();

//保存时，重新复制一份数据，以免原有数据状态被破坏.
BM.LinkObject.prototype.getCopyToSave = function () {

    //检查单元格的数据有效性设置是否修改.
    var validationChanged = false;
    for (var valid in this.DataValidation) {
        var tmpValid = this.DataValidation.get(valid);
        if (tmpValid.IsNew || tmpValid.IsDirty || tmpValid.IsDeleted) {
            validationChanged = true;
            if (this.IsNew == false) {
                this.IsDirty = true;
            }
            break;
        }
    }

    var result = {};

    result.ID = this.ID;
    result.IsNew = this.IsNew;
    result.IsDirty = this.IsDirty;
    result.IsDeleted = this.IsDeleted;
    if (this.IsNew === true || this.IsDeleted === true || this.IsDirty === true || validationChanged == true) {
        result.IsHidden = this.IsHidden;
        result.Title = this.Title;
        result.Order = this.Order;
        result.PosX = this.PosX;
        result.PosY = this.PosY;
        result.DataRegionID = this.DataRegionID;
        result.LinkExpression = this.LinkExpression;
        result.EditMode = this.EditMode;
        result.EnumStyle = this.EnumStyle;
        result.UniqueCode = this.UniqueCode;
        result.EnumSourceType = this.EnumSourceType;
        result.EnumExpression = this.EnumExpression;
        result.DisplayMode = this.DisplayMode;
        //var validationArray = [];
        //for (var validId in this.DataValidation) {
        //    var validItem = this.DataValidation.get(validId);
        //    validationArray.push(validItem.toString());
        //}

        result.DataValidation = this.DataValidation;//validationArray.join(";");
    }
    return result;
};

BM.LinkObject.prototype.markDirty = function () {
    if (this.IsNew == false) {
        if (this.IsDirty != true) {
            this.beforePropertyChanged("IsDirty", this.IsDirty, true);
            this.IsDirty = true;
            this.propertyHasChanged("IsDirty");
        }
    }
    return this;
};

BM.LinkObject.prototype.markNew = function () {
    if (this.IsNew != true) {
        this.beforePropertyChanged("IsNew", this.IsNew, true);
        this.IsNew = true;
        this.propertyHasChanged("IsNew");
    }
    if (this.IsDirty != false) {
        this.beforePropertyChanged("IsDirty", this.IsDirty, false);
        this.IsDirty = false;
        this.propertyHasChanged("IsDirty");
    }
    if (this.IsDeleted != false) {
        this.beforePropertyChanged("IsDeleted", this.IsDeleted, false);
        this.IsDeleted = false;
        this.propertyHasChanged("IsDeleted");
    }
    return this;
};

BM.LinkObject.prototype.markDeleted = function () {
    
    for (var valId in this.DataValidation) {
        var validationObj = this.DataValidation.get(valId);
        if (isNaN(validationObj.FormulaID) && validationObj.FormulaID.indexOf("LinkObject") >= 0) {
            //note 循环体外进行清除.
        } else {
            validationObj.markDeleted();
            this.DelDataValidation.add(validationObj.ValidationType, validationObj);
        }
    }
    this.DataValidation.clear();

    if (this.IsNew != false) {
        this.beforePropertyChanged("IsNew", this.IsNew, false);
        this.IsNew = false;
        this.propertyHasChanged("IsNew");
    }
    if (this.IsDirty != false) {
        this.beforePropertyChanged("IsDirty", this.IsDirty, false);
        this.IsDirty = false;
        this.propertyHasChanged("IsDirty");
    }
    if (this.IsDeleted != true) {
        this.beforePropertyChanged("IsDeleted", this.IsDeleted, true);
        this.IsDeleted = true;
        this.propertyHasChanged("IsDeleted");
    }
    return this;
};

BM.LinkObject.prototype.markUnDeleted = function () {
    if (this.IsDeleted != false) {
        this.beforePropertyChanged("IsDeleted", this.IsDeleted, false);
        this.IsDeleted = false;
        this.propertyHasChanged("IsDeleted");
    }
    return this;
};

BM.LinkObject.prototype.setTitle = function (newTitle) {
    if (newTitle == null || newTitle.trim() === "")
        return null;
    newTitle = newTitle.trim();

    if (this.Title != newTitle) {
        this.beforePropertyChanged("Title", this.Title, newTitle);
        this.Title = newTitle;
        this.markDirty();
        this.propertyHasChanged("Title");
    }
    return this;
};

BM.LinkObject.prototype.setPosX = function (newPosX) {
    if (newPosX == null || newPosX === "")
        return null;

    if (isNaN(newPosX))
        return null;

    if (this.PosX != newPosX) {
        this.beforePropertyChanged("PosX", this.PosX, newPosX);
        this.PosX = newPosX;
        this.markDirty();
        this.propertyHasChanged("PosX");
    }
    return this;
};

BM.LinkObject.prototype.setPosY = function (newPosY) {
    if (newPosY == null || newPosY === "")
        return null;

    if (isNaN(newPosY))
        return null;

    if (this.PosY != newPosY) {
        this.beforePropertyChanged("PosY", this.PosY, newPosY);
        this.PosY = newPosY;
        this.markDirty();
        this.propertyHasChanged("PosY");
    }
    return this;
};

BM.LinkObject.prototype.setDataRegionID = function (newDataRegionId) {
    if (newDataRegionId == null || newDataRegionId === "")
        return null;

    if (this.DataRegionID != newDataRegionId) {
        this.beforePropertyChanged("DataRegionID", this.DataRegionID, newDataRegionId);
        this.DataRegionID = newDataRegionId;
        this.markDirty();
        this.propertyHasChanged("DataRegionID");
    }
    return this;
};

BM.LinkObject.prototype.setLinkExpression = function (newLinkExpression) {
    if (newLinkExpression == null || newLinkExpression === "")
        return null;

    if (this.LinkExpression != newLinkExpression) {
        this.beforePropertyChanged("LinkExpression", this.LinkExpression, newLinkExpression);
        this.LinkExpression = newLinkExpression;
        this.markDirty();
        this.propertyHasChanged("LinkExpression");
    }
    return this;
};

BM.LinkObject.prototype.setEditMode = function (newEditMode) {
    if (newEditMode == null || newEditMode === "")
        return null;

    if (this.EditMode != newEditMode) {
        this.beforePropertyChanged("EditMode", this.EditMode, newEditMode);
        this.EditMode = newEditMode;
        this.markDirty();
        this.propertyHasChanged("EditMode");
    }
    return this;
};

BM.LinkObject.prototype.setEnumStyle = function (newEnumStyle) {
    if (newEnumStyle == null || newEnumStyle === "")
        return null;

    if (this.EnumStyle != newEnumStyle) {
        this.beforePropertyChanged("EnumStyle", this.EnumStyle, newEnumStyle);
        this.EnumStyle = newEnumStyle;
        this.markDirty();
        this.propertyHasChanged("EnumStyle");
    }
    return this;
};

BM.LinkObject.prototype.toString = function () {
    return "链接ID【" + this.ID + "】X【" + this.PosX + "】Y【" + this.PosY + "】指标ID【" + this.LinkExpression + "】";
};

BM.LinkObject.prototype.setEnumSourceType = function (newEnumSourceType) {
    if (this.EnumSourceType != newEnumSourceType) {
        this.beforePropertyChanged("EnumSourceType", this.EnumSourceType, newEnumSourceType);
        this.EnumSourceType = newEnumSourceType;
        this.markDirty();
        this.propertyHasChanged("EnumSourceType");
    }
    return this;
};

BM.LinkObject.prototype.setEnumExpression = function (newEnumExpression) {
    if (newEnumExpression != null)
        newEnumExpression = newEnumExpression.toString();
    else
        newEnumExpression = '';
    
    if (this.EnumExpression != newEnumExpression) {
        this.beforePropertyChanged("EnumExpression", this.EnumExpression, newEnumExpression);
        this.EnumExpression = newEnumExpression;
        this.markDirty();
        this.propertyHasChanged("EnumExpression");
    }
    return this;
};

//修改数据链接的显示模式.
BM.LinkObject.prototype.setDisplayMode = function (newDisplayMode) {
    if (newDisplayMode == null || newDisplayMode === "")
        return null;

    if (this.DisplayMode != newDisplayMode) {
        this.beforePropertyChanged("DisplayMode", this.DisplayMode, newDisplayMode);
        this.DisplayMode = newDisplayMode;
        this.markDirty();
        this.propertyHasChanged("DisplayMode");
    }
    return this;
};

BM.LinkObject.prototype.copyFrom = function (sourceLink) {
    if (sourceLink == null || !(sourceLink instanceof BM.LinkObject))
        return;

    this.setTitle(sourceLink.Title);
    this.setPosX(sourceLink.PosX);
    this.setPosY(sourceLink.PosY);
    this.setDataRegionID(sourceLink.DataRegionID);
    this.setLinkExpression(sourceLink.LinkExpression);
    this.setEditMode(sourceLink.EditMode);
    this.setEnumStyle(sourceLink.EnumStyle);
    this.setEnumSourceType(sourceLink.EnumSourceType);
    this.setEnumExpression(sourceLink.EnumExpression);
    this.setDisplayMode(sourceLink.DisplayMode);
    this.setIsHidden(sourceLink.IsHidden);
};

//根据审核类型获取对应的审核设置对象.
BM.LinkObject.prototype.getValidationByType = function (validationType) {
    if (validationType == null || validationType === "")
        return null;

    return this.DataValidation[validationType];
};

BM.LinkObject.prototype.removeValidationByType = function (validationType) {
    if (validationType == null || validationType === "")
        return;

    var tmpValidationObj = this.DataValidation.get(validationType);
    if (tmpValidationObj) {
        if (!this.IsNew)
            this.markDirty();
        if (isNaN(tmpValidationObj.FormulaID) && tmpValidationObj.FormulaID.indexOf("FormulaObject") >= 0) {
            //如果要删除的指标本来就是新建的，则直接删除。   
            this.DataValidation.remove(validationType);
        } else {
            //如果带删除的指标是数据库中记录，则标记为删除.
            tmpValidationObj.markDeleted();
            this.DataValidation.remove(tmpValidationObj.ValidationType);
            this.DelDataValidation.add(tmpValidationObj.ValidationType, tmpValidationObj);
        }
    }
};

//修改数据链接的显示模式.
BM.LinkObject.prototype.setIsHidden = function (newIsHidden) {
    if (newIsHidden == null || newIsHidden === "")
        return this;

    if (this.IsHidden != newIsHidden) {
        this.beforePropertyChanged("IsHidden", this.IsHidden, newIsHidden);
        this.IsHidden = newIsHidden;
        this.markDirty();
        this.propertyHasChanged("IsHidden");
    }
    return this;
};

BM.LinkObject.prototype.hasEnumExpression = function () {
    if (this.EnumExpression == ''
        || this.EnumExpression == '0'
        || this.EnumExpression == 0)
        return false;
    return true;
};
