﻿//----------------------------------------------------------------------------------------------------------------------------区域扩展.
BM.RegionExtension = function (extensionStr) {
    BM.UndoBase.call(this);
    if (extensionStr == null
        || extensionStr == "") {
        this.OrderIndex = -1;
        this.OrderType = 0;
        this.EntityNameIndex = -1;
        return;
    }

    try {
        var tmpObj = JSON.parse(extensionStr);

        this.OrderIndex = tmpObj.OrderIndex;
        this.OrderType = tmpObj.OrderType == -1 ? 0 : tmpObj.OrderType;
        this.EntityNameIndex = tmpObj.EntityNameIndex;
    } catch (e) {
        this.OrderIndex = -1;
        this.OrderType = 0;
        this.EntityNameIndex = -1;
    }
};

BM.RegionExtension.prototype = new BM.UndoBase();

BM.RegionExtension.prototype.setOrderIndex = function (newOrderIndex) {
    if (newOrderIndex == null || newOrderIndex === "")
        return null;

    var newValue = parseInt(newOrderIndex);
    if (this.OrderIndex != newValue) {
        this.beforePropertyChanged("OrderIndex", this.OrderIndex, newValue);
        this.OrderIndex = newValue;
        this.markDirty();
        this.propertyHasChanged("OrderIndex");
    }
    return this;
};

BM.RegionExtension.prototype.setEntityNameIndex = function (newNameIndex) {
    if (newNameIndex == null || newNameIndex === "")
        return null;

    var newValue = parseInt(newNameIndex);
    if (this.EntityNameIndex != newValue) {
        this.beforePropertyChanged("EntityNameIndex", this.EntityNameIndex, newValue);
        this.EntityNameIndex = newValue;
        this.markDirty();
        this.propertyHasChanged("EntityNameIndex");
    }
    return this;
};

BM.RegionExtension.prototype.setOrderType = function (newOrderType) {
    if (newOrderType == null || newOrderType === "")
        return null;

    var newValue = parseInt(newOrderType);
    if (this.OrderType != newValue) {
        this.beforePropertyChanged("OrderType", this.OrderType, newValue);
        this.OrderType = newValue;
        this.markDirty();
        this.propertyHasChanged("OrderType");
    }
    return this;
};

BM.RegionExtension.prototype.markDirty = function () {
    if (this.IsNew == false) {
        if (this.IsDirty != true) {
            this.beforePropertyChanged("IsDirty", this.IsDirty, true);
            this.IsDirty = true;
            this.propertyHasChanged("IsDirty");
        }
    }
    return this;
};

BM.RegionExtension.prototype.getString = function () {
    var item = {};
    item.OrderIndex = this.OrderIndex;
    item.OrderType = this.OrderType;
    item.EntityNameIndex = this.EntityNameIndex;
    return JSON.stringify(item);
};

BM.RegionExtension.prototype.toString = function () {
    return JSON.stringify(this);
};

//-------------------------------------------------------------------------------------------------------------------------------区域.
BM.RegionObject = function (regionObj) {
    BM.UndoBase.call(this);

    this.ID = regionObj.ID;
    this.Title = regionObj.Title ? regionObj.Title : "";
    this.Order = regionObj.Order;

    this.IsNew = regionObj.IsNew;
    this.IsDirty = regionObj.IsDirty;
    this.IsDeleted = regionObj.IsDeleted;

    this.FormID = regionObj.FormID ? regionObj.FormID : 0;
    this.RegionKind = regionObj.RegionKind ? regionObj.RegionKind : BM.Enum.DataRegionKind.dr_Simple;
    this.InputOrderFieldID = regionObj.InputOrderFieldID ? regionObj.InputOrderFieldID : 0;
    this.RowsInFloatRegion = regionObj.RowsInFloatRegion ? parseInt(regionObj.RowsInFloatRegion) : 0; //浮动区域保留行.

    //多级浮动相关信息.
    var multiLevelStr = regionObj.MultiLevel ? regionObj.MultiLevel : "";
    this.MultiLevelInfo = new BM.MultiLevelObject(multiLevelStr);

    this.RegionLeft = regionObj.RegionLeft ? regionObj.RegionLeft : 0;
    this.RegionRight = regionObj.RegionRight ? regionObj.RegionRight : 0;
    this.RegionTop = regionObj.RegionTop ? regionObj.RegionTop : 0;
    this.RegionBottom = regionObj.RegionBottom ? regionObj.RegionBottom : 0;
    this.Links = new BM.UndoList("链接");
    for (var linkId in regionObj.Links) {
        var tmpLink = regionObj.Links[linkId];
        var linkObj = new BM.LinkObject(tmpLink);
        this.Links.add(linkObj.ID, linkObj);
    }
    this.Tables = new BM.UndoList("存储表");
    for (var tableId in regionObj.Tables) {
        var tmpTable = regionObj.Tables[tableId];
        var tableObj = new BM.TableObject(tmpTable);
        this.Tables.add(tableObj.ID, tableObj);
    }

    this.DelLinks = new BM.UndoList("删除链接");
    this.DelTables = new BM.UndoList("删除存储表");

    //数据区域扩展信息，现存储编号列，编号类型和名称列等信息.
    this.RegionExtension = new BM.RegionExtension(regionObj.RegionExtension);
};

BM.RegionObject.prototype = new BM.UndoBase();

BM.RegionObject.prototype.setRegionLeft = function (regionLeft) {
    if (regionLeft == null || regionLeft === "")
        return null;

    var newValue = parseInt(regionLeft);
    if (this.RegionLeft != newValue) {
        this.beforePropertyChanged("RegionLeft", this.RegionLeft, newValue);
        this.RegionLeft = newValue;
        this.markDirty();
        this.propertyHasChanged("RegionLeft");
    }
    return this;
};

BM.RegionObject.prototype.setRegionRight = function (regionRight) {
    if (regionRight == null || regionRight === "")
        return null;

    var newValue = parseInt(regionRight);
    if (this.RegionRight != newValue) {
        this.beforePropertyChanged("RegionRight", this.RegionRight, newValue);
        this.RegionRight = newValue;
        this.markDirty();
        this.propertyHasChanged("RegionRight");
    }
    return this;
};

BM.RegionObject.prototype.setRegionTop = function (regionTop) {
    if (regionTop == null || regionTop === "")
        return null;

    var newValue = parseInt(regionTop);
    if (this.RegionTop != newValue) {
        this.beforePropertyChanged("RegionTop", this.RegionTop, newValue);
        this.RegionTop = newValue;
        this.markDirty();
        this.propertyHasChanged("RegionTop");
    }
    return this;
};

BM.RegionObject.prototype.setRegionBottom = function (regionBottom) {
    if (regionBottom == null || regionBottom === "")
        return null;

    var newValue = parseInt(regionBottom);
    if (this.RegionBottom != newValue) {
        this.beforePropertyChanged("RegionBottom", this.RegionBottom, newValue);
        this.RegionBottom = newValue;
        this.markDirty();
        this.propertyHasChanged("RegionBottom");
    }
    return this;
};

BM.RegionObject.prototype.setTitle = function (newTitle) {
    if (newTitle == null || newTitle.trim() === "")
        return null;

    newTitle = newTitle.trim();

    if (this.Title != newTitle) {
        this.beforePropertyChanged("Title", this.Title, newTitle);
        this.Title = newTitle;
        this.markDirty();
        this.propertyHasChanged("Title");
    }
    return this;
};

//设置浮动区域的保留行数.(非浮动区域不可设置保留行数)
BM.RegionObject.prototype.setRowsInFloatRegion = function (newRowsInFloatRegion) {
    if (newRowsInFloatRegion == null || newRowsInFloatRegion === "")
        return null;

    if (this.RegionKind == BM.Enum.DataRegionKind.dr_ColList
        || this.RegionKind == BM.Enum.DataRegionKind.dr_RowList) {
        if (this.RowsInFloatRegion != newRowsInFloatRegion) {
            this.beforePropertyChanged("RowsInFloatRegion", this.RowsInFloatRegion, newRowsInFloatRegion);
            this.RowsInFloatRegion = newRowsInFloatRegion;
            this.markDirty();
            this.propertyHasChanged("RowsInFloatRegion");
        }
        return this;
    }
    return null;
};

//获取数据区域所包含的面积区域，用于判断坐标是否包含在其内.(//note 此区域为表格上的显示区域)
BM.RegionObject.prototype.getDisplayRectangle = function () {
    //if (this.RowsInFloatRegion > 0) {
    //    switch (this.RegionKind) {
    //        case BM.Enum.DataRegionKind.dr_RowList:
    //            {
    //                var rowSpan = this.RegionBottom - this.RegionTop;
    //                rowSpan = (rowSpan == 0) ? 1 : rowSpan;
    //                var height = rowSpan * this.RowsInFloatRegion;//fixed this.RowsInFloatRegion default value is 0.

    //                return { Left: this.RegionLeft, Top: this.RegionTop, Right: this.RegionRight, Bottom: this.RegionTop + height };
    //            }
    //        case BM.Enum.DataRegionKind.dr_ColList:
    //            {
    //                var colSpan = this.RegionRight - this.RegionLeft;
    //                colSpan = (colSpan == 0) ? 1 : colSpan;
    //                var width = colSpan * this.RowsInFloatRegion;

    //                return { Left: this.RegionLeft, Top: this.RegionTop, Right: this.RegionLeft + width, Bottom: this.RegionTop };
    //            }
    //        case BM.Enum.DataRegionKind.dr_Simple:
    //            {
    //                return { Left: this.RegionLeft, Top: this.RegionTop, Right: this.RegionRight, Bottom: this.RegionBottom };
    //            }
    //        case BM.Enum.DataRegionKind.dr_Scroll:
    //            {
    //                return { Left: this.RegionLeft, Top: this.RegionTop, Right: this.RegionRight, Bottom: this.RegionBottom };
    //            }
    //    }
    //}

    return { Left: this.RegionLeft, Top: this.RegionTop, Right: this.RegionRight, Bottom: this.RegionBottom };
};

//获取当前数据区域的前一个区域，用于设置当前区域链接的虚拟坐标.
BM.RegionObject.prototype.getPreRegion = function () {
    var taskObj = $.m("BM_MainFrameModel").getCurrentTask();
    var ownerForm = taskObj.getFormByID(this.FormID);
    var formRegionKind = ownerForm.getFormRegionKind();
    switch (formRegionKind) { //虚拟坐标，正常与原始坐标一致，除了该区域出现保留行.
        case BM.Enum.DataRegionKind.dr_RowList:
            {
                var preRow = this.RegionTop - 1;
                for (var regId in ownerForm.Regions) {
                    var regObj = ownerForm.Regions.get(regId);
                    if (regObj.ID != this.ID && regObj.containsRow(preRow)) {
                        return regObj;
                    }
                }
            }
            break;
        case BM.Enum.DataRegionKind.dr_ColList:
            {
                var preCol = this.RegionLeft - 1;
                for (var regId in ownerForm.Regions) {
                    var regObj = ownerForm.Regions.get(regId);
                    if (regObj.ID != this.ID && regObj.containsCol(preCol)) {
                        return regObj;
                    }
                }
            }
            break;
    }
    return null;
};

//判断当前坐标是否包含在数据区域内部.
BM.RegionObject.prototype.contains = function (col, row) {
    var regionRectangle = this.getDisplayRectangle();

    return regionRectangle.Left <= col
        && regionRectangle.Right >= col
        && regionRectangle.Top <= row
        && regionRectangle.Bottom >= row;
};

BM.RegionObject.prototype.containsCol = function (col) {
    var regionRectangle = this.getDisplayRectangle();

    return regionRectangle.Left <= col
        && regionRectangle.Right >= col;
};

BM.RegionObject.prototype.containsRow = function (row) {
    var regionRectangle = this.getDisplayRectangle();

    return regionRectangle.Top <= row
        && regionRectangle.Bottom >= row;
};

//判断两个区域是否有单元格交叉.
BM.RegionObject.prototype.isIntersected = function (regionObject2) {
    if (regionObject2 == null || !(regionObject2 instanceof BM.RegionObject))
        return false;

    var regionRectangle1 = this.getDisplayRectangle();
    var regionRectangle2 = regionObject2.getDisplayRectangle();

    //note 进行区域的交叉检查.
    return regionRectangle1.Left < regionRectangle2.Right
        && regionRectangle2.Left < regionRectangle1.Right
        && regionRectangle1.Top < regionRectangle2.Bottom
        && regionRectangle2.Top < regionRectangle1.Bottom;
};

BM.RegionObject.prototype.isDataChanged = function () {
    if (this.IsNew || this.IsDirty || this.IsDirty)
        return true;

    if (this.DelLinks.getCount() > 0 || this.DelTables.getCount() > 0)
        return true;

    for (var linkId in this.Links) {
        var linkObj = this.Links.get(linkId);
        if (linkObj.IsNew || linkObj.IsDirty || linkObj.IsDirty)
            return true;
    }

    for (var tableId in this.Tables) {
        var tableObj = this.Tables.get(tableId);
        var tableChanged = tableObj.isDataChanged();
        if (tableChanged == true)
            return true;
    }

    return false;
};

//保存时，重新复制一份数据，并精简传输内容，以免原有数据状态被破坏.
BM.RegionObject.prototype.getCopyToSave = function () {
    var result = {};

    //因为修改每一行的扩展属性时，不更新数据区域的状态，所以在此进行修复.
    var currentForm = $.m("BM_MainFrameModel").getCurrentTask().__getFormByID(this.FormID);
    var rowExtension = currentForm.getRowExtension(this.RegionTop);
    if (rowExtension && rowExtension.IsDirty == true) {
        this.IsDirty = true;
    }

    result.ID = this.ID;
    result.IsNew = this.IsNew;
    result.IsDirty = this.IsDirty;
    result.IsDeleted = this.IsDeleted;
    if (this.IsNew === true || this.IsDeleted === true || this.IsDirty === true) {
        result.Title = this.Title;
        result.Order = this.Order;
        result.FormID = this.FormID;
        result.RegionKind = this.RegionKind;
        result.InputOrderFieldID = this.InputOrderFieldID;
        result.RowsInFloatRegion = this.RowsInFloatRegion;
        result.RegionLeft = this.RegionLeft;
        result.RegionRight = this.RegionRight;
        result.RegionTop = this.RegionTop;
        result.RegionBottom = this.RegionBottom;
        //result.RegionExtension = this.RegionExtension.toString();
    }

    result.Links = new BM.BusinessList("链接");
    for (var linkId in this.Links) {
        var linkObjToSave = this.Links.get(linkId).getCopyToSave();
        if (linkObjToSave.IsDirty === true
            || linkObjToSave.IsDeleted === true
            || linkObjToSave.IsNew === true) {
            result.Links.add(linkObjToSave.ID, linkObjToSave);
        }
    }

    for (var deletedLinkId in this.DelLinks) {
        var delLink = {};
        delLink.ID = deletedLinkId;
        delLink.IsDeleted = true;
        result.Links.add(delLink.ID, delLink);
    }

    result.Tables = new BM.BusinessList("存储表");
    for (var tableId in this.Tables) {
        var tableObj = this.Tables.get(tableId).getCopyToSave();
        result.Tables.add(tableObj.ID, tableObj);
    }

    for (var deletedTableId in this.DelTables) {
        var deletedTableObj = this.DelTables.get(deletedTableId).getCopyToSave();
        result.Tables.add(deletedTableObj.ID, deletedTableObj);
    }

    return result;
};

BM.RegionObject.prototype.beforeSave = function () {
    //todo 保存表单之前，进行缓存参数的设置.
    var linksToSave = new BM.BusinessList();
    for (var linkId in this.Links) {
        var linkObj = this.Links.get(linkId);
        if (linkObj.IsDirty == true || linkObj.IsDeleted == true || linkObj.IsNew == true) {
            linksToSave.add(linkId, linkObj);
        }
    }

    for (var deletedLinkId in this.DelLinks) {
        //var deletedLinkObj = this.DelLinks.get(deletedLinkId);
        //this.Links.add(deletedLinkObj.ID, deletedLinkObj);
        var delLink = {};
        delLink.ID = deletedLinkId;
        delLink.IsDeleted = true;
        linksToSave.add(delLink.ID, delLink);
        this.DelLinks.remove(deletedLinkId);
    }
    this.Links = linksToSave;

    for (var tableId in this.Tables) {
        var tableObj = this.Tables.get(tableId);
        tableObj.beforeSave();
    }

    for (var deletedTableId in this.DelTables) {
        var deletedTableObj = this.DelTables.get(deletedTableId);
        deletedTableObj.beforeSave();

        this.Tables.add(deletedTableObj.ID, deletedTableObj);
        this.DelTables.remove(deletedTableId);
    }
};

BM.RegionObject.prototype.getRegionID = function () {
    return this.ID;
};

BM.RegionObject.prototype.getLinks = function () {
    return this.Links;
};

BM.RegionObject.prototype.getLinksCount = function () {
    return this.Links.getCount();
};

/*
* 根据链接ID获取当前数据区域下的指定链接
* @param linkId {String} 链接的ID
* @returns {LinkObject} 链接
*/
BM.RegionObject.prototype.getLinkById = function (linkId) {
    return this.Links.get(linkId);
};

/*
* 根据链接ID获取当前数据区域下的指定链接
* @param linkId {String} 链接的ID
* @returns {LinkObject} 链接
*/
BM.RegionObject.prototype.__getLinkById = function (linkId) {
    var linkObj = this.Links.get(linkId);

    if (!linkObj)
        return this.DelLinks.get(linkId);

    return linkObj;
};

/*
* 根据坐标获取当前数据区域下的指定链接
* @param col {Int32} 链接的X
* @param row {Int32} 链接的Y
* @returns {LinkObject} 链接
*/
BM.RegionObject.prototype.getLinkByPos = function (col, row) {
    for (var linkId in this.Links) {
        var linkObj = this.Links.get(linkId);
        if (linkObj.PosX == col
            && linkObj.PosY == row)
            return linkObj;
    }
    return null;
};

/*
* 根据列号获取当前数据区域下的指定列所有的链接
* @param col {Int32} 列号
* @returns {BM.BusinessList} 链接列表
*/
BM.RegionObject.prototype.getLinksByCol = function (col) {
    var result = new BM.BusinessList();
    for (var linkId in this.Links) {
        var linkObj = this.Links.get(linkId);
        if (linkObj.PosX == col)
            result.add(linkObj.ID, linkObj);
    }
    return result;
};

/*
* 根据行号获取当前数据区域下的指定行所有的链接
* @param row {Int32} 行号
* @returns {BM.BusinessList} 链接列表
*/
BM.RegionObject.prototype.getLinksByRow = function (row) {
    var result = new BM.BusinessList();
    for (var linkId in this.Links) {
        var linkObj = this.Links.get(linkId);
        if (linkObj.PosY == row)
            result.add(linkObj.ID, linkObj);
    }
    return result;
};

/*
* 根据指标ID获取当前数据区域下的指定链接，只检查当前可用的链接.
* @param fieldId {Int32/String} 链接的X
* @param row {Int32} 链接的Y
* @returns {LinkObject} 链接
*/
BM.RegionObject.prototype.getLinkByFieldId = function (fieldId) {
    for (var linkId in this.Links) {
        var linkObj = this.Links.get(linkId);
        if (linkObj.LinkExpression == fieldId)
            return linkObj;
    }
    return null;
};

BM.RegionObject.prototype.__getLinkByPos = function (col, row) {
    for (var linkId in this.Links) {
        var linkObj = this.Links.get(linkId);
        if (linkObj.PosX == col
            && linkObj.PosY == row)
            return linkObj;
    }

    //note 如果当前链接列表中找不到该链接，则从删除列表里面查找，并重复利用.
    for (var deletedLinkId in this.DelLinks) {
        var deledLinkObj = this.DelLinks.get(deletedLinkId);
        if (deledLinkObj.PosX == col
            && deledLinkObj.PosY == row)
            return deledLinkObj;
    }

    return null;
};

BM.RegionObject.prototype.getFieldById = function (fieldId) {
    for (var tableId in this.Tables) {
        var tableObj = this.Tables.get(tableId);
        var fieldObj = tableObj.getFieldById(fieldId);
        if (fieldObj)
            return fieldObj;
    }
    return null;
};

BM.RegionObject.prototype.__getFieldById = function (fieldId) {
    for (var tableId in this.Tables) {
        var tableObj = this.Tables.get(tableId);
        var fieldObj = tableObj.__getFieldById(fieldId);
        if (fieldObj)
            return fieldObj;
    }

    for (var delTableId in this.DelTables) {
        var delTableObj = this.DelTables.get(delTableId);
        var delFieldObj = delTableObj.__getFieldById(fieldId);
        if (delFieldObj)
            return delFieldObj;
    }
    return null;
};

BM.RegionObject.prototype.getTableById = function (tableId) {
    return this.Tables.get(tableId);
};

BM.RegionObject.prototype.__getTableById = function (tableId) {
    var tableObj = this.Tables.get(tableId);

    //note 如果当前指标列表中找不到该指标，则从删除列表里面查找，并重复利用.
    if (!tableObj)
        return this.DelTables.get(tableId);

    return tableObj;
};

/*
* 根据当前数据区域中可用的存储表，即存储表下指标的个数小于指定上限。
* @returns {TableObject} 可用的存储表
*/
BM.RegionObject.prototype.queryOrCreateTableObject = function () {
    var mainFrameModel = $.m("BM_MainFrameModel");
    var formHelper = mainFrameModel.getService(BM_ServiceName_FormHelper);

    for (var tableId in this.Tables) {
        var tableObj = this.Tables.get(tableId);
        if (tableObj.getFieldsCount() < formHelper.FieldsMaxCount)
            return tableObj;
    }

    var newTable = this.createTableObject();
    //todo 创建新的存储表，并返回。
    return newTable;
};

/*
* 根据坐标在当前区域下创建链接
* @param col {Int32} 链接的X
* @param row {Int32} 链接的Y
* @returns {LinkObject} 链接
*/
BM.RegionObject.prototype.createLinkByPos = function (col, row) {
    var mainFrameModel = $.m("BM_MainFrameModel");
    var formHelper = mainFrameModel.getService(BM_ServiceName_FormHelper);

    var newLinkId = formHelper.JCPGuid("LinkObject-");
    var tmpLink = {};
    tmpLink.ID = newLinkId;

    tmpLink.IsNew = true;
    tmpLink.IsDirty = false;
    tmpLink.IsDeleted = false;
    tmpLink.Title = "";//从表格上获取，类似于指标标题.

    var tmpCode = formHelper.NewUniqueCode();
    while (formHelper.CheckUniqueCodeExist(tmpCode)) {
        tmpCode = formHelper.NewUniqueCode();
    }
    tmpLink.UniqueCode = tmpCode;
    tmpLink.PosX = col;
    tmpLink.PosY = row;
    tmpLink.LinkExpression = '0';
    tmpLink.DataRegionID = this.ID;
    tmpLink.EnumExpression = 0;
    tmpLink.EditMode = BM.Enum.DataLinkEditMode.dl_None;
    tmpLink.EnumStyle = BM.Enum.DataLinkEnumStyle.de_Code;

    var newLinkObj = new BM.LinkObject(tmpLink);

    this.Links.add(newLinkObj.ID, newLinkObj);
    return newLinkObj;
};

//创建业务数据表.
BM.RegionObject.prototype.createTableObject = function () {
    var mainFrameModel = $.m("BM_MainFrameModel");
    var formHelper = mainFrameModel.getService(BM_ServiceName_FormHelper);
    var currentTask = mainFrameModel.getCurrentTask();
    var currentForm = currentTask.getFormByID(this.FormID);//mainFrameModel.getCurrentForm();

    var bizFieldGroup = currentTask.getBizTableFieldGroup();
    if (bizFieldGroup == null) {
        jAlert("未能找到业务数据表指标分组，请检查表格创建流程", "系统提示");
        return null;
    }

    var newTableId = formHelper.JCPGuid("TableObject-");
    var tmpTable = {};
    tmpTable.ID = newTableId;
    tmpTable.IsNew = true;
    tmpTable.IsDirty = false;
    tmpTable.IsDeleted = false;
    tmpTable.BizKeyFieldsStr = "";
    tmpTable.PeriodFieldID = 0;
    tmpTable.Kind = BM.Enum.TableKind.tk_BizData;

    var floatRegionCode = "";
    if (this.RegionKind == BM.Enum.DataRegionKind.dr_ColList) {
        floatRegionCode = "F" + this.RegionLeft;
    }
    else if (this.RegionKind == BM.Enum.DataRegionKind.dr_RowList) {
        floatRegionCode = "F" + this.RegionTop;
    }
    var tmpTableCode = currentTask.TaskFileFix + "_" + currentForm.Code + ((floatRegionCode != "") ? "_" + floatRegionCode : "");
    while (currentForm.isExistTableCode(tmpTableCode)) {
        tmpTableCode = formHelper.generateNewStringByTemplet(tmpTableCode);
    }
    tmpTable.Code = tmpTableCode;
    tmpTable.Fields = new BM.UndoList("指标");
    tmpTable.BizkeyFields = new BM.UndoList("业务主键");
    //note 设置存储表的业务主键.

    for (var masterFieldId in currentTask.MasterFields) {
        var srcField = currentTask.MasterFields.get(masterFieldId);
        var newField = new BM.FieldObject(srcField);
        newField.ReferField = srcField.ID;
        newField.ID = formHelper.JCPGuid("FieldObject-");
        newField.IsNew = true;
        newField.IsDirty = false;
        newField.IsDeleted = false;
        if (newField.ValueType == BM.Enum.FieldValueType.fv_PeriodValue) {
            tmpTable.PeriodFieldID = newField.ID;
        }
        newField.OwnerTableID = tmpTable.ID;
        if (tmpTable.BizKeyFieldsStr == "")
            tmpTable.BizKeyFieldsStr = newField.ID;
        else
            tmpTable.BizKeyFieldsStr = tmpTable.BizKeyFieldsStr + ";" + newField.ID;

        tmpTable.Fields.add(newField.ID, newField);
        tmpTable.BizkeyFields.add(newField.ID, newField);
    }

    if (this.RegionKind == BM.Enum.DataRegionKind.dr_ColList || this.RegionKind == BM.Enum.DataRegionKind.dr_RowList) {
        //创建顺序号指标
        var orderFieldId = formHelper.JCPGuid("FieldObject-");
        var orderField = {};
        orderField.ID = orderFieldId;
        orderField.IsNew = true;
        orderField.IsDirty = false;
        orderField.IsDeleted = false;

        //Code 由"DK3Z_MTJ46WQ2AF_F7Or" 改成 "DK3Z_MTJ46WQ_F7Order".
        var tmpFieldCode = tmpTable.Code;
        if (tmpFieldCode.length > 14)
            tmpFieldCode = tmpFieldCode.substring(0, 14);


        tmpFieldCode = tmpTable.Code + "_" + formHelper.ORDERCODE;

        orderField.Code = tmpFieldCode;
        orderField.Title = formHelper.ORDERTITLE;
        orderField.Type = BM.Enum.FieldType.ft_Integer;
        orderField.Size = 10;
        orderField.OwnerTableID = tmpTable.ID;

        orderField.Description = formHelper.ORDERDESC;
        //orderField.FieldName = tmpFieldCode;//tmpTable.Code + formHelper.ORDERCODE;
        //orderField.TableName = tmpTable.Code;

        orderField.FixedSize = false;
        orderField.FractionDigits = 0;
        orderField.Nullable = false;
        orderField.Order = "";
        orderField.ReferField = 0;
        orderField.ShowFormat = "";
        orderField.ValueType = BM.Enum.FieldValueType.fv_BizKeyOrder;

        var orderFieldObj = new BM.FieldObject(orderField);

        tmpTable.Fields.add(orderFieldObj.ID, orderFieldObj);

        if (tmpTable.BizKeyFieldsStr == "")
            tmpTable.BizKeyFieldsStr = orderFieldObj.ID;
        else
            tmpTable.BizKeyFieldsStr = tmpTable.BizKeyFieldsStr + ";" + orderFieldObj.ID;

        tmpTable.BizkeyFields.add(orderFieldObj.ID, orderFieldObj);
    }

    tmpTable.OwnerGroupID = bizFieldGroup.ID;
    var newTableObj = new BM.TableObject(tmpTable);

    this.Tables.add(newTableObj.ID, newTableObj);
    return newTableObj;
};

//数据区域判断当前区域下是否已经存在重复的存储表标识.
BM.RegionObject.prototype.isExistTableCode = function (tableCode) {
    if (tableCode == null || tableCode === "")
        return false;

    for (var tableId in this.Tables) {
        var tableObj = this.Tables.get(tableId);
        if (tableObj.Code.toUpperCase() == tableCode.toUpperCase())
            return true;
    }

    //note 由于可能出现存储表重名的现象，现判断是否存在存储表标题包含已标记为删除的存储表.
    for (var delTableId in this.DelTables) {
        var delTableObj = this.DelTables.get(delTableId);
        if (delTableObj.Code.toUpperCase() == tableCode.toUpperCase())
            return true;
    }

    return false;
};

BM.RegionObject.prototype.deleteLinkByPos = function (col, row) {
    var linkObj;
    for (var link in this.Links) {
        var tmpLinkObj = this.Links.get(link);
        if (tmpLinkObj.PosX == col && tmpLinkObj.PosY == row)
            linkObj = tmpLinkObj;
    }

    if (linkObj) {
        this.deleteLinkByID(linkObj.ID);
    }
};

BM.RegionObject.prototype.deleteLinkByID = function (linkId) {
    var linkObj = this.Links.get(linkId);
    if (linkObj) {

        //删除数据连接后，更新引用了该链接的公式.
        var mainFrame = $.m("BM_MainFrameModel");
        //var formObject = mainFrame.getCurrentForm();
        var taskObject = mainFrame.getCurrentTask();
        var formObject = taskObject.getFormByID(this.FormID);

        for (var fmId in formObject.Formulas) {
            var tempFormula = formObject.Formulas.get(fmId);
            var pattern = "[" + linkObj.UniqueCode + "]";
            var patternIndex = tempFormula.Expression.indexOf(pattern);
            if (patternIndex >= 0) {
                var newStr = "#REF!";
                var patternLength = pattern.length;
                var exprLength = tempFormula.Expression.length;
                var tmp = tempFormula.Expression.substring(0, patternIndex) + newStr + tempFormula.Expression.substring(patternIndex + patternLength, exprLength);
                tempFormula.setExpression(tmp);
            }
        }

        for (var valId in linkObj.DataValidation) {
            var validationObj = linkObj.DataValidation.get(valId);
            formObject.deleteFormula(validationObj.FormulaID);
        }

        if (isNaN(linkObj.ID) && linkObj.ID.indexOf("LinkObject") >= 0) {
            //如果要删除的指标本来就是新建的，则直接删除。   
            this.Links.remove(linkObj.ID);
        } else {
            //如果带删除的指标是数据库中记录，则标记为删除.
            linkObj.markDeleted();
            this.Links.remove(linkObj.ID);
            this.DelLinks.add(linkObj.ID, linkObj);
        }
    }
};

BM.RegionObject.prototype.__unDeleteLinkByID = function (linkId) {
    var linkObj = this.DelLinks.get(linkId);

    if (linkObj) {
        linkObj.markUnDeleted();
        this.DelLinks.remove(linkObj.ID);
        this.Links.add(linkObj.ID, linkObj);
    }
};

//链接反删除，重复利用.
BM.RegionObject.prototype.__unDeleteLinkByPos = function (col, row) {
    var linkObj;
    for (var linkId in this.DelLinks) {
        var tmpLinkObj = this.DelLinks.get(linkId);
        if (tmpLinkObj.PosX == col && tmpLinkObj.PosY == row)
            linkObj = tmpLinkObj;
    }

    if (linkObj) {
        linkObj.markUnDeleted();
        this.DelLinks.remove(linkObj.ID);
        this.Links.add(linkObj.ID, linkObj);
    }
};

//可以删除返回true，否则返回false.
BM.RegionObject.prototype.__checkTableCanDelete = function (tableId) {
    var tableObject = this.getTableById(tableId);
    if (tableObject == null)
        return false;

    if (tableObject.Fields.getCount() >= tableObject.BizkeyFields.getCount() + 2)
        return false;

    var mainFrameModel = $.m("BM_MainFrameModel");
    var formHelper = mainFrameModel.getService(BM_ServiceName_FormHelper);
    //note 指标进行转移到新的存储表的时候，判断旧的存储表是否只剩下主键，是的话，直接删除该存储表.
    //note 浮动区域发布之后，存储表会新增加一个叫做"UPDATETIME"标识的指标，如果除了主键只剩下这个指标的话，也进行删除。
    for (var fieldId in tableObject.Fields) {
        if (tableObject.BizkeyFields.containsKey(fieldId))
            continue;

        var fieldObj = tableObject.Fields.get(fieldId);
        if (fieldObj.Code.toLowerCase() == formHelper.FLOATORDERCODE.toLowerCase()
            && fieldObj.ValueType == BM.Enum.FieldValueType.fv_InputOrder)
            continue;

        var availableLinkObj = this.getLinkByFieldId(fieldObj.ID);
        if (availableLinkObj != null)
            return false;
    }
    return true;
};

BM.RegionObject.prototype.deleteTableByID = function (tableId) {
    var tableObj = this.Tables.get(tableId);
    if (tableObj) {
        if (isNaN(tableObj.ID) && tableObj.ID.indexOf("TableObject") >= 0) {
            //todo.
            if (!isNaN(tableObj.ID)) {
                var currentTask = $.m("BM_MainFrameModel").getCurrentTask();
                var currentForm = currentTask.getFormByID(this.FormID);//mainFrameModel.getCurrentForm();
                var defaultRegion = currentForm.getDefaultRegion();
                if (defaultRegion == null)
                    throw new Error("参数错误");

                tableObj.markDeleted();
                this.__moveTableToDefaultRegionForDelete(tableObj, this, defaultRegion);
            }
            //如果要删除的指标本来就是新建的，则直接删除。   
            this.Tables.remove(tableObj.ID);
        } else {
            //如果带删除的指标是数据库中记录，则标记为删除.
            tableObj.markDeleted();
            this.Tables.remove(tableObj.ID);
            this.DelTables.add(tableObj.ID, tableObj);
        }
    }
};

//存储表反删除，重复利用.
BM.RegionObject.prototype.__unDeleteTableByID = function (tableId) {
    var tableObj = this.DelTables.get(tableId);
    if (tableObj) {
        tableObj.markUnDeleted();
        this.DelTables.remove(tableId);
        this.Tables.add(tableId, tableObj);
    }
};

BM.RegionObject.prototype.markDirty = function () {
    var ownerForm = $.m("BM_MainFrameModel").getCurrentTask().getFormByID(this.FormID);
    if (ownerForm.onInitializingReservedCount === true)
        return this;

    if (this.IsNew == false) {
        if (this.IsDirty != true) {
            this.beforePropertyChanged("IsDirty", this.IsDirty, true);
            this.IsDirty = true;
            this.propertyHasChanged("IsDirty");
        }
    }
    return this;
};

BM.RegionObject.prototype.markNew = function () {
    if (this.IsNew != true) {
        this.beforePropertyChanged("IsNew", this.IsNew, true);
        this.IsNew = true;
        this.propertyHasChanged("IsNew");
    }
    if (this.IsDirty != false) {
        this.beforePropertyChanged("IsDirty", this.IsDirty, false);
        this.IsDirty = false;
        this.propertyHasChanged("IsDirty");
    }
    if (this.IsDeleted != false) {
        this.beforePropertyChanged("IsDeleted", this.IsDeleted, false);
        this.IsDeleted = false;
        this.propertyHasChanged("IsDeleted");
    }
    return this;
};

BM.RegionObject.prototype.markDeleted = function () {
    for (var linkId in this.Links) {
        var linkObj = this.Links.get(linkId);
        if (isNaN(linkObj.ID) && linkObj.ID.indexOf("LinkObject") >= 0) {
            //note 循环体外进行清除.
        } else {
            linkObj.markDeleted();
            this.DelLinks.add(linkId, linkObj);
        }
    }
    this.Links.clear();

    for (var tableId in this.Tables) {
        var tableObj = this.Tables.get(tableId);
        if (isNaN(tableObj.ID) && tableObj.ID.indexOf("TableObject") >= 0) {
            //note 循环体外进行清除.
        } else {
            tableObj.markDeleted();
            this.DelTables.add(tableId, tableObj);
        }
    }
    this.Tables.clear();

    if (this.IsNew != false) {
        this.beforePropertyChanged("IsNew", this.IsNew, false);
        this.IsNew = false;
        this.propertyHasChanged("IsNew");
    }
    if (this.IsDirty != false) {
        this.beforePropertyChanged("IsDirty", this.IsDirty, false);
        this.IsDirty = false;
        this.propertyHasChanged("IsDirty");
    }
    if (this.IsDeleted != true) {
        this.beforePropertyChanged("IsDeleted", this.IsDeleted, true);
        this.IsDeleted = true;
        this.propertyHasChanged("IsDeleted");
    }
    return this;
};

BM.RegionObject.prototype.markUnDeleted = function () {
    if (this.IsDeleted != false) {
        this.beforePropertyChanged("IsDeleted", this.IsDeleted, false);
        this.IsDeleted = false;
        this.propertyHasChanged("IsDeleted");
    }
    return this;
};

BM.RegionObject.prototype.toString = function () {
    var result = "Top【" + this.RegionTop + "】Left【" + this.RegionLeft + "】Right【" + this.RegionRight + "】Bottom【" + this.RegionBottom + "】";
    if (this.RegionKind == BM.Enum.DataRegionKind.dr_ColList || this.RegionKind == BM.Enum.DataRegionKind.dr_RowList) {
        result = result + "保留行/列数【" + this.RowsInFloatRegion + "】";
    }

    return result;
};

/*
* 根据数据链接唯一标识获取对应的链接.
* @param linkUniqueCode {String} 数据链接唯一标识
* @returns {LinkObject} 链接
*/
BM.RegionObject.prototype.getLinkByUniqueCode = function (linkUniqueCode) {
    for (var linkId in this.Links) {
        var linkObj = this.Links.get(linkId);
        if (linkObj.UniqueCode == linkUniqueCode)
            return linkObj;
    }
    return null;
};

BM.RegionObject.prototype._resetRegion = function (left, right, top, bottom) {
    var leftOffset = this.RegionLeft - left;
    var rightOffset = this.RegionRight - right;
    var topOffset = this.RegionTop - top;
    var bottomOffset = this.RegionBottom - bottom;

    for (var linkId in this.Links) {
        var linkObj = this.Links.get(linkId);

        linkObj.setPosX(linkObj.PosX - leftOffset);
        linkObj.setPosY(linkObj.PosY - topOffset);
    }

    for (var linkId in this.DelLinks) {
        var delLinkObj = this.DelLinks.get(linkId);

        delLinkObj.setPosX(delLinkObj.PosX - leftOffset);
        delLinkObj.setPosY(delLinkObj.PosY - topOffset);
    }

    this.setRegionLeft(left);
    this.setRegionRight(right);
    this.setRegionTop(top);
    this.setRegionBottom(bottom);
};

BM.RegionObject.prototype.insertCol = function (colIndex) {
    for (var linkId1 in this.Links) {
        var linkObj1 = this.__getLinkById(linkId1);
        if (linkObj1.PosX >= colIndex) {
            linkObj1.setPosX(linkObj1.PosX + 1);
        }
    }

    switch (this.RegionKind) {
        case BM.Enum.DataRegionKind.dr_Simple:
            {
                if (this.RegionRight >= colIndex
                    && this.RegionLeft <= colIndex) {
                    this.setRegionRight(this.RegionRight + 1);
                } else {
                    if (this.RegionRight > colIndex
                        && this.RegionLeft > colIndex) {
                        this.setRegionTop(this.RegionLeft + 1);
                        this.setRegionBottom(this.RegionRight + 1);
                    }
                }

            }
            break;
        case BM.Enum.DataRegionKind.dr_RowList:
            {
                this.setRegionRight(this.RegionRight + 1);
            }
            break;
        case BM.Enum.DataRegionKind.dr_ColList:
            {
                if (this.RegionLeft >= colIndex) {
                    this.setRegionLeft(this.RegionLeft + 1);
                    this.setRegionRight(this.RegionRight + 1);
                }
                if (this.RegionLeft < colIndex && this.RegionRight >= colIndex) {
                    this.setRegionRight(this.RegionRight + 1);
                }
            }
            break;
    }
};

BM.RegionObject.prototype.deleteCol = function (colIndex) {
    var delLinkIds = [];
    for (var linkId1 in this.Links) {
        var linkObj1 = this.__getLinkById(linkId1);
        if (linkObj1.PosX == colIndex && linkObj1.PosY != 0) {
            delLinkIds.push(linkId1);

            var fieldObj1 = this.getFieldById(linkObj1.LinkExpression);
            if (fieldObj1) {
                var tableObj1 = this.getTableById(fieldObj1.OwnerTableID);
                if (tableObj1) {
                    tableObj1.delFieldById(fieldObj1.ID);

                    //删除只剩下业务主键和UpdateTime指标的存储表.
                    var tableCanDelete = this.__checkTableCanDelete(tableObj1.ID);
                    if (tableCanDelete == true) {
                        this.deleteTableByID(tableObj1.ID);
                    }
                }
            }
        } else {
            if (linkObj1.PosX >= colIndex) {
                linkObj1.setPosX(linkObj1.PosX - 1);
            }
        }
    }

    for (var delLinkIdIndex = 0 ; delLinkIdIndex < delLinkIds.length; delLinkIdIndex++) {
        var delLinkId = delLinkIds[delLinkIdIndex];
        this.deleteLinkByID(delLinkId);
    }

    delLinkIds = [];
};

BM.RegionObject.prototype.appendCol = function (colIndex, appendedCount) {
    switch (this.RegionKind) {
        case BM.Enum.DataRegionKind.dr_Simple:
            {
                if (this.RegionRight == colIndex - 1) {
                    this.setRegionRight(this.RegionRight + appendedCount);
                }
            }
            break;
        case BM.Enum.DataRegionKind.dr_RowList:
            {
                this.setRegionRight(this.RegionRight + appendedCount);
            }
            break;
    }
};

BM.RegionObject.prototype.insertRow = function (rowIndex) {
    for (var linkId in this.Links) {
        var linkObj = this.__getLinkById(linkId);//已经删除的数据链接也进行相应的变化，方便以后进行重用.
        if (linkObj.PosY >= rowIndex) {
            linkObj.setPosY(linkObj.PosY + 1);
        }
    }

    switch (this.RegionKind) {
        case BM.Enum.DataRegionKind.dr_Simple:
            {
                if (this.RegionBottom >= rowIndex
                    && this.RegionTop <= rowIndex) {
                    this.setRegionBottom(this.RegionBottom + 1);
                } else {
                    if (this.RegionBottom > rowIndex
                        && this.RegionTop > rowIndex) {
                        this.setRegionTop(this.RegionTop + 1);
                        this.setRegionBottom(this.RegionBottom + 1);
                    }
                }
            }
            break;
        case BM.Enum.DataRegionKind.dr_RowList:
            {
                if (this.RegionTop < rowIndex
                    && this.RegionBottom >= rowIndex) {
                    this.setRegionBottom(this.RegionBottom + 1);
                }

                if (this.RegionTop >= rowIndex) {
                    this.setRegionTop(this.RegionTop + 1);
                    this.setRegionBottom(this.RegionBottom + 1);
                }

                if (this.RegionTop > rowIndex
                    && this.RegionBottom <= rowIndex) {
                    this.setRegionBottom(this.RegionBottom + 1);
                }
                if (this.RegionBottom == rowIndex - 1) {
                    this.setRegionBottom(this.RegionBottom + 1);
                }
            }
            break;
        case BM.Enum.DataRegionKind.dr_ColList:
            {
                this.setRegionBottom(this.RegionBottom + 1);
            }
            break;
    }
};

BM.RegionObject.prototype.appendRow = function (rowIndex, appendedCount) {
    switch (this.RegionKind) {
        case BM.Enum.DataRegionKind.dr_Simple:
            {
                if (this.RegionBottom == rowIndex - 1) {
                    this.setRegionBottom(this.RegionBottom + appendedCount);
                }
            }
            break;
        case BM.Enum.DataRegionKind.dr_ColList:
            {
                this.setRegionBottom(this.RegionBottom + appendedCount);
            }
            break;
        case BM.Enum.DataRegionKind.dr_RowList:
            {
                if (this.RegionBottom == rowIndex - 1) {
                    this.setRegionBottom(this.RegionBottom + appendedCount);
                }
            }
            break;
    }
};

BM.RegionObject.prototype.setLinkVisibility = function (colVisibility, rowVisibility) {
    for (var linkId in this.Links) {
        var linkObj = this.Links.get(linkId);
        var linkVisibility = colVisibility.get(linkObj.PosX) && rowVisibility.get(linkObj.PosY);
        linkObj.setIsHidden(!linkVisibility);
    }
};

//指标从存储表之间进行移动，此时不改变指标的ID，因为会导致链接找不到对应的指标.
BM.RegionObject.prototype.__moveFieldToNewTableNDelete = function (fieldObject, srcTableObject, targetTableObject) {
    if (fieldObject.OwnerTableID != srcTableObject.ID
       || !(srcTableObject.getFieldById(fieldObject.ID))
       || fieldObject.OwnerTableID == targetTableObject.ID
       || targetTableObject.getFieldById(fieldObject.ID))
        return null;

    var mainFrameModel = $.m("BM_MainFrameModel");
    var formHelper = mainFrameModel.getService(BM_ServiceName_FormHelper);

    var newFieldObj = new BM.FieldObject(fieldObject);
    newFieldObj.OwnerTableID = targetTableObject.ID;
    newFieldObj.TableName = targetTableObject.Code;
    var newFieldCode = newFieldObj.Code;
    while (targetTableObject.isExistFieldCode(newFieldCode)) {//note 指标移到新表中，校验指标标识是否存在重码.
        newFieldCode = formHelper.generateNewStringByTemplet(newFieldCode);
    }
    newFieldObj.Code = newFieldCode;
    srcTableObject.delFieldById(fieldObject.ID);
    targetTableObject.addField(newFieldObj);

    var tableCanDelete = this.__checkTableCanDelete(srcTableObject.ID);
    if (tableCanDelete == true) {
        this.deleteTableByID(srcTableObject.ID);
    }

    return newFieldObj;
};

BM.RegionObject.prototype.isPrimaryKeyByPos = function (colIndex, rowIndx) {
    var linkObj = this.getLinkByPos(colIndex, rowIndx);
    if (linkObj == null)
        throw new Error("坐标X:" + colIndex + ",Y:" + rowIndex + "不存在任何数据链接");

    var fieldObj = this.getFieldById(linkObj.LinkExpression);
    var ownerTable = this.getTableById(fieldObj.OwnerTableID);
    return ownerTable.isBizField(linkObj.LinkExpression);
};

BM.RegionObject.prototype.setAsPrimaryKeyByPos = function (colIndex, rowIndex) {
    var linkObj = this.getLinkByPos(colIndex, rowIndex);
    if (linkObj == null)
        throw new Error("坐标X:" + colIndex + ",Y:" + rowIndex + "不存在任何数据链接");

    var fieldObj = this.getFieldById(linkObj.LinkExpression);
    var ownerTable = this.getTableById(fieldObj.OwnerTableID);
    if (ownerTable) {
        ownerTable.addBizField(fieldObj);

        if (this.RegionKind != BM.Enum.DataRegionKind.dr_Simple) {
            var floatOrderField = ownerTable.getOrderField();
            if (floatOrderField != null)
                ownerTable.delFieldById(floatOrderField.ID);
        }
    }
};

BM.RegionObject.prototype.removePrimaryKeyByPos = function (colIndex, rowIndex) {
    var linkObj = this.getLinkByPos(colIndex, rowIndex);
    if (linkObj == null)
        throw new Error("坐标X:" + colIndex + ",Y:" + rowIndex + "不存在任何数据链接");

    var fieldObj = this.getFieldById(linkObj.LinkExpression);
    var ownerTable = this.getTableById(fieldObj.OwnerTableID);
    if (ownerTable) {
        ownerTable.removeBizFieldById(fieldObj.ID);

        if (this.RegionKind != BM.Enum.DataRegionKind.dr_Simple) {
            var isAllSysFields = ownerTable.isAllSystemFields();
            if (isAllSysFields == false)
                return;
            
            //note 业务主键被删除之后，判断是否还包含非系统的指标，如果不包含的话，则添加默认的FloatOrder指标.
            var floatOrderField = ownerTable.__getOrderField();
            if (floatOrderField != null) {
                if (floatOrderField.IsDeleted) {
                    ownerTable.unDeleteFieldByID(floatOrderField.ID);
                }
            } else {
                floatOrderField = ownerTable.createFloatOrderField();
            }
            ownerTable.addBizField(floatOrderField);
        }
    }
};