﻿BM.TaskObject = function (taskObj) {
    BM.UndoBase.call(this);    
    if(!taskObj){
    	return;
    }

    this.ID = taskObj.TaskObj.ID;
    this.Title = taskObj.TaskObj.Title;
    this.DefaultPeriod = taskObj.DefaultPeriod;

    this.IsNew = false;
    this.IsDirty = false;
    this.IsDeleted = false;

    this.EnumDataBlobUrl = taskObj.EnumDataBlobUrl;
    this.PeriodType = taskObj.TaskObj.PeriodType;
    this.Enums = taskObj.Enums;
    this.TaskFileFix = taskObj.TaskObj.TaskFileFix;
    this.HasPublished = taskObj.HasPublished;
    this.ActivedFormId = (taskObj.ActivedFormId == null) ? 0 : taskObj.ActivedFormId;

    this.RuntimeTaskCount = taskObj.RuntimeTaskCount;//wyj用于控制发布按钮的状态使用.
    this.FunctionList = taskObj.FunctionList;
    this.OperatorList = taskObj.OperatorList;
    this.EntityTables = new BM.BusinessList(); //任务下所有的实体表.
    for (var entityId in taskObj.EntityTables) {
        var tmpTable = taskObj.EntityTables[entityId];
        var tableObj = new BM.TableObject(tmpTable);
        this.EntityTables.add(tableObj.ID, tableObj);
    }

    this.MasterEntityViews = new BM.BusinessList(); //任务主控实体视图.
    for (var viewId in taskObj.TaskObj.MasterEntityViews) {
        var tmpView = taskObj.TaskObj.MasterEntityViews[viewId];
        var viewObj = new BM.EntityViewObject(tmpView);
        this.MasterEntityViews.add(viewObj.ID, viewObj);
    }

    this.MasterFields = new BM.BusinessList(); //任务主控实体主键指标.
    for (var masterViewId in this.MasterEntityViews) {
        var masterViewObj = this.MasterEntityViews.get(masterViewId);
        var masterTableObj = this.EntityTables.get(masterViewObj.TableID);
        if (masterTableObj) {

            for (var masterFieldId in masterTableObj.BizkeyFields) {
                var tmpMasterField = masterTableObj.BizkeyFields.get(masterFieldId);
                this.MasterFields.add(masterFieldId, tmpMasterField);
            }
        }
    }
    
    this.Orders = taskObj.Orders; //顺序号，用于调整顺序使用[后台返回20个备用]
    this.Forms = new BM.UndoList("表单");
    for (var formIndex in taskObj.FormObjects) {
        var tmpForm = taskObj.FormObjects[formIndex];
        var formObj = new BM.FormObject(tmpForm);
        this.Forms.add(tmpForm.ID, formObj);
    }

    this.DelForms = new BM.UndoList("删除表单");

    this.FormGroups = new BM.UndoList("表单分组");
    for (var fgpId in taskObj.FormGroups) {
        var tmpfgp = taskObj.FormGroups[fgpId];
        var formGroupObj = new BM.FormGroupObject(tmpfgp);
        this.FormGroups.add(formGroupObj.ID, formGroupObj);
    }

    this.DelFormGroups = new BM.UndoList("删除表单分组");

    this.FieldGroups = new BM.BusinessList();
    for (var fieldGroupId in taskObj.FieldGroups) {
        var tmpFieldGroup = taskObj.FieldGroups[fieldGroupId];
        var fieldGroupObj = new BM.FieldGroupObject(tmpFieldGroup);
        this.FieldGroups.add(fieldGroupObj.ID, fieldGroupObj);
    }

    this.FormulaSchemes = new BM.BusinessList();//公式方案列表，原则上只有一个.
    for (var formulaSchemeId in taskObj.FormulaSchemes) {
        var tmpFormulaSchemeObj = taskObj.FormulaSchemes[formulaSchemeId];
        var formulaSchemeObj = new BM.FormulaSchemeObject(tmpFormulaSchemeObj);
        this.FormulaSchemes.add(formulaSchemeObj.ID, formulaSchemeObj);
    }

    this.EnumObjects = new BM.BusinessList();//租户下枚举定义
    for (var enumId in taskObj.EnumObjects) {
        var tmpEnumObj = taskObj.EnumObjects[enumId];
        var enumObject = new BM.EnumObject(tmpEnumObj);
        this.EnumObjects.add(enumObject.ID, enumObject);
    }
};

BM.TaskObject.prototype = new BM.UndoBase();

BM.TaskObject.prototype.isDataChanged = function (checkNewForm) {
    var taskEditable = $.m("BM_MainFrameModel").isTaskEditable();
    if (taskEditable == false)
        return false;

    if (this.IsDirty === true)
        return true;
    if (this.DelForms.getCount() >= 1)
        return true;

    if (this.DelFormGroups.getCount() >= 1)
        return true;

    var mainFrame = $.m("BM_MainFrameModel");
    for (var formId in this.Forms) {
        var formObj = this.Forms.get(formId);
        var undoUnit = mainFrame.getUndoUnit(formId);
        if ((checkNewForm && formObj.IsNew) || (undoUnit != null && (undoUnit.canUndo() === true || undoUnit.canRedo() === true)))
            return true;
          var formObj = this.Forms.get(formId);
          if (formObj.isDataChanged() === true)
              return true;
    }

    for (var formGPId in this.FormGroups) {
        var formGPObj = this.FormGroups.get(formGPId);
        if (formGPObj.isDataChanged() === true)
            return true;
    }

    return false;
};

//note 获取任务待保存信息，以后如果要增加保存信息，在此添加。
BM.TaskObject.prototype.getCopyToSave = function () {
    var result = {};

    var task = {};
    task.ID = this.ID;
    task.Title = this.Title;
    task.PeriodType = this.PeriodType;
    result.TaskObj = task;

    var mainFrame = $.m("BM_MainFrameModel");
    result.FormObjects = [];
    for (var formId in this.Forms) {
        var formObj = this.Forms.get(formId);
        var undoUnit = mainFrame.getUndoUnit(formId);
        if ((undoUnit != null && (undoUnit.canUndo() === true || undoUnit.canRedo() === true)) || formObj.isDataChanged() == true) {
            result.FormObjects.push(formObj.getCopyToSave());
        }
    }

    for (var delFormId in this.DelForms) {
        var delFormObj = this.DelForms.get(delFormId).getCopyToSave();
        result.FormObjects.push(delFormObj);
    }

    result.FormGroups = new BM.BusinessList("表单分组");
    for (var formGPId in this.FormGroups) {
        var formGPObj = this.FormGroups.get(formGPId);
        if (formGPObj.isDataChanged() == true)
            result.FormGroups.add(formGPObj.ID, formGPObj.getCopyToSave());
    }

    for (var delFormGPId in this.DelFormGroups) {
        var delFormGPObj = this.DelFormGroups.get(delFormGPId).getCopyToSave();
        result.FormGroups.add(delFormGPObj.ID, delFormGPObj);
    }

    return result;
};

BM.TaskObject.prototype.setPeriodType = function (newPeriodType) {
    if (newPeriodType == null) return;

    if (this.PeriodType !== newPeriodType) {
        this.PeriodType = newPeriodType;
        this.markDirty();
    }
};

BM.TaskObject.prototype.getTaskID = function () {
    return this.ID;
};

BM.TaskObject.prototype.getForms = function () {
    return this.Forms;
};

BM.TaskObject.prototype.getFormsCount = function () {
    return this.Forms.getCount();
};

//通过表单ID获取对应的表单对象.
BM.TaskObject.prototype.getFormByID = function (formId) {
    return this.Forms.get(formId);
};

//通过表单ID获取对应的表单对象.
BM.TaskObject.prototype.__getFormByID = function (formId) {
    var form = this.Forms.get(formId);
    if (form == null)
        return this.DelForms.get(formId);
    return form;
};

//通过表单Code获取对应的表单对象.
BM.TaskObject.prototype.getFormByCode = function (formCode) {
    if (formCode == null || formCode === "")
        return null;

    for (var formId in this.Forms) {
        var formObj = this.Forms.get(formId);
        if (formObj.Code.toUpperCase() == formCode.trim().toUpperCase())
            return formObj;
    }

    return null;
};

BM.TaskObject.prototype.getFormGroupByID = function (formGroupId) {
    return this.FormGroups.get(formGroupId);
};

//获取任务下的所有的根表单分组（排序后）.
BM.TaskObject.prototype.getRootFormGroups = function () {
    var result = [];
    for (var fgpId in this.FormGroups) {
        var tmpfgp = this.FormGroups.get(fgpId);
        if (tmpfgp.ParentGroupID == 0)
            result.push(tmpfgp);
    }
    var orderedFormGroups = result.sort(
               function (a, b) {
                   if (a.Order < b.Order) return -1;
                   if (a.Order > b.Order) return 1;
                   return 0;
               }

           );
    return orderedFormGroups;
};

//根据表单分组ID获取该分组下的所有表单（排序后）.
BM.TaskObject.prototype.getFormsInGroup = function (formGroupId) {
    var formGroupObj = this.getFormGroupByID(formGroupId);
    var result = [];//new BM.BusinessList();
    if (formGroupObj) {
        for (var formId in this.Forms) {
            var formObj = this.Forms.get(formId);
            if (formObj.OwnGroupId == formGroupObj.ID) {
                result.push(formObj);
            }
        }
    }
    var orderedForms = result.sort(
                function (a, b) {
                    if (a.Order < b.Order) return -1;
                    if (a.Order > b.Order) return 1;
                    return 0;
                }

            );

    return orderedForms;
};

//新增一个表单.
BM.TaskObject.prototype.addForm = function (formTitle, formType) {
    if (formTitle == null || formTitle === "")
        return null;
    var mainFrameModel = $.m("BM_MainFrameModel");
    var formHelper = mainFrameModel.getService(BM_ServiceName_FormHelper);

    formTitle = formHelper.filterReservedChars(formTitle);

    if (formTitle == null || formTitle === "")
        return null;
    if (this.isExistFormByTitle(0, formTitle.toUpperCase()))
        return null;

    var tmpFormCode = formHelper.NewUniqueCode();

    while (this.isExistFormCode(tmpFormCode)) {//保证任务下的表单标识唯一性.
        tmpFormCode = formHelper.NewUniqueCode();
    }

    var isValidFormCode = formHelper.isValidFormCode(tmpFormCode);
    if (isValidFormCode == false)
        return null;

    var tmpFormObj = {};
    tmpFormObj.ID = formHelper.JCPGuid("FormObject-");

    tmpFormObj.IsNew = true;
    tmpFormObj.IsDirty = false;
    tmpFormObj.IsDeleted = false;

    tmpFormObj.Published = false;
    tmpFormObj.Title = formTitle;
    tmpFormObj.TaskId = this.ID;
    tmpFormObj.FormType = formType;

    tmpFormObj.Code = tmpFormCode.toUpperCase();
    tmpFormObj.Order = this.getNewOrder();

    var rootFormGroups = this.getRootFormGroups();
    tmpFormObj.OwnGroupId = rootFormGroups[rootFormGroups.length - 1].ID; //将表单默认加入最后一个表单分组中.

    //生成默认表格（20*10）.
    var formData = formHelper.getGridTemplet(4, 3);
    formData.options.enumDataBlobUrl = this.EnumDataBlobUrl;
    tmpFormObj.FormStyle = formData;

    var newFormObj = new BM.FormObject(tmpFormObj);
    newFormObj.FormStatus = BM.Enum.FormStatus.fs_Queried;

    this.Forms.add(newFormObj.ID, newFormObj);

    //新建的表单，默认所有单元格都为常规类型.(行方向优先.)
    for (var row = 1; row < formData.rowCount; row++) {
        for (var col = 1; col < formData.colCount; col++) {
            var fieldLinkSet = newFormObj.setFieldByPos(BM.Enum.FieldType.ft_General, formHelper.getGeneralTypeSize(), col, row, formData.colCount, formData.rowCount);
            //[linkInCell, fieldByCell];
            var field = fieldLinkSet[1];
            var link = fieldLinkSet[0];            
            field.setTitle("新建题目");
            if(row == 1){
            	field.setDefaultValue("新建题目");
            	link.setEditMode(BM.Enum.DataLinkEditMode.dl_ReadOnly);
            	field.setGatherType(BM.Enum.FieldGatherType.fg_None);
            } else{
            	field.setGatherType(BM.Enum.FieldGatherType.fg_None);
            }
        }

        var rowExtension = new BM.RegionExtension("");
        newFormObj.RowExtensions.add(row, rowExtension);
    }

    return newFormObj;
};

BM.TaskObject.prototype.addDefaultForm = function () {
    var newFormTitle = this._queryNewFormTitle();
    return this.addForm(newFormTitle, BM.Enum.FormType.ft_FixForm);
};

BM.TaskObject.prototype._queryNewFormTitle = function () {
    var index = 1;
    var newFormBaseTitle = "工作表";
    var newFormTitle = "工作表1";
    while (this.isExistFormByTitle(0, newFormBaseTitle + index)) {
        index++;
        newFormTitle = newFormBaseTitle + index;
    }

    return newFormTitle;
};

BM.TaskObject.prototype.updateFormID = function (oldId, newId) {
    var formObj = this.Forms.get(oldId);
    if (formObj != null) {
        formObj.ID = newId;
        this.Forms.remove(oldId);
        this.Forms.add(formObj.ID, formObj);
    }
};

//返回当前任务下是否有表单正在保存.
//note 正在保存的话，则不可以进行发布操作.
BM.TaskObject.prototype.isBusySaving = function () {
    for (var formId in this.Forms) {
        var formObj = this.Forms.get(formId);
        if (formObj.FormStatus === BM.Enum.FormStatus.fs_Saving)
            return true;
    }

    return false;
};

//当前任务是否已经存在某个标题对应的表单.
BM.TaskObject.prototype.isExistFormByTitle = function (formIdToCheck, formTitle) {
    if (formTitle == null || formTitle === "")
        return false;

    var mainFrameModel = $.m("BM_MainFrameModel");
    var formHelper = mainFrameModel.getService(BM_ServiceName_FormHelper);

    var convertedFormTitle = formHelper.QJ2BJ(formTitle);

    for (var formId in this.Forms) {
        if (formIdToCheck == formId)
            continue;
        var formObj = this.Forms.get(formId);
        if (formObj.Title.toUpperCase() == convertedFormTitle.toUpperCase())
            return true;
    }

    return false;
};

//任务下是否已经存在指定标识的表单.
BM.TaskObject.prototype.isExistFormCode = function (formCode) {
    if (formCode == null || formCode === "")
        return false;

    for (var formId in this.Forms) {
        var formObj = this.Forms.get(formId);
        if (formObj.Code.toUpperCase() == formCode.trim().toUpperCase())
            return true;
    }

    return false;
};

//是否已经存在表单分组标题.
BM.TaskObject.prototype.isExistFormGroupByTitle = function (formGroupIdToCheck, formGroupTitle) {
    if (formGroupTitle == null || formGroupTitle === "")
        return false;

    for (var formGroupId in this.FormGroups) {
        if (formGroupIdToCheck == formGroupId)
            continue;
        var formGroupObj = this.FormGroups.get(formGroupId);
        if (formGroupObj.Title == formGroupTitle.trim())
            return true;
    }

    return false;
};

//新增一个表单到缓存中.
BM.TaskObject.prototype.addFormObject = function (formObject) {
    //note 当前新切换的表单已经在前台进行过分组调整（未加载），此时应该把新加载的表单所属分组更新为新分组，并标记为已修改.
    var oldForm = this.Forms.get(formObject.ID);
    if (oldForm != null && oldForm.isDataChanged() && oldForm.OwnGroupId != formObject.OwnGroupId) {
        formObject.OwnGroupId = oldForm.OwnGroupId;
        formObject.markDirty();
    }
    //formObject.FormStatus = BM.Enum.FormStatus.fs_Initialized;//note 移动MainFrameModel.OnFormDataLoaded中.
    this.Forms.add(formObject.ID, formObject);
};

//根据表单分组标题创建一个表单分组对象.
BM.TaskObject.prototype.addFormGroup = function (formGroupTitle) {
    if (formGroupTitle == null || formGroupTitle === "")
        return null;

    var mainFrameModel = $.m("BM_MainFrameModel");
    var formHelper = mainFrameModel.getService(BM_ServiceName_FormHelper);

    var convertedFGTitle = formHelper.QJ2BJ(formGroupTitle);

    if (this.isExistFormGroupByTitle(0, convertedFGTitle))
        return null;

    var tmpFormGroupObj = {};
    tmpFormGroupObj.ID = formHelper.JCPGuid("FormGroupObject-");

    tmpFormGroupObj.IsNew = true;
    tmpFormGroupObj.IsDirty = false;
    tmpFormGroupObj.IsDeleted = false;

    tmpFormGroupObj.Title = convertedFGTitle;
    tmpFormGroupObj.TaskId = this.ID;
    tmpFormGroupObj.Order = this.getNewOrder();

    var newFormGroupObj = new BM.FormGroupObject(tmpFormGroupObj);

    this.FormGroups.add(tmpFormGroupObj.ID, newFormGroupObj);
    return newFormGroupObj;
};

//根据实体表ID获取任务下的指定实体.
BM.TaskObject.prototype.getEntityTableByID = function (entityTableId) {
    return this.EntityTables.get(entityTableId);
};

BM.TaskObject.prototype.delEntityTableByID = function (entityTableId) {
    //note 更新所有表单中引用了该枚举的链接和指标.
    var tableObj = this.EntityTables.get(entityTableId);
    for (var formId in this.Forms) {
        var formObj = this.Forms.get(formId);
        formObj.updateFieldLinkByDeleteEnum(tableObj);
    }
    this.EntityTables.remove(entityTableId);
};

//根据视图ID获取指定视图对象，不存在返回NULL.
BM.TaskObject.prototype.getEntityViewByID = function (entityViewId) {
    for (var entityTableId in this.EntityTables) {
        var entityTableObj = this.EntityTables.get(entityTableId);
        for (var viewId in entityTableObj.Views) {
            if (viewId == entityViewId)
                return entityTableObj.Views.get(viewId);
        }
    }
    return null;
};

//新增实体表.
BM.TaskObject.prototype.addEntityTable = function (entityTableId, entityTableObject) {
    return this.EntityTables.add(entityTableId, entityTableObject);
};

//交换两个表单的顺序.
BM.TaskObject.prototype.exchangeFormOrders = function (orderedFormIds) {
    if (orderedFormIds == null || orderedFormIds.length == 0)
        return null;

    var preFormOrders = [];
    for (var idx = 0; idx < orderedFormIds.length; idx++) {
        var formId = orderedFormIds[idx];
        var formObj = this.getFormByID(formId);
        preFormOrders.push(formObj.Order);
    }

    var orderedFormOrders = preFormOrders.sort(
                function (a, b) {
                    if (a < b) return -1;
                    if (a > b) return 1;
                    return 0;
                }

            );

    var formObjDict = new BM.BusinessList();
    for (var idx = 0; idx < orderedFormIds.length; idx++) {
        var formId = orderedFormIds[idx];
        var formObj = this.getFormByID(formId);
        formObj.setOrder(orderedFormOrders[idx]);
        if (formObj.IsNew !== true) {
            formObjDict.add(formId, orderedFormOrders[idx]);
        }
    }
    return formObjDict;
};

//通过拖拽页签来改变表单的顺序。【向前拖拽】
BM.TaskObject.prototype.exchangeFormsOrderByDragForward = function (nextFormId, currentFormId) {
    var orderedFormIds = [];

    var firstFormFound = false;
    var lastFormFound = false;
    orderedFormIds.push(currentFormId);
    orderedFormIds.push(nextFormId);
    for (var formGroupId in this.FormGroups) {
        var formsInGroup = this.getFormsInGroup(formGroupId);
        for (var formIdx in formsInGroup) {
            var form = formsInGroup[formIdx];
            if (form.ID && form.ID == nextFormId) {
                firstFormFound = true;
            }
            if (form.ID && form.ID == currentFormId) {
                lastFormFound = true;
            }
            if (lastFormFound == true) {
                return orderedFormIds;
            }
            if (firstFormFound == true) {
                if (form.ID != nextFormId)
                    orderedFormIds.push(form.ID);
            }
        }
    }
    return orderedFormIds;
};

//通过拖拽页签来改变表单的顺序。【向后拖拽】
BM.TaskObject.prototype.exchangeFormsOrderByDragBackward = function (currentFormId, preFormId) {
    var orderedFormIds = [];

    var firstFormFound = false;
    var lastFormFound = false;
    for (var formGroupId in this.FormGroups) {
        var formsInGroup = this.getFormsInGroup(formGroupId);
        for (var formIdx in formsInGroup) {
            var form = formsInGroup[formIdx];
            if (form.ID && form.ID == currentFormId) {
                firstFormFound = true;
            }
            if (form.ID && form.ID == preFormId) {
                lastFormFound = true;
            }
            if (lastFormFound == true) {
                orderedFormIds.push(preFormId);
                orderedFormIds.push(currentFormId);
                return orderedFormIds;
            }
            if (firstFormFound == true) {
                if (form.ID != currentFormId)
                    orderedFormIds.push(form.ID);
            }
        }
    }
    return orderedFormIds;
};

//交换两个表单的顺序.
BM.TaskObject.prototype.exchangeFormGroupOrders = function (orderedFormGroupIds) {
    if (orderedFormGroupIds == null || orderedFormGroupIds.length == 0)
        return null;

    var preFormGroupOrders = [];
    for (var idx = 0; idx < orderedFormGroupIds.length; idx++) {
        var formGPId = orderedFormGroupIds[idx];
        var formGPObj = this.getFormGroupByID(formGPId);
        preFormGroupOrders.push(formGPObj.Order);
    }

    var orderedFormGroupOrders = preFormGroupOrders.sort(
                function (a, b) {
                    if (a < b) return -1;
                    if (a > b) return 1;
                    return 0;
                }

            );

    var formGPObjDict = new BM.BusinessList();
    for (var idx = 0; idx < orderedFormGroupIds.length; idx++) {
        var formGPId = orderedFormGroupIds[idx];
        var formGPObj = this.getFormGroupByID(formGPId);
        formGPObj.setOrder(orderedFormGroupOrders[idx]);
        if (formGPObj.IsNew !== true) {
            formGPObjDict.add(formGPId, orderedFormGroupOrders[idx]);
        }
    }
    return formGPObjDict;
};

//将表单移至新的表单分组中.
BM.TaskObject.prototype.moveFormToNewFormGroup = function (formId, newFormGroupId) {
    var formObject = this.getFormByID(formId);
    if (formObject == null || formObject.OwnGroupId == newFormGroupId)
        return false;

    formObject.OwnGroupId = newFormGroupId;
    formObject.markDirty();

    this.markDirty();
    return true;
};

//删除表单分组，删除之后，表单分组下的表单，默认归属到根表单分组中.
BM.TaskObject.prototype.deleteFormGroupByID = function (formGroupId) {
    var formGroup = this.FormGroups.get(formGroupId);
    if (formGroup) {
        formGroup.IsDeleted = true;
        this.DelFormGroups.add(formGroup.ID, formGroup);
        this.FormGroups.remove(formGroupId);
    }

    var rootFormGroups = this.getRootFormGroups();
    var newGroupId = rootFormGroups[0].ID; //将表单默认加入到跟表单分组中.

    for (var formId in this.Forms) {
        var tmpForm = this.Forms.get(formId);
        if (tmpForm.OwnGroupId == formGroupId) {
            tmpForm.OwnGroupId = newGroupId;
            tmpForm.markDirty();
        }
    }

    this.markDirty();
};

BM.TaskObject.prototype.deleteFormByID = function (formId) {
    var formObj = this.Forms.get(formId);
    if (!formObj) return;
    formObj.markDeleted();
    this.Forms.remove(formId);
    if (!formObj.IsNew) {
        this.DelForms.add(formId, formObj);
    }

    this.markDirty();
};

//获取新的Order.
BM.TaskObject.prototype.getNewOrder = function () {
    if (this.Orders.length <= 0) {
        var mainFrameModel = $.m("BM_MainFrameModel");
        var newOrders = mainFrameModel.generateNewOrders(20);
        for (var order in newOrders) {
            this.Orders.push(newOrders[order]);
        }
    }

    //var result = this.Orders[this.Orders.length - 1];
    //this.Orders.length--;
    var result = this.Orders[0];//Order顺序获取.
    this.Orders.splice(0, 1);
    return result;
};

//获取业务数据表的所属指标分组.
BM.TaskObject.prototype.getBizTableFieldGroup = function () {
    for (var fieldGroupId in this.FieldGroups) {
        var fieldGroupObj = this.FieldGroups.get(fieldGroupId);
        if (fieldGroupObj.Title == "数据表分组")
            return fieldGroupObj;
    }

    return null;
};

//获取字典数据表的所属指标分组.
BM.TaskObject.prototype.getDictionaryFieldGroup = function () {
    for (var fieldGroupId in this.FieldGroups) {
        var fieldGroupObj = this.FieldGroups.get(fieldGroupId);
        if (fieldGroupObj.Title == "字典分组")
            return fieldGroupObj;
    }

    return null;
};

//获取默认的公式方案.
BM.TaskObject.prototype.getDefaultFormulaScheme = function () {
    if (this.FormulaSchemes.getCount() == 0) {
        var mainFrameModel = $.m("BM_MainFrameModel");
        var formHelper = mainFrameModel.getService(BM_ServiceName_FormHelper);

        var formulaScheme = {};
        formulaScheme.ID = formHelper.JCPGuid("FormulaSchemeObject-");
        formulaScheme.IsNew = true;
        formulaScheme.IsDirty = false;
        formulaScheme.IsDeleted = false;
        formulaScheme.Description = "默认创建的公式方案";
        formulaScheme.TaskID = this.ID;
        var tmpObj = new BM.FormulaSchemeObject(formulaScheme);
        this.FormulaSchemes.add(tmpObj.ID, tmpObj);
    }

    for (var formulaSchemeId in this.FormulaSchemes) {
        var formulaScheme2 = this.FormulaSchemes.get(formulaSchemeId);
        if (formulaScheme2)
            return formulaScheme2;
    }

    return null;
};

BM.TaskObject.prototype.setTitle = function (newTitle) {
    if (newTitle == null || newTitle.trim() === "")
        return null;
    newTitle = newTitle.trim();

    if (newTitle.length > 25)
        return null;

    var mainFrameModel = $.m("BM_MainFrameModel");
    var formHelper = mainFrameModel.getService(BM_ServiceName_FormHelper);
    newTitle = formHelper.filterReservedChars(newTitle);

    if (this.Title != newTitle) {
        this.beforePropertyChanged("Title", this.Title, newTitle);
        this.Title = newTitle;
        this.markDirty();
        this.propertyHasChanged("Title");
    }
    return this;
};

BM.TaskObject.prototype.markClean = function () {
    this.IsNew = false;
    this.IsDirty = false;
    this.IsDeleted = false;
    return this;
};

BM.TaskObject.prototype.markDirty = function () {
    if (!this.IsNew)
        this.IsDirty = true;

    return this;
};

BM.TaskObject.prototype.markNew = function () {
    this.IsNew = true;
    this.IsDirty = false;
    this.IsDeleted = false;
    return this;
};

BM.TaskObject.prototype.markDeleted = function () {
    this.IsNew = false;
    this.IsDirty = false;
    this.IsDeleted = true;
    return this;
};

//通过视图ID获取枚举
BM.TaskObject.prototype.getEnumByViewId = function (viewId) {
    return this.EnumClasses.get(viewId);
};

//插入一行时，新增一个枚举项
BM.TaskObject.prototype.insertRow = function (rowIndex, viewId) {
    this.EnumClasses[viewId].Nodes.splice(rowIndex, 0, new BM.EnumNodeObject());
    this.EnumClasses[viewId].NodeCount = this.EnumClasses[viewId].NodeCount + 1;
};

//删除一行时，删除该行的枚举项
BM.TaskObject.prototype.deleteRow = function (rowIndex, viewId) {
    this.EnumClasses[viewId].Nodes.splice(rowIndex, 1);
    this.EnumClasses[viewId].NodeCount = this.EnumClasses[viewId].NodeCount - 1;
};

//修改数据时,更新枚举项中对应数据
BM.TaskObject.prototype.updateValue = function (row, col, newValue, oldValue, viewId) {
    if (1 == col) {
        this.EnumClasses[viewId].Nodes[row].Code = newValue;
    } else if (2 == col) {
        this.EnumClasses[viewId].Nodes[row].Title = newValue;
    } else if (3 == col) {
        if (this.EnumClasses[viewId].Nodes[row].Values) {
            this.EnumClasses[viewId].Nodes[row].Values[0] = newValue;
        } else {
            this.EnumClasses[viewId].Nodes[row].Values = new Array(newValue);
        }

    }
};

BM.TaskObject.prototype.deleteEnumObject = function (entityViewId) {
    this.EnumClasses.remove(entityViewId);
};

BM.TaskObject.prototype.afterSaved = function () {
    for (var formId in this.Forms) {
        var formObj = this.Forms.get(formId);
        formObj.FormStatus = BM.Enum.FormStatus.fs_Uninitialize;
        formObj.markClean();
        formObj.Regions.clear();
        formObj.Formulas.clear();
        formObj.IsNew = false;
    }
    this.DelForms = new BM.UndoList("删除表单");
    this.DelFormGroups = new BM.UndoList("删除表单分组");
    this.markClean();
};

BM.TaskObject.prototype.getEnumObjectById = function (enumId) {
    return this.EnumObjects[enumId];
};

BM.TaskObject.prototype.deleteEnumObjectById = function (enumId) {
    this.EnumObjects.remove(enumId);
};

//添加枚举缓存
BM.TaskObject.prototype.addEnumObject = function (enumObj) {
    var enumObject = new BM.EnumObject(enumObj);
    this.EnumObjects.add(enumObject.ID, enumObject);
};

BM.TaskObject.prototype.updateEnumObject = function (enumObj) {
    var enumObject = new BM.EnumObject(enumObj);
    this.EnumObjects[enumObject.ID] = enumObject;
};

BM.TaskObject.prototype.getEnumNodesById = function (enumExpression) {
    var enumObject = this.EnumObjects.get(enumExpression);
    if (enumObject != null) {
        var enumDataListLoaded = enumObject.EnumDataList.getCount() > 0;
        if (enumDataListLoaded == false) {
            var mainFrame = $.m("BM_MainFrameModel");
            var result = mainFrame.queryEnumData(enumExpression);
            for (var key in result) {
                var enumNodeObj = result[key];
                var newEnumObject = new BM.EnumNodeObject(enumNodeObj);
                enumObject.EnumDataList.add(newEnumObject.Code, newEnumObject);
            }
        }
        return enumObject.EnumDataList;
    }
};
