﻿//可撤销对象基类.
BM.UndoBase = function () {
    this.IsNew = false;
    this.IsDeleted = false;
    this.IsDirty = false;
};

//属性修改前，进行属性的记录.
BM.UndoBase.prototype.beforePropertyChanged = function (propertyName, oldValue, newValue) {
    var serviceContainer = $.m("BM_MainFrameModel");
    if (serviceContainer == null) return;

    //var undoService = serviceContainer.getService(BM_ServiceName_UndoService);
    var undoUnit = serviceContainer.getUndoUnit();
    if (undoUnit != null) {
        if (!undoUnit.isEnabled())
            return;

        var currentUnit = undoUnit.getCurrentAction();
        if (currentUnit != null) {
            var itemChangedEventArgs = new BM.ItemChangedEventArgs(this, propertyName, oldValue, newValue);
            currentUnit.itemChanged(itemChangedEventArgs);
        }
    }
};

//属性更改事件，用于发送通知.
BM.UndoBase.prototype.propertyHasChanged = function (propertyName) {
    if (this.IsDirty == false && this.IsDeleted == false && this.IsNew == false)
        this.IsDirty = true;
    //todo.
	return;
    var mainFrame = $.m("BM_MainFrameModel");
    var currentForm = mainFrame.getCurrentForm();
    if (currentForm.onInitializingReservedCount == false) {
        var info = "状态：未保存";
        mainFrame.refreshStatusBar(info, "promopt");
    }
};

BM.UndoListBase = function () {

};

BM.UndoListBase.prototype.beforeItemAdd = function (key, value) {

};

BM.UndoListBase.prototype.onItemAdded = function () {

};

BM.UndoListBase.prototype.beforeItemRemove = function (key) {

};

BM.UndoListBase.prototype.onItemRemoved = function () {

};

BM.UndoList = function (listName) {
    var props = {
        Name: { value: listName, enumerable: false, writable: true, configurable: false },
        Count: { value: 0, enumerable: false, writable: true, configurable: false },
        add: {
            value: function (key, value) {
                if (key == null)
                    throw new Error("null key is not available.");
                var serviceContainer = $.m("BM_MainFrameModel");
                //var undoService = serviceContainer.getService(BM_ServiceName_UndoService);
                if (serviceContainer) {
                    var itemExisted = this[key];
                    var undoUnit = serviceContainer.getUndoUnit();
                    if (undoUnit != null && this[key] == null) {
                        if (undoUnit.isEnabled()) {
                            var currentAction = undoUnit.getCurrentAction();
                            if (currentAction != null) {
                                var listChangedEventArgs = new BM.ListChangedEventArgs(this, value, true);
                                currentAction.itemAdded(listChangedEventArgs);
                            }
                        }
                    }
                }
                if (itemExisted) {
                    this[key] = value;
                } else {
                    this[key] = value;
                    this.Count++;
                }
            }, enumerable: false, writable: true, configurable: false
        },
        get: {
            value: function (key) {
                return this[key];
            }, enumerable: false, writable: true, configurable: false
        },
        remove: {
            value: function (key) {
                if (this[key]) {
                    var serviceContainer = $.m("BM_MainFrameModel");
                    if (serviceContainer) {
                        var currentAction = serviceContainer.getCurrentAction();
                        if (currentAction != null) {
                            var listChangedEventArgs = new BM.ListChangedEventArgs(this, this[key], false);
                            currentAction.itemRemoved(listChangedEventArgs);
                        }
                    }

                    delete this[key];
                    this.Count--;
                }
            }, enumerable: false, writable: true, configurable: false
        },
        getCount: {
            value: function () {
                return this.Count;
            }, enumerable: false, writable: true, configurable: false
        },
        clear: {
            value: function () {
                var serviceContainer = $.m("BM_MainFrameModel");
                if (serviceContainer) {
                    var currentAction = serviceContainer.getCurrentAction();
                }
                for (var id in this) {
                    var item = this[id];

                    if (currentAction != null) {
                        var listChangedEventArgs = new BM.ListChangedEventArgs(this, item, false);
                        currentAction.itemRemoved(listChangedEventArgs);
                    }

                    delete this[id];
                    this.Count--;
                }
            }, enumerable: false, writable: true, configurable: false
        },
        containsKey: {
            value: function (key) {
                return this[key] != null;
            }, enumerable: false, writable: true, configurable: false
        },
        toString: {
            value: function () {
                return this.Name + "，Count【" + this.Count + "】";
            }, enumerable: false, writable: true, configurable: false
        },
    };

    return Object.create(BM.UndoList.prototype, props);
};
