BM_ServiceName_FormHelper = 'formHelper';

var ServiceContainer = {
    addService: function (type, instance) {
        if (this[type] != null)
            throw new Error(type + "不可以添加多次");

        this[type] = instance;
    },
    removeService: function (type) {
        var serviceInstance = this[type];
        if (serviceInstance && serviceInstance["dispose"]) {
            serviceInstance.dispose();
        }
        delete this[type];
    },
    getService: function (type) {
        return this[type];
    }
};

$.Class("BM_MainFrameModel", MvcModel, ServiceContainer, {
	//当前任务.
    _taskObject: {},
    //当前激活的表单对象.
    _activedFormObject: {},    
    _formHelper: {},
    _taskId: 0,    
    _globalChanged: false,
    
	construct: function () {
        this._super().construct.call(this);        
    },
    
	onEntry: function(){
		var me = this;
		this._super().onEntry.call(this);
		this._toolbar = $.m('BM_ToolBarModel');
		document.addEventListener(mui.readyEvt_Jcp, function(){		
			//新增帮助类服务.
            me._formHelper = new BM.FormHelper();
            me.addService(BM_ServiceName_FormHelper, me._formHelper);
			
			me._onLoad();
			document.getElementById("publish").addEventListener("tap", function(){
				mui.showWaiting("正在发布...");
				me._saveAndPublish();
			});
			mui.currentWebview.addEventListener("show", function () {
                var billForm = mui.getWebviewById("billform");
                if(billForm){
                	billForm.close();
                }
            });
            
            var contentContainer = $('.container .billform-content');
			$(".billform-newfield").bind("click",function(){
				//
				me.fieldTypeSelectMenuHide();
				
				var index = contentContainer.children().length + 1;
				var question = me._newDefaultQuestion(index);
				var questionitem = $.QuestionCreator['singleText'];
				var data={};
				questionitem.render(data,contentContainer,question);
				me._addQuestion(question);
				$("#" + question.ID)[0].scrollIntoView(true);
				$('html, body').animate({ scrollTop: $("#" + question.ID).offset().top }, {duration:'slow', easing: 'swing'});
			});
			
			contentContainer.bind("toolbarshow", function(event, question){
				me._toolbar.show(me._taskObj, contentContainer, question);
			});
			
			contentContainer.bind("newfieldadd",function(event, newquestion){
				//根据newquestion的index更新TaskObj
				me._addQuestion(newquestion);
			});
			
			contentContainer.bind("fielddelete",function(event, index){
				//更新TaskObj
				me._deleteQuestion(index);
			});
			
			contentContainer.bind("fieldchange",function(event, question){
				//更新TaskObj
				me._modifyQuestion(question);
			});
			me.fieldTypeSelectMenuHide();
		});		
	},
	
	_onLoad: function(){
		var me = this;
		var taskId = mui.currentWebview._taskId;
		if(taskId){
			me._loadTask(taskId);
		} else{
			me._newTask();
		}
	},
	
	_loadTask: function(taskId){
		var me = this;
		var url = $.BaseUrl + "BusinessModel/Home/LoadTask?sourceTaskType=1&_taskId_=" + taskId;
		mui.showWaiting("正在加载数据...");
		$.doAction(url, {
			
		}, function(result) {
			if (result) {
				me._initData(result);
				mui.closeWaiting();
			}
		});
	},
	
	_newTask: function(){
		var me = this;
		var url = $.BaseUrl + "BusinessModel/Home/NewTask?sourceTaskType=1";
		mui.showWaiting("正在加载数据...");
		$.doAction(url, {
			
		}, function(result) {
			if (result) {
				me._initData(result);
				mui.closeWaiting();
			}
		});
	},
	
	_initData: function(data){
		var self = this;
		var initReg = false;
		
		self._taskObject = new BM.TaskObject(data);
		this._taskId = self._taskObject.ID;
		if (self._taskObject.Forms.getCount() == 0) {
            self._taskObject.addDefaultForm();
            initReg = true;
        }
        for(var k in this._taskObject.Forms){
			if(k){
				this._activedFormObject = this._taskObject.Forms.get(k);
				this._activedFormObject.setTitle(this._taskObject.Title);
				break;
			}
		}
        
        if(initReg){
        	var formdata = this._activedFormObject.FormStyle;
        	this._activedFormObject.setFloatRegionByPos(1, formdata.colCount - 1, 2, 1, true, formdata.colCount, formdata.rowCount);
        }
        
       this._loadSurvey();		
	},
	
	_saveAndPublish: function() {
		var me = this;
		if(me._globalChanged){
			var newTaskTitle = $("#billformtitle").val();
			if(newTaskTitle === "" || newTaskTitle === undefined || newTaskTitle === null){
				mui.toast("表单名称不能为空！");
				mui.closeWaiting();
				return;
			}
			me._taskObject.setTitle(newTaskTitle);
	        me._activedFormObject.setTitle(newTaskTitle);
		}
		
		if (this._taskObject.isDataChanged(true) === false) {
            me._doPublish();
            return;
        }
		var url = $.BaseUrl + "BusinessModel/TaskService/SaveTask?&_taskId_=" + this._taskId;
		//从后台返回来的FormStyle再保存回后台后进录入时表格模式下表格有问题（变黑），临时统一在保存时重置表样。
        var formdata = this._activedFormObject.FormStyle;
        this._activedFormObject.FormStyle = me._formHelper.getGridTemplet(formdata.colCount, formdata.rowCount);
		
		var tmpTaskObj = JSON.stringify(me._taskObject.getCopyToSave());
		var foreFormId = this._activedFormObject.ID;
        this._activedFormObject.FormStatus = BM.Enum.FormStatus.fs_Saving; 
        
		$.doAction(url, {
			 taskObj: tmpTaskObj, activedFormId: me._activedFormObject.ID, timelog: ""
		}, function(returnData) {
			if(returnData){
				if (returnData.success) {
					var savedResult = returnData.data;
	                if (savedResult.ActivedFormObject != null) {
	                    for (var mapper in savedResult.SavedIDMapper) {
	                        //me.RefreshProportionedForms(mapper, savedResult.SavedIDMapper[mapper]);
	                        me._taskObject.updateFormID(mapper, savedResult.SavedIDMapper[mapper]);
	                    }
	                    if (savedResult.ActivedFormObject.ID != undefined) {
	                        if (foreFormId != savedResult.ActivedFormObject.ID) {
	                            me._taskObject.Forms.remove(foreFormId);
	                        }
	
	                        me._taskObject.afterSaved();
	                        var formObject = new BM.FormObject(savedResult.ActivedFormObject);
	                        me._taskObject.addFormObject(formObject);
	                        me._activedFormObject = formObject;
	                        me._globalChanged = false;
	
	                        me._doPublish(); 
	                    } else {
	                        mui.closeWaiting();	
	                        mui.toast("保存出错。" + returnData.message);
	
	                        var foreForm = me._taskObject.Forms.get(foreFormId);
	                        if (foreForm.FormStatus === BM.Enum.FormStatus.fs_Saving) {
	                            foreForm.FormStatus = BM.Enum.FormStatus.fs_Initialized;
	                        }
	                    }
	                } else {
	                    mui.closeWaiting();
						mui.toast("保存出错。" + returnData.message);
	                }
					
				} else {
					mui.closeWaiting();
					mui.toast("保存出错。" + ((returnData.data && returnData.data.innerMSG) ? returnData.data.innerMSG : ""));
				}
			}			
		});
		
	},
	
	_doPublish: function(){
		var me = this;
		var task = this._taskObject;
        if (task.PeriodType === 0) {
            task.setPeriodType(8);
        }
		
		var url = $.BaseUrl + "BusinessModel/InstanceService/PublishByTask?&_taskId_=" + this._taskId;
		$.doAction(url, {
			 formId: 0
		}, function(info) {
			if (info ) {
				if (info.state.IsFinished === true) {
                        var exception = info.state.ErrorMessage;
                        if (exception && exception != "") {
                            alert("发布失败：" + exception);
                            mui.closeWaiting();  
                        } else {
                            if (task.DefaultPeriod){
                            	info.periodCode = task.DefaultPeriod;
                            }                                
                            else{
                            	me._taskObject.DefaultPeriod = info.periodCode;
                            }                                
                            me._taskObject.RuntimeTaskCount = info.runtimeTaskCount;
                            mui.closeWaiting();                            
                            
                            me._openDatainput();
                        }
                    }
			}
		});
	},
	
	_openDatainput: function() {
		var userId = localStorage.getItem("currentUserId");
		var datainputView = mui.getWebviewById('datainput');
		datainputView.hide();
		mui.openWindow({
			url: '_www/tasks/datainput/index.html',
			id: 'datainput',
			waiting: {
				autoShow: true,
				title: '发布成功正在加载数据……'
			}
		});				
		datainputView.hide();
		mui.showWaiting('发布成功正在加载数据……');
		mui.fire(datainputView, "datainputshow", {
			taskId: this._taskId,
			period: "",
			creater: userId,
			taskType: "1",
		});
	},
	
	_addQuestion: function(question) {
		// formdata的操作
		var me = this;
		var colCount = me._getColCount();
		var formData = me._formHelper.getGridTemplet(colCount + 1, 3);
		this._activedFormObject.FormStyle = formData;
		
		//
		this._activedFormObject.insertCol(question.index);
		
		// 标题指标
		var fieldLinkSet = this._activedFormObject.setFieldByPos(BM.Enum.FieldType.ft_General, me._formHelper.getGeneralTypeSize(), question.index, 1, formData.colCount, formData.rowCount);
        //[linkInCell, fieldByCell];
        var field = fieldLinkSet[1];
        var link = fieldLinkSet[0];
        field.setGatherType(BM.Enum.FieldGatherType.fg_None);
        field.setTitle(question.titleName);
        field.setDefaultValue(question.titleName);
        link.setEditMode(BM.Enum.DataLinkEditMode.dl_ReadOnly);
        
        // value指标
        fieldLinkSet = this._activedFormObject.setFieldByPos(BM.Enum.FieldType.ft_General, me._formHelper.getGeneralTypeSize(), question.index, 2, formData.colCount, formData.rowCount);
        //[linkInCell, fieldByCell];
        field = fieldLinkSet[1];
        field.setGatherType(BM.Enum.QuestionGatherType2FieldGatherType[question.gatherType]);
        field.setTitle(question.titleName);
        field.setNullable(question.allowEmpty);
        //field.setAllowMultSelect(question.allowMultSelect);
	},
	
	_deleteQuestion: function(index) {
		// formdata的操作
		var me = this;
		var colCount = me._getColCount();
		var formData = me._formHelper.getGridTemplet(colCount - 1, 3);
		this._activedFormObject.FormStyle = formData;
		
		this._activedFormObject.deleteCol(index);	
		this._taskObject.markDirty();
	},
	
	_modifyQuestion: function(question) {
		var titleLink = this._activedFormObject.getLinkByPos(question.index, 1);
		if(titleLink){
			var titleField = this._activedFormObject.getFieldById(titleLink.LinkExpression);
			titleField.setTitle(question.titleName);
			titleField.setDefaultValue(question.titleName);
		}
		
		var valueLink = this._activedFormObject.getLinkByPos(question.index, 2);
		if(valueLink){
			var valueField = this._activedFormObject.getFieldById(valueLink.LinkExpression);
			var fType = BM.Enum.QuestionType2FieldType[question.type];
			var fSize = BM.Enum.QuestionType2FieldSize[question.type];
			this._activedFormObject.changeFieldType(valueLink, valueField, fType, fSize);
			valueField.setTitle(question.titleName);
        	valueField.setNullable(question.allowEmpty);
        	valueField.setAllowMultSelect(question.type == "multiChoice");
	      	valueField.setGatherType(BM.Enum.QuestionGatherType2FieldGatherType[question.gatherType]);
        	
        	if(question.enumObject){ // 增删改选择题都会回传enumObject
        		if(question.type == "multiChoice" || question.type == "singleChoice"){
        			// 改变之后还是选择题
	        		valueLink.setEditMode(BM.Enum.DataLinkEditMode.dl_DropDown);
	    			valueLink.setEnumStyle(BM.Enum.DataLinkEnumStyle.de_Title);
	    			valueLink.setEnumExpression(question.enumObject.ID);
	    			this._taskObject.updateEnumObject(question.enumObject);
        		} else{
        			// 删除了枚举
        			valueLink.setEditMode(BM.Enum.DataLinkEditMode.dl_Default);
    				valueLink.setEnumExpression(null);  
    				this._taskObject.deleteEnumObjectById(question.enumObject.ID);
        		}
        	} 
		}
		this._taskObject.markDirty();
		this._activedFormObject.markDirty();
	},	
	
	_getColCount: function() {
		var defReg = this._activedFormObject.getDefaultRegion();
		return defReg.RegionRight - defReg.RegionLeft + 2;
	},
	
	fieldTypeSelectMenuShow: function(){
		$("#question-type-menu").show();
	},
	
	fieldTypeSelectMenuHide: function(){
		$("#question-type-menu").hide();
		$(".field-value-item").parent().removeClass('field-type-edit');
	},
	
	_loadSurvey: function(){
		var me = this;
		var billtitle = this._taskObject.Title.substring(0,4) === '新建表单' ? '' : this._taskObject.Title;
		var billDesc = this._activedFormObject.FillingGuide || "";
		var contentContainer = $('.container .billform-content').empty();
		var titleContainer = $('.container .billform-title').empty();

		var billformtitleStr = '<div class="billform-title-item"><textarea id="billformtitle" class="billform-title-input textarea" placeholder="点此修改表单名称">' + billtitle + '</textarea></div><div class="mui-input-row"><textarea class="billform-title-description" placeholder="请输入填报说明">' + billDesc + '</textarea></div>'
		titleContainer.append(billformtitleStr);
		
		var titleElem = document.getElementById('billformtitle');
		autoTextarea(titleElem);
		
		for(var regId in this._activedFormObject.Regions){
			var region = this._activedFormObject.Regions.get(regId);
			for(var c = region.RegionLeft; c <= region.RegionRight; c++){
				var link = region.getLinkByPos(c, 2);
				var field;
				if(link){
					field = region.getFieldById(link.LinkExpression);
					if(field){
						var renderContext = {task: this._taskObj, form: this._activedFormObject, link: link, field: field};
						var qType = me._getQuestionType(field, link);
						var questionCreator = $.QuestionCreator[qType];
						var currentQuestion = me._getQuestion(field, link);
						questionCreator.render(me._taskObject,contentContainer,currentQuestion);
					}
				}
			}
		}
		me._showReleaseBtn();
		this._bindEvent(contentContainer);
	},
	
	_showReleaseBtn: function(){
		$(".billform-newfield").show();
		$(".billform-submit").show();
	},
	
	_getQuestionType: function(field, link){
		if(link.EditMode == BM.Enum.DataLinkEditMode.dl_DropDown || link.EditMode == BM.Enum.DataLinkEditMode.dl_DropDownEdit){
			if(field.AllowMultSelect){
				return "multiChoice";
			}
			return "singleChoice";
		}
		var qType = BM.Enum.FieldType2QuestionType[field.Type];
		return qType;
	},	
	
	// 根据field、datalink构造question对象
	_getQuestion: function(field, link){
		var me = this;
		var qType = this._getQuestionType(field, link);
		var question = {
			ID:"question_" + link.PosX,
			index:link.PosX,
			titleName:field.Title,
			type:qType,
			choiceItems:[],
			allowEmpty:field.Nullable,
			taskId: me._taskId,
			gatherType: BM.Enum.FieldGatherType2QuestionGatherType[field.GatherType]
		};
		
		if(link.EditMode == BM.Enum.DataLinkEditMode.dl_DropDown || link.EditMode == BM.Enum.DataLinkEditMode.dl_DropDownEdit) {
			if(link.hasEnumExpression()){
				var enumObject = this._taskObject.EnumObjects.get(link.EnumExpression);
				if(enumObject){
					for(var code in enumObject.EnumDataList){
						var enumItem = enumObject.EnumDataList[code];
						question.choiceItems.push(enumItem);
					}
					question.enumObject = enumObject;
				}
			}
		}
		return question;
	},
	
	_newDefaultQuestion: function(index){
		var newQuestion = {
			ID:"question_" + index, 
			index: index,   
			titleName:'新建题目', 
			type:'singleText',
			choiceItems:[], 
			allowEmpty:true,
			taskId: self._taskId,
			gatherType: BM.Enum.FieldGatherType2QuestionGatherType[BM.Enum.FieldGatherType.fg_None]
		};
		return newQuestion;
	},
	
	_bindEvent: function(container){
		var self = this;
		$("#billformtitle").off("input").on("input", function() {
			self._globalChanged = true;
		});
		
		$(".container .billform-title").off("focus","input, textarea").on("focus","input, textarea", function(){
			self.fieldTypeSelectMenuHide();
		});
		
		$(".container .billform-title-description").off("input").on("input", function(){
			// 设置描述
			var desc = $(this).val();
			self._activedFormObject.setFillGuide(desc);
		});
		
		container.off("click",".field-value-item").on("click",".field-value-item", function(e){
			$(".field-value-item").parent().removeClass('field-type-edit');
			$(this).parent().addClass('field-type-edit');
			
			var questionIndex = $(this).prev().attr('questionindex');
			if(questionIndex != '') {
				var question = self.getQuestionByIndex(parseInt(questionIndex));
				container.trigger('toolbarshow',[question]);
			}		
		});
		
		container.on("input",".field-title-input", function(){
			var questionIndex = $(this).parent().attr("questionindex");
			var question = self.getQuestionByIndex(parseInt(questionIndex));
			question.titleName = $(this).val() != '' ? $(this).val() : '新建题目';
			self._modifyQuestion(question);
		});
		
		container.off("click",".question-after-add[type=button]").on("click",".question-after-add[type=button]", function(){
			self.fieldTypeSelectMenuHide();
			
			var $this = $(this);
			var currentFieldId = this.parentElement.parentElement.id;
			var currentFieldObject = $(document.getElementById(currentFieldId));
			var currentFieldIndex = parseInt(currentFieldObject.children(".field-title-item").attr("questionindex"));			
			$.each(currentFieldObject.nextAll(), function(index,value) {
				var nextField = $(value).children(".field-title-item");
				var nextFieldIndex = nextField.attr("questionindex");
				if(null != nextField){
					var newFieldIndex = parseInt(nextFieldIndex) + 1;
					nextField.attr("questionindex", newFieldIndex);
					nextField.parent().attr("id","question_" + newFieldIndex);
					nextField.children("[name=order]").text(newFieldIndex + ".");
				}
			});			
			var newQuestion = self._newDefaultQuestion(currentFieldIndex + 1);
			var contentStr = $.QuestionCreator[newQuestion.type].getRenderHtml(null,container,newQuestion);
			var questionStr = ['<div id="'+ newQuestion.ID + '" class="field">', contentStr, '</div>'];
			currentFieldObject.after(questionStr.join(''));			
			$("#" + currentFieldId)[0].scrollIntoView(true);
			$('html, body').animate({ scrollTop: $("#" + currentFieldId).offset().top }, { duration: 'slow', easing: 'swing'});
			self._addQuestion(newQuestion);
			
			var elem = document.getElementById(newQuestion.ID).children[0].children[2];
			autoTextarea(elem);
		});
		
		container.off("click",".question-delete[type=button]").on("click",".question-delete[type=button]", function(){
			self.fieldTypeSelectMenuHide();
			
			var $this = $(this);
			var curQuesCount = $this.parent().parent().parent().children().length;
			if(curQuesCount == 1){
				mui.toast('必须保留一个问题哦，亲~');
				return;
			}
			var currentFieldId = this.parentElement.parentElement.id;
			var currentFieldObject = $(document.getElementById(currentFieldId));
			$.each(currentFieldObject.nextAll(), function(index,value) {
				var nextField = $(value).children(".field-title-item");
				var nextFieldIndex = nextField.attr("questionindex");
				if(null != nextField){
					var newFieldIndex = parseInt(nextFieldIndex) - 1;
					nextField.attr("questionindex", newFieldIndex);
					nextField.parent().attr("id","question_" + newFieldIndex);
					nextField.children("[name=order]").text(newFieldIndex + ".");
				}
			});
			currentFieldObject.remove();
			var deletedIndex = parseInt(currentFieldObject.children(".field-title-item").attr("questionindex"));
			self._deleteQuestion(deletedIndex);			
			
			//删除题目未发布之前暂不删除枚举
			var deletedQuestion = self.getQuestionByIndex(deletedIndex);
			if(deletedQuestion && deletedQuestion.enumObject) {
				self._toolbar.deleteEnumObject(deletedQuestion.enumObject);
			}
		});
		
		container.off("click",".field-empty-star").on("click",".field-empty-star", function(){
			var $this = $(this);
			var questionIndex = $(this).parent().attr("questionindex");
			var question = self.getQuestionByIndex(parseInt(questionIndex));
			
			if($this.hasClass('field-empty-forbid')) {
				$this.removeClass('field-empty-forbid');
				question.allowEmpty = true;
			}
			else {
				$this.addClass('field-empty-forbid');
				question.allowEmpty = false;
			}
			self._modifyQuestion(question);
		});
		
		container.off("focus","input, textarea, div[type='input']").on("focus","input, textarea, div[type='input']", function(){
			self.fieldTypeSelectMenuHide();
		});
		
	},
	
	///对外提供接口
	getCurrentTask: function () {
        return this._taskObject;
    },	
    
    getCurrentForm: function () {
        return this._activedFormObject;
    },
	
	getUndoUnit: function(){
		
	},
	
	getCurrentAction: function() {
		
	},
	
	isTaskEditable: function() {
		return true;
	},
	
	// 性能
	getQuestionByIndex: function(index){
		var link = this._activedFormObject.getLinkByPos(index, 2);
		if(link){
			var field = this._activedFormObject.getFieldById(link.LinkExpression);
			return this._getQuestion(field, link);
		}		
	}
});