$.Class("ItemList", MvcModel, {
	construct: function() {
		this._super().construct.call(this);
	},
	

	_allNumFieldList: [],
	_selectedNumField: null,
	_opener: null,

	onEntry: function() {
		this._super().onEntry.call(this);
		
		var self = this;
		document.addEventListener(mui.readyEvt_Jcp, function(){
			// 非App模式下未支持预加载窗口，因此在每次加载时进行初始化
			if(!mui.os.plus){
				self._allNumFieldList = mui.currentWebview.allNumFields;
				self._selectedNumField = mui.currentWebview.selectedNumField;
				self._opener = mui.currentWebview.opener;
				self._createList(mui.currentWebview.allNumFields, mui.currentWebview.selectedNumField);
			}			
		});				
		
		document.addEventListener('onShowItemList', function(event) {
			self._allNumFieldList = event.detail.allNumFields;
			self._selectedNumField = event.detail.selectedNumField;
			self._opener = event.detail.opener;
			self._createList(event.detail.allNumFields, event.detail.selectedNumField);
		});
		
		function hideItemList() {
			var opener = mui.getWebviewById(self._opener);
			mui.fire(opener, "onHideItemList", {});
		};
		
		if(mui.os.plus){ // 普通浏览器中滑动方向稍微有点倾斜就会触发该事件，调整为只在app中处理
			window.addEventListener("swiperight", hideItemList); 
		}		 
		document.getElementById("itemlist_back").addEventListener('tap', hideItemList);
		
		mui('.mui-bar').on("tap", '#itemlist_done', function() {
			self._onItemSelect();
		});
		mui("button").on("tap", "#itemlist_back", function(){
			mui.fire(opener, 'onHideItemList');
		});
		self._bindEvent();
	},
	
	_bindEvent: function() {
		var self = this;
		mui('.mui-content').on("tap", 'li', function(event) {
			var selected = $('.mui-icon', this).hasClass('item-selected');
			$('.mui-content .item .mui-icon.item-selected').each(function() {
				$(this).removeClass('item-selected');
			});
				
			$('.mui-icon', this).toggleClass('item-selected');
			self._onItemSelect();
		});
	},
	
	_createList: function(items, selected) {
		if (!items || !items.length) return;
		if(!selected)
			selected = items[0];
		var listStr = '';
		for (var i = 0, len = items.length; i < len; i++) {
			var item = items[i];
			var isSelected = item.dataLink == selected.dataLink ? true : false;
			var itemStr = this._generateItemStr(item, isSelected);
			if (!itemStr) continue;
			listStr += itemStr;
		}
		
		$("#itemlist_content").empty().append('<ul class="mui-table-view">' + listStr + '</ul>');
	},
	
	_generateItemStr: function(item, isSelected) {
		if (!item) return null;
		var itemStyle = isSelected ? " item-selected" : '';
		var itemStr = ['<li id="' + item.dataLink + '" class="mui-table-view-cell item">', '<div class="title"><span>' + item.title + '</span></div><div class="icon"><span class="mui-icon' + itemStyle + '"></span></div>', '</li>'];
		return itemStr.join("");
	},
	
	_onItemSelect: function() {
		this._getSelectedItems();
		
		var self = this, opener = mui.getWebviewById(self._opener);
		mui.fire(opener, 'onItemSelect', {
		  	selectdatalinkid: self._selectedNumField
		});
	},
	
	_getSelectedItems: function() {
		var items = $(".mui-content .item .mui-icon.item-selected");
		if (!items) return;
		this._selectedNumField = {dataLink: items.parent().parent().attr('id'), title: items.parent().prev().children().text()}; 				
	},

    onDestroy: function() {
        this._super().onDestroy.call(this);
    }
});