/*var question = {
	ID:'1001',  //唯一标识
	index:1,    //在问题列表中的索引
	titleName:'题目2',  //题目名称
	type:'singleChoice', //题目类型
	choiceItems:['特大','重大','大','一般'], //选择题选项
	allowEmpty:'false'  //是否允许为空
},*/
/*
* 题型操作基类
* */
$.Class("questionCreator", {
	/*
	* 构造出问题的输入部分
	* 由不同的子类分别实现
	* */
	renderInput: function(question){
		throw "not implemented";
	},
	
	
	/*
	* 构造出问题
	* 不同类型问题通用的部分可在此构造，比如题目
	* */
	//	总是在最后添加一个新问题??
	render: function(taskObj,container,question){
		//
		var input = this.renderInput(question);
		var allowEmptyClass = question.allowEmpty == 'true' ? 'field-empty-forbid' : '';
		var contentStr = this.getRenderHtml(taskObj,container,question);
		var questionStr = ['<div id="'+ question.ID + '" class="field">', contentStr, '</div>'];
		var questionObj = $(questionStr.join(''));
		container.append(questionObj);
		var elem = document.getElementById(question.ID).children[0].children[2];
		autoTextarea(elem);
	},
	
	getRenderHtml: function(taskObj,container,question){
		var input = this.renderInput(question);
		var defaultTitle = question.titleName === '新建题目' ? '' : question.titleName;
		var allowEmptyClass = question.allowEmpty == false ? 'field-empty-forbid' : '';
		var questionStr = ['<div class="field-title-item" questionIndex='+ question.index +'>',
		'<span class="field-empty-star '+ allowEmptyClass + '">*</span>' ,
		'<label name="order" class="field-order">' + (question.index) + '.</label>',
		'<textarea class="field-title-input textarea" placeholder="点此修改题目名称">' + defaultTitle + '</textarea>',
		'<span type="button" class="question-after-add question-add-icon"></span>',
		'<span type="button" class="question-delete question-delete-icon"></span>',
		'</div>', input];
		return questionStr.join('');
	},
	
	reRender:function(taskObj,container,question){
		//修改类型时，只绘制内容，标题不变
		var questionStr = this.getRenderHtml(taskObj,container,question);
		$(document.getElementById(question.ID)).html(questionStr);
		return question;		
	},
	
	//绘制不同类型的汇总结果显示
	renderTotalResult: function(container, question) {
		var forbidEmpty = question.allowEmpty == false ? '*' : '';
		var detailDataHtml = '';
		if(question.type === 'integer' || question.type === 'float') 
			detailDataHtml = '<button class="field-detail-btn" type="button">' + (question.billPeriod == '6' ? '30天数据详情' : '详细数据') + '</button>';
		var questionStr = ['<div class="field-title-item" questionIndex='+ question.dataItem.Index +'>',
		'<span class="field-empty-star">' + forbidEmpty + '</span>' ,
		'<label name="order" class="field-order">' + (question.dataItem.Index) + '、</label>',
		'<label class="field-title-input textarea">' + question.dataItem.Title + '</label>',
		detailDataHtml,
		'</div>'];
		var questionStr = ['<div id="'+ question.ID + '" class="field" datalink="' + question.dataItem.DataLinkId + '" fieldid="' + question.dataItem.FieldId + '" index="' + question.dataItem.Index + '" fieldtype="' + question.type + '">', questionStr.join(''), '</div>'];
		var questionObj = $(questionStr.join(''));
		container.append(questionObj);
		//绘图
		this.renderTotalResultCont(container, question);
	},
	
	//绘制各题目的详细结果显示
	renderDetailResult: function(container, question, detailResultData) {
		
	},
	
	//绘制不同类型题目的总体结果显示
	renderTotalResultCont: function(container, question, totalResultData) {
		throw "not implemented";
	},
	
	//绘制不同类型题目的详细结果显示
	renderDetailResultCont: function(question, detailResultData) {
		throw "not implemented";
	},
});

/*
* 单行文本题型操作类
* */
$.Class("singleTextQuestionCreator", questionCreator, {
	renderInput: function(question){
		var itemStr = '<div class="field-value-item" fieldtype="singleText" gatherType="' + question.gatherType + '"><input type="text" readonly="readonly" placeholder="单行文本（点我更改类型）"></div>';
		return itemStr;
	},
	
	renderTotalResultCont: function(container, question) {
		var itemStr = '<div class="field-value-item" fieldtype="singleText" gatherType="' + question.gatherType + '"><span>共收到' + question.dataItem.RecordCount + '条数据。</span><button class="field-detail-btn" type="button">详细数据</button></div>';
		$("#" + question.ID).append(itemStr);
	},
	
	renderDetailResultCont: function(question, detailResultData) {
		return itemStr;
	}
});


/*
* 多行文本题型操作类
* */
$.Class("multiTextQuestionCreator", questionCreator, {
	renderInput: function(question){
		var itemStr = '<div class="field-value-item" fieldtype="multiText" gatherType="' + question.gatherType + '"><textarea type="text" readonly="readonly" placeholder="多行文本（点我更改类型）"></textarea></div>';
		return itemStr;
	},
	
	renderTotalResultCont: function(container, question) {
		var itemStr = '<div class="field-value-item" fieldtype="singleText" gatherType="' + question.gatherType + '"><span>共收到' + question.dataItem.RecordCount + '条数据。</span><button class="field-detail-btn" type="button">详细数据</button></div>';
		$("#" + question.ID).append(itemStr);
	},
	
	renderDetailResultCont: function(question, detailResultData) {
		return itemStr;
	}
});


/*
* 整型操作类
* */
$.Class("integerQuestionCreator", questionCreator, {
	renderInput: function(question){
		var itemStr = '<div class="field-value-item" fieldtype="integer" gatherType="' + question.gatherType + '"><input type="integer" readonly="readonly" placeholder="整型（点我更改类型）"></div>';
		return itemStr;
	},
	
	renderTotalResultCont: function(container, question) {
		var textStr = '<span>共收到' + question.dataItem.RecordCount + '条数据;数据累计值：' + question.dataItem.Sum+ '。</span>';
		var len = Math.floor($("#" + question.ID + " .field-title-item").width() / 16);
		if(textStr.length - 15 > len){
			textStr = '<textarea readonly="readonly">共收到' + question.dataItem.RecordCount + '条数据;数据累计值：\n' + question.dataItem.Sum + '。</textarea>';
		}
		var itemStr = '<div class="field-value-item" fieldtype="integer" gatherType="' + question.gatherType + '">' + textStr + '</div>';
		$("#" + question.ID).append(itemStr);
		if(question.dataItem.RecordCount < 1) 
			return;
		$("#" + question.ID).append('<div id="' + question.ID + '_chart" class="field-value-item" style="width:100%;height:150px;"></div>');
		var Options = {
			title: {
				show: false,
				text: '',
				textStyle: {
					fontSize: 16,
				    fontWeight: 'bold',
				    color: '#535353'
				}
			},
			grid: {
				x: '80',
				y: '20',
				x2: '40',
				y2: '40',
				borderWidth:0,
			},
			tooltip:{
				show:true,
				trigger: 'items'
			},
			calculable : false,
		    xAxis : [
		        {
		            type : 'value' ,
		            splitNumber: 3,
		            scale:false	,
		            splitLine:{
		            	show:false
		            },
		            axisLine:{
		            	show:false
		            },
		            axisLabel:{
		            	show:false
		            }
		        }
		    ],
		    yAxis : [
		        {
		            type : 'category',
		            data : ['最大值', '平均值', '最小值'],
		            axisTick:{
			    		show:false
			    	},
			    	splitLine:{
			    		show:false
			    	},
			    	axisLine:{
		            	show:false
		            }
		        }
		    ],
		    series : [
		        {
		            type:'bar',
		            data:[question.dataItem.Max, question.dataItem.Avg.toFixed(2), question.dataItem.Min],
		            barWidth:20,
		            itemStyle:{
		            	normal:{
		            		label:{
		            			show:true,
		            			textStyle : {
		                            fontSize : '14',
		                            fontFamily : '微软雅黑',
		                            fontWeight : 'normal'
		                        }
		            		}
		            	}
		            }
		        },
		    ]
		};
		var barChart = echarts.init(document.getElementById(question.ID + "_chart"));
		barChart.setOption(Options);
		
	},
	
	renderDetailResultCont: function(question, detailResultData) {
		return itemStr;
	}
});

/*
* 浮点题型操作类
* */
$.Class("floatQuestionCreator", questionCreator, {
	renderInput: function(question){
		var itemStr = '<div class="field-value-item" fieldtype="float" gatherType="' + question.gatherType + '"><input type="float" readonly="readonly" placeholder="浮点型（点我更改类型）"></div>';
		return itemStr;
	},
	
	renderTotalResultCont: function(container, question) {
		var textStr = '<span>共收到' + question.dataItem.RecordCount + '条数据;数据累计值：' + question.dataItem.Sum.toFixed(2) + '。</span>';
		var len = Math.floor($("#" + question.ID + " .field-title-item").width() / 16);
		if(textStr.length - 15 > len){
			textStr = '<textarea readonly="readonly">共收到' + question.dataItem.RecordCount + '条数据;数据累计值：\n' + question.dataItem.Sum.toFixed(2) + '。</textarea>';
		}
		var itemStr = '<div class="field-value-item" fieldtype="integer" gatherType="' + question.gatherType + '">' + textStr + '</div>';
		$("#" + question.ID).append(itemStr);
		if(question.dataItem.RecordCount < 1) 
			return;
		$("#" + question.ID).append('<div id="' + question.ID + '_chart" class="field-value-item" style="width:100%;height:150px;"></div>');
		var Options = {
			title: {
				show: false,
				text: '',
				textStyle: {
					fontSize: 16,
				    fontWeight: 'bold',
				    color: '#535353'
				}
			},
			grid: {
				x: '80',
				y: '20',
				x2: '40',
				y2: '40',
				borderWidth:0
			},
			tooltip:{
				show:true,
				trigger: 'items'
			},
			calculable : false,
		    xAxis : [
		        {
		            type : 'value' ,
		            axisLabel:{
		            	show:false,
		            },
		            splitNumber: 3,
		            scale:false,
		            splitLine:{
		            	show:false
		            },
		            axisLine:{
		            	show:false
		            }
		            
		        }
		    ],
		    yAxis : [
		        {
		            type : 'category',
		            data : ['最大值', '平均值', '最小值'],
		            axisTick:{
			    		show:false
			    	},
			    	splitLine:{
		            	show:false
		            },
		            axisLine:{
		            	show:false
		            }
		        }
		    ],
		    series : [
		        {
		            type:'bar',
		            data:[question.dataItem.Max.toFixed(2), question.dataItem.Avg.toFixed(2), question.dataItem.Min.toFixed(2)],
		            barWidth:20,
		            itemStyle:{
		            	normal:{
		            		label:{
		            			show:true,
		            			textStyle : {
		                            fontSize : '14',
		                            fontFamily : '微软雅黑',
		                            fontWeight : 'normal'
		                        }
		            		}
		            	}
		            }
		        },
		    ]
		};
		var barChart = echarts.init(document.getElementById(question.ID + "_chart"));
		barChart.setOption(Options);
		
	},
	
	renderDetailResultCont: function(question, detailResultData) {
		return itemStr;
	}
});

/*
* 单选题型操作类
* */
$.Class("singleChoiceQuestionCreator", questionCreator, {
	renderInput: function(question){
		var itemStr = '<div class="field-value-item list" fieldtype="singleChoice" gatherType="' + question.gatherType + '">';		
		var enumObject = question.enumObject;
		if(!enumObject) return;
		var curChoicesItems = [];
		for(var code in enumObject.EnumDataList){
			var enumItem = enumObject.EnumDataList[code];
			curChoicesItems.push(enumItem);
		}
		curChoicesItems.sort(
	        function (a, b) {
	            if (a.Order < b.Order) return -1;
	            if (a.Order > b.Order) return 1;
	            return 0;
	        }
        );
		for(var i = 0;i < curChoicesItems.length; i++){
			var enumItem = curChoicesItems[i];
			var value = enumItem.Title;
			itemStr += '<div class="mui-input-row mui-radio mui-left"><label>' + value + '</label><input enumCode="' + enumItem.Code + '" disabled="true" type="radio"></div>';
		}
		itemStr += '</div>';
		return itemStr;
	},
	
	renderTotalResultCont: function(container, question) {
		var chartHeight = (question.organizations.length * 30) + 40;
		var itemStr = '<div class="field-value-item" fieldtype="singleChoice" gatherType="' + question.gatherType + '"><span>共收到' + question.dataItem.RecordCount + '条数据。</span><button class="field-detail-btn" type="button">分类统计</button></div>';
		$("#" + question.ID).append(itemStr);
		if(question.dataItem.RecordCount < 1) 
			return;
		$("#" + question.ID).append('<div id="' + question.ID + '_chart" class="field-value-item" style="width:100%;height:' + chartHeight + 'px;"></div>');		
		var Options = {
		    title : {
		    	show:false,
		        text: '',
		        textStyle: {
					fontSize: 16,
				    fontWeight: 'bold',
				    color: '#535353'
				}
		    },
		    tooltip : {
		    	show:true,
		        trigger: 'items',
		        axisPointer: {
		        	type:'none'
		        }
		    },
		    legend: {
		    	show:false,
		        data:['蒸发量','降水量'],
		        x:'right'
		    },
		    grid: {
				x: '80',
				y: '20',
				x2: '40',
				y2: '40',
				borderWidth:0
			},
		    toolbox: {
		        show : false,
		        feature : {
		            mark : {show: true},
		            dataView : {show: true, readOnly: false},
		            magicType : {show: true, type: ['line', 'bar']},
		            restore : {show: true},
		            saveAsImage : {show: true}
		        },
		        orient:'vertical',
		        x: 'right',
		        y: 'center'
		    },
		    calculable : false,
		    xAxis : [
		        {
		            type : 'value' ,
		            splitLine:{
		            	show:false
		            },
		            axisLine:{
		            	show:false,
		            },
		            axisLabel:{
		            	show:false,
		            }
//		            boundaryGap : [0, 5]
		        }
		    ],
		    yAxis : [
		        {
		            type : 'category',
		            data : question.organizations,
		            axisTick:{
			    		show:false
			    	},
			    	axisLabel:{  
                        interval:0 ,  
                    },
                    splitLine:{
		            	show:false
		            },
		            axisLine:{
		            	show:false
		            }
		        }
		    ],
		    series : [
		        {
		            type:'bar',
		            data:question.value,
		            barWidth:20,
		            itemStyle:{
		            	normal:{
		            		label:{
		            			show:true,
		            			textStyle : {
		                            fontSize : '14',
		                            fontFamily : '微软雅黑',
		                            fontWeight : 'normal'
		                        }
		            		}
		            	}
		            }
		        },
		    ]
		};
		var barChart = echarts.init(document.getElementById(question.ID + "_chart"));
		barChart.setOption(Options);
	},
	
	renderDetailResultCont: function(question, detailResultData) {
		return itemStr;
	}
});
/*
* 多选题型操作类
* */
$.Class("multiChoiceQuestionCreator", questionCreator, {
	renderInput: function(question){
		var itemStr = '<div class="field-value-item list" fieldtype="multiChoice" gatherType="' + question.gatherType + '">';		
		var enumObject = question.enumObject;
		if(!enumObject) return;
		var curChoicesItems = [];
		for(var code in enumObject.EnumDataList){
			var enumItem = enumObject.EnumDataList[code];
			curChoicesItems.push(enumItem);
		}
		curChoicesItems.sort(
	        function (a, b) {
	            if (a.Order < b.Order) return -1;
	            if (a.Order > b.Order) return 1;
	            return 0;
	        }
        );
		for(var i = 0;i < curChoicesItems.length; i++){
			var enumItem = curChoicesItems[i];
			var value = enumItem.Title;
			itemStr += '<div class="mui-input-row mui-checkbox mui-left"><label>' + value + '</label><input enumCode="' + enumItem.Code + '" disabled="true" type="checkbox"></div>';
		}
		itemStr += '</div>';
		return itemStr;
	},
	
	renderTotalResultCont: function(container, question) {
		var itemStr = '<div class="field-value-item" fieldtype="multiChoice" gatherType="' + question.gatherType + '"><span>共收到' + question.dataItem.RecordCount + '条数据。</span><button class="field-detail-btn" type="button">详细数据</button></div>';
		$("#" + question.ID).append(itemStr);
		$("#" + question.ID).append('<div id="' + question.ID + '_chart" class="field-value-item" style="width:100%;height:200px;"></div>');

		var Options = {
			title: {
				show:false,
				text:'',
				textStyle: {
					fontSize: 16,
				    fontWeight: 'bold',
				    color: '#535353'
				}
			},
		    toolbox: {
		        show : false,
		        feature : {
		            mark : {show: true},
		            dataView : {show: true, readOnly: false},
		            magicType : {show: true, type: ['line', 'bar']},
		            restore : {show: true},
		            saveAsImage : {show: true}
		        },
		        orient:'vertical',
		        x: 'right',
		        y: 'center'
		    },
		    grid: {
				x: '80',
				y: '20',
				x2: '40',
				y2: '40',
				borderWidth:0
			},
		    calculable : true,
		    xAxis : [
		        {
		            type : 'value' ,
		            splitLine:{
		            	show:false
		            },
		            axisLine:{
		            	show:false,
		            },
		            axisLabel:{
		            	show:false
		            }
		        }
		    ],
		    yAxis : [
		        {
		            type : 'category',
		            data : question.organizations,
		            axisTick:{
			    		show:false
			    	},
			    	axisLabel:{  
                        interval:0 ,  
                    } ,
                    splitLine:{
		            	show:false
		            },
		            axisLine:{
		            	show:false,
		            }
		        }
		    ],
		    series : [
		        {
		            type:'bar',
		            data:question.value,
		            barWidth:20,
		            itemStyle:{
		            	normal:{
		            		label:{
		            			show:true,
		            			textStyle : {
		                            fontSize : '14',
		                            fontFamily : '微软雅黑',
		                            fontWeight : 'normal'
		                        }
		            		}
		            	}
		            }
		        },
		    ]
		};
		var barChart = echarts.init(document.getElementById(question.ID + "_chart"));
		barChart.setOption(Options);
	},
	
	renderDetailResultCont: function(question, detailResultData) {
		return itemStr;
	}
});


/*
* 日期题型操作类
* */
$.Class("dateQuestionCreator", questionCreator, {
	renderInput: function(question){
		var myDate = new Date();
		var todayStr = myDate.getFullYear() + '/' + (myDate.getMonth() + 1) + '/' + myDate.getDate();
		var itemStr = ['<div class="field-value-item mui-table-view" fieldtype="date">','<span class="field-date-value">yyyy/mm/dd</span>',
		'<span class="mui-icon mui-icon-arrowdown field-date-icon"></span>','</div>'];
		return itemStr.join('');
	},
	
	renderTotalResultCont: function(container, question) {
		var itemStr = '<div class="field-value-item" fieldtype="date" gatherType="' + question.gatherType + '"><span>共收到' + question.dataItem.RecordCount + '条数据。</span><button class="field-detail-btn" type="button">详细数据</button></div>';
		$("#" + question.ID).append(itemStr);
	},
	
	renderDetailResultCont: function(question, detailResultData) {
		return itemStr;
	}
});

/*
* 日期时间题型操作类
* */
$.Class("datetimeQuestionCreator", questionCreator, {
	renderInput: function(question){
		var myDate = new Date();
		var todayStr = myDate.getFullYear() + '/' + (myDate.getMonth() + 1) + '/' + myDate.getDate() + ' 00:00:00';
		var itemStr = ['<div class="field-value-item mui-table-view" fieldtype="datetime">','<span class="field-date-value">yyyy/mm/dd 00:00:00</span>',
		'<span class="mui-icon mui-icon-arrowdown field-date-icon"></span>','</div>'];
		return itemStr.join('');
	},
	
	renderTotalResultCont: function(container, question) {
		var itemStr = '<div class="field-value-item" fieldtype="datetime" gatherType="' + question.gatherType + '"><span>共收到' + question.dataItem.RecordCount + '条数据。</span><button class="field-detail-btn" type="button">详细数据</button></div>';
		$("#" + question.ID).append(itemStr);
	},
	
	renderDetailResultCont: function(question, detailResultData) {
		return itemStr;
	}
});

/*
* 布尔题型操作类
* */
$.Class("boolQuestionCreator", questionCreator, {
	renderInput: function(question){
		var itemStr = '<div class="mui-switch mui-switch-mini value-switch mui-active field-value-item field-value-switch" fieldtype="bool"><div class="mui-switch-handle"></div></div>'
		return itemStr;
	},
	
	renderTotalResultCont: function(container, question) {
		var itemStr = '<div class="field-value-item" fieldtype="bool" gatherType="' + question.gatherType + '"><span>共收到' + question.dataItem.RecordCount + '条数据。</span><button class="field-detail-btn" type="button">详细数据</button></div>';
		$("#" + question.ID).append(itemStr);
		if(question.dataItem.RecordCount < 1) 
			return;
		$("#" + question.ID).append('<div id="' + question.ID + '_chart" class="field-value-item" style="width:100%;height:150px;"></div>');
		var Options = {
		    tooltip : {
		        trigger: 'item',
		        formatter: "{a} <br/>{b} : {c} ({d}%)"
		    },
		    toolbox: {
		        show : false,
		    },
		    calculable : false,
		    series : [
		        {
		            name:'统计结果',
		            type:'pie',
		            radius : '65%',
		            center: ['50%', '50%'],
		            data:[
		                {value:question.dataItem.TrueCount, name:'是'},
		                {value:question.dataItem.FalseCount, name:'否'}
		            ],
		            itemStyle : {
		                normal : {
		                    label : {
		                        position : 'inner',
		                        formatter : function (params) {                         
		                          return (params.percent - 0).toFixed(0) + '%'
		                        }
		                    },
		                    labelLine : {
		                        show : false
		                    }
		                },
		                emphasis : {
		                    label : {
		                        show : true,
		                        formatter : "{b}\n{d}%"
		                    }
		                }
		                
		            },
		        }
		    ]
		};
		var barChart = echarts.init(document.getElementById(question.ID + "_chart"));
		barChart.setOption(Options);
	},
	
	renderDetailResultCont: function(question, detailResultData) {
		return itemStr;
	}
});


/*
* 评分题型操作类
* */
$.Class("scoreQuestionCreator", questionCreator, {
	renderInput: function(question){
		var itemStr = ['<div class="field-value-item" fieldtype="score" gatherType="' + question.gatherType + '">','<ul class="mui-table-view-cell">',
		'<li><span class="field-type-score-icon"></span></li>',
		'<li><span class="field-type-score-icon"></span></li>',
		'<li><span class="field-type-score-icon"></span></li>',
		'<li><span class="field-type-score-icon"></span></li>',
		'<li><span class="field-type-score-icon"></span></li>',
		'</ul>','</div>'];
		return itemStr.join('');
	},
});

/*
* 附件类型操作类
* */
$.Class("attachQuestionCreator", questionCreator, {
	renderInput: function(question){
		var itemStr = '<div class="field-value-item" fieldtype="attach" gatherType="' + question.gatherType + '"><input type="text" readonly="readonly" placeholder="附件（点我更改类型）"></div>';
		return itemStr;
	},
	
	renderTotalResultCont: function(container, question) {
		var textStr = '<span>共收到' + question.dataItem.RecordCount + '条数据; 附件总数：' + question.dataItem.FileCount + '。</span>';
		var len = Math.floor($("#" + question.ID + " .field-title-item").width() / 16);
		if(textStr.length - 15 > len){
			textStr = '<textarea readonly="readonly">共收到' + question.dataItem.RecordCount + '条数据; 附件总数：\n' + question.dataItem.FileCount + '。</textarea>';
		}
		var itemStr = '<div class="field-value-item" fieldtype="attach" gatherType="' + question.gatherType + '">' + textStr + '</div>';
		$("#" + question.ID).append(itemStr);
		
	},
	
	renderDetailResultCont: function(question, detailResultData) {
		return itemStr;
	}
});

$.QuestionCreator = {
	singleText: $.New(singleTextQuestionCreator),
	multiText: $.New(multiTextQuestionCreator),
	integer: $.New(integerQuestionCreator),
	float: $.New(floatQuestionCreator),
	singleChoice: $.New(singleChoiceQuestionCreator),
	multiChoice: $.New(multiChoiceQuestionCreator),
	date: $.New(dateQuestionCreator),
	datetime: $.New(datetimeQuestionCreator),
	bool: $.New(boolQuestionCreator),
	score: $.New(scoreQuestionCreator),
	attach: $.New(attachQuestionCreator)
};

// 指标类型对应的问题类型
BM.Enum.FieldType2QuestionType = {
    /// <summary>
    /// 常规类型，新建后默认的指标类型。ft_General: 0
    /// </summary>
    0: "singleText",
    /// <summary>
    /// 浮点数，内部处理成double，有效精度不超过15。ft_Float: 1
    /// </summary>
    1: "float",
    /// <summary>
    /// 字符类型，为保证效率，最大长度500。ft_String: 2
    /// </summary>
    2: "singleText",
    /// <summary>
    /// 整数类型。ft_Integer: 3
    /// </summary>
    3: "integer",
    /// <summary>
    /// 逻辑/布尔类型。ft_Logic: 4
    /// </summary>
    4: "bool",
    /// <summary>
    /// 日期类型。ft_Date: 5
    /// </summary>
    5: "date",
    /// <summary>
    /// 时间日期型。ft_DateTime: 6
    /// </summary>
    6: "datetime",
    /// <summary>
    /// Guid类型。ft_Guid: 7
    /// </summary>
    7: "singleText",
    /// <summary>
    /// 数值型，有效精度不超过28。ft_Decimal: 8
    /// </summary>
    8: "float",
    /// <summary>
    /// 时间戳。ft_TimeStamp: 9
    /// </summary>
    9: "date",
    /// <summary>
    /// 文本类型。ft_Text: 16
    /// </summary>
    16: "multiText",
    /// <summary>
    /// 图片类型，只能存储一幅图片。ft_Picture: 17
    /// </summary>
    17: "singleText",
    /// <summary>
    /// 二进制类型，可以存储多个文件。ft_Binary: 18
    /// </summary>
    18: "attach",
    /// <summary>
    /// 未定义类型或错误类型，为默认值。ft_Error: 127
    /// </summary>
    127: "singleText",
};

// 问题类型对应的指标类型
BM.Enum.QuestionType2FieldType = {
	"singleText": BM.Enum.FieldType.ft_String,
	"multiText": BM.Enum.FieldType.ft_Text,
	"integer": BM.Enum.FieldType.ft_Integer,
	"float": BM.Enum.FieldType.ft_Float,
	"singleChoice": BM.Enum.FieldType.ft_String,
	"multiChoice": BM.Enum.FieldType.ft_String,
	"date": BM.Enum.FieldType.ft_Date,
	"datetime":BM.Enum.FieldType.ft_DateTime,
	"bool": BM.Enum.FieldType.ft_Logic,
	"score": BM.Enum.FieldType.ft_Float,
	"attach":BM.Enum.FieldType.ft_Binary,
};

// 问题类型对应的指标默认汇总类型
/*BM.Enum.QuestionType2FieldGatherType = {
	"singleText": BM.Enum.FieldGatherType.fg_None,
	"multiText": BM.Enum.FieldGatherType.fg_None,
	"integer": BM.Enum.FieldGatherType.fg_Sum,
	"float": BM.Enum.FieldGatherType.fg_Sum,
	"singleChoice": BM.Enum.FieldGatherType.fg_None,
	"multiChoice": BM.Enum.FieldGatherType.fg_None,
	"date": BM.Enum.FieldGatherType.fg_None,
	"datetime": BM.Enum.FieldGatherType.fg_None,
	"bool": BM.Enum.FieldGatherType.fg_Count,
	"score": BM.Enum.FieldGatherType.fg_Avg,
	"attach": BM.Enum.FieldGatherType.fg_None,
};*/

// 问题类型对应的指标可选汇总类型
BM.Enum.QuestionType2FieldGatherType = {
	"singleText": [BM.Enum.FieldGatherType.fg_None],
	"multiText": [BM.Enum.FieldGatherType.fg_None],
	"integer": [BM.Enum.FieldGatherType.fg_Sum, BM.Enum.FieldGatherType.fg_Count, BM.Enum.FieldGatherType.fg_Max, BM.Enum.FieldGatherType.fg_Min, BM.Enum.FieldGatherType.fg_Avg, BM.Enum.FieldGatherType.fg_None],
	"float": [BM.Enum.FieldGatherType.fg_Sum, BM.Enum.FieldGatherType.fg_Count, BM.Enum.FieldGatherType.fg_Max, BM.Enum.FieldGatherType.fg_Min, BM.Enum.FieldGatherType.fg_Avg, BM.Enum.FieldGatherType.fg_None],
	"singleChoice": [BM.Enum.FieldGatherType.fg_None],
	"multiChoice": [BM.Enum.FieldGatherType.fg_None],
	"date": [BM.Enum.FieldGatherType.fg_None, BM.Enum.FieldGatherType.fg_Max, BM.Enum.FieldGatherType.fg_Min],
	"datetime": [BM.Enum.FieldGatherType.fg_None, BM.Enum.FieldGatherType.fg_Max, BM.Enum.FieldGatherType.fg_Min],
	"bool": [BM.Enum.FieldGatherType.fg_None, BM.Enum.FieldGatherType.fg_Count],
	"score": [BM.Enum.FieldGatherType.fg_None, BM.Enum.FieldGatherType.fg_Avg],
	"attach": [BM.Enum.FieldGatherType.fg_None],
};

//指标汇总类型对应的问题汇总类型
BM.Enum.QuestionGatherType2FieldGatherType = {
	"none": BM.Enum.FieldGatherType.fg_None,
	"sum": BM.Enum.FieldGatherType.fg_Sum,
	"count": BM.Enum.FieldGatherType.fg_Count,
	"averge": BM.Enum.FieldGatherType.fg_Avg,
	"max": BM.Enum.FieldGatherType.fg_Max,
	"min": BM.Enum.FieldGatherType.fg_Min
};
//问题汇总类型对应的指标汇总类型
BM.Enum.FieldGatherType2QuestionGatherType = {
	0: "none",
	1: "sum",
	2: "count",
	3: "averge",
	4: "min",
	5: "max",
	6: "reCal"
	
};

// 问题类型对应的指标长度、精度
BM.Enum.QuestionType2FieldSize = {
	"singleText": 501,
	"multiText": 0,
	"integer": 0, 
	"float": 2, //精度
	"singleChoice": 501,
	"multiChoice": 501,
	"date": 0,
	"datetime": 0,
	"bool": 1,
	"score": 0,
	"attach": 0,
};
//问题类型对应结果查看绘图类型
BM.Enum.QuestionResultChartType = {
	//不绘图
	0: "none",
	//绘制单位-指标柱状图
	1: "entityValue",
	//绘制时期-指标折线图
	2: "periodValue",
	//绘制选择题-数值型指标累计值柱状图
	3: "EnumGatherValue"
};
//问题类型对应的详细结果查询绘图类型
BM.Enum.QuestionType2ChartType = {
	"singleText": BM.Enum.QuestionResultChartType[0],
	"multiText": BM.Enum.QuestionResultChartType[0],
	"integer": BM.Enum.QuestionResultChartType[1],
	"float": BM.Enum.QuestionResultChartType[1],
	"bool": BM.Enum.QuestionResultChartType[0],
	"singleChoice": BM.Enum.QuestionResultChartType[3],
	"muitiChoice": BM.Enum.QuestionResultChartType[3],
	"date": BM.Enum.QuestionResultChartType[0],
	"datetime": BM.Enum.QuestionResultChartType[0],
	"score": BM.Enum.QuestionResultChartType[0],
	"attach": BM.Enum.QuestionResultChartType[0],
};
