$.Class("BM_DetailResultShow", MvcModel, {
	_dataLink:0,
	_fieldId:0,
	_index:0,
	_dataItemLength:0,
	_questionType:null,
	_chartType:null,
	_questionTitle: null,
	_CanSelectNumField:[],
	_selectedNumField: null,
	Context : {
		UserId: null,
        TaskId: 0,
        Period: null,
        PeriodType: null,
        EntityKey: null,
        PeriodCount: 0,		
	},
	construct: function(){
		this._super().construct.call(this);	
	},
	 
	onEntry: function() {
		var me = this;
		this._super().onEntry.call(this);
		document.addEventListener(mui.readyEvt_Jcp, function(){
			me._init();
			me._bindEvent();
		});
		window.addEventListener('onItemSelect', function(event){
			me._refresh(event.detail.selectdatalinkid);
			closeItemList();
		});
		window.addEventListener('onHideItemList', function(event){
			closeItemList();
		});
	},
    
	_init: function() {
		var self = this;
		self.Context.TaskId = mui.currentWebview.taskId;
		self.Context.Period = mui.currentWebview.period;
		self.Context.EntityKey = mui.currentWebview.entityKey;
		self.Context.PeriodType = mui.currentWebview.periodType;
		self.Context.PeriodCount = mui.currentWebview.periodCount;
		self._dataLink = mui.currentWebview.dataLink;
		self._fieldId = mui.currentWebview.fieldId;
		self._CanSelectNumField = mui.currentWebview.allNumDataLinks;
		self._index = mui.currentWebview.index;
		self._questionType = mui.currentWebview.type || 'none';
		self._questionTitle = mui.currentWebview.questionTitle;
		
		if(mui.currentWebview.allNumDataLinks && mui.currentWebview.allNumDataLinks.length > 0) {
			self._selectedNumField = self._CanSelectNumField[0];
		}		
		self._chartType = QuestionType2ChartType[mui.currentWebview.type];
		//如果数值型指标而且是日报类型，则画时期-指标折线图
		if((self._questionType == 'integer' || self._questionType == 'float') && this.Context.PeriodType == '6' && this.Context.PeriodCount > 0){
			self._chartType = QuestionResultChartType[2];
		}
		
		self._loadData();
				
	},

	_loadData: function(callback){
		var me = this;
		var url = $.BaseUrl + "FillResult/LoadDetailResultData?_taskId_=" + me.Context.TaskId;
		mui.showWaiting('正在加载数据...');
		var data = {
			chartType: me._chartType,
			period: me.Context.Period,
			entityKey: me.Context.EntityKey,
			linkId: me._dataLink,
			selectNumLinkId: me._selectedNumField ? me._selectedNumField.dataLink : 0
		};
		me._action(url, data, function(result) {
			if (result.errorMsg && result.errorMsg.length > 0) {
				mui.toast(result.errorMsg);				
			} else {

				me._questionTitle = result.Detailresult.FieldTitle;				
				$(".billform-title").text('单位数据统计结果');
				if(result.Detailresult.FieldType && BM.Enum.FieldType2QuestionType[result.Detailresult.FieldType] != "integer"
				&& BM.Enum.FieldType2QuestionType[result.Detailresult.FieldType] != "float")
				{
					me._chartType = QuestionResultChartType[0];	
				}
				me._renderData(result.Detailresult.DetailResultItems);
				callback && callback();
			}
			mui.closeWaiting(); 
		}, true, function (xhr, type, errorThrown) {
            mui.closeWaiting();
       	});
	},
	
	_renderData: function(data){
		var self = this;
		var column1Name = self._chartType === QuestionResultChartType[2] ? '时期' : (self._chartType === QuestionResultChartType[3] ? '选项' : '单位名称') ;
		var column2Name = self._chartType === QuestionResultChartType[3] ? self._selectedNumField.title + '汇总值' : '填报值';
		var chartElem = document.getElementById("chart");
		$(".result-query-menu").hide();
		if(self._chartType != QuestionResultChartType[0] && data && data.length > 0) {
			var titles = [];
			var values = [];
			$.each(data, function(index, value) {
				titles.push(value.DimTitle);
				values.push(value.Result ? value.Result*1 : 0);
			});
			var yAxisName = self._questionTitle;
			if(self._chartType === QuestionResultChartType[1]) {				
				var chartTitle = '各单位的 - ' + self._questionTitle;
				$(".billform-title").text(chartTitle);
				if(data.length <= 10)  {
					self._renderChartByOptions(chartElem, 'bar', '','单位', yAxisName, titles, values, 'vertical');
				} else if(data.length <= 20) {
					$("#chart").height(350);
					self._renderChartByOptions(chartElem, 'bar', '','单位', yAxisName, titles, values, 'horizontal');
				} else {
					$("#chart").hide();
				}
			}
			if(self._chartType === QuestionResultChartType[2]){
				var chartTitle = '时间 - ' + self._questionTitle + ' 曲线图';
				$(".billform-title").text(chartTitle);
				self._renderChartByOptions(chartElem, 'line', '', '时间', yAxisName, titles, values);
			}
			if(self._chartType === QuestionResultChartType[3]){
				$(".result-query-menu").show();
				var chartTitle = self._selectedNumField.title.length <= 10 ? self._selectedNumField.title : self._selectedNumField.title.substr(0,10);
				$(".billform-title").html('选项 - <span class="field-select-btn">' + chartTitle + '</span> 累加值柱状图');
				self._renderChartByOptions(chartElem, 'bar', '','选项', yAxisName, titles, values);		
				self._bindEvent();
			} 
			
		}else {
			$("#chart").hide();
		}
						
		self._renderDataForm(data, column1Name, column2Name);
		
		mui.closeWaiting();
	},
	
	_refresh: function(newnumfield){
		var self = this;
		self._selectedNumField = newnumfield;
		self._loadData();
		self._bindEvent();
	}, 
	
	_renderChartByOptions:function(elem, chartType, title, xName, yName, xAxisVal, yAxisVal, chartOrient){
		//elem:Dom对象；chartType:图表类型;title:图表标题；xAxisVal:x坐标轴的值数组，yAxisVal:y坐标轴的值数组
		//chartOrient: 图表放向，'vertical'：柱状图（y轴是值）；'horizontal': 条形图（x轴是值）
		if(elem == undefined || chartType == undefined || title == undefined || 
			xAxisVal == undefined || yAxisVal == undefined)
		return ;
		var self = this;
		title = title.length < 10 ? title : title.substr(0,10) + '…';
		xName = self._splitStr(xName, 6, '\n', 2);
		yName = self._splitStr(yName, 6, '\n', 2);
		if(chartType == 'bar') {
			xAxisVal = self._preProcessTitleStr(xAxisVal, window.innerWidth, 300, 60, 60, 60, 60, true);
			var x = [{
				        type : 'category' ,
				        data : xAxisVal,
				        name : xName,
				        axisLabel:{  
		                    interval:0, 
		                    rotate: 30,
		                },
		                axisLine:{
		                	show:true,
		                	lineStyle:{
		                		color:'#ade2e1',
		                		width:2
		                	}
		                },
		                axisTick: {
			            	show:false,
			            },
		                splitLine:{
		                	show:false,
		                }
				    }];
			var y = [{
				        type : 'value',	
				        name : yName,
				        axisLine:{
		                	show:true,
		                	lineStyle:{
		                		color:'#ade2e1',
		                		width:2
		                	}
		                },
		                splitLine:{
		                	show:false,
		                }
				   }];

			if(chartOrient && chartOrient == 'horizontal') {
				xAxisVal = self._preProcessTitleStr(xAxisVal, window.innerWidth, 400, 60, 60, 60, 60, false);
				x = [{
					type : 'value',
					name : yName,
					axisLine:{
		                show:true,
		                lineStyle:{
		                	color:'#ade2e1',
		                	width:2
		                }
		            },		            
		            splitLine:{
		                show:false,
		            }
				}];
				y = [{
					type : 'category' ,
				    data : xAxisVal,
				    name : xName,
				    axisLabel:{  
		                interval:0,  
//		                rotate: 30
		            },
		            axisTick: {
		            	show:false,
		            },
		            axisLine:{
		                	show:true,
		                	lineStyle:{
		                		color:'#ade2e1',
		                		width:2
		                	}
		                },
		            splitLine:{
		                show:false,
		            }
				}];
			}
			var Options = {
				title : {
				    show:true,
				    text: title,
				    textStyle: {
						fontSize: 16,
						fontWeight: 'bold',
						color: '#535353'
					},
					x: 'center'
				},
				tooltip : {
				    show:true,
				    trigger: 'item'
				},
				legend: {
				    show:false,
				    data:[],
				    x:'right'
				},
				toolbox: {
				    show : true,
				    feature : {
				        mark : {show: false},
				        dataView : {show: false, readOnly: false},
				        magicType : {show: true, type: ['line', 'bar']},
				        restore : {show: false},
				        saveAsImage : {show: false}
				    },
				    orient:'vertical',
				    x: 'right',
				    y: 'center'
				},
				grid: {
				    x:'60',
				    y:'40',
				    x2:'60',
				    y2:'60',
				    borderWidth:0,
				},
				calculable : false,
				xAxis : x,
				yAxis : y,
				series : [
				    {
				        type:'bar',
				        data: yAxisVal,
				    },
				],
				
			};
			var barChart = echarts.init(elem);
			barChart.setOption(Options);
		}		
		if(chartType == 'pie') {
			//饼状图			
		}
		if(chartType == 'line') {
			//折线图
			var self = this;
//			xAxisVal = self._preProcessTitleStr(xAxisVal, window.innerWidth, 300, 60, 60, 60, 60, true);
			var intervals = xAxisVal.length < 10 ? 0 : (xAxisVal.length < 20 ? 1 : 3);
			var Options = {
				title : {
				    show:true,
				    text: title,
				    textStyle: {
						fontSize: 16,
						fontWeight: 'bold',
						color: '#535353'
					},
					x: 'center'
				},
				tooltip : {
				    show:true,
				    trigger: 'items'
				},
				legend: {
				    show:false,
				    data:[],
				    x:'right'
				},
				grid: {
					x: '60',
					y: '40',
					x2: '60',
					y2: '60',
					borderWidth:0,
				},
				toolbox: {
				    show : true,
				    feature : {
				        mark : {show: false},
				        dataView : {show: false, readOnly: false},
				        magicType : {show: true, type: ['line', 'bar']},
				        restore : {show: false},
				        saveAsImage : {show: false}
				    },
				    orient:'vertical',
				    x: 'right',
				    y: 'center'
				},
				calculable : false,
				xAxis : [
				    {
				        type : 'category' ,
				        name : xName,
				        data : xAxisVal,
				        axisLabel:{
				        	interval:intervals,
				        	rotate:30
				        },
				        axisLine:{
		                	show:true,
		                	lineStyle:{
		                		color:'#ade2e1',
		                		width:2
		                	}
		                },
		                axisTick: {
			            	show:false,
			            },
		                splitLine:{
		                	show:false,
		                }
				    }
				],
				yAxis : [
				    {
				        type : 'value',
				        name : yName,
				        scale : true,
				        axisLine:{
		                	show:true,
		                	lineStyle:{
		                		color:'#ade2e1',
		                		width:2
		                	}
		                },
		                axisTick: {
			            	show:false,
			            },
		                splitLine:{
		                	show:false,
		                }
				    }
				],
				series : [
				    {
				        type:'line',
				        data: yAxisVal,
				    },
				]
			};
			var barChart = echarts.init(elem);
			barChart.setOption(Options);
			
		}
	},
	
	_renderDataForm: function(data, title1, title2) {
		var self = this;
		var titleStr = $('<tr class="row" style="height:40px;line-height:40px;text-align:center;"><td class="column color"><div><label>' + title1 + '</label></div></td><td class="column color"><div><label>' + title2 + '</label></div></td></tr>');
		var domStr = $("<table\>").append(titleStr);
		$("#form thead").append(titleStr);
		if(data && data.length > 0) {
			$.each(data, function(index, value) {
				domStr.append('<tr class="row"><td class="column color"><div><label>' + value.DimTitle + '</label></div></td><td class="column"><div><label>' + value.Result + '</label></div></td></tr>');
			});
			self._dataItemLength = data.length;
			$("#hiddenresult").empty().append(domStr);
			var optInit = this._getOptionsOfPagination();
			$("#Pagination").pagination(data.length, optInit);			
			this._renderFormMidLine("#hiddenresult");
			this._renderFormMidLine("#form");
			if(data.length > 20) {
				$("#form-bottom-menu").show();
			}else {
				$("#form-bottom-menu").hide();
			}
			
		} else {
			mui.toast('没有查到数据~');
			mui.closeWaiting();
		}
	},
	
	_getOptionsOfPagination: function(){
		var self = this;
		var opt = {callback: self._pageselectCallback};
		opt.prev_text = "上一页";
		opt.next_text = "下一页";
		opt.num_display_entries = 0;
		opt.num_edge_entries = 0;
		opt.items_per_page = parseInt($("#selectPage input[type='radio']:checked").val());
		//避免demo重引入HTML
		var htmlspecialchars ={ "&":"&amp;", "<":"&lt;", ">":"&gt;", '"':"&quot;"}
		$.each(htmlspecialchars, function(k,v){
			opt.prev_text = opt.prev_text.replace(k,v);
			opt.next_text = opt.next_text.replace(k,v);
		})
		return opt;
	},
	
	//分页器回调函数
	_pageselectCallback: function(page_index, jq){
		// 从表单获取每页的显示的列表项数目
		var items_per_page = parseInt($("#selectPage input[type='radio']:checked").val());
		var length = $("#hiddenresult tbody").children().length;
		var max_elem = Math.min((page_index+1) * items_per_page, length);
		$("#form tbody").html("");
		// 获取加载元素
		for(var i = page_index*items_per_page; i < max_elem; i++){
			$("#form tbody").append($("#hiddenresult tbody>tr:eq(" + i + ")").clone());
		}
		var totalPages = Math.ceil(length/ items_per_page);
		$("#currPageShow").html('第<span>' + (page_index + 1) + '</span>/' + totalPages + '页');
		//阻止单击事件
		return false;
	},
		
	_renderFormMidLine: function(tableElem){
		$(tableElem + " tr").each(function() {
			$(this).children("td:first").height() > $(this).children("td:last").height() ? $(this).children("td:first").css("border-right","1px solid #ade2e1") : $(this).children("td:last").css("border-left","1px solid #ade2e1");
		});
	},
	
	/**@data:标题数组*/
	_preProcessTitleStr: function(data,barContainerWidth,barContainerHeight, xWidth, x2Width, yHeight, y2Height,isXaxis){
		
		if(!data || data.length < 0) {
			return;
		}
		for(var i = 0; i < data.length; i++){
			data[i] = this.getEchartBarXAxisTitle(data[i], data.length, null, barContainerWidth,barContainerHeight, xWidth, x2Width, yHeight, y2Height, null, isXaxis);
		}
		return data;
	},
	/**
	 * <li>Echarts 中axisLabel中值太长自动换行处理；经测试：360、IE7-IE11、google、火狐  * 均能正常换行显示</li>
	 * <li>处理echarts 柱状图 x 轴数据显示根据柱子间隔距离自动换行显示</li>
	 * @param title             将要换行处理x轴值
	 * @param data              
	 * @param fontSize          x轴数据字体大小，根据图片字体大小设置而定，此处内部默认为12 
	 * @param barContainerWidth         柱状图初始化所在的外层容器的宽度
	 * @param barContainerHeight        柱状图初始化所在的外层容器的高度
	 * @param xWidth            柱状图x轴左边的空白间隙 x 的值，详见echarts文档中grid属性，默认80
	 * @param x2Width           柱状图x轴邮编的空白间隙 x2 的值，详见echarts文档中grid属性，默认80
	 * @param yWidth            柱状图y轴左边的空白间隙 y 的值，详见echarts文档中grid属性，默认80
	 * @param y2Width           柱状图y轴邮编的空白间隙 y2 的值，详见echarts文档中grid属性，默认80
	 * @param insertContent     每次截取后要拼接插入的内容， 不传则默认为换行符：\n
	 * @returns titleStr        截取拼接指定内容后的完整字符串
	 * @author lixin
	 */
	getEchartBarXAxisTitle: function(title, datas, fontSize, barContainerWidth,barContainerHeight, xWidth, x2Width, yHeight, y2Height, insertContent, isXaxis){
     
	    if(!title || title.length == 0) {
	        mui.toast("截取拼接的参数值不能为空！");return false;
	    }
	    if(datas == null || datas <= 0) {
	        mui.toast("用于计算柱状图柱子个数的参数datas不合法！"); return false;
	    }
	    if(isNaN(barContainerWidth) || isNaN(barContainerHeight)) {
	        mui.toast("柱状图初始化所在的容器的宽度或高度不是一个数字");return false;
	    }
	    if(!fontSize){
	        fontSize = 12;
	    }
	    if(xWidth == null || isNaN(xWidth)) {
	        xWidth = 80;//默认与echarts的默认值一致
	    }
	    if(x2Width == null || isNaN(x2Width)) {
	        xWidth = 80;//默认与echarts的默认值一致
	    }
	    if(yHeight == null || isNaN(yHeight)) {
	        yHeight = 80;//默认与echarts的默认值一致
	    }
	    if(y2Height == null || isNaN(y2Height)) {
	        y2Height = 80;//默认与echarts的默认值一致
	    }
	    if(!insertContent) {
	        insertContent = "\n";
	    }
	    var xAxisWidth =  parseInt(barContainerWidth) - (parseInt(xWidth) + parseInt(x2Width));//柱状图x轴宽度=统计页面宽度-柱状图x轴的空白间隙(x + x2)
	    var yAxisHeight =  parseInt(barContainerHeight) - (parseInt(yHeight) + parseInt(y2Height));//柱状图y轴宽度=统计图形高度-柱状图y轴的空白间隙(y + y2)
	    var barCount = datas;                                //x轴单元格的个数（即为获取x轴的数据的条数）
	    var preBarWidth = Math.floor(xAxisWidth / barCount);        //统计x轴每个单元格的间隔	  
	    var fontCountOneRow = Math.floor(y2Height / fontSize);       //每行最多显示多少个字
	   	if(!isXaxis) {
	    	preBarWidth = Math.floor(yAxisHeight / barCount);        //统计y轴每个柱子的间隔
	    	fontCountOneRow = Math.floor(xWidth / fontSize);
	    }
	   	var preBarFontCount = Math.floor(preBarWidth / fontSize) == 0 ? 1 :  Math.floor(preBarWidth / fontSize);  //柱状图每个柱最多可以显示几行/列字
	    if(preBarFontCount > 3) {    //为了x轴标题显示美观，每个标题显示留两个字的间隙，如：原本一个格能一样显示5个字，处理后一行就只显示3个字
	        preBarFontCount -= 2;
	    } else if(preBarFontCount <= 3 && preBarFontCount >= 2) {//若每个间隔距离刚好能放两个或者字符时，则让其只放一个字符
	        preBarFontCount -= 1;
	    }	    
	     
	    var newTitle = "";      //拼接每次截取的内容，直到最后为完整的值
	    var titleSuf = "";      //用于存放每次截取后剩下的部分
	    var rowCount = Math.ceil(title.length / fontCountOneRow);   //标题显示需要换行的次数 
	    if(rowCount > 1) {       //标题字数大于柱状图每个柱子x轴间隔所能容纳的字数，则将标题换行
	        for(var j = 1; j <= rowCount; j++) {	        	
	            if(j == 1) {	                 
	                if( j == preBarFontCount) {
	                	newTitle += title.substring(0, fontCountOneRow - 1) + "…";
	                	break;
	                } else {
	                	newTitle += title.substring(0, fontCountOneRow) + insertContent;
	                	titleSuf = title.substring(fontCountOneRow);    //存放将截取后剩下的部分，便于下次循环从这剩下的部分中又从头截取固定长度
	                }
	            }else {
	                var startIndex = 0;
	                var endIndex = fontCountOneRow;
	                if(titleSuf.length > fontCountOneRow) {  //检查截取后剩下的部分的长度是否大于柱状图单个柱子间隔所容纳的字数	                     
	                    if( j == preBarFontCount) {
	                    	newTitle += titleSuf.substring(startIndex, endIndex - 1) + "…";
			            	break;
			            }else {
			            	newTitle += titleSuf.substring(startIndex, endIndex) + insertContent;
	                    	titleSuf = titleSuf.substring(endIndex);    //更新截取后剩下的部分，便于下次继续从这剩下的部分中截取固定长度
			            }	                    
	                } else if(titleSuf.length > 0){
	                    newTitle += titleSuf.substring(startIndex);
	                }
	            }
	             
	        }
	    } else {
	        newTitle = title;
	    }	    
	    return newTitle;
	},
	
	_bindEvent: function() {
		var self = this;
		$("#btn-data-field-exchange").on("click", function() {
			var targetPage = mui.getWebviewById('numberfieldslist');
			if(mui.os.plus) {
				mui.fire(targetPage, 'onShowItemList', {
					allNumFields: self._CanSelectNumField,
					selectedNumField: self._selectedNumField,
					opener: 'questionresultdetail'
				});					
				openItemList();
			} else {
				mui.openWindow({
					id: 'numberfieldslist',
					url: 'numberfieldslist.html',
					shadeClose: true, // 普通浏览器下特有的属性，APP中无效
					styles: {
						left: '25%',
						width: '75%'
					},
					extras:{
						allNumFields: self._CanSelectNumField,
						selectedNumField: self._selectedNumField,
						opener: 'questionresultdetail'
					}
				});
			}
				
		});	
		
		$("input[name='items-per-page']").on('tap', function(){
			var me = this;
			mui("#selectPage").popover('hide');
			mui.showWaiting();			
			setTimeout(function(){
				var opt = self._getOptionsOfPagination();
				var length = $("#hiddenresult tbody").children().length;
				$("#select a").html(me.value + '条/页&nbsp;&nbsp;<span class="select-pulldown"></span>');
				$("#Pagination").pagination(length, opt);				
				self._renderFormMidLine("#hiddenresult");
				mui.closeWaiting();
			},300);			
		});
	},
	
	
	/*@str:待分隔字符串
	  @interval: 间隔长度
	  @symbol: 分隔符
	  @maxLine: 最多截取次数*/
	_splitStr: function(str, interval, symbol, maxLine) {
		if(!str || str.length < 0)
			return '';
		if(isNaN(interval) || interval < 0) {
			interval = 10;
		}
		if(!symbol) {
			symbol = '\n';
		}
		if(isNaN(maxLine) || maxLine < 0) {
			maxLine = 3;
		}
		var startIndex = 0;
		var sufStr = str;
		var result = '';
		var count = 0;
		if(str.length < interval)
			return str;
		while(sufStr) {
			count++;
			if(sufStr.length < interval) {
				result += sufStr;
				sufStr = '';
				break;
			} else {
				if(count >= maxLine) {
					result += sufStr.substr(0, interval) + '…';
					sufStr = sufStr.substr(interval);
					break;
				}
				result += sufStr.substr(0, interval) + symbol;
				sufStr = sufStr.substr(interval);
			}						
		}
		return result;
		
	},
	
	_action: function (path, _data, callback, async, onError, headers) {
        $.doAction(path, _data, callback, async, onError, headers);
    },

	onDestroy: function() {
		this._super().onDestroy.call(this);
	}
});

//问题类型对应结果查看绘图类型
QuestionResultChartType = {
	//不绘图
	0: "none",
	//绘制单位-指标柱状图
	1: "entityValue",
	//绘制时期-指标折线图
	2: "periodValue",
	//绘制选择题-数值型指标累计值柱状图
	3: "EnumGatherValue"
};
//问题类型对应的详细结果查询绘图类型
QuestionType2ChartType = {
	"singleText": QuestionResultChartType[0],
	"multiText": QuestionResultChartType[0],
	"integer": QuestionResultChartType[1],
	"float": QuestionResultChartType[1],
	"bool": QuestionResultChartType[0],
	"singleChoice": QuestionResultChartType[3],
	"muitiChoice": QuestionResultChartType[0],
	"date": QuestionResultChartType[0],
	"datetime": QuestionResultChartType[0],
	"score": QuestionResultChartType[0],
	"attach": QuestionResultChartType[0],
};
