
$.Class("BM_ToolBarModel", MvcModel, {
		
	construct: function () {
        this._super().construct.call(this);
//      this._billForm = $.m('BM_MainFrameModel');
    },
    Context: {
		question:null,
    	taskObj:null,
    	container:null
    },
    onEntry: function(){
    	var self = this;
    	self._bindEvent();
    	mui.plusReady(function(){
    		window.addEventListener("singleChoiceChange",function(event){   			
    			var questionValue = event.detail.question;    			
    			//修改taskObj中的类型，
				$.QuestionCreator[questionValue.type].reRender(self.Context.taskObj, self.Context.container, questionValue);				
				self.Context.container.trigger('fieldchange',[questionValue]);
				self._initMenu(questionValue);
			});
			window.addEventListener("updateContext", function(event){
				self.Context.question = event.question;
			});
    	});
    	
    },
    _bindEvent:function(){
    	//修改问题类型
    	var self = this;
    	$("#question-type-menu-closebtn").bind("click",function(){
			$("#question-type-menu").hide();
			$(".field-value-item").parent().removeClass('field-type-edit');
		});
    	mui('#typemenu').off('tap','ul>li').on('tap','ul>li', function(){
    		$(this).siblings().removeClass("question-active");
    		$(this).addClass("question-active");
			self._switchType(this.type);
    	});
    	mui('#gathertypemenu').off('tap','ul>li').on('tap','ul>li', function(){
    		if($(this).hasClass("question-disabled")) {
    			mui.toast('该汇总类型不可用');
    		} else {
    			self._switchGatherType($(this).attr("gatherType"));
    			$(this).siblings().removeClass("question-active");
    			$(this).addClass("question-active");
			}   		
    	});
    },
    _switchType: function(newtype){
    	var self = this;
    	if(newtype == "singleChoice" || newtype == "multiChoice") {
    		mui.openWindow({
    			id:'singlechoice.html',
    			url:'_www/tasks/businessmodel/singlechoice.html',
    			createNew: true,
    			waiting: {
					autoShow: true,
					title: '正在努力加载数据……'
				},
				extras: {
					question:self.Context.question,
					targetType: newtype
				}
    		});
    	} else {
	    	if(self.Context.question.type == newtype) 
	    	{
	    		mui.toast('与原类型相同， 无需修改！');
	    		return;
	    	}
	    	if(self.Context.question.type == 'singleChoice' || self.Context.question.type == 'multiChoice') {
	    		self.deleteEnumObject(self.Context.question.enumObject);
	    	}	    	
	    	self.Context.question.type = newtype;
	    	self.Context.question.gatherType = BM.Enum.FieldGatherType2QuestionGatherType[BM.Enum.QuestionType2FieldGatherType[newtype][0]];
//	    	self.Context.question.enumObject = null;
	    	$.QuestionCreator[newtype].reRender(self.Context.taskObj, self.Context.container, self.Context.question);
	    	self.Context.container.trigger('fieldchange',[self.Context.question]); 
	    	
	    	self._initMenu(self.Context.question);
    	}
//  	$("#question-type-menu").hide();
//  	$(".field-value-item").parent().removeClass('field-type-edit');
    },
    
    _switchGatherType: function(newGatherType){
    	var self = this;
    	if(self.Context.question.gatherType == newGatherType) 
	    {
	    	mui.toast('与原类型相同， 无需修改！');
	    	return;
	    }	    	
	    self.Context.question.gatherType = newGatherType;
	    self.Context.container.trigger('fieldchange',[self.Context.question]);   
    },
    
    show: function(taskObj, container, question){
    	var self = this;
    	self._initMenu(question);
    	$("#question-type-menu").show();
    	this.Context.question = question;
    	this.Context.taskObj = taskObj;
    	this.Context.container = container;
    },
    
    _getNewTypeField:function(){
    	
    },
    
    _initMenu: function(question){
    	var typeDomObj = $("#typemenu ul>li");
    	var gathertypeDomObj = $("#gathertypemenu ul>li");
    	var usableGatherType = BM.Enum.QuestionType2FieldGatherType[question.type];
    	$.each(typeDomObj, function(index, obj) {
    		if(question.type == obj.type) {
    			$(obj).siblings().removeClass("question-active");
    			$(obj).addClass("question-active");
    			return;
    		}
    	});
    	$.each(gathertypeDomObj, function(index, obj) {
    		if(question.gatherType == $(obj).attr("gatherType")) {
    			$(obj).siblings().removeClass("question-active");
    			$(obj).addClass("question-active");   			
    		} 
    		if($.inArray(BM.Enum.QuestionGatherType2FieldGatherType[$(obj).attr("gatherType")], usableGatherType) === -1) {
    			$(obj).addClass("question-disabled");
    		} else {
    			$(obj).removeClass("question-disabled");
    		}
    	});	
    },
    
    deleteEnumObject: function(enumObj) {
        if (enumObj) {
            enumObj.markDeleted();
            var data = {
            	enumObject: JSON.stringify(enumObj), 
            	enumNodeDict: null
            };
            var url = $.BaseUrl + "BusinessModel/EnumDataService/SaveEnum?_taskId_=" + this.Context.question.taskId;
			$.doAction(url, data, function(result) {
                if (!result.success) {
                    mui.toast(result.data.innerMSG);
                }
            });            
        }
    }
});