$.Class("BM_SingleChoiceModel",MvcModel,{
	construct: function () {
        this._super().construct.call(this);
//      this._choiceItems = [];  //维护当前表单的选项
        this._question = null;
    },
    onEntry: function(){
    	var self = this;		
		document.addEventListener(mui.readyEvt_Jcp,function() {
			var curView = mui.currentWebview;
    		if(curView.targetType == 'multiChoice') {
    			$("#title").text('多选题型');
    		}
    		self._init();
		});						
	 
		this.reservedEnumTitleCode = ['|', ';'];
        this.formHelper = new BM.FormHelper();        
		this.DeletedEnumNode = new BM.BusinessList("删除的节点列表");
		
		$("#btn").unbind("click").bind("click", function(){
			if(!$.trim($("#choiceTitle").val()))
			{
				mui.toast('您还未设置题目名称哦~');
				return;
			}
			var newChoice = {};
			var choiceObjs = $("#choiceItems").children();
			if(!choiceObjs || choiceObjs.length < 2){
				mui.toast('选项不能少于2个哦~');
				return;
			}
			var hasEmptyItem = false;
			$.each(choiceObjs, function(index,value){
				var tempvalue = $.trim($(value).children("input").val());
				if(tempvalue === '')
				{
					hasEmptyItem = true;
					return;
				}				
			});
			
			for(var i = 0; i < choiceObjs.length; i++) 
			{
				var siblingObjs = $(choiceObjs[i]).siblings();
				var isrepeat = false;
				for(var j = 0; j < siblingObjs.length; j++)
				{
					if($(siblingObjs[j]).children("input").val() === $(choiceObjs[i]).children("input").val())
					{
						isrepeat = true;
						break;						
					}
				}
				if(isrepeat)
				{
					mui.toast('选项重复啦~');
					return;
				}
			}
			if(hasEmptyItem) 
			{
				mui.toast('选项不能为空哦~');
				return;
			}
			self._question.titleName = $("#choiceTitle").val();
			self.onConfirm();

		});
		$("#addChoiceItem").unbind("click").bind("click", function(){
			self.addChoiceItem($(this).prev().children().length + 1);
			self._bindEvent();
		});		
    },
    _init: function(){
    	var self = this;  
    	self._question = mui.currentWebview.question;
    	self.enumDataList = new BM.BusinessList("所有的枚举项");
    	var curQuestionType = self._question.type;  
    	if(self._question.enumObject != null) {
    		self.enumObject = new BM.EnumObject(self._question.enumObject);
	    	self.enumDataList = self.enumObject.EnumDataList;
	    	self.enumId = self.enumObject.ID;
	    	
    	}
 	   	
    	var curChoicesItems = []; 
    	if(self.enumObject != null) { 
	    	for(var code in self.enumObject.EnumDataList){
				var enumItem = self.enumObject.EnumDataList.get(code);
				curChoicesItems.push(enumItem);
			}
    	}
    	$("#choiceTitle").val(self._question.titleName);
    	if(curChoicesItems != null && curChoicesItems.length > 0 && (curQuestionType == 'singleChoice' || curQuestionType == 'multiChoice'))
    	{
    		curChoicesItems.sort(
	            function (a, b) {
	                if (a.Order < b.Order) return -1;
	                if (a.Order > b.Order) return 1;
	                return 0;
	            }
        	);
    		//选择题内容修改
    		for (var r in curChoicesItems)
    		{
    			var choiceitem = {};
    			choiceitem.Index = curChoicesItems[r].Order;
    			choiceitem.Value = curChoicesItems[r].Title;
    			choiceitem.enumCode = curChoicesItems[r].Code;
    			choiceitem.Name = "choiceitem";
    			$("#choiceItems").append(self.getChoiceFieldStr(choiceitem));
    		}
    	} else {
    		for(var i = 0; i < 4; i++){
    			var choiceitem = {};
    			choiceitem.Index = i + 1;
    			choiceitem.enumCode = "";
    			choiceitem.Value = "";
    			choiceitem.Name = "choiceitem";
    			$("#choiceItems").append(self.getChoiceFieldStr(choiceitem));
    		}    		
    	}
    	
    	self._bindEvent();
    },
    
    _bindEvent:function(){
    	var self = this;
    	$(".choice-item span[type=button]").unbind("click").bind("click",function(){
			var curParentObj = $(this).parent();
			$.each(curParentObj.nextAll(), function(index,value) {
				var valueIndex = $(value).attr("choiceIndex");
				if(valueIndex){
					$(value).attr("choiceIndex", (parseInt(valueIndex) - 1));
				}
			});	
			var delIndex = parseInt(curParentObj.attr("choiceIndex"));
			self.deleteChoiceItem(delIndex);
			
			var enumCode = curParentObj.attr("enumCode");
	        if (enumCode) {
	            var enumObject = self.enumDataList.get(enumCode);
	            enumObject.markDeleted();
	            self.enumDataList.remove(enumCode);
	            self.DeletedEnumNode.add(enumObject.Code, enumObject);
	        }
			curParentObj.remove();
		});
    },
    
    _getModifiedEnumData: function () {
    	var self = this;
        var result = new BM.BusinessList("待保存枚举数据列表");
 
        var itemsObj = $("#choiceItems").children();
        var count = itemsObj.length;
        $.each(itemsObj, function(index, value){
        	var enumCode = $(value).attr("enumCode");
        	if (!enumCode) {
                enumCode = self.formHelper.NewUniqueCode();
                $(value).attr("enumCode", enumCode);
            }
        	
        	var newEnumTitle = $(value).children('.choice-item-value').val();
            if (self.formHelper.isNullOrEmpty(newEnumTitle) == true) {
                //标题不存在的，则删除该条记录.
                var enumObjectToDel = self.enumDataList.get(enumCode);
                if (enumObjectToDel) {
                    enumObjectToDel.markDeleted();
                    self.enumDataList.add(enumCode, enumObjectToDel);
                }
                return true;
            }
            
            var enumObject = self.enumDataList.get(enumCode);

            if (!enumObject) {
                var tmpNode = {};
                tmpNode.IsNew = true;
                tmpNode.IsDirty = false;
                tmpNode.IsDeleted = false;
                enumObject = new BM.EnumNodeObject(tmpNode);
                enumObject.setCode(enumCode);

                self.enumDataList.add(enumCode, enumObject);
            }
            
            enumObject.setCode(enumCode);

            var checkedTitle = self.formHelper.filterReservedChars(newEnumTitle, self.reservedEnumTitleCode);
            var titleLength = self.formHelper.getStringCodeLength(newEnumTitle);
            if (titleLength > 70)
                checkedTitle = self.formHelper.getStringByLength(newEnumTitle, 70);
            enumObject.setTitle(checkedTitle);
            enumObject.setOrder(index + 1);
            
        });
        
        for (var enumCode2 in self.enumDataList) {
            var enumNodeObject = self.enumDataList.get(enumCode2);
            if (enumNodeObject.IsDirty == true
                || enumNodeObject.IsNew == true
                || enumNodeObject.IsDeleted == true)
                result.add(enumNodeObject.Code, enumNodeObject);
        }

        for (var enumCode3 in self.DeletedEnumNode) {
            var deletedEnumNode = self.DeletedEnumNode.get(enumCode3);
            deletedEnumNode.markDeleted();
            result.add(deletedEnumNode.Code, deletedEnumNode);
        }
        return result;    
    },
    
    _getEnumObjectDefaultTitle: function (enumNodeObjectList) {
        var newTitle = "";
        for (var enumCode in enumNodeObjectList) {
            var enumNodeObject = enumNodeObjectList.get(enumCode);
            if (this.formHelper.isNullOrEmpty(enumNodeObject.ParentCode)) {
                if (this.formHelper.isNullOrEmpty(newTitle) == false)
                    newTitle += "，";

                newTitle += enumNodeObject.Title;
            }
        }
        var result = newTitle;
        var titleLength = this.formHelper.getStringCodeLength(newTitle);
        if (titleLength > 47)
            result = this.formHelper.getStringByLength(newTitle, 47) + "...";
        return result;
    },
    
    _setEnumNodeListClean: function(enumNodeObjectList, nodeCodePair){
    	if(nodeCodePair){
    		for(var oldCode in nodeCodePair){
    			if(!nodeCodePair.hasOwnProperty(oldCode)){
    				continue;
    			}
    			var newCode = nodeCodePair[oldCode];
    			var enumNode = enumNodeObjectList[oldCode];
    			if(enumNode && newCode){
    				enumNode.Code = newCode;
    				enumNodeObjectList.remove(oldCode);
    				enumNodeObjectList.add(newCode, enumNode);    				
    			}
    		}
    	}
    	
    	for (var enumCode in enumNodeObjectList) {
            var enumNodeObject = enumNodeObjectList.get(enumCode);          
           	enumNodeObject.IsDirty = false;
            enumNodeObject.IsNew = false;
            enumNodeObject.IsDeleted = false;
        }
    },
    
    onConfirm: function () {
        var self = $.m("BM_SingleChoiceModel");

        var enumObjectToSave = self._getModifiedEnumData();
        var taskObject = self.taskObject;
        if (enumObjectToSave.getCount() > 0) {
            if (self.enumObject == null || self.enumId == 0) {
                var tmpNodeObject = {};

                tmpNodeObject.IsNew = true;
                tmpNodeObject.IsDirty = false;
                tmpNodeObject.IsDeleted = false;
                self.enumObject = new BM.EnumObject(tmpNodeObject);
                self.enumObject.setEnumType(BM.Enum.EnumType.Tree);
            } else {

                self.enumObject.setEnumType(BM.Enum.EnumType.Tree);
                self.enumObject.markDirty();
            }

            if (self.formHelper.isNullOrEmpty(self.enumObject.Title) == true) {
                var newTitle = self._getEnumObjectDefaultTitle(enumObjectToSave);
                self.enumObject.setTitle(newTitle);
            }
            mui.showWaiting('正在加载中...');
            var data = {
            	enumObject: JSON.stringify(self.enumObject), 
            	enumNodeDict: JSON.stringify(enumObjectToSave)
            };
            var url = $.BaseUrl + "BusinessModel/EnumDataService/SaveEnum?_taskId_=" + self._question.taskId;
			$.doAction(url, data, function(result) {
				if (result.success) {
                    if (result.data && result.data.EnumObject) {
                        self._question.enumObject = new BM.EnumObject(result.data.EnumObject);
                        self._setEnumNodeListClean(self.enumDataList, result.data.NodeCodePair);
                        self._question.enumObject.EnumDataList = self.enumDataList;
                        self._question.type = mui.currentWebview.targetType;
                        self._question.gatherType = "none";
						var mainwebview = mui.getWebviewById('designbillform');
						mui.fire(mainwebview,"singleChoiceChange", {question: self._question});
						
						mui.closeWaiting();
						mui.currentWebview.close();
                    }
                   
                } else {
                    mui.toast(result.message);
                }
			});
       } else if(self._question.type != mui.currentWebview.targetType) {
       		self._question.type = mui.currentWebview.targetType;
			var mainwebview = mui.getWebviewById('designbillform');
			mui.fire(mainwebview,"singleChoiceChange", {question: self._question});  
			mui.currentWebview.close();
       } else{
       		mui.currentWebview.close();
       }
       

    },
    
    //获取选择项的html
    getChoiceFieldStr: function (choiceItem) {
       var self = this;
       var itemstr = [];
       var previconClass = mui.currentWebview.targetType == 'singleChoice' ? '' : 'multi-icon';
       if (choiceItem) {
			itemstr = ['<div class="choice-item" enumCode="' + choiceItem.enumCode + '" choiceIndex="' + choiceItem.Index + '">',
			'<div class="choice-item-prev-icon '+ previconClass + '"></div>'
			,'<input type="text" class="choice-item-value" name="choiceItem" placeholder="选项" value="' + (choiceItem.Value != null ? choiceItem.Value : '') + '">'
			,'<span type="button" class="question-delete question-delete-icon"></span>','</div>'];
        } 
        return itemstr.join('');
    },
    
    //添加选项
    addChoiceItem: function (index) {
    	var self = this;
    	var choiceitem = {};
    	choiceitem.Index = index;
    	choiceitem.enumCode = ""; 
    	choiceitem.Value = "";
    	choiceitem.Name = "choiceitem";

        $("#choiceItems").append(self.getChoiceFieldStr(choiceitem));
    },
    
    deleteChoiceItem: function(delIndex){
	   	
    }
});