MSG_PeriodSelector_AfterSelect = 'msg_periodselector_afterselect';
MSG_Common_AfterDataSave = 'msg_common_afterdatasave';

window.MyDtPicker = mui.DtPicker.extend({
	hide: function(){ // 重写hide方法，否则界面上会有好多对象未释放
		this._super();
		var self = this;
		setTimeout(function() {
			if(self.ui && self.ui.picker && self.ui.picker.parentNode){
				self.ui.picker.parentNode.removeChild(self.ui.picker);
			}				
			for (var name in self) {
				self[name] = null;
				delete self[name];
			};
			self.disposed = true;
		}, 300);
	}
});

$.Class("BillForm", MvcModel, {
	construct: function() {
	    this._super().construct.call(this);
	    this.addListener(MSG_PeriodSelector_AfterSelect, this.onPeriodSelected, this);

		this._dataInput = $.m("DataInput");
    	this._billForm = $.m("BillForm");
	},
	
	Context: {
		UserId: null,
        TaskId: 0,
        TaskType: null,
        TaskCreater: null,
        Period: null,
        PeriodTitle: null,
        PeriodType: null,
        PeriodCount: 0,
        EntityFilledPeriods: null,
        MarkedFilledPeriod_Up: null,
        MarkedFilledPeriod_Down: null,
        AllPeriods: [],
        SharedPeriods: [],
        TimeSegments:[],
        EntityKey: null,
        FormId: 0,
        FormType: null,
        ShareToken: null,
        BillMode: null,
        DataRecord: null,
        SelectedEntityExtInfo: null,
        IsTempPeriod: false,
        FmlScripts: null
    },
    
    Status: {
        ReadOnly: false,
        IsTaskOwner: false,
    },
    
    _curPage: null,
    _srcPage: null,
    _dataModified: false,
    _submitFlag: false,
    _periodModified: false,
    _entityModified: false,
    _entityInTotalModified: false,
    _initText: '-- 请选择 --',
    _isInterfaceExp : false,
    _checkErrorItems: null,
    _disabledEvent: false,
    _allRecords: null,
    _isEnumOpen: false,
    _checkMsgs: null,

	onEntry: function() {
		this._super().onEntry.call(this);
		//this.FABMenu = $.New(FABMenu); 卡片中先临时隐藏该按钮
		this.PeriodSelector = $.New(PeriodSelector);
		this.CustomDlg = $.New(CustomDlg);
		this.orgHeight = window.innerHeight;
		this.orgWidth = window.innerWidth;
	    
		var self = this;
		document.addEventListener(mui.readyEvt_Jcp, function() {
//			mui.currentWebview.setStyle({
//				softinputMode: "adjustResize"  // 弹出软键盘时自动改变webview的高度
//			});	
			
			if(!mui.os.plus && window.isMainPage){ 
				$(".billform_back").hide();
				
				// 普通浏览器中进入录入时由后台判断出是否直接打开卡片，卡片是直接打开时需要的数据从后台请求。
				self.Context.TaskId = mui.currentWebview.taskId;
				self.Context.Period = mui.currentWebview.period;
			    
				self._init(function (result) {
				    if (result.TaskTitle) {
				        var $body = $('body');
				        document.title = result.TaskTitle;
				        // hack在微信等webview中无法修改document.title的情况
				        var $iframe = $('<iframe src="/favicon.ico"></iframe>').on('load', function () {
				            setTimeout(function () {
				                $iframe.off('load').remove();
				            }, 0);
				        }).appendTo($body);
				    }
				}, false);
			} else{				
			    self._initFromTableMode();
			    
			}								
			mui.closeWaiting();
		}, false);
		
		if(false){// swiper会导致ios普通浏览器下弹出窗奔溃、内容显示不全，安卓下弹出窗卡顿、键盘弹出收回后键盘的位置渲染空白等问题，暂时停用。
			this.Swiper = new Swiper('.swiper-container', {
				initialSlide: 1,
				loop: true
			});
			
			this.Swiper.lockSwipes();
			this.Swiper.on('onDoubleTap', function(swiper, e) {
				//mui.toast('data count')
			}).on('slideChangeEnd', function(swiper) {
				if (swiper.touches.diff > 0) {
			    	self._onSwipleRight();
			    } else {
					self._onSwipleLeft();
			    }
			});
		} else{
			// 未启用Swiper时避免无法添加数据
			 $('.swiper-slide:first-child').addClass("swiper-slide-active");
		}
		
		if(mui.os.ios){
			$("body").addClass("bodyscroll");
			$("html").addClass("bodyscroll");
			$(".mui-content").addClass("contentscroll");
		}
						
		var startX = 0, startY = 0, offsetX = 0, offsetY = 0;
		document.addEventListener('touchstart', function(event) {
			startX = event.touches[0].clientX;
			startY = event.touches[0].clientY;
			
			var $this = $(event.target);
			if(event.target.tagName === "TEXTAREA" && $this.attr("readonly") == "readonly" // ios下普通浏览器端再弹出键盘的情况下点击只读文本框为导致崩溃
				|| event.target.tagName === "INPUT" && $this.attr("readonly") == "readonly"){
				event.preventDefault();
			}
		}, false);
		
		document.addEventListener('touchend', function(event) {
			var offsetX = event.changedTouches[0].clientX - startX;
			var offsetY = event.changedTouches[0].clientY - startY;
			
			var absX = Math.abs(offsetX), absY = Math.abs(offsetY);
			if (absX < 100 || absX < absY) return;
			
			//if (offsetX > 0 && isOpen) closeItemList();
	    	var record = self.Context.DataRecord;
		    if (!record || record.RegType === 0) return;
		    
		    document.activeElement.blur();
		    if (offsetX > 0) {
		    	if (isOpen) {
					closeItemList();
				} else {
					self._onSwipleLeft();
				}
		    } else {
				self._onSwipleRight();
		    }
		}, false);
		
		document.addEventListener('onEntitySelect', function (event) {
			if(!event.detail.isToBill) {
				mui.back();
				return;
			}
			if (event.detail.entityKey === self.Context.EntityKey) return;
			
			if (self.Context.EntityKeyInDetail && self.Context.EntityInTotal) {
				self._entityInTotalModified = true;
				if(self.Context.EntityInTotal.id === event.detail.parentEntityKey){
					self._entityInTotalModified = false;
				}
			}

			self._onEntitySelected(event.detail.entityKey, event.detail.entityTitle, event.detail.isLeaf, event.detail.shareToken, event.detail.extInfo, event.detail.selectedFormId, event.detail.selectedFormTitle);

		});
        
		window.addEventListener('onItemSelect', function(event) {
			self._updateItemValue(event.detail.id, event.detail.codes, event.detail.titles);
			closeItemList();
		});
		window.addEventListener('onItemSelected', function(event) {//卡片枚举中新加的
			self._isEnumOpen=false;
			self._updateItemValue(event.detail.eData.id, event.detail.editText, event.detail.showText);
			closeItemList();
		});
		
		window.addEventListener("onHideItemList", function(event) {
			closeItemList();
		});

		window.addEventListener("resize", function () {
		    if (window.innerHeight < self.orgHeight && window.innerWidth == self.orgWidth) { // 弹出键盘	
		        $("#billform-ctrl").hide();
		    } else if (window.innerHeight == self.orgHeight && window.innerWidth == self.orgWidth) { // 收回键盘
		        self._initBillFormCtrl();		        
		    }
		}, false);
		
		window.addEventListener('msg_datainput_files', function (event) {
         	 var options = event.detail.fileOptions;
         	 if (!options) return;
         	 
         	 var dataItem = self._getItemById(options.fid), fileItems = options.fileData && eval(options.fileData);
         	 if (!dataItem || !fileItems) return;
         	 
         	 dataItem.Value = JSON.stringify(options.fileData);
         	 dataItem.IsModified = true;
         	 if (self.Context.DataRecord.State == 0) self.Context.DataRecord.State = 2;
         	 
         	 var i, len, count = 0;
         	 for (i = 0, len = fileItems.length; i < len; i++) {
         	 	if (fileItems[i].FileState == 3) continue;
         	 	count++;
         	 }
         	 
         	 $('#' + options.fid + ' .file_count').html(count);
        });
        
		window.addEventListener('msg_datainput_filesDownload', function (event) {
        	 mui.toast('暂不支持下载');
        	 //self._downloadFile(event.detail.fileOptions);
        });
        
		mui('.mui-content').on("tap", '.field .value-popup', function(e) {
			var fid = $(this).parent().parent().attr('id');
			var dataItem = self._getItemById(fid);
			if (!dataItem || (!dataItem.EnumItems && !dataItem.EnumLst)) return;
			if(dataItem.IsReadOnly){
				mui.toast('单元格只读，不可编辑');
				return ;
			}
			self._isEnumOpen=true;
            var enumItems;
			if(dataItem.EnumLst){
				var enumLst=[];
				for(var i=0;i<dataItem.EnumLst.length;i++){		
					enumLst.push({Code:dataItem.EnumLst[i]+'enum'+i,'Title':dataItem.EnumLst[i],isParent:false,Mnemonic:'',ParentCode:'',isMatched:false});
				}
				enumItems=enumLst;
			}else{
				enumItems=dataItem.EnumItems;
			}
			document.activeElement.blur();
			
			var $this = this, multiSelect = this.getAttribute('multiSelect') || 'false';
			var arr=self._enumReset(enumItems),curEText='',curSText='',hostCod=[];
			var __setLevel= function(id,level) {
                for (var i = 0; i < arr.length; i++) {
                    if (arr[i].pId == id) {
                        arr[i].level = level;
                        __setLevel(arr[i].id, level+1);
                    }
                }
            }
            for (var i = 0; i < arr.length; i++) {
                if (arr[i].pId == "") {
                    arr[i].level = "1";
                    __setLevel(arr[i].id, 2);
                }
            }
			var hostLink = dataItem.HostLink;hostDataItem = self._getItemById(hostLink),curArr=[],realArr=[],hasHost=false,levels=dataItem.LinkageLevels ?dataItem.LinkageLevels.split(";"):[];
			var minLevel = Math.min.apply(null,levels);
			var maxLevel = Math.max.apply(null,levels);
			if(hostDataItem){
				var hostValue = hostDataItem.Value.split(";"),hostEnumLevel = hostDataItem.LinkageLevels;				
				for(var j=0;j<hostValue.length;j++){
					var hValue;
					if(hostValue[j].split("|").length>1){
						hValue=hostValue[j].split("|")[1];
					}else{
						hValue=hostValue[j];
					}
                    for(var i=0;i<arr.length;i++){
                    	var isCod = false;
				     	if(arr[i].id==hValue){
				     		hostCod.push(hValue);
				     		isCod = true;
				     	}
				     	if(i == arr.length-1 && !isCod){
				          for(var j=0;j<arr.length;j++){
					     		if(arr[j].name==hValue){
						     		hostCod.push(arr[j].id);
						     		isCod = true;
						     		break;
						     	}
					     	}
					     }
				     	if(isCod)break;
					}										
				}
			}
			for(var i=0;i<levels.length;i++){
				for(var j=0;j<arr.length;j++){
					if(arr[j].level == levels[i]){
						curArr.push(arr[j]);
					}
				}
			}
			if(hostDataItem){
				var hostValue = hostDataItem.Value.split(";"),hostEnumLevel = hostDataItem.LinkageLevels;
				hasHost=true;
				var _getChidArr = function(id ,curArr){
					var chidArr=[] ;
					for(var i=0 ;i<curArr.length;i++){
						if(curArr[i].pId == id){
							chidArr.push(curArr[i]);
						}
					}
					return chidArr;
				}									
				for(var i=0;i<hostCod.length;i++){
				    for(var i=0;i<curArr.length;i++){
				     	if(curArr[i].pId==hostCod){
				     		realArr.push(curArr[i]);
				     		var childArr = _getChidArr(curArr[i].id,curArr);
				     		for(var k=0;k<childArr.length;k++){
				     			realArr.push(childArr[k]);
				     		}
				     	}
					}
				}
			}
			if(hostDataItem){
				for(var i=0;i<realArr.length;i++){
					if(realArr[i].level == minLevel){
						realArr[i].pId = "";
					}
					if(realArr[i].level == maxLevel){
						realArr[i].isParent = false;
					}
			     }
			}else{
				for(var i=0;i<curArr.length;i++){
					if(curArr[i].level == minLevel){
						curArr[i].pId = "";
					}
					if(curArr[i].level == maxLevel){
						curArr[i].isParent = false;
					}
			     }
			}
			if(dataItem.EnumLst){
				var curETextArr = self._getItemTexts(dataItem.Value);
				for(var i=0;i<curETextArr.length;i++){
					for(var j=0;j<enumItems.length;j++){
						if(enumItems[j].Title == curETextArr[i] && !enumItems[j].isMatched){
							curSText += curSText==''?enumItems[j].Title:";"+enumItems[j].Title;
							curEText += curEText==''?enumItems[j].Code:";"+enumItems[j].Code;
							enumItems[j].isMatched=true;
							break;
						}
					}
					
				}
			}
				var eData={   
					        id: fid,
					        name: dataItem.Name,
					        returnListenString:"onItemSelected",
							selectType: multiSelect=="false"?"1":"2",
							arr: realArr.length>0 && hasHost?realArr:curArr.length>0?curArr:arr,
							curEText:dataItem.EnumLst?curEText : self._getItemCodes(dataItem.Value).join(";"),
							curSText:dataItem.EnumLst?curSText : self._getItemTexts(dataItem.Title).join(";")
				           }
				   if( (hasHost && realArr.length == 0 )|| (dataItem.EnumLst && dataItem.EnumLst.length==0)){
					   mui.toast("没有符合的选项！");
					   return ;
				   }
				   mui.openWindow({
						url: 'enumTree.html',
					    id: 'enumTree',
					    extras: {
					    	eData:eData				    	
					    },
					    show: {
					    	autoShow: true
					    },
					    waiting: {
					    	autoShow: true,
					    	title:'正在加载...'
					    }
					});
				/*

				if (mui.os.plus) { // 非App模式下未支持预加载窗口，调整为每次都打开
					var targetPage = mui.getWebviewById('itemlist');
					mui.fire(targetPage, 'onShowItemList', {
						id: fid,
				    	name: dataItem.Name,
						multiSelect: multiSelect,
						items: dataItem.EnumItems,
						selected: self._getItemCodes(dataItem.Value),
						opener: 'billform'
					});
					
					openItemList();
				} else {
					mui.openWindow({
						id: 'itemlist',
						url: 'itemlist.html',
						shadeClose: true, // 普通浏览器下特有的属性，APP中无效
						styles: {
							left: '25%',
							width: '75%'
						},
						extras:{
							id: fid,
					    	name: dataItem.Name,
							multiSelect: multiSelect,
							items: dataItem.EnumItems,
							selected: self._getItemCodes(dataItem.Value),
							opener: 'billform'
						}
					});
					isOpen = true;
				}
				*/		
		});
		
		mui.back = function() {
			if($('#__MUI_PREVIEWIMAGE').length > 0 && $('#__MUI_PREVIEWIMAGE')[0].style.display=="block"){
			    //$('#__MUI_PREVIEWIMAGE')[0].style.display = 'none';
//				$('#__MUI_PREVIEWIMAGE')[0].classList.remove('preview-out');
//				$('#__MUI_PREVIEWIMAGE')[0].classList.remove('preview-in');
//				laterClose = null;
				return;
			}
			if(!mui.os.plus && window.isMainPage){
				self._beforeAction(function() {
					window.top.location.href = "/JcpMobile/tasks/datainput/index.html" + window.top.location.search;
				});				
				return;
			}
			
			if (isOpen) {
				closeItemList();
			} else {
				self._beforeAction(function() {
					if (!self.Context.BillMode.AutoShow || !mui.os.plus) {
						if (self._dataModified) {
							mui.fire(_parent, 'onReloadData', {});
						}
						mui.currentWebview.opener().show('none');
					}
					mui.currentWebview.close();
				});
			}
		};

		self._initFabmenu();
		self._bindEvents();
	
//		this.FABMenu = $.New(FABMenu);				
	},
	
	_initWebSiteTips: function(){
		if(!mui.os.plus){
			if($("#billform-website-container").is(":visible"))
				return;
			$("#billform-website-container a").unbind("tap").bind("tap", function(){
				window.top.location.href = "https://97gg.net/";
			});
			$("#billform-website-container").show();
		}else{
			$("#billform-website-container").hide();
		}
	},
	
	_initBottomBtnsState: function(){
		var dataRecord = this.Context.DataRecord, readOnly = this.Status.ReadOnly && this.Status.ReadOnly.Result;
		var canAdd = (!dataRecord.SetAsFixed || dataRecord.DataCount < dataRecord.FixedCount) && (dataRecord.MaxCount <= 0 || dataRecord.DataCount < dataRecord.MaxCount);
		var canDelete = !dataRecord.SetAsFixed;
		
		this._setBtnState("billform-new", canAdd, !readOnly);
	    this._setBtnState("billform-del", canDelete, !readOnly);
	},
	
    /*
     *从表格模式进入卡片模式后初始化页面
     */
	_initFromTableMode: function () {
	    var self = this;
	    var view = mui.currentWebview;
	    self._curPage = view;
	    self._srcPage = view.opener();

	    self.Context.UserId = view.userId;
	    self.Context.TaskId = view.taskId;
	    self.Context.TaskType = view.taskType;
	    self.Context.TaskCreater = view.taskCreater;
	    self.Context.IsAnonymous = view.isAnonymous;
	    self.Status.IsTaskOwner = view.isTaskOwner;
	    
	    self.Context.IsTempPeriod = view.isTempPeriod;
	    self.Context.Period = view.period;
	    self.Context.PeriodTitle = view.periodTitle;
	    self.Context.PeriodType = view.periodType;
	    self.Context.PeriodCount = view.periodCount;
	    self.Context.AllPeriods = view.allPeriods;
	    self.Context.SharedPeriods = view.sharedPeriods;
	    self.Context.TimeSegments = view.timeSegments;
	  
	    self.Context.FormId = view.formId;
	    self.Context.FormTitle = view.formTitle;
	    self.Context.FormType = view.formType;
	    self.Context.BillMode = view.billMode;
	    self.Context.DataRecord = view.dataRecord;
	    self.Context.FillingGuide = view.fillingGuide;
	    self.Context.UploadParams = view.uploadParams;
	    self.Context.FmlScripts = view.fmlScripts;
	    self.Status.ReadOnly = view.readOnly;

	  	self.registerFormulaScriptMethod();
	  	self._initFmlScripts();
	    self._initWrapper();
		
	    //单位
	    self.Context.EntityKeyInDetail = view.entityKeyInDetail;
	    self.Context.EntityNodes = view.entityNodes;
	    if (self.Context.EntityKeyInDetail) {
	    	self.Context.EntityInTotal = {
	    		id: view.entityKey,
	    		name: view.entityTitle,
	    		isLeaf: false,
	    		shareToken: view.shareToken,
	    		extInfo: view.selectedEntityExtInfo
	    	};
	    	
	        self._setPeriod();
	        self._setFormTitle();
	        self._getEntityNodeInDetail(function (curNode) {
	        	if(curNode){
	        		self._onEntitySelected(curNode.id, curNode.name, true, curNode.shareToken, curNode.extInfo, null, null, view.curRowKey);
	        		return;
	        	}
	        	
	        	self._queryEntityByEntityKey(self.Context.EntityKeyInDetail, function(entityObj){
	        		if(!entityObj){
	        			mui.toast("小伙伴不存在！");
	        			return;
	        		}
	        		self._onEntitySelected(entityObj.Key, entityObj.Title, entityObj.IsLeaf, null, null, null, null, view.curRowKey);
	        	});
	        	
	        });
	    } else {
	        self.Context.EntityFilledPeriods = view.entityFilledPeriods;
	        //self.Context.MarkedFilledPeriod_Up = view.markedFilledPeriod_Up;
	        //self.Context.MarkedFilledPeriod_Down = view.markedFilledPeriod_Down;
	        
	        self.Context.EntityKey = view.entityKey;
	        self.Context.EntityTitle = view.entityTitle;
	        self.Context.ShareToken = view.shareToken;
	        self.Context.SelectedEntityExtInfo = view.selectedEntityExtInfo;
	        self._setEntityTitle(view.entityTitle);
	        self._initAfterLoaded(view.curRowKey, view.curRowState, view.isTappedEnter);
	    }
		
	},

    /*
     *卡片模式下初始化页面
     */
	_init: function (callback, hasTips) {
	    var self = this;
	    self._loadData(function (result) {
	        if (!result) return;
	        
	        callback && callback(result);
	        
	        if(!result.IsLeafNode || !result.FormData) return;

	        var formData = result.FormData;
	        self.Status.IsTaskOwner = result.IsTaskOwner;
	        self.Status.IsFiller = result.IsFiller;
	        self.Status.ReadOnly = formData.ReadOnly;
	        
	        self.Context.IsTempPeriod = result.IsTempPeriod;
	        self.Context.Period = result.PeriodCode;
	        self.Context.PeriodTitle = result.PeriodTitle;
	        self.Context.PeriodType = result.PeriodType;
	        self.Context.PeriodCount = result.PeriodCount;
	        self.Context.EntityFilledPeriods = result.EntityFilledPeriods;

	        self.Context.MarkedFilledPeriod_Up = null;
	        self.Context.MarkedFilledPeriod_Down = null;
	        self.Context.AllPeriods = null;
	        self.Context.SharedPeriods = null;

	        self.Context.IsAnonymous = result.IsAnonymous;
	        self.Context.ShareToken = result.InitShareId;
	        self.Context.EntityKey = result.SelectedKey;
	        self.Context.FormId = result.SelectedForm;
	        self.Context.FormTitle = result.FormTitle;
	        self.Context.FormType = result.FormType;
	        self.Context.FormList = result.FormList;
	        self.Context.BillMode = formData.BillMode;
	        self.Context.DataRecord = formData.DataRecord;
	        self.Context.FillingGuide = formData.FillingGuide;
	        self.Context.FmlScripts = formData.FmlScripts;
	        self.Context.SelectedEntityExtInfo = result.SelectedEntityExtInfo;
	        
	        self.registerFormulaScriptMethod();
	        self._initFmlScripts();
	        self._initWrapper();
	        self._setEntityTitle(result.EntityTitle);
	        self._initAfterLoaded(0);
	        
	    }, hasTips);
	},
	
    /*加载数据后初始化页面
     *curRowKey 当前行rowKey
     *curRowState 当前行状态(如，新增=1、修改=2、删除=3、保留=1、合计=9)
     */
	_initAfterLoaded: function (curRowKey, curRowState, isTappedEnter) {
	    var self = this;
	    
	    //初始化时期
        self._setPeriod();

	    //初始化表单列表
	    self._setFormTitle(self.Context.FormTitle);
	    
	    //初始化表单数据
	    if (self.Context.BillMode.AutoShow && !self.Context.BillMode.ReloadData && !isTappedEnter) {
	        self._createBillForm();
	    } else {
	        self.Context.BillMode.ReloadData = false;
	        var queryDirection = 0;
	        if (curRowState === "1") {
	            queryDirection = 2;
	        } else {
	            queryDirection = curRowKey ? 0 : -2;
	        }
	        self._queryDataRecord(curRowKey, queryDirection, function (result) {
	            self._createBillForm();
	            mui.closeWaiting();
	        });
	    }

	    //移动端网页浏览器，页面下方显示官网标志
	    self._initWebSiteTips();
	},


    _initWrapper: function(){
    	if(this.Context.IsAnonymous){
	    	$("#billform-top-entity-wrapper").hide();
	    	$("#billform-top-form-wrapper").show();
	    	$("#billform-bottom-form-container").hide();
	    }else{
	    	$("#billform-top-entity-wrapper").show();
	    	$("#billform-top-form-wrapper").hide();
	    	$("#billform-bottom-form-container").show();
	    }
    },

    /*后台请求
     *加载表单模式下的数据
     */
	_loadData: function (callback, hasTips) {
	    if (hasTips) {
	        mui.showWaiting("数据加载中……");
	    }

	    var self = this;
	    var path = self._getPath($.BaseUrl + 'DataInput/Home/Init_Mobile', true, true, true);
	    var data = {};
	    var reg = new RegExp('(^|&)' + "initDataGuid" + '=([^&]*)(&|$)', 'i');
	    var r = window.top.location.search.substr(1).match(reg);
	    if (r != null) {
	        data.initDataGuid = unescape(r[2]);
	    }
	    data.isFromBill = true;
	   
	    self._action(path, data, function (result) {
	        callback && callback(result);
	        mui.closeWaiting();
	    }, true, function (xhr, type, errorThrown) {
	        mui.closeWaiting();
	    });
	},
	
	_initFabmenu: function(){
		var self = this;
		var tabmenu = {
			"id":"fab-menu",
			"size":"btn-large",
			"img":"fab-icon-fixed",
			"bgdcolor":"blue",
			"dragFlag":true,
			onClick: this.onFabMenuTapped
		};
		var fabtable= {
			"id": "sub-fab-table",
			"title":"表格模式",
			"style": "fab-table",
			"color":"red",
			"img": "fab-icon-table"
		};
		var fabinvite = {
			"id": "sub-fab-invite",
			"title": "邀请",
			"style":"fab-invite",
			"color":"purple",
			"img": "fab-icon-invite"
		};
		var fabdesign = {
			"id": "sub-fab-designform",
			"title": "修改",
			"style":"fab-design",
			"color":"green",
			"img": "fab-icon-modify",
		};
		var fabresult = {
        	"id": "sub-fab-result",
        	"title": "查看结果",
        	"style": "fab-result",
        	"color": "deepgreen",
        	"img": "fab-icon-result"
        };
		var controls = [];
        if(mui.os.plus){
        	controls = [fabtable, fabinvite, fabdesign, fabresult];         	
        }else{
        	controls = [fabtable, fabresult];
        }
		
		var fabsubtabitems = {
			"id":"sub-fab-items",
			"controls":controls,
			onClick: this.onFabSubMenuTapped,    //点击子菜单时需触发的事件
			onClose: this._closeInviteWindow
		};
		$(".fixed-action-btn").fabmenu({"Tabmenu": tabmenu, "SubTabItems": fabsubtabitems});
		$(".fixed-action-btn").fabmenu("initMovingRegion",0, $(".mui-bar").height(), window.innerWidth, window.innerHeight - $(".mui-bar").height());
		setTimeout(function(){
			self._setFabmenuState();
		},100);		
	},
	
	onSetFabMenuPos: function(xPos, yPos){
		$(".fixed-action-btn").fabmenu("setInitPosition", xPos, yPos);
	},
	
	onFabMenuTapped: function() {
//		mui.toast("请在电脑上访问www.97gg.net创建表格。");
	},
	
	onFabSubMenuTapped: function(event,me) {
		var self = $.m("BillForm"), fabIcon = me.find('.fab-icon,.btn-title');
		switch(me.attr("id")){
			case "sub-fab-table": {
				var tableMode = fabIcon.hasClass('fab-table');
                if (tableMode) {
                    self.switchTableMode();
                } else {
                    self._dataInput.ToolBar.switchBillMode();
                }
			};break;
			case "sub-fab-invite": {
				if (fabIcon.hasClass('fab-invite') && mui.os.plus) {
                    var re = self._showInviteDlg();
                    if(re)
                    {
                    	event.stopPropagation();
                    }
                }
			};break;
			case "sub-fab-designform":{	
				self.onFabDesignTapped();
			};break;
			case "sub-fab-result":{
				self.enterResultShow();
			};break;
			default :{
				mui.toast('正在开发中，敬请期待！');
			};
		}
	},
	 
	onFabDesignTapped: function() {
		var self = this;
		mui.openWindow({
				url: '_www/tasks/businessmodel/designbillform.html',
				id: 'designbillform',
				//createNew: true,
				waiting: {
					autoShow: true,
					title: '正在努力加载数据……'
				},
				extras: {
					_taskId: self.Context.TaskId
				}
			});	
	},
	
	_setFabmenuState: function(){
		var self = this;
		if(self.Context.TaskType === "1") {
			var resultState = (self.Context.DataRecord && (self.Context.DataRecord.DataCount > 0));
			var designState = (self.Status.IsTaskOwner || (self.Context.UserId && (self.Context.UserId == self.Context.TaskCreater)));
			$(".fixed-action-btn").fabmenu("setState", "sub-fab-result", resultState);
			$(".fixed-action-btn").fabmenu("setState", "sub-fab-designform", designState);
		} else {
			$(".fixed-action-btn").fabmenu("setState", "sub-fab-designform", false);
			$(".fixed-action-btn").fabmenu("setState", "sub-fab-result", false);
		}
	},
	
	_closeInviteWindow:function(){
		var invite = mui.getWebviewById('Invite');
		if(invite){
			invite.close();
		}
	},
	
	_showInviteDlg: function(){
		var datainputOrBillForm = null;
		if(!this._dataInput)
			datainputOrBillForm = this._billForm;
		else{
				datainputOrBillForm = this._dataInput;
			}
		if(datainputOrBillForm.Context.IsAnonymous){
			mui.toast("此任务为匿名填报任务，不能使用此功能！")
			return false;
		}
		if(datainputOrBillForm.Context.ShareToken){
			mui.toast("此任务为共享任务，不能使用此功能！")
			return false;
		}
		var path = datainputOrBillForm._getPath($.BaseUrl + 'DataInput/Invite/Invite', true, true, true);
		 if (path.indexOf('?') >= 0) {
		        path += "&parentKey=" + datainputOrBillForm.Context.EntityKey;
		  } else {
		        path += "?parentKey=" + datainputOrBillForm.Context.EntityKey;
		  }
		  var thi = this;
		$.doAction(path, {}, function(data){
			mui.openWindow({
					url:'Invite.html',
					id:'Invite',
					styles:{
							bottom:'0',
							left:'0',
							width:'100%',
							height:'335',
					},
				extras:{//自定义扩展参数，可以用来处理页面间传值
					taskId: datainputOrBillForm.Context.TaskId,
					period: datainputOrBillForm.Context.Period,
					entityKey: datainputOrBillForm.Context.EntityKey,
					//inviteUrl:data.url
					}
				});
			});
		return true;
	},
	
	_bindEvents: function() {
		var self = this;
		mui('.mui-bar').on("tap", '.billform_back', function() {
			mui.back();
		});
		
		mui('.mui-bar').on("tap", '.form-title', function() {
			//mui('#form_list').popover('toggle');
		});

        mui('.mui-bar').on("tap", '#entity_current', function () {
            if (self.Context.IsAnonymous)
                return;
            mui.showWaiting('小伙伴加载中……');
            self._loadEntityData();
            //self.ToolBar.hideBottomBtns();
        });

		mui('.mui-bar').on("tap", '#billform-new', function () {
		    if ($(this).attr("disabled")) {
		        return;
		    }
	        self._beforeAction(function () {
	            self.newBillForm(true);
	         });
	    });
	    
		mui('.mui-bar').on("tap", '#billform-del', function () {
			if($(this).attr("disabled")){
				return;
			}
			mui.confirm("正在执行删除操作，是否继续？", '操作提示', ["是", "否"], function(e) {
				if (e.index !== 0) {
				    return;
				} 
				
				$(this).attr("disabled", "disabled");
		    	self._delDataRecord(function () {
		        	self._setBtnState("billform-del", true, true);
		    	
		       		self.refreshMarkedFilledPeriods();
		       		self._initBillFormCtrl(true);
		        	self._dataModified = true;
		        	if (self.Context.DataRecord.DataCount === 1) {
		            	self.Context.DataRecord.DataCount = 0;
		            	self.Context.DataRecord.RowIndex = 0;
		            	if (self._allRecords != null){
		            		self._allRecords = null;
		            	}
		           		self._newRecord();
		            	mui.toast('删除成功！');
		            	return;
		        	}
		        	if (self.Context.DataRecord.DataCount === self.Context.DataRecord.RowIndex) {
		            	--self.Context.DataRecord.DataCount;
		            	self.delFromAllRecords();
		            	self._onSwipleLeft();
		            	mui.toast('删除成功！');
		            	return;
		        	}
		        	if (self.Context.DataRecord.RowIndex < self.Context.DataRecord.DataCount) {
		            	--self.Context.DataRecord.DataCount;
		            	self.delFromAllRecords();
		            	self._onSwipleRight();
		            	mui.toast('删除成功！');
		        	}   
				});
				//先向后查找  待后面的没有行后再向前查找，直到向前查找也没有行时，直接新建出来一个表单。
			});
					

		});
	    
		mui('.mui-bar').on("tap", '#billform-slide-left', function () {
			if($(this).attr("disabled")){
				return;
			}
			$(this).attr("disabled", "disabled");
		    self._onSwipleLeft(function(){
		    	$("#billform-slide-left").removeAttr("disabled");
		    });
		});
	    
		mui('.mui-bar').on("tap", '#billform-slide-right', function () {
			if($(this).attr("disabled")){
				return;
			}
			$(this).attr("disabled", "disabled");
		    self._onSwipleRight(function(){
		    	$("#billform-slide-right").removeAttr("disabled");
		    });
		});
		
		mui('.mui-content').on("tap", '.field .value-switch', function() {
			if ($(this).attr('disabled') === 'disabled') return;
			$(this).toggleClass('mui-active');
		});
		
		mui('.mui-content').on("tap", '.field .value-date', function(e) {
			var type = this.getAttribute('type') || 'date';
			var valueElement = $('.value span:first', this), initText = valueElement.text(), initValue = '';
			if (self._isStringEqual(initText, self._initText)) {
				initText = '';
				initValue = $.datepicker.formatDate('yy-mm-dd', new Date());
			} else {
				initValue = $.datepicker.formatDate('yy-mm-dd', new Date(initText));
			}
			
			var options = '{"type": "' + type + '", "value": "' + initValue + '", "beginYear": 1900, "endYear": 2099}';	
			var optionsJson = JSON.parse(options);
			
			var fid = $(this).parent().parent().attr('id');
			var dataItem = self._getItemById(fid);
			if (!dataItem) return;
			if(dataItem.IsReadOnly) {
				mui.toast("只读项，不允许编辑！");
				return;
			}
			var hasKeybord = document.activeElement.tagName == 'TEXTAREA' || document.activeElement.tagName == 'INPUT'; // 用焦点是否在文本框上来判断当前是否有键盘
			if(!mui.os.plus && mui.os.ios && hasKeybord){
				// ios下普通浏览器弹出窗中，弹日期的场景中键盘弹出后通过document.activeElement.blur()收不回去，此处使用特殊方式。
				// 其他地方要使用时请注意，如果document.activeElement.blur()有效果则最好不要用这种方式。
				var str = '<input id="tmpInput" disabled="disabled" style="width:0; height:0; opacity:0" type="text" />';
				$(e.target).after(str);
				$("#tmpInput").removeAttr("disabled").focus().blur().attr("disabled", "disabled");
				$("#tmpInput").remove();
			} else{
				document.activeElement.blur();
			}
		
			var $this = this;
			var showDtPicker = function(){
				var dtPicker = new window.MyDtPicker(optionsJson);
				dtPicker.show(function(result) {
					
					if (!self._isStringEqual(initText, result.text)) {	
						var addStr=dataItem.FieldType=="6"?":00":"";
						valueElement.text(result.text+addStr);//"00"为补充秒
						dataItem.Value = result.text+addStr;
						dataItem.Title = result.text+addStr;
						dataItem.IsModified = true;
						self._onValueChanged();
					}					 
					dtPicker.dispose();
				});
				if(valueElement[0].innerHTML!="-- 请选择 --"){//添加清除按钮
	            	    $("<button id='data-id-btn-clear' class='mui-btn' style='margin-left:3px'>清除</button>").insertAfter($(".mui-dtpicker-header")[0].children[0]); 
		                $("#data-id-btn-clear").on("tap",function(){
		         	       valueElement.text("-- 请选择 --");
						   dataItem.Value = "";
						   dataItem.Title = "";
						   dataItem.IsModified = true;
						   self._onValueChanged();
		         	       $("#data-id-btn-clear").remove();	         	     	
		         	       dtPicker.dispose();
		                });
	             } 
			}
			if(hasKeybord){ // 只有在有键盘时才延迟加载，否则弹出耗时比较长
				setTimeout(function() {
					showDtPicker();
				}, 300);				
			} else {
				showDtPicker();
			}
		});
		
		mui('.mui-content').on("tap", '.field .value-file', function(e) {
			var fid = $(this).parent().parent().attr('id');
			self._onFileManager(fid);
		});
		
		mui('.mui-content').on("tap", '.billform-submit', function() {
		    if (self.Status.ReadOnly && self.Status.ReadOnly.Result) {
		    	mui.toast(self.Status.ReadOnly.Message);
		    	return;
		    }

		    document.activeElement.blur();
		    if (self._checkErrorItems != null && self._checkErrorItems.length > 0) {
		        self.toastCheckErrorMsg();
		        return;
		    }
			self._beforeDataSave();
			var isModified = self._isDataModified();
			if (!isModified) {
				if(self.Context.DataRecord.State === 1){
					mui.toast('请填写数据！');
				}else{
					mui.toast('提交成功！');
				}
				return;
			}

			self._saveDataRecord(function(data) {
				if (data && data.BoolResult.Result) {	                
				    $('.billform-submit').text("提交");
				    $("#billform-del").removeAttr("disabled");
				    self._initBillFormCtrl(true);
				    if(self._submitFlag){
				    	var dataRecord = self.Context.DataRecord;
						var canAdd = (!dataRecord.SetAsFixed || dataRecord.DataCount < dataRecord.FixedCount) && (dataRecord.MaxCount <= 0 || dataRecord.DataCount < dataRecord.MaxCount);
				    	self.CustomDlg.loadSubmitDlg(self.Context.FormType, !canAdd);
				    }else{
				    	mui.toast('提交成功！');
				    }
	                window.sendMessage(MSG_Common_AfterDataSave, null, this);
	            } else {
	            	var dataItem = null;
	            	if (data.ErrorInfo && data.ErrorInfo.LinkIds) {
	            		var linkId = data.ErrorInfo.LinkIds[0];
	            		dataItem = self._getItemById(linkId);
	            		self._locateError(linkId);
	            	}
	                mui.toast('提交失败：' + (dataItem ? dataItem.Name + '，' : '') + data.BoolResult.Message);
	            }
			});
		});
		
		mui('.mui-content').on("tap", '.mui-icon-clear', function() {
			var prevCtrl = $(this).prev();
			if (prevCtrl.length <= 0)
				return;
			prevCtrl[0].value = '';			
			$(this).hide();
			//value-input清除内容时，人为触发input事件
			if (prevCtrl.hasClass("value-input")){				
				prevCtrl.trigger("input");	
			}
		});
		
        //卡片input值变化时触发，用于执行计算公式
		$('.mui-content').off("input", ".field .value-input").on("input", ".field .value-input", function () {
		    var fid = $(this).parent().parent().attr('id');
		    var cellValue = $(this).val();
		    self.excuteExpression(fid, cellValue, cellValue);
		    if (cellValue == null || cellValue.length <= 0) {
		        self.excuteCheckExpression($(this), cellValue, cellValue, fid, event);
		    }
		});

		$('.mui-content').off("change", "input.enum-input").on("change", "input.enum-input", function () {
		    var fid = $(this).parent().parent().parent().attr('id');
		    var editText = null, showText = null;
		    if ($(this).hasClass('.checked') || this.checked) {
		        editText = $(this).attr("value");
		        showText = $(this).attr("enumTitle");
		    }
		    self.excuteCheckExpression($(this), showText, editText, fid, event);
		    self.excuteExpression(fid, showText, editText);
		});
		
	    //卡片input获得焦点时触发，用于设置错误input的颜色
		$('.mui-content').off("focus", ".field .value-input").on("focus", ".field .value-input", function (event) {
			var dataInput = $(this);
			var fid = dataInput.parent().parent().attr('id');
			if (self._checkErrorItems != null && self._checkErrorItems.indexOf(fid) >= 0){
				dataInput.css('border', '1px solid red');
				if (self._checkErrorItems.length == 1)
					self._disabledEvent = false;
			}
		});
		
		$('.mui-content').off("blur", ".field .value-input").on("blur", ".field .value-input", function (event) {
			if (self._disabledEvent)
				return;
			var dataInput = $(this);
			var fid = dataInput.parent().parent().attr('id');
		    var cellValue = dataInput.val();
		    self.excuteCheckExpression(dataInput, cellValue, cellValue, fid, event);
		});
		
		$('.mui-content').off("blur", "span.enum-span").on("blur", "span.enum-span", function (event) {
			if (self._isEnumOpen)
				return;
			var dataInput = $(this);
			var fid = dataInput.parent().parent().parent().parent().attr('id');
			var cellValue = dataInput.text();
			var dataItem = self._getItemById(fid);
		    if (dataItem == null)
		        return;
		    var valuArray = dataItem.Value.split('|'),
			    code = valuArray.length >= 2 ? valuArray[1].split(';') : dataItem.Value.split(';');
		    self.excuteCheckExpression(dataInput, cellValue, code, fid, event);
		});
	},
	
    /*单位*/
	_setEntityTitle: function (title) {
	    if (!title) return;
	    $("#entity_cur_title").attr("title", title);
	    var overlong = title && title.length > 6;
	    title = overlong ? (title.substring(0, 6) + "...") : title;
	    $("#entity_cur_title").text(title);
	},
	
	_loadEntityData: function () {
	    if (!this.Context.EntityNodes) this.Context.EntityNodes = {};
	    if (this.Context.EntityNodes[this.Context.Period]) {
	        this._selectEntity();
	        return;
	    }

	    var self = this;
	    self._onLoadEntityData(function () {
	        self._selectEntity();
	    });
	},
	
	_queryEntityByEntityKey: function (entityKey, callback) {
	    var self = this;
	    var path = self._getPath($.BaseUrl + 'DataInput/Home/QueryEntity', true);
	    path += "&entityKey=" + entityKey;
	    self._action(path, {}, function (data) {
	        callback && callback(data);
	    }, true, function (xhr, type, errorThrown) {
	        mui.closeWaiting();
	    });
	},
	
	_onLoadEntityData: function (callback) {
	    var self = this;
	    var path = self._getPath($.BaseUrl + 'DataInput/Home/LoadEntityData', true);
	    path += "&isMobile=true";
	    self._action(path, {}, function (data) {
	        self.Context.EntityNodes[self.Context.Period] = data;
	        callback && callback();
	    }, true, function (xhr, type, errorThrown) {
	        mui.closeWaiting();
	    });
	},

	_selectEntity: function () {
	    var self = this;
	    if (self.Context.IsAnonymous)
	        return;
	    mui.openWindow({
	        url: 'entity.html',
	        id: 'entity_select',
	        createNew: true,
	        extras: {
	            isFromBill: true,
	            userId: self.Context.UserId,
	            taskId: self.Context.TaskId,
	            period: self.Context.Period,
	            formId: self.Context.FormId,
	            entityKey: self.Context.EntityKey,
	            entityNodes: self.Context.EntityNodes[self.Context.Period]
	        },
	        show: {
	            autoShow: true
	        },
	        waiting: {
	            autoShow: false
	        }
	    });
	},
	
    /*汇总节点在表格模式从明细行进入表单模式
     *从明细行中的entityKey获取entityNode
     * 注：EntityNodes中读不到匿名节点
     */
	_getEntityNodeInDetail: function (callback) {
	    var self = this;
	    var getNode = function () {
	        var arr = self.Context.EntityNodes[self.Context.Period];
	        if (arr && arr.length > 0) {
	            for (var i = 0; i < arr.length; i++) {
	                if (self.Context.EntityKeyInDetail != arr[i].id)
	                    continue;
	                return arr[i];
	            }
	        }

	        return null;
	    };

	    var curNode = null;
	    if (self.Context.EntityNodes && self.Context.EntityNodes[self.Context.Period]) {
	        curNode = getNode();
	        callback && callback(curNode);
	    } else {
	        self.Context.EntityNodes = {};
	        self._onLoadEntityData(function () {
	            curNode = getNode();
	            callback && callback(curNode);
	        });
	    }
	},
	
    _onEntitySelected: function (entityKey, entityTitle, isLeafNode, shareToken, extInfo, selectedFormId, selectedFormTitle, curRowKey) {
        this.Context.EntityKey = entityKey;
        this.Context.EntityTitle = entityTitle;
        this.Context.IsLeafNode = isLeafNode;
        this.Context.ShareToken = shareToken;
        this.Context.SelectedEntityExtInfo = extInfo;

        if (selectedFormId && selectedFormTitle && this.Context.FormId != selectedFormId) {
            this.Context.FormId = selectedFormId;
            this.Context.FormTitle = selectedFormTitle;
            this._setFormTitle();
        }

        if(!curRowKey){
        	this._entityModified = true;
        }
        this._afterEntitySelected(curRowKey);

    },
  
    _afterEntitySelected: function (curRowKey) {
        var self = this;
        self._setEntityTitle(self.Context.EntityTitle);
        self.refreshMarkedFilledPeriods();
        self.refreshSelectedEntityExtInfo();
        
        var curRowKey = !curRowKey ? 0 : curRowKey;
        var queryDirection = curRowKey == 0 ? 2 : 0;
        self._queryDataRecord(curRowKey, queryDirection, function (result) {
        	 if (result) {
	            self._createBillForm();
	        } else {
	            self.Context.DataRecord.DataCount = 0;
	            self.Context.DataRecord.RowIndex = 0;
	            self._newRecord();
	        }
            mui.closeWaiting();
        });
    },
	
    /*时期*/
    _setPeriod: function () {
        //	    var hasPeriodDrop = self.Context.PeriodType != "8" || (self.Context.PeriodType == "8" && self.Context.PeriodCount > 1);
        //	    if (hasPeriodDrop && !self.Context.IsAnonymous) {
        //	        $("#period-cur-title").text(self.Context.PeriodTitle);
        //	        $("#billform-period-container").show();
        //	        self.PeriodSelector.onInit(self.Context, self.Status, $("#period-cur-title"), true, self.Context.IsTempPeriod);
        //	    }

        var self = this;
        $("#period_cur_title").text(self.Context.PeriodTitle);
        var hasPeriodDrop = self.Context.PeriodType != "8" || (self.Context.PeriodType == "8" && self.Context.PeriodCount > 1);
        if (!self.Context.IsAnonymous && hasPeriodDrop) {
            self.PeriodSelector.onInit(self.Context, self.Status, $("#period_current"), true, self.Context.IsTempPeriod);
        }
    },

    refreshMarkedFilledPeriods: function () {
        this.PeriodSelector.refreshMarkedFilled();
    },
    
    refreshSelectedEntityExtInfo: function () {
        this.PeriodSelector.refreshSelectedEntityExtInfo(this.Context.SelectedEntityExtInfo);
    },

    onPeriodSelected: function (sender, msg) {
        if (!msg || !msg.code || !msg.title)
            return;

        var self = this;
        var tempCode = self.Context.Period;
        var tempTitle = self.Context.PeriodTitle;
        var tempIsTemp = self.Context.IsTempPeriod;
        self.Context.Period = msg.code;
        self.Context.PeriodTitle = msg.title;
        self.Context.IsTempPeriod = msg.isTemp;
        self._periodModified = true;

        self._init(function (result) {
            if (result && !result.IsLeafNode) {
                var message = '这期的数据由多人参与填写，系统将以表格形式展现，是否继续？';
                mui.confirm(message, '操作提示', ["是", "否"], function (e) {
                    if (e.index === 0) {
                        self.switchTableMode();
                    } else {
                        self.Context.Period = tempCode;
                        self.Context.PeriodTitle = tempTitle;
                        self.Context.IsTempPeriod = tempIsTemp;
                    }
                });
                return;
            }

            self.PeriodSelector.onReset(self.Context.Period, self.Context.PeriodTitle, self.Context.IsTempPeriod);
        }, true);
    },

    /*表单*/
	newBillForm: function (showTips) {
	    if (this.Context.DataRecord.State === 1) return;
	    this.Context.DataRecord.RowIndex = ++this.Context.DataRecord.DataCount;
	    this._newRecord(showTips);
	    this._setBtnState("billform-del", true, false);
    },

	_initBillFormCtrl: function (isUpdated) {
	    var self = this;
	    if(self.Context.FormType === 0){
	    	$(".mui-bar-nav~.mui-content").css("padding", "48px 0 0 0");
	        $("#billform-ctrl").hide();
			return;	    	
	    }
	    self._initBottomBtnsState();
	    if (self.Context.DataRecord.DataCount > 0) {
	        if (isUpdated) {
	            $("#billform-slide-title").html("<span style=\"color:#01b6cc;\">" + self.Context.DataRecord.RowIndex + "</span>/" + self.Context.DataRecord.DataCount);
	        }
	        $(".mui-bar-nav~.mui-content").css("padding", "48px 0");
	        $("#billform-ctrl").show();		        
	        self.onSetFabMenuPos(window.innerHeight - $("#billform-ctrl").height() - $(".mui-bar").height()-8,$(".fixed-action-btn").parent().width() - $(".fixed-action-btn").width() - 5);	           
	    } else {
	    	$(".mui-bar-nav~.mui-content").css("padding", "48px 0 0 0");
	        $("#billform-ctrl").hide();
	        self.onSetFabMenuPos(window.innerHeight - $(".mui-bar").height()-8,$(".fixed-action-btn").parent().width() - $(".fixed-action-btn").width() - 5);          
	    }
	    setTimeout(function(){
	    	self._setFabmenuState();
	    },300);
	    
	},
	
	_onSwipleRight: function(callback) {
		var self = this, record = self.Context.DataRecord;
		if($(".img-toolbar").length>0 ){
		    self._destroyImgToolBar();
		}
		if($("#__MUI_PREVIEWIMAGE").is(":visible"))return;
		if (!record) return;
		
		self._beforeAction(function() {
			self._queryDataRecord(record.Key, 1, function(result) {
	    		if (!result) {
	    			mui.toast('后面没有数据了。');
	    		} else {
	    		    self._createBillForm();
	    		    
	    		}
	    		self._rowKeyModified = true;
	    		callback && callback();
	    		mui.closeWaiting();
	    	});
		});
	},

	_onSwipleLeft: function(callback) {
		if($("#__MUI_PREVIEWIMAGE").is(":visible"))return;			
		var self = this, record = self.Context.DataRecord;
		if($(".img-toolbar").length>0 ){
		    self._destroyImgToolBar();
		}
		if (!record || record.RegType === 0) return;
		self._beforeAction(function() {
			self._queryDataRecord(record.Key, record.State === 1 ? 2 : -1, function(result) {
	    		if (!result) {
	    			mui.toast('前面没有数据了。');
	    		} else {
	    		    self._createBillForm();
	    		}
	    		self._rowKeyModified = true;
	    		callback && callback();
	    		mui.closeWaiting();
	    	});
		});
	},
	
	_setFormTitle: function (formTitle) {
	    if (!formTitle) {
	        formTitle = this.Context.FormTitle;
	    }
	    var width = 25;
	    if(this.Context.IsAnonymous){
	    	width = $('#billform-top-form-wrapper').width() - 25;
	    }
	    else{
	    	width = $('#billform-bottom-form-container h1').width();	
	    }
	    var maxLen = Math.floor((width - 50) / 17), title = '';
		if (formTitle && formTitle.length > maxLen) {
			title = formTitle.substring(0, maxLen - 1) + '...';
		} else {
			title = formTitle;
		}
		$(".form_cur_title").text(title);
	},
	
	_initFormList: function(formList) {
		if (!formList || formList.length === 0) return;
		
		var self = this;
		var htmlStr = '';
		for (var i = 0, len = formList.length; i < len; i++) {
			var item = "<li id='" + formList[i].ID + "' title='" + formList[i].Title + "' class='mui-table-view-cell'><a href='#'>" + formList[i].Title + "</a></li>";
			htmlStr += item;
		}
		
		$("#form_list ul").append(htmlStr);
		mui("#form_list").off('tap', 'li');
		mui("#form_list").on('tap', 'li', function () {
			var formId = this.id, formTitle = this.title;
		    self._onFormSelect(formId, formTitle);
		});
	},
	
	_onFormSelect: function(newFormId, newFormTitle) {
		this.Context.FormId = newFormId;
		this._setFormTitle(newFormTitle);
		
		if ($('#form_list').hasClass('.mui-popover.mui-active')) {
			mui('#form_list').popover('toggle');	
		}
		
		//todo 服务器端请求数据
	},
	
	_onFileManager: function(fid) {
		var dataItem = this._getItemById(fid);
		if (!dataItem || dataItem.IsReadOnly) return;
		
		var fileOptions = {},Context=this.Context;
		fileOptions.fid = fid;
		fileOptions.imgOnly = dataItem.isImgOnly ? true : false;
        fileOptions.fileData = dataItem.Value && eval(dataItem.Value);
        fileOptions.editable = !dataItem.IsReadOnly;
		fileOptions.returnListenString = "msg_datainput_files";
    	fileOptions.downloadListenString = "msg_datainput_filesDownload";
    	fileOptions.URL = Context.UploadParams?Context.UploadParams:"?Container=attachfiles-"+Context.TaskId+"&Directory="+Context.Period+"/"+Context.EntityKey + "&_taskId_=" +Context.TaskId;
    	mui.openWindow({
			url: 'filesManagement.html',
		    id: 'filesManagement',
		    extras: {
		    	fileOptions:fileOptions,				    	
		    },
		    show: {
		    	autoShow: true,
		    },
		    waiting: {
		    	autoShow: true,
		    }  
		});
	},
	
	getBase64Data: function(fileData) {
		var self = this, fileItem = fileData && eval(fileData);
		var postData = { taskId: self.Context.TaskId, period: self.Context.Period, entityKey: self.Context.EntityKey, fileInfo: fileData, getBase64: true };
		this._action($.BaseUrl + 'DataInput/Home/DownloadAttachedFile', postData, function(data) {
			return data;
		});
	},
	
	/*
	 * Download File(unfinished)
	 */
	_downloadFile: function(fileData) {
		var self = this, fileItem = fileData && eval(fileData);
		this._action($.BaseUrl + 'DataInput/Home/DownloadAttachedFile', {
			taskId: self.Context.TaskId,
			period: self.Context.Period,
			entityKey: self.Context.EntityKey,
			fileInfo: fileData,
			getBase64: true
		}, function(data) {
			self._writeFile(fileItem[0].FileName, data, function (filePath) {
				self._moveFile(filePath, 'Download', function () {
					alert('download complete.');
				});
			});
		}, true, function (xhr, type, errorThrown) {
            
        });
	},
	
	_writeFile: function(fileName, data, callback) {
		this._checkFile(fileName, function() {
			var path = '_downloads/' + fileName;
			plus.io.resolveLocalFileSystemURL(path, function(entry) {
				entry.createWriter(function(writer) {
					writer.onwrite = function(e) {
						mui.toast('write success');
						callback && callback(path);
					};
					writer.onerror = function(e) {
						mui.toast('write error: ' + e.message);
					};
					
					var binary_string =  window.atob(data);					
					writer.write(binary_string);
				}, function(e) {
					alert(e.message);
				});
			});
		});
	},
	
	_moveFile: function(filePath, directory, callback) {
		this._checkDirectory(directory, function(dirPath) {
			plus.io.resolveLocalFileSystemURL(dirPath, function(dirEntry) {
				plus.io.resolveLocalFileSystemURL(filePath, function(fileEntry) {
					fileEntry.copyTo(dirEntry, null, function(entry) {
						//fileEntry.remove()
						callback && callback();
					}, function(e){
						alert('文件复制失败：' + e.message);
					});
				});			
			});
		});
	},
	
	_checkFile: function(fileName, callback) {
		var dirPath = '_downloads', filePath = dirPath + '/' + fileName;
		plus.io.resolveLocalFileSystemURL(dirPath, function(entry) {
			entry.getFile(fileName, { create: true, exclusive: false }, function(file) {
				callback && callback();
			}, function (e) {
				alert('无法访问文件：' + filePath + '\r\n错误信息：' + e.message);
			});
		}, function(e) {
			alert('无法访问目录：' + dirPath + '\r\n错误信息：' + e.message);
		});
	},
	
	_checkDirectory: function(directory, callback) {
		var rootPath = '/storage/emulated/0/', dirPath = rootPath + directory;
		plus.io.resolveLocalFileSystemURL(rootPath, function(entry) {
			entry.getDirectory(directory, { create: true, exclusive: false }, function(dir) {
				callback && callback(dirPath);
			}, function (e) {
				alert('无法访问目录：' + dirPath + '\r\n错误信息：' + e.message);
			});
		}, function(e) {
			alert('无法访问目录：' + rootPath + '\r\n错误信息：' + e.message);
		});
	},
	/*
	 * End Download File
	 */
	
	switchTableMode: function() {
		var self = this;
		if(!mui.os.plus && window.isMainPage){
			self._beforeAction(function() {
				window.top.location.href = "/JcpMobile/tasks/datainput/index.html" + window.top.location.search;
			});				
			return;
		}		

		self._beforeAction(function () {
			self._sendMsgToTableMode();
			mui.currentWebview.opener().show('none');
			mui.currentWebview.close();
		});
	},
	
	enterResultShow: function() {
		var self = this;
		var oldView = mui.getWebviewById('billformresultheader.html');
		if(oldView)
		{
			oldView.close();
		}
		mui.openWindow({
			url:'_www/tasks/businessmodel/billformresultheader.html',
			id:'billformresultheader.html',
			createNew: true,
			waiting: {
				autoShow: true,
				title:'正在加载数据...'
			}
		});
		var intervals = setInterval(function(){
			var targetView = mui.getWebviewById('billformtotalresult.html');
			if(targetView) {
				mui.fire(targetView, 'datashow', {
					taskId: self.Context.TaskId,
					taskType: self.Context.TaskType,
					selectedEntityExtInfo: self.Context.SelectedEntityExtInfo,
					entityKey: self.Context.EntityKey,
					formId: self.Context.SelectedForm,
					shareToken: self.Context.InitShareId,
					isLeafNode: self.Context.IsLeafNode,         
					periodCount: self.Context.PeriodCount,
					period: self.Context.Period,
					periodTitle: self.Context.PeriodTitle,
					periodType: self.Context.PeriodType,
					isTempPeriod: self.Context.IsTempPeriod
				});
				clearInterval(intervals);
			}
		},2000);
	},
	
	_sendMsgToTableMode: function(){
		var context = this.Context;
		var rowKeys = context.DataRecord.Key;
		var linkIds = [];
		if(context.DataRecord.DataItems && context.DataRecord.DataItems.length > 0){
		    linkIds.push(context.DataRecord.DataItems[0].ID);
		}
		//汇总节点进入，汇总节点返回
		if(context.EntityKeyInDetail && context.EntityInTotal && !this._entityInTotalModified){ 	
		    if (this._periodModified) {
		    	this._sendMsgOfReloadPeriod(context.Period, context.PeriodTitle, context.IsTempPeriod, context.EntityInTotal.id, rowKeys, linkIds);
		    }
		    else if(this._entityModified){
		    	this._sendMsgOfReloadEntity(context.EntityInTotal.id, context.EntityInTotal.name, context.EntityInTotal.isLeaf, context.EntityInTotal.shareToken, context.EntityInTotal.extInfo, rowKeys, linkIds);
		    }
		    else if (this._dataModified) {
		    	this._sendMsgOfReloadData(context.FormId, rowKeys, linkIds);
			}else if(this._rowKeyModified){
				this._sendMsgOfReFocusCell(rowKeys, linkIds);
			}			
		    return;
		}
		
		//叶子节点进入，叶子节点返回
		var entityKeyIndex = rowKeys.indexOf('ENTITYKEY');
		if(entityKeyIndex > -1){
			var entityKeyInRowKeys = rowKeys.substr(entityKeyIndex, 45);
			rowKeys = rowKeys.replace(entityKeyInRowKeys,"");
		}
		if (this._periodModified) {
		    this._sendMsgOfReloadPeriod(context.Period, context.PeriodTitle, context.IsTempPeriod, context.EntityKey, rowKeys, linkIds);
		}
		else if(this._entityModified){
		    this._sendMsgOfReloadEntity(context.EntityKey, context.EntityTitle, context.IsLeafNode, context.ShareToken, context.SelectedEntityExtInfo, rowKeys, linkIds);
		}
		else if (this._dataModified) {
			this._sendMsgOfReloadData(context.FormId, rowKeys, linkIds);
		}else if(this._rowKeyModified){
			this._sendMsgOfReFocusCell(rowKeys, linkIds);
		}
		
	},
	
	_sendMsgOfReFocusCell: function(rowKeys, linkIds){
		mui.fire(_parent, 'onReFocusCell', {
		    rowKeys: rowKeys,
		    linkIds: linkIds
		});
	},
	
	_sendMsgOfReloadData: function(formId, rowKeys, linkIds){
		mui.fire(_parent, 'onReloadData', {
		    formId: formId,
		    rowKeys: rowKeys,
		    linkIds: linkIds
		});
	},
	
	_sendMsgOfReloadPeriod: function(periodCode, periodTitle, isTempPeriod, entityKey, rowKeys, linkIds){
		mui.fire(_parent, 'onReloadPeriod', {
		    code: periodCode, 
		    title: periodTitle, 
		    isTempPeriod: isTempPeriod,
		    entityKey: entityKey,
		    rowKeys: rowKeys,
		    linkIds: linkIds
		});
	},
	
	_sendMsgOfReloadEntity: function(entityKey, entityTitle, isLeaf, shareToken, extInfo, rowKeys, linkIds){
		mui.fire(_parent, 'onReloadEntity', { 
			entityKey: entityKey,
		    entityTitle: entityTitle,
		    isLeafNode: isLeaf,
		    shareToken: shareToken,
		    extInfo: extInfo,
		    rowKeys: rowKeys,
		    linkIds: linkIds
		});
	},
	
	_beforeAction: function(callback, message) {
		this._beforeDataSave();
		var isModified = this._isDataModified();
		if (isModified) {
			var self = this, message = message || '提交失败，是否继续修改当前的数据？';
			self._saveDataRecord(function(data) {
				if (data && data.ErrorInfo) {
					mui.confirm(message, '操作确认', ["是", "否"], function(e) {
						if (e.index === 0) {
							var linkId = data.ErrorInfo.LinkIds[0];
            				self._locateError(linkId);
						} else {
							callback && callback();
						}
					});
	            } else {
	           		callback && callback();
	            }
			});
		} else {
	    	callback && callback();
		}
	},
	
	_newRecord: function(showTips) {		
		var dataItem, dataItems = this.Context.DataRecord.DataItems;
		for (var i = 0, len = dataItems.length; i < len; i++) {
			dataItem = dataItems[i];
			dataItem.Value = '';
			dataItem.Title = '';
			dataItem.IsModified = false;
		    if (this.Status.ReadOnly && this.Status.ReadOnly.Result) {
		        dataItem.IsReadOnly = true;
		    } 
		}

		this.Context.DataRecord.Key = 'tmpkey';
		this.Context.DataRecord.State = 1;
		this.Context.DataRecord.FloatOrder = 0;
		this._createBillForm();
		
		$("html, body").animate({ scrollTop: 0 }, "slow");
		if (showTips) {
		    mui.toast('开始新增数据');
		}
	  
	},
	_curImgsOnLongTap :function(node,fileguid){
		for(var i=0;i<node.children.length-1;i++){
			if(node.children[i].getAttribute('fileguid')==fileguid){
				$(node.children[i]).addClass("note-selected");
			}else{
				$(node.children[i]).addClass("note-notselected");
			}
		}
	},
	_setImgSelected:function(){
		
	},
	_removeSelectedImg:function(){ 
		var self = this;
		var selectedNode = $(".note-selected");
		if(selectedNode.length==0){
			mui.toast("请先选中要删除的图片");
		}else{
		   var id= selectedNode[0].parentNode.id,
		    item = self._getItemById(id),
		    files = eval(item.Value);
		    var __deleteFile = function(fileCod){
		    		for(var i=0,len=files.length;i<len;i++){
		    			if(files[i].FileGuid == fileCod){
		    				files[i].FileState =3;
		    				break;
		    			}
		    		}
		    	}
		    for(var i=0;i<selectedNode.length;i++){
		    	var fileCod = selectedNode[i].getAttribute("fileguid");
		    	__deleteFile(fileCod);
		    	$(selectedNode[i]).remove();
		    }
		    item.Value = JSON.stringify(files);
         	item.IsModified = true;
         	if (self.Context.DataRecord.State == 0) self.Context.DataRecord.State = 2;
         	self._destroyImgToolBar();
		}
	},
	_destroyImgToolBar :function(){
		$(".img-toolbar").slideUp(130);
		$(".img-toolbar").remove();
		$(".value-img-show").removeClass("note-selected").removeClass("note-notselected");
	},
	_showImgToolBar:function(id){
		var self = this;
		$("<div id="+id+" class='img-toolbar'><div class='img-toolbar-option'><div class='delete'>删除</div><div class=download>下载</div></div><div class='cancel'>取消</div></div>").appendTo(document.body);
		$(".img-toolbar").slideDown(130);	
		$(document).on('tap',  function(e) {
			if($(".img-toolbar").is(":visible")){
				var classList = e.target.classList
				if(classList.length>0 &&(classList.contains("delete") || classList.contains("cancel")) || classList.contains("download")){
					if(e.target.parentNode.classList.contains("img-toolbar") || e.target.parentNode.parentNode.classList.contains("img-toolbar")){
						if(classList.contains("delete")){
							self._removeSelectedImg();
						}else if(classList.contains("cancel")){
						    self._destroyImgToolBar();
						}else{
							mui.toast('暂不支持下载！');
						}
					}else{
						self._destroyImgToolBar();
					}
				}else if(e.target.parentNode.classList.contains("note-selected") || e.target.parentNode.classList.contains("note-notselected") ){
					if(e.target.parentNode.classList.contains("note-selected")){
						$(e.target.parentNode).removeClass("note-selected").addClass("note-notselected");
					}else{
						$(e.target.parentNode).removeClass("note-notselected").addClass("note-selected");
					}
				}else{
					self._destroyImgToolBar();
				}
			}
			e.stopImmediatePropagation()
		});
	
	},
	_addFiles :function(file,id){
		var self = this;
		$("<span fileguid="+file.FileGuid + "  class='value-img-show'><img data-preview-src data-preview-group=" +id +" class='value-img-show-img' style='width:100%;display:none' src=" + file.FileURl +"></span>").insertBefore($("#"+id+" span[name=addfile]"));
		var imgWidth = $('.value-img-show').css('width');
		$('.value-img-show').css('height',imgWidth).css('border-radius',parseInt(imgWidth)*0.1);
		if($('.value-img-show-img').length>0){
			for(var i=0;i<$('.value-img-show-img').length ;i++){
				var img = $('.value-img-show-img')[i];
				img.onload = function(){
					 var naturalHeight =this.naturalHeight,
                         naturalwidth = this.naturalWidth;
                     if(naturalwidth>naturalHeight){
                     	$(this).css('height','100%').css('width','auto').show();	
                     }else{
                     	$(this).show();
                     }
				}
			}
		} 
		$('.value-img-show-img').off('longtap').on('longtap',function(e){
			var fileguid =e.target.parentNode.getAttribute('fileguid'),
			    imgCount = e.target.parentNode.parentNode.children.length - 1,
			    id = e.target.parentNode.parentNode.id,
			    item = self._getItemById(id),
			    files = eval(item.Value),
			    fileCount = 0;
		    if($(".img-toolbar").length>0 &&  $(".img-toolbar")[0].getAttribute('id') == id){
		    	return;
		    }else if($(".img-toolbar").length>0 && $(".img-toolbar")[0].getAttribute('id') != id){
		    	self._destroyImgToolBar();
		    }
			self._showImgToolBar(id);
			self._curImgsOnLongTap( e.target.parentNode.parentNode,fileguid);
			self._setImgSelected(fileguid);
		})
	},
	_imgInBillForm :function(){
		var self = this;
		if($('.value-img-show').length == 0) return;
		var imgWidth = $('.value-img-show').css('width');
		$('.value-img-show').css('height',imgWidth).css('border-radius',parseInt(imgWidth)*0.1);
		$('.form_FileUplaod').css('height','100%').css('width','100%');		
		if($('.value-img-show-img').length>0){
			for(var i=0;i<$('.value-img-show-img').length ;i++){
				var img = $('.value-img-show-img')[i];
				img.onload = function(){
					 var naturalHeight =this.naturalHeight,
                         naturalwidth = this.naturalWidth;
                     if(naturalwidth>naturalHeight){
                     	$(this).css('height','100%').css('width','auto').show();	
                     }else{
                     	$(this).show();
                     }
				}
			}
		} 
		$('.value-img-show-img').on('tap',function(e){
	  
		})
		$('.value-img-show-img').on('longtap',function(e){
			var fileguid =e.target.parentNode.getAttribute('fileguid'),
			    imgCount = e.target.parentNode.parentNode.children.length - 1,
			    id = e.target.parentNode.parentNode.id,
			    item = self._getItemById(id),
			    files = eval(item.Value),
			    fileCount = 0;
		    if($(".img-toolbar").length>0 &&  $(".img-toolbar")[0].getAttribute('id') == id){
		    	return;
		    }else if($(".img-toolbar").length>0 && $(".img-toolbar")[0].getAttribute('id') != id){
		    	self._destroyImgToolBar();
		    }
			self._showImgToolBar(id);
			self._curImgsOnLongTap( e.target.parentNode.parentNode,fileguid);
			self._setImgSelected(fileguid);
		})
		$('.value-img-show-add').on('change',function(e){	
			var id = e.target.parentNode.parentNode.parentNode.id,
			    item = self._getItemById(id),
			    curfiles;
			    if(item.Value){
			    	 try{
					   curfiles =  eval(item.Value);
					}
					catch(err){
					   curfiles =JSON.parse(item.Value);
					}
			    }else{
			    	curfiles=[];
			    }
			   
	        var _getUploadFileSize = function (fileUpload, file) {
			    if (file == null)
			        return 0;
			    if (typeof window.ActiveXObject != 'undefined') {
			        try {
			            var fso = new ActiveXObject("Scripting.FileSystemObject");
			            var fileObj = fso.GetFile(file);
			            return fileObj && fileObj.size || 0;
			        } catch (e) {
			            return -1;
			        }
			    } else {
			        var files = fileUpload[0].files;
			        return files && files[0] && files[0].size || 0;
			    }
			};
			var __getFileName = function(fullName,curfiles){
				if(!files || files.length ==0 ) return fullName;
	        	var files=curfiles,flagNum=false,
				 indexHash = {},
				 index = 0,
				 splitIndex = fullName.lastIndexOf(".", fullName.length - 1),
	             curFileName = fullName.substring(0, splitIndex),
	             extName = fullName.substring(splitIndex);
				 for (var j = 0; j < files.length; j++) {
			        var fileName = files[j].FileName;
			        if (fileName == fullName) {
			                indexHash["0"] = 1;
			                continue;
			            }
			            var pattern = curFileName.replace("(", "\\(").replace(")", "\\)").replace(".", "\\.") + " \\(\\d*\\)\\" + extName;
			            var regExp = new RegExp(pattern);
			            if (regExp.test(fileName)) {
			                indexHash[fileName.substring(curFileName.length + 2, fileName.length - extName.length - 1)] = 1;
			            }
			        }
	
			        while (indexHash[index.toString()] && indexHash[index.toString()] == 1) {
			            index++;
			        }
			        if (index > 0) {
			            curFileName += " (" + index + ")";
			        }
			        curFileName += extName;  
			        return curFileName;
            }
            var file = $(".value-img-show-add")[0].value;
    	    fileType = file.substr(file.lastIndexOf('.') + 1).toLowerCase(),
            fileSize = _getUploadFileSize($(".value-img-show-add"), file);
        
            if(fileSize>20971520){
            	mui.toast("超过图片上传限制，请选择小于20MB文件再次上传！"); 
            	return;
            }

            //$(document.body).showLoading();
            mui.showWaiting();
             $("#form_FileUplaod_"+id).ajaxSubmit({
             	contentType: "application/x-www-form-urlencoded; charset=utf-8", 
                success: function(files){
                	mui.closeWaiting();
                	var file;
                	try{
                		 file = eval(files);
                	}
                	catch(e){
                		mui.toast("图片上传失败，请重新上传！"); 
                		return;
                	}
                	var file = eval(files);
	             	if(file && file[0] && typeof(file[0])=="object"){
	             		var curFile={};
						 curFile.Description = file[0].Description==null?"": file[0].Description;
						 curFile.FileName=__getFileName(file[0].FileName,curfiles);
						 curFile.ModifiedTime=file[0].ModifiedTime;
						 curFile.FileGuid = file[0].FileGuid;
						 curFile.FileURl = file[0].FileURl ? file[0].FileURl : file[0].FileURL;
						 curFile.FileState = file[0].FileState;
						 curFile.FileSize = file[0].FileSize;
	             		 curfiles.push(curFile)
	             		 self._addFiles(curFile,id);
	             		 item.Value = JSON.stringify(curfiles);
				         item.IsModified = true;
				         if (self.Context.DataRecord.State == 0) self.Context.DataRecord.State = 2;
	             		 mui.toast("图片上传成功！"); 
	             	}else{
	             		mui.toast("图片上传失败，请重新上传！"); 
	             	}
                }
             });
		})

	},
	_createBillForm: function() {
		var dataRecord = this.Context.DataRecord;
		if (!dataRecord || !dataRecord.DataItems) return;
		
		var container = $('.swiper-slide.swiper-slide-active .billform-content').empty();
		var slide = $('.swiper-slide:not(.swiper-slide-active) .billform-content').empty();
		this._gennerateGuide(container, slide);
		
		var hideCount = 0;
		for (var i = 0, len = dataRecord.DataItems.length; i < len; i++) {
			var dataItem = dataRecord.DataItems[i];
			if (dataItem.IsHidden) hideCount++;
			var itemStr = this._generateItemStr(dataItem, i - hideCount);
			if (!itemStr) continue;
			container.append(itemStr);
			if(true) continue; // swiper会导致ios普通浏览器下弹出窗奔溃、内容显示不全，安卓下弹出窗卡顿、键盘弹出收回后键盘的位置渲染空白等问题，暂时停用。
			itemStr = this._generateItemStr(dataItem, i - hideCount, true);
			slide.append(itemStr);
		}
		
		var self = this;		
		this._imgInBillForm();
		
		$(document).on('focusin', '.field input[type=text]', function() {
			if (this.value.trim()) $(this).next().show();
			var fieldId = $(this).parents('.field').attr('id');
			var item = self._getItemById(fieldId);
			if (item.FieldType !== 1 && item.FieldType !== 3 && item.FieldType !== 8) return;
			
			this.value = this.value.replace(/[,]/gi, '');
		}).on('focusout', '.field input[type=text]', function() {
			$(this).next().hide();
			var fieldId = $(this).parents('.field').attr('id');
			var item = self._getItemById(fieldId);
			if (item.FieldType !== 1 && item.FieldType !== 3 && item.FieldType !== 8) return;
			
			this.value = this.value.replace(/(\d)(?=(\d\d\d)+(?!\d))/gi, '$1,');
		}).on('input', '.field input[type=text]', function() {
			if (this.value.trim()) {
				$(this).next().show();
			} else {
				$(this).next().hide();
			}
		});
		
		$('.field input[type=radio]').unbind().bind('click', function(e) {
			var isChecked = $(this).hasClass('.checked');
			if (isChecked) {
				$(this).prop('checked', '');
			} else {
				$(this).addClass('.checked');
			}
			
			var fieldId = $(this).parents('.field').attr('id');
			$('#' + fieldId + ' input[type=radio]:not(:checked)').removeClass('.checked');
			if (isChecked) {
			    $(this).trigger("change");
			}
		});
		
		this.excuteInterfaceExpressions();
		
		autosize($('textarea'));
		
		$('.billform-submit').text("提交");
		$('.billform-submit').show();
		
		if (dataRecord.RegType === 0 && false) this.Swiper.lockSwipes(); // swiper会导致ios普通浏览器下弹出窗奔溃、内容显示不全，安卓下弹出窗卡顿、键盘弹出收回后键盘的位置渲染空白等问题，暂时停用。
		$('#billform-new').css('display', dataRecord.RegType === 0 ? 'none' : 'block');
	    
		self._initBillFormCtrl(true);
	},
		
	_gennerateGuide: function(container, slide){
		var guide = this.Context.FillingGuide;
		if(guide){
			guide = ((guide.replace(/<(.+?)>/gi,"&lt;$1&gt;")).replace(/ /gi,"&nbsp;")).replace(/\n/gi,"<br>");
			var guideStr = '<div class="guide_div"><div class = "filling_guide">'+ guide+'</div></div>';
			container.append(guideStr);
			slide.append(guideStr);
			var maxheight = window.innerHeight/4;
			$(".guide_div div").css("max-height", maxheight);
			if(mui.os.plus){
				if(plus.os.name == "iOS"){
					$(".guide_div div").css("padding-left", "7px");
				}
			}		
		}
	},
	
	_generateItemStr: function(dataItem, index, ignoreValue) {
		if (!dataItem) return null;
		
		var itemStr, itemClass = '';
		if (dataItem.RefEnumId > 0 && (dataItem.EnumItems || dataItem.EnumLst)) {
			itemStr = this._getEnumItemStr(dataItem, index, ignoreValue);
			return itemStr;
		}
		var __getUrl=function(urlParamers){
			var url = $.BaseUrl + "ImgUploadService.axd" + encodeURI(urlParamers);
	     	url += url.substr(url.length - 1) == "?" ? "Action=UploadImgToBlob" : "&Action=UploadImgToBlob";
		    return url; 
		}
		var readOnlyAttr = dataItem.IsReadOnly || dataItem.DynamicEnum ? ' disabled="disabled" ' : '';  // 安卓普通浏览器中设了readonly还是会弹出键盘
		var title = dataItem.Title && !ignoreValue ? dataItem.Title : '';
		if(dataItem.isOrderCell){
			title =this.Context.DataRecord.RowIndex;
		}
		var clearSpan = dataItem.IsReadOnly?"":"<span class='mui-icon mui-icon-clear' style='display: none;'></span>";
		switch (dataItem.FieldType) {
			case 0: //General
			case 2: //String
				itemStr = '<div class="mui-input-row"><input type="text" class="mui-input-clear value-input blink" value="' + title + '"' + readOnlyAttr + '></input>'+clearSpan+'</div>';
				break;
			case 1: //Float
			case 3: //Integer
			case 8: //Decimal
				itemStr = '<div class="mui-input-row"><input type="text" class="mui-input-clear value-input blink" value="' + title + '"' + readOnlyAttr + '></input>'+clearSpan+'</div>';
				break;
			case 4: //Logic
				var selected = this._toLogic(dataItem.Value) && !ignoreValue ? ' mui-active' : '';
				itemStr = '<div class="mui-switch mui-switch-mini value-switch' + selected + '"' + readOnlyAttr + '><div class="mui-switch-handle"></div></div>';
				itemClass = ' switch';
				break;
			case 5: //Date
				title = title || this._initText;
				itemStr = '<div class="mui-table-view"><div class="mui-table-view-cell value-date blink" type="date"><div class="value"><span>' + title + '</span></div><div class="icon"><span class="mui-icon mui-icon-arrowdown"></span></div></div></div>';
				break;
			case 6: //DateTime
				title = title || this._initText;
				itemStr = '<div class="mui-table-view"><div class="mui-table-view-cell value-date blink" type="datetime"><div class="value"><span>' + title + '</span></div><div class="icon"><span class="mui-icon mui-icon-arrowdown"></span></div></div></div>';
				break;
			case 16: //Text
				itemStr = '<div class="mui-input-row"><textarea class="text-paragraph value-input" rows="6"' + readOnlyAttr + '>' + title + '</textarea></div>';
				break;
			case 17: //Picture
			case 18: //Binary
				var fileItems = dataItem.Value && eval(dataItem.Value);
				var fileTypeTitle = dataItem.isImgOnly?'图片':'附件',Context = this.Context;
				var imgshow='',url = __getUrl(Context.UploadParams?Context.UploadParams:"?Container=attachfiles-"+Context.TaskId+"&Directory="+Context.Period+"/"+Context.EntityKey),fileCount=0;
				url += "&_taskId_=" +Context.TaskId;
				if(fileItems && fileItems.length){
					for(var i=0,len=fileItems.length;i<len;i++){
						if(fileItems[i].FileState!=3){	
							if(dataItem.isImgOnly){
								var fileUrl = fileItems[i].FileURL?fileItems[i].FileURL:fileItems[i].FileURl;
								imgshow +="<span fileguid="+fileItems[i].FileGuid + "  class='value-img-show'><img data-preview-src data-preview-group="+dataItem.ID+" class='value-img-show-img' style='width:100%;display:none' src=" + fileUrl +"></span>";															
							}else{
								fileCount++;
							}
						}
					}
				}
				if(dataItem.isImgOnly){					
				//imgshow = "<<input type='file'  style='width:100%; height:100%' accept='image/*'  name='aaa' >";
				    var disPlayType =dataItem.IsReadOnly?"display:none;":"";
					imgshow +=" <span name='addfile' style='border:1px solid #a4a4a4;background-position:center;background-repeat:no-repeat;background-image:url(../images/gg-file-add.png)' class='value-img-show'><form class='form_FileUplaod' id='form_FileUplaod_"+dataItem.ID+"' action='" + url + "' method='post' enctype='multipart/form-data'><input type='file' class='value-img-show-add'  style='width:100%; opacity:0; "+ disPlayType +" height:100%' accept='image/*'   name='aaa' ></form></span>";
		    	    itemStr = '<div class="mui-input-row"><div id='+ dataItem.ID  +' class="mui-table-view-cell  value-img-show-cell">' + imgshow + '</div></div>';							   
				}else{
			        title = '<span>已经上传</span> <span class="file_count">' +fileCount + '</span> <span>个'+fileTypeTitle+'</span>';
		    	    itemStr = '<div class="mui-input-row"><div id='+ dataItem.ID  +' class="mui-table-view-cell value-file ">' + title + '</div></div>';							   
				}

				break;
			default:
				itemStr = '<div class="mui-input-row"><input type="text" class="mui-input-clear value-input blink" value="' + title + '"' + readOnlyAttr + '></input>'+clearSpan+'</div>';
				break;
		}
		
		var nullableHtml = dataItem.Nullable ? '' : '<span style="color: red;">*</span>';
		var displayStyle = dataItem.IsHidden ? 'display: none;' : '';
		var readOnlyHtml = dataItem.IsReadOnly || dataItem.DynamicEnum ? '<span style="color: #BFDEFF;">（自动生成）</span>' : '';
		var fieldName = dataItem.Name.replace(/\r/ig, '<br />').replace(/\n/ig, '<br />'), showTitle = nullableHtml + (index + 1 + '.') + fieldName + readOnlyHtml + '：';
		var item = ['<div id=' + dataItem.ID + ' class="field' + itemClass + '" style="' + displayStyle + '">', '<span class="title">', showTitle, '</span>', itemStr, '</div>'];
		
		return item.join("");
	},
	
	_getEnumItemStr: function(dataItem, index, ignoreValue) {
		if (!dataItem || dataItem.RefEnumId <= 0 || (!dataItem.EnumItems && !dataItem.EnumLst)) return null;
		var enumItems;
		if(dataItem.EnumLst){
			var enumLst=[];
			for(var i=0;i<dataItem.EnumLst.length;i++){		
				enumLst.push({Code:dataItem.EnumLst[i]+'enum'+i,'Title':dataItem.EnumLst[i],isParent:false,Mnemonic:'',ParentCode:'',isMatched:false});
			}
			enumItems=enumLst;
		}else{
			enumItems=dataItem.EnumItems;
		}
		var nullableHtml = dataItem.Nullable ? '' : '<span style="color: red;">*</span>';
		var readOnlyHtml = dataItem.IsReadOnly ? '<span style="color: #BFDEFF;">（自动生成）</span>' : '';
		var selected = this._getItemCodes(dataItem.Value);
		var item, itemStr, listStr = '',checked;
		if(dataItem.EnumLst){
				var curETextArr = dataItem.Value.split(";");
				for(var i=0;i<curETextArr.length;i++){
					for(var j=0;j<enumItems.length;j++){
						if(enumItems[j].Title == curETextArr[i] && !enumItems[j].isMatched){
							enumItems[j].isMatched=true;
							break;
						}
					}
					
				}
		}		
		var isTree=false;
		if(enumItems.length < 6){
			for(var i =0;i<enumItems.length;i++){
				if(enumItems[i].pId){
					isTree=true;
					break;
				}
			}
		}
		if (enumItems.length >0 && enumItems.length < 6 && !dataItem.IsReadOnly && !dataItem.LinkageLevels && !isTree) {		
			for (var i = 0, len = enumItems.length; i < len; i++) {
				var enumItem = enumItems[i];
				if(dataItem.EnumLst){
				    checked = !enumItems[i].isMatched || ignoreValue ? '' : 'class=".checked" checked="checked"';
				}else{
					checked = $.inArray(enumItem.Code, selected) === -1 || ignoreValue ? '' : 'class=".checked" checked="checked"';
				}

				if (!dataItem.MultiSelect) {
				    listStr += '<div class="mui-input-row mui-radio mui-left"><label>' + enumItem.Title + '</label><input class=\'enum-input\' name="' + dataItem.ID + '" value="' + enumItem.Code + '" ' + '" enumtitle="' + enumItem.Title + '" ' + checked + ' type="radio"></div>';
				} else {
				    listStr += '<div class="mui-input-row mui-checkbox mui-left"><label>' + enumItem.Title + '</label><input class=\'enum-input\' name="' + dataItem.ID + '" value="' + enumItem.Code + '"' + '" enumtitle="' + enumItem.Title + '" ' + checked + ' type="checkbox"></div>';
				}
			}
			
			itemStr = '<div class="list">' + listStr + '</div>';
			var fieldName = dataItem.Name.replace(/\r/ig, '<br />').replace(/\n/ig, '<br />'), showTitle = nullableHtml + (index + 1 + '.') + fieldName + readOnlyHtml + '：';
			item = ['<div id=' + dataItem.ID + ' class="field">', '<span class="title">', showTitle, '</span>', itemStr, '</div>'];
		} else {
			var titles = '',isSelected;
			for (var i = 0, len = enumItems.length; i < len; i++) {
				var enumItem = enumItems[i];
				
				if(dataItem.EnumLst){
				    isSelected = enumItem.isMatched && !ignoreValue;
				}else{
					isSelected = ($.inArray(enumItem.Code, selected) >= 0 ||   $.inArray(enumItem.Title, selected) >= 0) && !ignoreValue;
				}
				if (!isSelected) continue;
				titles += (titles.length > 0 ? ', ' : '') + enumItem.Title;
			}
			
			titles = titles || this._initText;
			itemStr = '<div class="mui-table-view"><div class="mui-table-view-cell value-popup blink" multiSelect="' + dataItem.MultiSelect + '"><div class="value"><span class="enum-span" tabindex="0">' + titles + '</span></div><div class="icon"><span class="mui-icon mui-icon-arrowright"></span></div></div></div>';
			var fieldName = dataItem.Name.replace(/\r/ig, '<br />').replace(/\n/ig, '<br />'), showTitle = nullableHtml + (index + 1 + '.') + fieldName + readOnlyHtml + '：';
			item = ['<div id=' + dataItem.ID + ' class="field">', '<span class="title">', showTitle, '</span>', itemStr, '</div>'];
		}
		
		return item.join("");
	},
	
	_getItemById: function(fid) {
		if (!fid) return null;
		
		var dataItem, dataItems = this.Context.DataRecord.DataItems;
		for (var i = 0, len = dataItems.length; i < len; i++) {
			if (dataItems[i].ID != fid) continue;
			dataItem = dataItems[i];
			break;
		}
		
		return dataItem;
	},
	
	_getItemCodes: function(valueStr) {
		if (!valueStr) return [];
		
		var valueArray = valueStr.split('|');
		var codeStr = valueArray ? valueArray[valueArray.length - 1] : '';
		var codes = codeStr ? codeStr.split(';') : [];
		return codes;
	},
	_getItemTexts: function(valueStr) {
		if (!valueStr) return [];		
		var valueArray = valueStr.split('|');
		var codeStr = valueArray ? valueArray[0] : '';
		var texts = codeStr ? codeStr.split(';') : [];
		return texts;
	},
	_isParent: function(item,enumLists){
		var isParent=false;
		for(var i=0;i<enumLists.length;i++){
			if(item.Code == enumLists[i].ParentCode){
				isParent=true;
				break;
			}
		}
		return isParent;
	},
	_enumReset: function(enumLists){
		if (enumLists===undefined) return [];
		var enumItems=[];
		for(var i=0;i<enumLists.length;i++){
			var isParent=this._isParent(enumLists[i],enumLists);
			var item={id:enumLists[i].Code,isParent:isParent,mnemonic:enumLists[i].Mnemonic,name:enumLists[i].Title,pId:enumLists[i].ParentCode};
		    enumItems.push(item)	
		}
		return enumItems;
	},
	_updateItemValue: function(fid, codes, titles) {
		var dataItem = this._getItemById(fid);
		if (!dataItem || dataItem.IsReadOnly) return;
		
		if (this._isStringEqual(codes, dataItem.Value)) return;	
		dataItem.IsModified = true;
		if(dataItem.EnumLst){
			dataItem.Value = titles ? titles  : '';
		    dataItem.Title = titles ? titles  : '';
		}else{
		    dataItem.Value = titles ? (titles + '|' + codes) : '';
		    dataItem.Title = titles ? (titles + '|' + codes) : '';
		}
		this._clearGuestItemValue(dataItem.GuestLinks);
		
	    var enumEle = $('.swiper-slide.swiper-slide-active #' + fid + ' div.value-popup .value span');
	    enumEle.html(titles ? titles.replace(/\;/g, ', ') : this._initText);
		
		this._onValueChanged();
		
		var self = this;
		var paramEvent = event;
		setTimeout(function(){
			//先执行审核公式
			self.excuteCheckExpression(enumEle, enumEle.text(), codes, fid, paramEvent);
	
			//后执行运算公式
			self.excuteExpression(fid, enumEle.text(), codes);
		}, 0);
	},
	_clearGuestItemValue:function(guestLids){
		if(!guestLids) return;
		guestLids = guestLids[guestLids.length - 1] == ";" ? guestLids.substring(0, guestLids.length - 1) : guestLids;
		var guestLidsList=guestLids==""?[]:guestLids.split(";");
		for(var i=0;i<guestLidsList.length;i++){
			$('.swiper-slide.swiper-slide-active #'+ guestLidsList[i] +' div.value-popup .value span').html(this._initText);
			var guestItem = this._getItemById(guestLidsList[i]);
			guestItem.IsModified = true;
			guestItem.Value = '';
		    guestItem.Title = '';
		    this._clearGuestItemValue(guestItem.GuestLinks);
		}
	},
	_onValueChanged: function() {
		var dataRecord = this.Context.DataRecord;
		if (dataRecord.State == 0) dataRecord.State = 2;
	},
	
	_beforeDataSave: function() {
		var dataRecord = this.Context.DataRecord;
		if (!dataRecord) return;
		
		var dataItems = this.Context.DataRecord.DataItems;
		for (var i = 0, len = dataItems.length; i < len; i++) {
			this._setFieldValue(dataItems[i]);
		}
	},
	
	_initFieldValue: function(dataItem, value, title) {
		if (!dataItem || dataItem.IsReadOnly) return;
		
		if (dataItem.RefEnumId > 0) {
			this._initEnumItem(dataItem, value, title);
			return;
		}
		
		if (value) value = value.trim();
		var isEqual = this._isEqual(dataItem.FieldType, dataItem.Value, value);
		if (isEqual) return;
		
		dataItem.Value = value;;
		dataItem.Title = dataItem.FieldType === 4 ? this._toLogic(value) ? '是' : '否' : value;
		dataItem.IsModified = true;
		this._onValueChanged();
	},
	
	_initEnumItem: function(dataItem, value, title) {
		if (!dataItem || dataItem.RefEnumId <= 0) return;		
		if (this._isStringEqual(value, dataItem.Value)) return;
		
		dataItem.Value = title + '|' + value;		
		dataItem.Title = title + '|' + value;
		dataItem.IsModified = true;
		this._onValueChanged();
	},
	
	_setFieldValue: function(dataItem) {
		if (!dataItem || dataItem.IsReadOnly) return;
		
		if (dataItem.RefEnumId > 0) {
			this._setEnumItemValue(dataItem);
			return;
		}
		
		var value = '';
		switch (dataItem.FieldType) {
			case 0: //General
			case 2: //String
				value = $('.swiper-slide.swiper-slide-active #' + dataItem.ID + ' input').val();
				break;
			case 1: //Float
			case 3: //Integer
			case 8: //Decimal
				value = $('.swiper-slide.swiper-slide-active #' + dataItem.ID + ' input').val();
				break;
			case 4: //Logic
				value = $('.swiper-slide.swiper-slide-active #' + dataItem.ID + ' .mui-switch').hasClass('mui-active') ? '1' : '0';
				break;
			case 16: //Text
				value = $('.swiper-slide.swiper-slide-active #' + dataItem.ID + ' textarea').val();
				break;
			default:
				return;
		}
		
		if (value) value = value.trim();
		var isEqual = this._isEqual(dataItem.FieldType, dataItem.Value, value);
		if (isEqual) return;
		
		dataItem.Value = value;;
		dataItem.Title = dataItem.FieldType === 4 ? this._toLogic(value) ? '是' : '否' : value;
		dataItem.IsModified = true;
		this._onValueChanged();
	},
	
	_setEnumItemValue: function(dataItem) {
		if (!dataItem || dataItem.RefEnumId <= 0 || ((!dataItem.EnumItems || dataItem.EnumItems.length >= 6)&&(!dataItem.EnumLst || dataItem.EnumLst.length >= 6))) return;
		
		var selectedItems;
		if (dataItem.MultiSelect) {
			selectedItems = $('.swiper-slide.swiper-slide-active input[name=' + dataItem.ID + '][type=checkbox]:checked');
		} else {
			selectedItems = $('.swiper-slide.swiper-slide-active input[name=' + dataItem.ID + '][type=radio]:checked');
		}
		
		if (!selectedItems || selectedItems.length === 0) {
			if (!dataItem.Value && !dataItem.Title) return;
			
			dataItem.Value = '';
			dataItem.Title = '';
			dataItem.IsModified = true;
			this._onValueChanged();
			return;
		}
		
		var value = '', title = '';
		selectedItems.each(function() {
			if(dataItem.EnumLst){
			    value += (value.length > 0 ? ';' : '') +$(this).prev().text();
			}else{
				value += (value.length > 0 ? ';' : '') + $(this).val();
			}
			
			title += (title.length > 0 ? ';' : '') + $(this).prev().text();
		});
		
		if (this._isStringEqual(value, dataItem.Value)) return;
		
		dataItem.Value =dataItem.EnumLst? title : title + '|' + value;		
		dataItem.Title =dataItem.EnumLst? title : title + '|' + value;
		dataItem.IsModified = true;
		this._onValueChanged();
	},
	
	_toLogic: function(str) {
		var result = !str || str === '0' ? false : true;
		return result;
	},
	
    _existSpecialChar: function (str) {
        if (!str) return false;
        var regex = /[`~!@#$%^&*|+=?;:,.<>\{\}\\\/]/gi;
        return regex.test(str);
    },

	_isNullOrEmpty: function(str) {
		if (!str || !str.trim()) return true;
		return false;
	},
	
	_isEqual: function(type, src, target) {
		if (this._isNullOrEmpty(src) && this._isNullOrEmpty(target)) return true;
		
		var isEqual = false;
		switch(type) {
			case 1: //Float
			case 3: //Integer
			case 8: //Decimal
				isEqual = this._isFloatEqual(src, target);
				break;
			case 4: //Logic
				isEqual = this._toLogic(src) === this._toLogic(target);
				break;
			default:
				isEqual = this._isStringEqual(src, target);
				break;
		}
		
		return isEqual;
	},
	
	_isFloatEqual: function(src, target, absoluteError, relativeError) {
		var abs = Math.abs, min = Math.min;
		var FLT_EPSILON = 1.19209290e-7, DBL_EPSILON = 2.2204460492503131e-16;
  
		if (absoluteError == null) absoluteError = DBL_EPSILON;
		if (relativeError == null) relativeError = absoluteError;
		
		var diff = abs(src - target)
		if(diff <= absoluteError) return true;		
		if(diff <= relativeError * min(abs(src), abs(target))) return true;		
		return src === target;
	},
	
	_isStringEqual: function(src, target) {
		if (src && src.indexOf('|') !== -1) src = src.split('|')[1];
		if (target && target.indexOf('|') !== -1) target = target.split('|')[1];
		
		if (!src && !target) return true;
		if ((src && !target) || (!src && target)) return false;
		
		var srcArray = src.split(';'), targetArray = target.split(';');
		var isEqual = srcArray.length === targetArray.length && srcArray.every(function(item, index) { return ($.inArray(item, targetArray) !== -1)});
		return isEqual;
	},
	
	_isDataModified: function() {
		var record = this.Context.DataRecord, dataItems = record.DataItems;
		if (record.State === 0 || !dataItems || dataItems.length === 0) return false;
		
		for (var i = 0, len = dataItems.length; i < len; i++) {
			var dataItem = dataItems[i];
			if (!dataItem.IsModified || (record.State == 1 && dataItem.IsModified && 
				((dataItem.RefEnumId > 0 && (dataItem.Value == null || dataItem.Value.length <= 0) && (dataItem.Title == null || dataItem.Title.length <= 0))
				|| (dataItem.Value == null || dataItem.Value.length <= 0)))) continue;
			return true;
		}
		
		return false;
	},
	
	_resetModifiedState: function() {
		var record = this.Context.DataRecord, dataItems = record.DataItems;
		if (record.State === 0 || !dataItems || dataItems.length === 0) return false;
		
		for (var i = 0, len = dataItems.length; i < len; i++) {
			dataItems[i].IsModified = false;
		}
	},
	
	_locateField: function(fid) {
		var title = $('#' + fid + ' .title');
		if (!title) return;
		
		var top = title.offset().top - 48 - 15; 
		$('html, body').animate({ scrollTop: top >= 0 ? top : 0 }, 'slow');
		
		var blinkItem = $('#' + fid + ' .blink');
		if (!blinkItem) return;
		if (blinkItem.is('input') || blinkItem.is('textarea')) blinkItem.focus();
	},
	
	_locateError: function(fid) {
		var title = $('#' + fid + ' .title');
		if (!title) return;
		
		var top = title.offset().top - 48 - 15; 
		$('html, body').animate({ scrollTop: top >= 0 ? top : 0 }, 'slow');
		
		var blinkItem = $('#' + fid + ' .blink');
		if (!blinkItem) return;
		
		//先定位input，后闪烁提示
	    if (blinkItem.is('input') || blinkItem.is('textarea')) blinkItem.focus();
		var count = 0;
	    var timer = setInterval(function () {
	        count++
	        if (count === 6) {
	            blinkItem.css('border', '1px solid #BFDEFF');
	            clearInterval(timer);
	        } else {
	            count % 2 === 1 ? blinkItem.css('border', '1px solid red') : blinkItem.css('border', '1px solid #BFDEFF');
	        }
	    }, 500);
	},
	
	_saveDataRecord: function(callback) {
	    var self = this, context = self.Context, record = context.DataRecord;
        if (self._checkErrorItems != null && self._checkErrorItems.length > 0) {
	        self.toastCheckErrorMsg();
	        return;
	    }
		
		mui.showWaiting('正在提交数据……');
        
        var path = self._getPath($.BaseUrl + "DataInput/Home/SaveDataRecord", true, true, true);
        var jsonStr = self._getJsonStr(record.DataItems);
        //self.Context.IsTempPeriod = self.PeriodSelector.isTempPeriod();
        var postData = { dataRegId: record.RegId, stateCode: record.State, rowKeyData: record.Key, floatOrder: record.FloatOrder, jsonData: jsonStr, isTempPeriod: self.Context.IsTempPeriod };
        this._action(path + "&shareToken=" + context.ShareToken, postData, function(data) {
        	if (data.BoolResult.Result) {
        		self._dataModified = true;
        		self._resetModifiedState();
        		
        		if (record.State === 1) {        			
	                var curKey = self.Context.DataRecord.Key;
	                if (data.RowKeysMap) {
	                	self.Context.DataRecord.Key = data.RowKeysMap[curKey];	                	
	                }
	                if (data.FloatOrdersMap) {
	                	var curOrder = self.Context.DataRecord.FloatOrder;
	                	self.Context.DataRecord.FloatOrder = data.FloatOrdersMap[curOrder];
	                }
                	
	                self.insertToAllRecords(curKey);	//数据插入到全部卡片缓存中
	                self._submitFlag = true;
        		}else{
        			self._submitFlag = false;
        			self.updateToAllRecords();
        		}
                record.State = 0;
        	}
        	
            callback && callback(data);
        	mui.closeWaiting();
        }, true, function(xhr, type, errorThrown) {
			mui.closeWaiting();
			mui.toast(xhr.responseText);
		});
	},
	
	_delDataRecord: function(callback){
		var self = this, context = self.Context, record = context.DataRecord;
        mui.showWaiting('正在删除数据……');
        var path = self._getPath($.BaseUrl + "DataInput/Home/SaveDataRecord", true, true, true);
        var postData = { dataRegId: record.RegId, stateCode: 3, rowKeyData: record.Key, floatOrder: record.FloatOrder };
        this._action(path + "&shareToken=" + context.ShareToken, postData, function(data) {
        	if (data.BoolResult.Result) {
        		//mui.toast('删除成功！');
        		callback && callback(data);
      			mui.closeWaiting();
        	}       
        }, true, function(xhr, type, errorThrown) {
        	mui.closeWaiting();
			mui.toast(xhr.responseText);
		});
	},
	
    /*queryDirection值
    0当前条
    -1上一条
    1下一条
    -2第一条
    2最后一条
	*/
	_queryDataRecord: function(rowKey, queryDirection, callback) {
		mui.showWaiting('数据加载中……');
		var self = this, context = self.Context, record = context.DataRecord;
        var path = self._getPath($.BaseUrl + "DataInput/Home/QueryDataRecord", true, true, true);
        var postData = { dataRegId: record.RegId, rowKeyData: rowKey, floatOrder: record.FloatOrder, queryDirection: queryDirection };
        this._action(path + "&shareToken=" + context.ShareToken, postData, function (data) {
            self.Status.ReadOnly = data.ReadOnly;
        	if (data.BoolResult.Result) {
        		self.Context.DataRecord = data.DataRecord;
        		self.Context.UploadParams = data.UploadParams;
        	} else {
        		var msg = data.BoolResult.Message;
        		if (msg != null && msg.length > 0)
        			mui.toast(msg);
        	}
        	self.Context.FmlScripts = data.FmlScripts;
        	self.registerFormulaScriptMethod();
        	self._initFmlScripts();
        	callback && callback(data.BoolResult.Result);
        	//mui.closeWaiting();
        }, true, function(xhr, type, errorThrown) {
			mui.toast(xhr.responseText);
			mui.closeWaiting();
		});
	},
	
    //#region 卡片公式执行代码
    //执行计算公式
	excuteExpression: function(fid, showText, editText) {
	    var self = this;
	    var dataItem = self._getItemById(fid);
	    if (dataItem == null)
	        return;
        var dataItem, dataItems = self.Context.DataRecord.DataItems;
        var lids = new Array();
        for (var index = 0; index < dataItems.length; index++) {
            var dataItem = dataItems[index];
            lids.push(dataItem.ID);
        }
	    var newValue = self.getNewValue(editText, showText, dataItem.RefEnumId);
        var expressions = formulaCache.GetExpressionsByDataLink(fid);
        var writeExpressions = formulaCache.GetWriteDataLinkExpressions();
        if (expressions && expressions.length > 0) {
            for (var index = 0; index < expressions.length; index++) {
                var expression = expressions[index];
                var writeLid = -1;
                for (var writeExp in writeExpressions) {
                    if (writeExp == null)
                        continue;
                    var writeExpression = writeExpressions[writeExp];
                    if (writeExpression == null || writeExpression != expression)
                        continue;
                    writeLid = writeExp;
                    break;
                }
                writeExp = parseInt(writeExp, 10);
                if (isNaN(writeExp) || writeExp < 0 || lids.indexOf(writeExp) < 0)
                    continue;
                self._isInterfaceExp = false;
                expression.getResult(null, fid, newValue);
            }
        }
	},

    //执行审核公式
	excuteCheckExpression: function (ele, showText, editText, fid, paramEvent) {
	    var self = this;
        var dataItem = self._getItemById(fid);
        if (dataItem == null)
            return;
	    var newValue = self.getNewValue(editText, showText, dataItem.RefEnumId);
        var relationLinks = formulaCache.GetRelatedCheckExpressionLinks(fid);
        if (((dataItem.Value != showText && !dataItem.IsModified) || dataItem.IsModified)) {
            if (newValue != null && newValue.length > 0) {
                var checkExpressions = formulaCache.GetCheckExpressionsByDataLink(fid);
                if (checkExpressions && checkExpressions.length > 0) {
                    var validationObjs = formulaCache.GetValidationByDataLink(fid);
                    for (index = 0; index < checkExpressions.length; index++) {
                        expression = checkExpressions[index]; //执行数据链接相关的公式
                        var validationTypeError = self.checkValidationTypeValid(expression, validationObjs, dataItem.FieldType, fid);
                        if (validationTypeError)
                            continue;
                        var returnData = expression.getResult(null, fid, newValue);
                        if (returnData.dataType === FMR.ConstDataTypes.Bool) {
                            var errorMsg = expression.Description;
                            var hasError = FMR.getValueByType(returnData.Value, returnData.dataType, returnData.isNull);
                            if (!hasError) {
                                //设置错误提示信息
                                self.setCheckError(errorMsg, fid);
                                setTimeout(function () {
                                    if (document.activeElement == ele[0])
                                        return;
                                    layer.alert(errorMsg, {
                                        icon: 7,
                                        btn: "确定", title: "提示信息", closeBtn: 0, offset: "auto", area: ["280px", "150px"]
                                    },
                                        function (index) {
                                            layer.close(index);
                                            self._disabledEvent = true;
                                            ele.focus();
                                            setTimeout(function() {
                                            	self._disabledEvent = false;
                                            }, 1000);
                                        }
                                    );
                                }, 300);
                                paramEvent.stopPropagation();
                                paramEvent.preventDefault();
                                break;
                            } else {
                            	self.setIDCard(expression, validationObjs, editText, fid, dataItem);
                                //清除错误提示信息
                                self.setCheckError(null, fid);
                            }
                        }
                    }
                }
                if (relationLinks != null && relationLinks.length > 0){
                	self.relationLinkCheck(relationLinks, fid, newValue);
                }
            }
            else {
                //清除错误提示信息
                self.setCheckError(null, fid);
                if (relationLinks != null && relationLinks.length > 0){
                	self.relationLinkCheck(relationLinks, fid, newValue);
                }
            }
        }
    },
	
	//关联数据链接审核（用于固定表中唯一性校验使用） lvzhanmeng 2016-08-19
	relationLinkCheck: function(relationLinks, fid, newValue){
		var self = this;
        for (var rIndex = 0; rIndex < relationLinks.length; rIndex++) {
            var rLink = relationLinks[rIndex];
	        var dataItem = self._getItemById(rLink);
	        if (dataItem == null)
	            return;
            var checkExpressions = formulaCache.GetCheckExpressionsByDataLink(rLink);
            if (checkExpressions) {
                var validationObjs = formulaCache.GetValidationByDataLink(rLink);
                for (var index = 0; index < checkExpressions.length; index++) {
                    var expression = checkExpressions[index]; //执行数据链接相关的公式
                    var validationTypeError = self.checkValidationTypeValid(expression, validationObjs, dataItem.FieldType, rLink);
                    if (validationTypeError)
                        continue;
                    var returnData = expression.getResult(null, fid, newValue);
                    if (returnData.dataType === FMR.ConstDataTypes.Bool) {
                        var hasError = FMR.getValueByType(returnData.Value, returnData.dataType, returnData.isNull);
                        if (!hasError) { //设置错误提示信息
                            self.setCheckError(expression.Description, rLink);
                            break;
                        } else {
                            self.setCheckError(null, rLink);
                        }
                    }
                }
            }
        }
	},
	
	    //设置身份证号
    setIDCard: function(expression, validationObjs, editText, fid, dataItem) {
        var fmlId = expression.FormulaId;
        if (fmlId != null && validationObjs != null && editText != null && editText.length > 0 && !dataItem.IsReadOnly) {
            var validationType = validationObjs[fmlId];
            if (validationType == FMR.ValidationType.vt_IDCardValidate) {  
                var idCard = FMR.getIDCard18(editText);    //15位身份证进行转换
                if (idCard.length == 18 && idCard != editText) {
                    var dataInput = $('.swiper-slide.swiper-slide-active #' + dataItem.ID + ' input');
	                if (dataInput.length <= 0) return;
	                dataInput.val(idCard);
		            dataItem.IsModified = true;
		            dataItem.Value = idCard;
		            dataItem.Title = idCard;
                    if (editText.length == 15)
                        mui.toast("15位身份证号已被转换为标准18位身份证号");
                    else if (editText.length == 18 && editText[17] == 'x')
                        mui.toast("身份证号最后一位小写x已被转换为大写X");
                }
            }
        }
    },
	
	//设置单元格审核错误信息，并维护审核错误单元格缓存s
    setCheckError: function(errorMsg, fid) {
        var self = this;
        if (self._checkErrorItems == null) {
            self._checkErrorItems = new Array();
            self._checkMsgs = { };
        }
        fid = fid.toString();
        var blinkItem = $('#' + fid + ' .blink');
        if (blinkItem.length <= 0) {
            blinkItem = $('#' + fid);
        }
        if (errorMsg == null || errorMsg.length <= 0) {
            var curIndex = self._checkErrorItems.indexOf(fid);
            if (curIndex >= 0) {
                self._checkErrorItems.splice(curIndex, 1);
                self._checkMsgs[fid] = null;
            }
            blinkItem.css('border', '')            
        } else {
            if (self._checkErrorItems.indexOf(fid) < 0) {
                self._checkErrorItems.push(fid);
                self._checkMsgs[fid] = errorMsg;
            }            
            blinkItem.css('border', '1px solid red');
        }
    },
    
	//检查数据验证指标类型是否正确
    checkValidationTypeValid: function(expression, validationObjs, fieldType, dataLink) {
        var validationTypeError = false;
        var fmlId = expression.FormulaId;
        if (fmlId != null && validationObjs != null) {
            var validationType = validationObjs[fmlId];
            if (validationType != null) {
                if (validationType == FMR.ValidationType.vt_RangeValidate) {
                    if (fieldType != 0 && fieldType != 1 && fieldType != 3 && fieldType != 8) {
                        validationTypeError = true;
                    }
                } else if (validationType == FMR.ValidationType.vt_LengthValidate) {
                    if (fieldType != 0 && fieldType != 2) {
                        validationTypeError = true;
                    }
                } else if (validationType == FMR.ValidationType.vt_DuplicateValidate) {
                    if (fieldType != 0 && fieldType != 1 && fieldType != 2 && fieldType != 3 && fieldType != 8) { //布尔等类型不执行唯一性校验
                        validationTypeError = true;
                    } else {
                        var interfaceExp = formulaCache.GetInterfaceExpressionByLink(dataLink);
                        if (interfaceExp != null)
                            validationTypeError = true;     //界面公式不执行唯一性校验
                    }
                } else if (validationType == FMR.ValidationType.vt_IDCardValidate){
                	if (fieldType != 2)
                		validationTypeError = true;
                }
            } else
            	validationTypeError = true;
        } else
        	return true;
        return validationTypeError;
    },
    
	//执行界面公式
	excuteInterfaceExpressions: function(){
		var interfaceExps = formulaCache.GetAllInterfaceExpressions();
        if (interfaceExps.length > 0) {
            var writeLinkInterfaceExps = formulaCache.GetWriteDataLinkInterfaceExpressions();
            var self = this;
            for (var writeLink in writeLinkInterfaceExps) {
                var exp = writeLinkInterfaceExps[writeLink];
                if (exp == null)
                    continue;
                var dataItem = self._getItemById(writeLink);
                if (dataItem == null)
                	continue;
				if (dataItem.Value == null || dataItem.Value.length <= 0) {
					_isInterfaceExp = true;
					exp.getResult(null, -1, null);
				}
            }
        }
	},

	getNewValue: function (cellValue, cellTitle, enumDefineId) {
	    var newValue = {};
	    newValue.editText = cellValue;
	    newValue.showText = cellTitle;
	    newValue.isEnum = enumDefineId && enumDefineId > 0;
	    newValue.length = newValue.isEnum ? (cellTitle == null ? 0 : cellTitle.length) : (cellValue == null ? 0 : cellValue.length);
	    return newValue;
	},

    toastCheckErrorMsg: function() {
        //默认定位第一个出错的单元格
        var errorFid = this._checkErrorItems[0];
        var errorMsg = this._checkMsgs == null ? null : this._checkMsgs[errorFid];
        if (errorMsg != null && errorMsg.length > 0) {
            mui.toast(errorMsg);
            this._locateField(errorFid);
            return;
        }
        mui.toast("存在数据校验错误，请修改后再提交。");
        return;
    },

    //注册公式方法
	registerFormulaScriptMethod: function() {
	    var self = this;
	    DynamicNodeFactory.registerMethod(DynamicNodeFactory.GetFieldDataMethod, function (fKey, dataLinkId, getPrevData, getCode) {
	        var dataItem = self._getItemById(dataLinkId);
	        if (dataItem == null || getPrevData)
	            return null;
	        self._setFieldValue(dataItem);
	        if (dataItem.RefEnumId > 0){
	            var valuArray = dataItem.Value.split('|'), 
	        		title = valuArray.length >= 2 ? valuArray[0] : (dataItem.Title == null ? "" : dataItem.Title);
                if (getCode) {
                    var code = valuArray.length >= 2 ? valuArray[1].split(';') : dataItem.Value.split(';');
                    if (code != null && code.length > 0 && title != null && title.length > 0) {
                    	if (code == '00000000000000000000000000000000')   //自定义枚举
                    		return title + "|" + title;
                        return title + "|" + code;
                    }
                }
	    		return title;
	        }
	        return dataItem.Value;
	    });
	    DynamicNodeFactory.registerMethod(DynamicNodeFactory.GetStatisticCellsMethod, function (fKey, dataLinkId, newValue, dataLink, getCode) {
	        var context = self.Context;
	        if (context == null || context.DataRecord == null || context.DataRecord.RegType != 3)	//只有行浮动的场景调用下面的代码去获取数据
	        	return new Array();
	        var dataRecord = context.DataRecord;
	        if (self._allRecords == null) {
	        	self.getAllRecords();	        	
	        }	        
	        if (self._allRecords == null || self._allRecords.length <= 0 || !dataLinkId)
				return new Array();
			if (dataRecord.State == 1) {
				self.insertTempRecordToAllRecords();
			}
			var cellValues = new Array();
			for (var index = 0; index < self._allRecords.length; index++) {
				var curRecord = self._allRecords[index];
				var dataItems = curRecord.DataItems;
				var dataItem = null;
				for (var i = 0, len = dataItems.length; i < len; i++) {
					if (dataItems[i].ID != dataLinkId)
						continue;
					dataItem = dataItems[i];
					break;
				}
				if (dataItem != null) {
				    if (dataLinkId == dataLink && curRecord.Key == dataRecord.Key) {
				        var curValue = FMR.getValue(newValue, getCode);
				        cellValues.push(curValue);
					} else {
						if (curRecord.Key == dataRecord.Key) {
							dataItem = self._getItemById(dataLinkId);
							if (dataItem != null) {
								if (dataItem.RefEnumId > 0){
									var valuArray = dataItem.Value.split('|'), 
	        							title = valuArray.length >= 2 ? valuArray[0] : (dataItem.Title == null ? "" : dataItem.Title);
									if (getCode) {
									    var code = valuArray.length >= 2 ? valuArray[1].split(';') : dataItem.Value.split(';');
									    if (code != null && code.length > 0 && title != null && title.length > 0) {
									    	if (code == '00000000000000000000000000000000')   //自定义枚举
                    							code = title;
									        var curValue = title + "|" + code;
									        cellValues.push(curValue);
									    }
									} else {
									    cellValues.push(title);
									}
								}
								else
									cellValues.push(dataItem.Value);
							}
						} else {
							if (dataItem.RefEnumId > 0){
								var valuArray = dataItem.Value.split('|'), 
	        						title = valuArray.length >= 2 ? valuArray[0] : (dataItem.Title == null ? "" : dataItem.Title);
								if (getCode) {
								    var code = valuArray.length >= 2 ? valuArray[1].split(';') : dataItem.Value.split(';');
								    if (code != null && code.length > 0 && title != null && title.length > 0) {
								    	if (code == '00000000000000000000000000000000')   //自定义枚举
                    							code = title;
								        var curValue = title + "|" + code;
								        cellValues.push(curValue);
								    }
								} else {
								    cellValues.push(title);
								}
							}
							else
								cellValues.push(dataItem.Value);
						}
					}
				}
			}
			return cellValues;
	    });
	    DynamicNodeFactory.registerMethod(DynamicNodeFactory.SetFieldDataMethod, function (fKey, dataLinkId, newValue) {
	        var dataItem = self._getItemById(dataLinkId);
	        if (dataItem == null)
	            return;
	        if (dataItem.RefEnumId > 0 && (dataItem.EnumItems || dataItem.EnumLst)) {
	            return;
	        }
	        var valueChange = false;
	        var triggerItem = null;
	        switch (dataItem.FieldType) {
	            case 0: //General
	            case 2: //String
	            case 1: //Float
	            case 3: //Integer
	            case 8: //Decimal
	                var dataInput = $('.swiper-slide.swiper-slide-active #' + dataItem.ID + ' input');
	                if (dataInput.length <= 0) return;
	                valueChange = true;
	                dataInput.val(newValue);
	                triggerItem = dataInput;
	                break;
	            case 4: //Logic
	                newValue = newValue.toLowerCase();
	                var switchInput = $('.swiper-slide.swiper-slide-active #' + dataItem.ID + ' .mui-switch');
	                if (switchInput.length <= 0) return;
	                valueChange = true;
                    if (newValue == 1 || newValue == true || newValue == "是" || newValue == "true") {
                        switchInput.addClass("mui-active")
                    } else {
                        switchInput.removeClass("mui-active")
                    }
	                break;
	            case 5: //Date
	            case 6: //DateTime
	                var dateInput = $('.swiper-slide.swiper-slide-active #' + dataItem.ID + ' .value-date');
	                if (dateInput.length <= 0) return;
	                valueChange = true;
	                var valueElement = $('.value span:first', dateInput[0]);
	                valueElement.text(newValue);
	                break;
	            case 16: //Text
	                var dataArea = $('.swiper-slide.swiper-slide-active #' + dataItem.ID + ' textarea');
	                if (dataArea.length <= 0) return;
	                valueChange = true;
	                dataArea.val(newValue);
	                triggerItem = dataArea;
	                break;
	            case 17: //Picture
	            case 18: //Binary
	                return;
	                break;
	            default:
	            	var dataInput = $('.swiper-slide.swiper-slide-active #' + dataItem.ID + ' input');
	                if (dataInput.length <= 0) return;
	                valueChange = true;
	                dataInput.val(newValue);
	                triggerItem = dataInput;
	                break;
	        }
	        if (!self._isInterfaceExp && valueChange) {
	            //界面公式不修改dataItem，避免被提交
	            dataItem.IsModified = true;
	            dataItem.Value = newValue;
	            dataItem.Title = newValue;
	        }
            if (triggerItem != null) {
                triggerItem.trigger("input");
            }
	    });
	    DynamicNodeFactory.registerMethod(DynamicNodeFactory.GetCellByDataLinkWithoutFkeyMethod, function (fKey, dataLinkId, isLastRow, getPrevData) {
	        return null;
	    });
	    DynamicNodeFactory.registerMethod(DynamicNodeFactory.SetEnumTitleMethod, function (enumCell, newValue, fKey, enumTitleLink) {
	        return;
	    });
	    DynamicNodeFactory.registerMethod(DynamicNodeFactory.GetUnitTitleMethod, function (fKey) {
	        var entityTitle = $("#entity_cur_title").text();
	        return entityTitle;
	    });
	},
	
	//获取所有卡片的数据
	getAllRecords: function() {
		var self = this, context = self.Context, record = context.DataRecord;
        var path = self._getPath($.BaseUrl + "DataInput/Home/GetAllRecords", true, true, true);
        var postData = { dataRegId: record.RegId };
        this._action(path + "&shareToken=" + context.ShareToken, postData, function (data) {
            self.Status.ReadOnly = data.ReadOnly;
        	if (data.BoolResult.Result) {
        		self._allRecords = data.DataRecords;
        	} else {
        		var msg = data.BoolResult.Message;
        		if (msg != null && msg.length > 0)
        			mui.toast(msg);
        	}
        }, false, function(xhr, type, errorThrown) {
			mui.toast(xhr.responseText);
			mui.closeWaiting();
		});
	},
	
	//检查全部卡片数据是否合法
	checkValidOfAllRecords: function(){
		var self = this;
		if (self._allRecords == null)
			return false;
		var dataRecord = self.Context == null ? null : self.Context.DataRecord;
		if (dataRecord == null)
			return false;
		var length = self._allRecords.length;
		if (length <= 0){
			self._allRecords == null;
			return false;
		}
		return true;
	},
	
	//更新当前卡片到全部卡片缓存中
	insertTempRecordToAllRecords: function(){
		var self = this;
		var isValid = self.checkValidOfAllRecords();
		if (!isValid)
			return;	
		var curIndex = -1;
		var dataRecord = self.Context.DataRecord;        
	    for	(var index = self._allRecords.length - 1; index >= 0; index--) {
	        var curRecord = self._allRecords[index];
	        if (curRecord.Key == dataRecord.Key) {
	            curIndex = index;
	            break;
	        }
	    }
	    if (curIndex >= 0){
	    	return;
	    }
	    self._allRecords.push($.extend(true, {}, dataRecord));
	},
	
	//更新当前卡片到全部卡片缓存中
	updateToAllRecords: function(){
		var self = this;
		var isValid = self.checkValidOfAllRecords();
		if (!isValid)
			return;	
		var curIndex = -1;
		var dataRecord = self.Context.DataRecord;        
	    for	(var index = self._allRecords.length - 1; index >= 0; index--) {
	        var curRecord = self._allRecords[index];
	        if (curRecord.Key == dataRecord.Key) {
	            curIndex = index;
	            break;
	        }
	    }
	    if (curIndex < 0){
	    	self._allRecords = null;
	    	return;
	    }
	    self._allRecords[curIndex] = $.extend(true, {}, dataRecord);
	},
	
	//当前卡片插入到全部卡片缓存中
	insertToAllRecords: function(curKey) {
		var self = this;
		var isValid = self.checkValidOfAllRecords();
		if (!isValid)
			return;
		var dataRecord = self.Context.DataRecord;
		var length = self._allRecords.length;
		var lastRecord = self._allRecords[length - 1];
		if (lastRecord.Key == curKey || lastRecord.Key == dataRecord.Key){
			self._allRecords[length - 1] = $.extend(true, {}, dataRecord);
		} else{
			self._allRecords == null;
		}
	},
	
	//从所有卡片缓存中删除当前卡片
	delFromAllRecords: function() {
		var self = this;
		var isValid = self.checkValidOfAllRecords();
		if (!isValid)
			return;
		var dataRecord = self.Context.DataRecord;	
		var curIndex = -1;
		for	(var index = 0; index < self._allRecords.length; index++){
			var curRecord = self._allRecords[index];
			if (curRecord.Key == dataRecord.Key){
				curIndex = index;
				break;
			}
		}
		if (curIndex < 0){
			self._allRecords == null;
			return;
		}
		self._allRecords.splice(curIndex, 1);
	},
	
	//将后台请求的公式js脚本加载到前台html中
    _initFmlScripts: function() {
        if (this.Context.FmlScripts === undefined)
            return;
        window.reloadJSByContent("formulaJs", this.Context.FmlScripts);
    },
    //#endregion
	
	_setBtnState: function (id, isShow, isEnable) {
	    var btnObj = $("#" + id);
	    if (!btnObj) return;

	    if (isShow) {
	        btnObj.show();
	    } else {
	        btnObj.hide();
	    }

	    if (isEnable) {
	        btnObj.removeAttr("disabled");
	    }
	    else {
	        btnObj.attr("disabled", "disabled");
	    }
	},
	
	_getJsonStr: function(dataItems) {
		if (!dataItems || dataItems.length === 0) return '';
		
		var jsonObj = {}, item, codes, titles, index, len, valueStr;
	    for (var i = 0, count = dataItems.length; i < count; i++) {
	    	item = dataItems[i];
	    	if (item.RefEnumId > 0 && item.EnumItems) {
	    		if (!item.Value) {
	    			jsonObj[item.ID] = '';
	    			continue;
	    		}
	    		
	    		var valuArray = item.Value.split('|'), codes = valuArray.length >= 2 ? valuArray[1].split(';') : item.Value.split(';')
	    		, titles = valuArray.length >= 2 ? valuArray[0].split(';') : item.Title.split(';'), valueStr = '';
	    		for (index = 0, len = codes.length; index < len; index++){
	    			valueStr += (valueStr.length > 0 ? ';' : '') + codes[index] + '|' + titles[index];
	    		}
	    		
	    		jsonObj[item.ID] = valueStr;
	    	} else {
				jsonObj[item.ID] = item.Value ? item.Value : '';
	    	}
		}
	    
	    var jsonStr = JSON.stringify(jsonObj);
	    return jsonStr;
	},

	_action: function(path, _data, callback, async, onError, headers) {
		$.doAction(path, _data, callback, async, onError, headers);
	},

	_getPath: function(action, withPeriod, withEntity, withForm) {
		var path = action + "?taskId=" + this.Context.TaskId;
		if (withPeriod && this.Context.Period)
			path += "&period=" + this.Context.Period;
		if (withEntity && this.Context.EntityKey)
			path += "&entityKey=" + this.Context.EntityKey;
		if (withForm && this.Context.FormId)
			path += "&formId=" + this.Context.FormId;
		if (this.Context.CurrenUserId)
			path += "&_userId_=" + this.Context.CurrenUserId;
		if (this.Context.ShareToken)
			path += "&shareToken=" + this.Context.ShareToken;
		path += "&_taskId_=" + this.Context.TaskId;
		return path;
	},

	_doUrl: function(fullUrl) {
		var taskIdIndex = fullUrl.search.indexOf("_taskId_"),
			userIdIndex = fullUrl.search.indexOf("_userId_");
		if (taskIdIndex !== -1) {
			var reg = new RegExp('(^|&)' + "_taskId_" + '=([^&]*)(&|$)', 'i'),
				reg2 = new RegExp('(^|&)' + "_userId_" + '=([^&]*)(&|$)', 'i'),
				reg3 = new RegExp('(^|&)' + "shareToken" + '=([^&]*)(&|$)', 'i'),
				reg4 = new RegExp('(^|&)' + "period" + '=([^&]*)(&|$)', 'i'),
				r = window.location.search.substr(1).match(reg),
				r2 = window.location.search.substr(1).match(reg2),
				r3 = window.location.search.substr(1).match(reg3),
				r4 = window.location.search.substr(1).match(reg4);
			if (r != null)
				$._taskId_ = unescape(r[2]) - 0;
			if (r2 != null)
				$._userId_ = unescape(r2[2]);
			if (r3 != null)
				$.shareToken = unescape(r3[2]);
			if (r3 != null)
				$.period = unescape(r4[2]);
		}
	},

    onDestroy: function() {
        this._super().onDestroy.call(this);
        this.removeListener(MSG_PeriodSelector_AfterSelect, this.onPeriodSelected, this);
    }
});
