﻿//#region Excel函数

//#region 统计函数
//ExcelSum (合计)
function ExcelSum() {
    FormulaFunction.call(this, "Sum", "求和", "数值和三角函数");
}
extend(ExcelSum, FormulaFunction);
ExcelSum.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var resultValue = FMR.getStatResult(fKey, dataLink, newValue, nodes, FMR.StatisticsEnum.Sum);
    if (resultValue == null)
        return new AbstractData(0.0, FMR.ConstDataTypes.Float, true);
    return new AbstractData(resultValue, FMR.ConstDataTypes.Float, false);
};
ExcelSum.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Float;
};

//ExcelAverage (平均值)
function ExcelAverage() {
    FormulaFunction.call(this, "Average", "求平均值", "统计函数");
}
extend(ExcelAverage, FormulaFunction);
ExcelAverage.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var resultValue = FMR.getStatResult(fKey, dataLink, newValue, nodes, FMR.StatisticsEnum.Avg);
    if (resultValue == null)
        return new ErrorData();
    return new AbstractData(resultValue, FMR.ConstDataTypes.Float, false);
};
ExcelAverage.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Float;
};

//ExcelCount (计数)
function ExcelCount() {
    FormulaFunction.call(this, "Count", "计数", "统计函数");
}
extend(ExcelCount, FormulaFunction);
ExcelCount.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var resultValue = FMR.getStatResult(fKey, dataLink, newValue, nodes, FMR.StatisticsEnum.Count);
    if (resultValue == null)
        return new AbstractData(0.0, FMR.ConstDataTypes.Float, true);
    return new AbstractData(resultValue, FMR.ConstDataTypes.Int, false);
};
ExcelCount.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Int;
};

//ExcelMax (最大值)
function ExcelMax() {
    FormulaFunction.call(this, "Max", "求最大值", "统计函数");
}
extend(ExcelMax, FormulaFunction);
ExcelMax.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var resultValue = FMR.getStatResult(fKey, dataLink, newValue, nodes, FMR.StatisticsEnum.Max);
    if (resultValue == null)
        return new AbstractData(0.0, FMR.ConstDataTypes.Float, true);
    return new AbstractData(resultValue, FMR.ConstDataTypes.Float, false);
};
ExcelMax.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Float;
};

//ExcelMin (最小值)
function ExcelMin() {
    FormulaFunction.call(this, "Min", "求最小值", "统计函数");
}
extend(ExcelMin, FormulaFunction);
ExcelMin.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var resultValue = FMR.getStatResult(fKey, dataLink, newValue, nodes, FMR.StatisticsEnum.Min);
    if (resultValue == null)
        return new AbstractData(0.0, FMR.ConstDataTypes.Float, true);
    return new AbstractData(resultValue, FMR.ConstDataTypes.Float, false);
};
ExcelMin.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Float;
};

//ExcelMedian (中位数)
function ExcelMedian() {
    FormulaFunction.call(this, "Median", "求中位数", "统计函数");
}
extend(ExcelMedian, FormulaFunction);
ExcelMedian.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var resultValue = FMR.getStatResult(fKey, dataLink, newValue, nodes, FMR.StatisticsEnum.Median);
    if (resultValue == null)
        return new ErrorData();
    return new AbstractData(resultValue, FMR.ConstDataTypes.Float, false);
};
ExcelMedian.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Float;
};

//ExcelMode (众数)
function ExcelMode() {
    FormulaFunction.call(this, "Mode", "求众数", "统计函数");
}
extend(ExcelMode, FormulaFunction);
ExcelMode.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var resultValue = FMR.getStatResult(fKey, dataLink, newValue, nodes, FMR.StatisticsEnum.Mode);
    if (resultValue == null)
        return new ErrorData();
    return new AbstractData(resultValue, FMR.ConstDataTypes.Float, false);
};
ExcelMode.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Float;
};

//ExcelCountIf (条件计数)
function ExcelCountIf() {
    FormulaFunction.call(this, "CountIf", "求条件计数", "统计函数");
}
extend(ExcelCountIf, FormulaFunction);
ExcelCountIf.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var param1Data = nodes[0].getResult(fKey, dataLink, newValue);
    var param2Data = nodes[1].getResult(fKey, dataLink, newValue);
    if (param1Data == null || param1Data.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    if (param2Data == null || param2Data.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var count = 0;
    var conditionString = param2Data.Value.toString();
    var listIndex, curValue;
    if (param1Data.dataType === FMR.ConstDataTypes.Object_Array) {
        var regionValues = param1Data.Value;
        for (var row = 0; row < regionValues.length; row++) {
            var rowValues = regionValues[row];
            for (var col = 0; col < rowValues.length; col++) {
                var cellValue = rowValues[col];
                if (cellValue == null || cellValue.Value === "" || cellValue.isNull)
                    continue;
                if (cellValue.dataType === FMR.ConstDataTypes.Object_List) {
                    var listValues = cellValue.Value;
                    for (listIndex = 0; listIndex < listValues.length; listIndex++) {
                        curValue = listValues[listIndex];
                        if (curValue == null || curValue.Value === "" || curValue.isNull)
                            continue;
                        if (curValue.Value.toString() === conditionString)
                            count++;
                    }
                } else {
                    if (cellValue.Value.toString() === conditionString)
                        count++;
                }
            }
        }
    } else if (param1Data.dataType === FMR.ConstDataTypes.Object_List) {
        var listData = param1Data.Value;
        for (listIndex = 0; listIndex < listData.length; listIndex++) {
            curValue = listData[listIndex];
            if (curValue == null || curValue.Value === "" || curValue.isNull)
                continue;
            if (curValue.Value.toString() === conditionString)
                count++;
        }
    } else {
        curValue = param1Data.Value;
        if (!(curValue == null || curValue.Value === "" || curValue.isNull)) {
            if (curValue.Value.toString() === conditionString)
                count++;
        }
    }
    return new AbstractData(count, FMR.ConstDataTypes.Int, false);
};
ExcelCountIf.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Int;
};

//ExcelSumIf (条件合计)
function ExcelSumIf() {
    FormulaFunction.call(this, "SumIf", "求条件合计", "统计函数");
}
extend(ExcelSumIf, FormulaFunction);
ExcelSumIf.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var param1Data = nodes[0].getResult(fKey, dataLink, newValue);
    var param2Data = nodes[1].getResult(fKey, dataLink, newValue);
    var param3Data = nodes[2].getResult(fKey, dataLink, newValue);
    if (param1Data == null || param1Data.dataType === FMR.ConstDataTypes.Error ||
        param2Data == null || param2Data.dataType === FMR.ConstDataTypes.Error ||
        param3Data == null || param3Data.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var data1Type = param1Data.dataType, data3Type = param3Data.dataType;
    var conditionString = param2Data.Value.toString();
    var hasAdd = false, resultValue = 0.0;
    var number3, conditionValue;
    if (data3Type == FMR.ConstDataTypes.Void) {
        param3Data = param1Data;
    }
    var valueData;
    var conditionListData;
    var valueListData;
    var listIndex;
    var conditionData;
    if (data1Type == FMR.ConstDataTypes.Object_Array && data3Type == FMR.ConstDataTypes.Object_Array) {
        var conditionValues = param1Data.Value;
        var valueDatas = param3Data.Value;
        if (conditionValues.length == valueDatas.length) {
            for (var row = 0; row < conditionValues.length; row++) {
                var conditionRowValues = conditionValues[row];
                var valueList = valueDatas[row];
                if (conditionRowValues.length != valueList.length)
                    return new ErrorData();
                for (var col = 0; col < conditionRowValues.length; col++) {
                    conditionValue = conditionRowValues[col];
                    valueData = valueList[col];
                    data1Type = conditionValue.dataType;
                    data3Type = valueData.dataType;
                    if (data1Type == FMR.ConstDataTypes.Object_List && data3Type == FMR.ConstDataTypes.Object_List) {
                        conditionListData = conditionValue.Value;
                        valueListData = valueData.Value;
                        if (conditionListData.length == valueListData.length) {
                            for (listIndex = 0; listIndex < conditionListData.length; listIndex++) {
                                conditionData = conditionListData[listIndex];
                                valueData = valueListData[listIndex];
                                if (!conditionData.isNull && !valueData.isNull) {
                                    number3 = new Number(valueData.Value + "");
                                    conditionValue = conditionData.Value.toString();
                                    if (!isNaN(number3) && conditionValue != "") {
                                        if (conditionValue === conditionString) {
                                            hasAdd = true;
                                            resultValue += number3;
                                        }
                                    }
                                }
                            }
                        } else {
                            return new ErrorData();
                        }
                    } else {
                        if (data1Type != FMR.ConstDataTypes.Object_Array && data1Type != FMR.ConstDataTypes.Object_List &&
                            data3Type != FMR.ConstDataTypes.Object_Array && data3Type != FMR.ConstDataTypes.Object_List) {
                            if (!conditionValue.isNull && !valueData.isNull) {
                                number3 = new Number(valueData.Value + "");
                                var conditionObj = conditionValue.Value.toString();
                                if (!isNaN(number3) && conditionObj != "") {
                                    if (conditionObj === conditionString) {
                                        hasAdd = true;
                                        resultValue += number3;
                                    }
                                }
                            }
                        } else {
                            return new ErrorData();
                        }
                    }
                }
            }
        } else {
            return new ErrorData();
        }
    } else if (data1Type == FMR.ConstDataTypes.Object_List && data3Type == FMR.ConstDataTypes.Object_List) {
        conditionListData = param1Data.Value;
        valueListData = param3Data.Value;
        if (conditionListData.length == valueListData.length) {
            for (listIndex = 0; listIndex < conditionListData.length; listIndex++) {
                conditionData = conditionListData[listIndex];
                valueData = valueListData[listIndex];
                if (!conditionData.isNull && !valueData.isNull) {
                    number3 = new Number(valueData.Value + "");
                    conditionValue = conditionData.Value.toString();
                    if (!isNaN(number3) && conditionValue != "") {
                        if (conditionValue === conditionString) {
                            hasAdd = true;
                            resultValue += number3;
                        }
                    }
                }
            }
        } else {
            return new ErrorData();
        }
    } else {
        if (data1Type != FMR.ConstDataTypes.Object_Array && data1Type != FMR.ConstDataTypes.Object_List &&
            data3Type != FMR.ConstDataTypes.Object_Array && data3Type != FMR.ConstDataTypes.Object_List) {
            if (!param1Data.isNull && !param3Data.isNull) {
                number3 = new Number(param3Data.Value + "");
                conditionValue = param1Data.Value.toString();
                if (!isNaN(number3) && conditionValue != "") {
                    if (conditionValue === conditionString) {
                        hasAdd = true;
                        resultValue += number3;
                    }
                }
            }
        } else {
            return new ErrorData();
        }
    }
    if (!hasAdd) {
        return new AbstractData(0.0, FMR.ConstDataTypes.Float, true);
    }
    return new AbstractData(resultValue, FMR.ConstDataTypes.Float, false);
};
ExcelSumIf.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Float;
};
//#endregion

//#region 逻辑函数
// ExcelIf (If条件)
function ExcelIf() {
    FormulaFunction.call(this, "If", "IF函数", "逻辑函数");
}
extend(ExcelIf, FormulaFunction);
ExcelIf.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    if (nodes.length < 3)
        return new ErrorData();
    var absData1 = nodes[0].getResult(fKey, dataLink, newValue);
    var dataType1 = absData1.dataType;
    if (dataType1 !== FMR.ConstDataTypes.Int && dataType1 !== FMR.ConstDataTypes.Float &&
        dataType1 !== FMR.ConstDataTypes.Currency && dataType1 !== FMR.ConstDataTypes.General && dataType1 !== FMR.ConstDataTypes.Bool)
        return new ErrorData();
    var conditionValue = false;
    if (dataType1 !== FMR.ConstDataTypes.Bool) {
        var curValue = FMR.getValueByType(absData1.Value, absData1.dataType, absData1.isNull, FMR.ConstDataTypes.Float);
        if (isNaN(curValue))
            return new ErrorData();
        if (curValue !== 0)
            conditionValue = true;
    } else {
        conditionValue = FMR.getValueByType(absData1.Value, absData1.dataType, absData1.isNull, FMR.ConstDataTypes.Bool);
    }
    if (conditionValue) {
        return nodes[1].getResult(fKey, dataLink, newValue);
    } else {
        if (nodes[2] instanceof VoidNode) {
            return new AbstractData(0, FMR.ConstDataTypes.Void, false);
        } else {
            return nodes[2].getResult(fKey, dataLink, newValue);
        }
    }
};
ExcelIf.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.AnyType;
};

// ExcelAnd (逻辑与)
function ExcelAnd() {
    FormulaFunction.call(this, "AND", "求逻辑与", "逻辑函数");
}
extend(ExcelAnd, FormulaFunction);
ExcelAnd.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var resultValue = true;
    var curValue;
    for (var index = 0; index < nodes.length; index++) {
        var node = nodes[index];
        var curData = node.getResult(fKey, dataLink, newValue);
        if (curData == null || curData.dataType === FMR.ConstDataTypes.Error || curData.dataType === FMR.ConstDataTypes.String)
            return new ErrorData();
        if (curData.isNull)
            continue;
        if (curData.dataType === FMR.ConstDataTypes.Int || curData.dataType === FMR.ConstDataTypes.Float || curData.dataType === FMR.ConstDataTypes.Currency) {
            curValue = FMR.getValueByType(curData.Value, curData.dataType);
            if (isNaN(curValue))
                return new ErrorData();
            if (curValue == 0) {
                resultValue = false;
                break;
            }
        }
        else if (curData.dataType === FMR.ConstDataTypes.General) {
            curValue = FMR.getValueByType(curData.Value, curData.dataType, curData.isNull, FMR.ConstDataTypes.Float);
            if (isNaN(curValue))
                return new ErrorData();
            if (curValue == 0) {
                resultValue = false;
                break;
            }
            resultValue &= curValue;
        }
        else if (curData.dataType === FMR.ConstDataTypes.Bool) {
            curValue = FMR.getValueByType(curData.Value, curData.dataType);
            resultValue &= curValue;
        }
    }
    return new AbstractData(resultValue ? 1 : 0, FMR.ConstDataTypes.Bool);
};
ExcelAnd.prototype.judgeResultType = function () {
    return ConstDataTypes.Bool;
};

// ExcelOr (逻辑或)
function ExcelOr() {
    FormulaFunction.call(this, "OR", "求逻辑或", "逻辑函数");
}
extend(ExcelOr, FormulaFunction);
ExcelOr.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var resultValue = false;
    var curValue;
    for (var index = 0; index < nodes.length; index++) {
        var node = nodes[index];
        var curData = node.getResult(fKey, dataLink, newValue);
        if (curData == null || curData.dataType === FMR.ConstDataTypes.Error || curData.dataType === FMR.ConstDataTypes.String)
            return new ErrorData();
        if (curData.isNull)
            continue;
        if (curData.dataType === FMR.ConstDataTypes.Int || curData.dataType === FMR.ConstDataTypes.Float || curData.dataType === FMR.ConstDataTypes.Currency) {
            curValue = FMR.getValueByType(curData.Value, curData.dataType);
            if (isNaN(curValue))
                return new ErrorData();
            if (curValue == 0) {
                continue;
            }
        }
        else if (curData.dataType === FMR.ConstDataTypes.General) {
            curValue = FMR.getValueByType(curData.Value, curData.dataType, curData.isNull, FMR.ConstDataTypes.Float);
            if (isNaN(curValue))
                return new ErrorData();
            if (curValue == 0) {
                continue;
            }
            resultValue |= curValue;
        }
        else if (curData.dataType === FMR.ConstDataTypes.Bool) {
            curValue = FMR.getValueByType(curData.Value, curData.dataType);
            resultValue |= curValue;
        }
    }
    return new AbstractData(resultValue ? 1 : 0, FMR.ConstDataTypes.Bool);
};
ExcelOr.prototype.judgeResultType = function () {
    return ConstDataTypes.Bool;
};
//#endregion

//#region 数值函数
//ExcelPower (乘方)
function ExcelPower() {
    FormulaFunction.call(this, "Power", "乘方", "数值和三角函数");
}
extend(ExcelPower, FormulaFunction);
ExcelPower.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    if (nodes.length < 2)
        return new ErrorData();
    var absData1 = nodes[0].getResult(fKey, dataLink, newValue);
    var absData2 = nodes[1].getResult(fKey, dataLink, newValue);
    if (absData1 == null || absData1.dataType === FMR.ConstDataTypes.Error || absData2 == null || absData2.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    if (absData1.dataType !== FMR.ConstDataTypes.Int && absData1.dataType !== FMR.ConstDataTypes.Float &&
        absData1.dataType !== FMR.ConstDataTypes.Currency && absData1.dataType !== FMR.ConstDataTypes.General)
        return new ErrorData();
    if (absData2.dataType !== FMR.ConstDataTypes.Int && absData2.dataType !== FMR.ConstDataTypes.Float &&
        absData2.dataType !== FMR.ConstDataTypes.Currency && absData2.dataType !== FMR.ConstDataTypes.General)
        return new ErrorData();
    var curData1 = FMR.getValueByType(absData1.Value, absData1.dataType, absData1.isNull, FMR.ConstDataTypes.Float);
    var curData2 = FMR.getValueByType(absData2.Value, absData2.dataType, absData2.isNull, FMR.ConstDataTypes.Float);
    if (isNaN(curData1) || isNaN(curData2))
        return new ErrorData();
    var resultValue = curData1.power(curData2);
    return new AbstractData(resultValue, FMR.ConstDataTypes.Float);
};
ExcelPower.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Float;
};

//ExcelAbs (绝对值)
function ExcelAbs() {
    FormulaFunction.call(this, "ABS", "绝对值", "数值和三角函数");
}
extend(ExcelAbs, FormulaFunction);
ExcelAbs.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    if (nodes.length < 1)
        return new ErrorData();
    var absData1 = nodes[0].getResult(fKey, dataLink, newValue);
    if (absData1 == null || absData1.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    if (absData1.dataType !== FMR.ConstDataTypes.Int && absData1.dataType !== FMR.ConstDataTypes.Float &&
        absData1.dataType !== FMR.ConstDataTypes.Currency && absData1.dataType !== FMR.ConstDataTypes.General)
        return new ErrorData();
    var curData1 = FMR.getValueByType(absData1.Value, absData1.dataType, absData1.isNull, FMR.ConstDataTypes.Float);
    if (isNaN(curData1))
        return new ErrorData();
    var resultValue = Math.abs(curData1);
    return new AbstractData(resultValue, FMR.ConstDataTypes.Float);
};
ExcelAbs.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Float;
};

//ExcelRound (保留小数)
function ExcelRound() {
    FormulaFunction.call(this, "ROUND", "四舍五入", "数值和三角函数");
}
extend(ExcelRound, FormulaFunction);
ExcelRound.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    if (nodes.length < 2)
        return new ErrorData();
    var absData1 = nodes[0].getResult(fKey, dataLink, newValue);
    var absData2 = nodes[1].getResult(fKey, dataLink, newValue);
    if (absData1 == null || absData1.dataType === FMR.ConstDataTypes.Error || absData2 == null || absData2.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    if (absData1.dataType !== FMR.ConstDataTypes.Int && absData1.dataType !== FMR.ConstDataTypes.Float &&
        absData1.dataType !== FMR.ConstDataTypes.Currency && absData1.dataType !== FMR.ConstDataTypes.General)
        return new ErrorData();
    if (absData2.dataType !== FMR.ConstDataTypes.Int && absData2.dataType !== FMR.ConstDataTypes.Float &&
        absData2.dataType !== FMR.ConstDataTypes.Currency && absData2.dataType !== FMR.ConstDataTypes.General)
        return new ErrorData();
    var curData1 = FMR.getValueByType(absData1.Value, absData1.dataType, absData1.isNull, FMR.ConstDataTypes.Float);
    if (isNaN(curData1))
        return new ErrorData();
    var curData2 = FMR.getValueByType(absData2.Value, absData2.dataType, absData2.isNull, FMR.ConstDataTypes.Int);
    if (isNaN(curData2))
        return new ErrorData();
    var digitsNum = parseInt(curData2, 10);
    var resultValue;
    with (Math) {
        resultValue = round(curData1 * pow(10, digitsNum)) / pow(10, digitsNum);
    }
    return new AbstractData(resultValue, FMR.ConstDataTypes.Float);
};
ExcelRound.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Float;
};

//#endregion

//#region 文本函数
// ExcelLen (文本长度)  
function ExcelLen() {
    FormulaFunction.call(this, "LEN", "长度", "字符函数");
}
extend(ExcelLen, FormulaFunction);
ExcelLen.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var absData = nodes[0].getResult(fKey, dataLink, newValue);
    if (absData == null || absData.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var curValue = FMR.getValueByType(absData.Value, absData.dataType, absData.isNull);
    if (curValue == null)
        return new AbstractData(0, FMR.ConstDataTypes.Int);
    else
        return new AbstractData(curValue.toString().length, FMR.ConstDataTypes.Int);
};
ExcelLen.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Int;
};

// ExcelLenB (双字节文本长度)  
function ExcelLenB() {
    FormulaFunction.call(this, "LENB", "长度", "字符函数");
}
extend(ExcelLenB, FormulaFunction);
ExcelLenB.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var absData = nodes[0].getResult(fKey, dataLink, newValue);
    if (absData == null || absData.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var curValue = FMR.getValueByType(absData.Value, absData.dataType, absData.isNull);
    if (curValue == null)
        return new AbstractData(0, FMR.ConstDataTypes.Int);
    else {
        curValue = curValue.toString();
        var ansiCount = curValue.length;
        for (var i = 0; i < curValue.length; i++)
            ansiCount += curValue[i] > 255 ? 1 : 0;
        return new AbstractData(ansiCount, FMR.ConstDataTypes.Int);
    }
};
ExcelLenB.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Int;
};

//ExcelConcatenate (字符串连接)
function ExcelConcatenate() {
    FormulaFunction.call(this, "CONCATENATE", "字符串连接", "字符函数");
}
extend(ExcelConcatenate, FormulaFunction);
ExcelConcatenate.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var resultData = "";
    var curString;
    for (var index = 0; index < nodes.length; index++) {
        var node = nodes[index];
        var curData = node.getResult(fKey, dataLink, newValue);
        if (curData == null || curData.dataType === FMR.ConstDataTypes.Error)
            return new ErrorData();
        var dataType = curData.dataType;
        if (dataType === FMR.ConstDataTypes.Int || dataType === FMR.ConstDataTypes.Float || dataType === FMR.ConstDataTypes.Currency) {
            if (curData.isNull)
                continue;
            curString = FMR.getStringByType(curData.Value, dataType);
            resultData += curString;
        }
        else if (dataType === FMR.ConstDataTypes.String || dataType === FMR.ConstDataTypes.Bool || dataType == FMR.ConstDataTypes.General
            || dataType == FMR.ConstDataTypes.Date || dataType == FMR.ConstDataTypes.DateTime) {
            curString = FMR.getStringByType(curData.Value, dataType);
            resultData += curString;
        }
    }
    return new AbstractData(resultData, FMR.ConstDataTypes.String);
};
ExcelConcatenate.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.String;
};

function ansiSubStr(strData, start, length) {
    if (strData == null || strData.length === 0)
        return strData;
    var len = strData.length;
    var ansiCount = strData.length;
    var isWideChar = new Array();
    for (var i = 0; i < len; i++) {
        isWideChar[i] = strData[i] > 255 ? 1 : 0;
        ansiCount += isWideChar[i];
    }
    if (start < 0) {
        start = ansiCount - length;
        if (start < 0) start = 0;
    }
    var fullLength = start + length >= ansiCount;
    var copyStart = 0;
    while (start > 0 && copyStart < len) {
        start = start - 1 - isWideChar[copyStart];
        if (start < 0) {
            length++;//半个中文字符
            break;
        }
        copyStart++;
    }
    var copyStop = fullLength ? len : copyStart;
    while (length > 0 && copyStop < len) {
        length = length - 1 - isWideChar[copyStop];
        copyStop++;
        if (length < 0) break;
    }
    return strData.substr(copyStart, copyStop - copyStart);
}

// ExcelLeft (字符串左串)
function ExcelLeft() {
    FormulaFunction.call(this, "LEFT", "左串", "字符函数");
}
extend(ExcelLeft, FormulaFunction);
ExcelLeft.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    if (nodes.length < 2)
        return new ErrorData();
    var absData1 = nodes[0].getResult(fKey, dataLink, newValue);
    var absData2 = nodes[1].getResult(fKey, dataLink, newValue);
    if (absData1 == null || absData1.dataType === FMR.ConstDataTypes.Error || absData2 == null || absData2.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var curValue = FMR.getValueByType(absData1.Value, absData1.dataType, absData1.isNull);
    var length = FMR.getValueByType(absData2.Value, absData2.dataType, absData2.isNull, FMR.ConstDataTypes.Int);
    if (length < 0)
        return new ErrorData();
    if (curValue == null || curValue.toString().length <= 0)
        return new AbstractData("", FMR.ConstDataTypes.String);
    else {
        curValue = curValue.toString();
        if (curValue.length > length)
            curValue = curValue.substr(0, length);
        return new AbstractData(curValue, FMR.ConstDataTypes.String);
    }
};
ExcelLeft.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.String;
};

// ExcelRight (字符串右串)
function ExcelRight() {
    FormulaFunction.call(this, "RIGHT", "右串", "字符函数");
}
extend(ExcelRight, FormulaFunction);
ExcelRight.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    if (nodes.length < 2)
        return new ErrorData();
    var absData1 = nodes[0].getResult(fKey, dataLink, newValue);
    var absData2 = nodes[1].getResult(fKey, dataLink, newValue);
    if (absData1 == null || absData1.dataType === FMR.ConstDataTypes.Error || absData2 == null || absData2.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var curValue = FMR.getValueByType(absData1.Value, absData1.dataType, absData1.isNull);
    var length = FMR.getValueByType(absData2.Value, absData2.dataType, absData2.isNull, FMR.ConstDataTypes.Int);
    if (length < 0)
        return new ErrorData();
    if (curValue == null || curValue.toString().length <= 0)
        return new AbstractData("", FMR.ConstDataTypes.String);
    else {
        curValue = curValue.toString();
        if (curValue.length > length)
            curValue = curValue.substr(curValue.length - length);
        return new AbstractData(curValue, FMR.ConstDataTypes.String);
    }
};
ExcelRight.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.String;
};

// ExcelLower (字符串转小写)  
function ExcelLower() {
    FormulaFunction.call(this, "LOWER", "字符串转化为小写", "字符函数");
}
extend(ExcelLower, FormulaFunction);
ExcelLower.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var absData = nodes[0].getResult(fKey, dataLink, newValue);
    if (absData == null || absData.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var curValue = FMR.getValueByType(absData.Value, absData.dataType, absData.isNull);
    if (curValue == null)
        return new AbstractData("", FMR.ConstDataTypes.String);
    else
        return new AbstractData(curValue.toString().toLowerCase(), FMR.ConstDataTypes.String);
};
ExcelLower.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.String;
};

// ExcelUpper (字符串转大写)  
function ExcelUpper() {
    FormulaFunction.call(this, "UPPER", "字符串转化为大写", "字符函数");
}
extend(ExcelUpper, FormulaFunction);
ExcelUpper.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var absData = nodes[0].getResult(fKey, dataLink, newValue);
    if (absData == null || absData.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var curValue = FMR.getValueByType(absData.Value, absData.dataType, absData.isNull);
    if (curValue == null)
        return new AbstractData("", FMR.ConstDataTypes.String);
    else
        return new AbstractData(curValue.toString().toUpperCase(), FMR.ConstDataTypes.String);
};
ExcelUpper.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.String;
};

//ExcelMid (字符串中串)
function ExcelMid() {
    FormulaFunction.call(this, "MID", "中串", "字符函数");
}
extend(ExcelMid, FormulaFunction);
ExcelMid.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    if (nodes.length < 2)
        return new ErrorData();
    var absData1 = nodes[0].getResult(fKey, dataLink, newValue);
    var absData2 = nodes[1].getResult(fKey, dataLink, newValue);
    var absData3 = nodes[2].getResult(fKey, dataLink, newValue);
    if (absData1 == null || absData1.dataType === FMR.ConstDataTypes.Error || absData2 == null || absData2.dataType === FMR.ConstDataTypes.Error
        || absData3 == null || absData3.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var curValue = FMR.getValueByType(absData1.Value, absData1.dataType, absData1.isNull);
    var startIndex = FMR.getValueByType(absData2.Value, absData2.dataType, absData2.isNull, FMR.ConstDataTypes.Int);
    var length = FMR.getValueByType(absData3.Value, absData3.dataType, absData3.isNull, FMR.ConstDataTypes.Int);
    if (length < 0 || startIndex <= 0)
        return new ErrorData();
    if (curValue == null || curValue.toString().length <= 0 || length == 0 || startIndex > curValue.length)
        return new AbstractData("", FMR.ConstDataTypes.String);
    else {
        curValue = curValue.toString();
        if (length > (curValue.Length - startIndex + 1))
            length = curValue.Length - startIndex + 1;
        curValue = curValue.substr(startIndex - 1, length);
        return new AbstractData(curValue, FMR.ConstDataTypes.String);
    }
};
ExcelMid.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.String;
};
//#endregion

//#region 信息函数
// ExcelIsNumber (判断是否数值)
function ExcelIsNumber() {
    FormulaFunction.call(this, "ISNUMBER", "是否是数值判断", "信息函数");
}
extend(ExcelIsNumber, FormulaFunction);
ExcelIsNumber.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    if (nodes.length > 1 || nodes.length < 0)
        return new ErrorData();
    var curParam = nodes[0];
    var curValue = curParam.getResult(fKey, dataLink, newValue);
    if (curValue.isNull) {
        return new AbstractData(0, FMR.ConstDataTypes.Bool);
    }
    var dataType = curValue.dataType;
    if (dataType == FMR.ConstDataTypes.General || dataType == FMR.ConstDataTypes.Int || dataType == FMR.ConstDataTypes.Float || dataType == FMR.ConstDataTypes.Currency) {
        var number = FMR.getValueByType(curValue.Value, dataType, curValue.isNull, FMR.ConstDataTypes.Float);
        if (isNaN(number))
            return new AbstractData(0, FMR.ConstDataTypes.Bool);
        return new AbstractData(1, FMR.ConstDataTypes.Bool);
    } else {
        return new AbstractData(0, FMR.ConstDataTypes.Bool);
    }
};
ExcelOr.prototype.judgeResultType = function () {
    return ConstDataTypes.Bool;
};
//#endregion

//#region 自定义函数
//ExcelPrevLineData (取上一行数)
function ExcelPrevLineData() {
    FormulaFunction.call(this, "PrevLineData", "取浮动行上一行引用单元格数据", "自定义函数");
}
extend(ExcelPrevLineData, FormulaFunction);
ExcelPrevLineData.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    if (nodes.length != 1)
        return new ErrorData();
    var cellNode = nodes[0];
    var cellData = cellNode.getResult(fKey, dataLink, newValue, true);
    return cellData;
};
ExcelPrevLineData.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.AnyType;
};
ExcelPrevLineData.prototype.isPrevLinkChange = function (dataLink, nodes) {
    if (nodes.length != 1)
        return false;
    var cellNode = nodes[0];
    return cellNode.isPrevLinkChange(dataLink, true);
};
ExcelPrevLineData.prototype.isGetPrevData = function () {
    return true;
}

//ExcelUnitTitle (取单位名称)
function ExcelUnitTitle() {
    FormulaFunction.call(this, "UnitTitle", "获取当前小伙伴单位名称函数", "自定义函数");
}
extend(ExcelUnitTitle, FormulaFunction);
ExcelUnitTitle.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    if (nodes.length != 0)
        return new ErrorData();
    var getUnitTitleMethod = DynamicNodeFactory.getMethod(DynamicNodeFactory.GetUnitTitleMethod);
    if (getUnitTitleMethod == null)
        return new ErrorData();
    var unitTitle = getUnitTitleMethod(fKey);
    if (unitTitle == null || unitTitle == "")
        return new ErrorData();
    return new AbstractData(unitTitle, FMR.ConstDataTypes.String, false);
};
ExcelUnitTitle.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.String;
};

//ExcelDuplicate (检查重复)
function ExcelDuplicate() {
    FormulaFunction.call(this, "Duplicate", "检查重复", "自定义函数");
}
extend(ExcelDuplicate, FormulaFunction);
ExcelDuplicate.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var param1Data = nodes[0].getResult(fKey, dataLink, newValue, false, true);
    var param2Data = nodes[1].getResult(fKey, dataLink, newValue, false, true);
    if (param1Data == null || param1Data.dataType === FMR.ConstDataTypes.Error || param1Data.Value == null)
        return new ErrorData();
    if (param2Data == null || param2Data.dataType === FMR.ConstDataTypes.Error || param2Data.Value == null)
        return new ErrorData();
    var count = 0;
    var conditionString = param2Data.Value.toString();
    var listIndex, curValue;
    if (param1Data.dataType === FMR.ConstDataTypes.Object_Array) {
        var regionValues = param1Data.Value;
        for (var row = 0; row < regionValues.length; row++) {
            var rowValues = regionValues[row];
            for (var col = 0; col < rowValues.length; col++) {
                var cellValue = rowValues[col];
                if (cellValue == null || cellValue.Value === "" || cellValue.isNull)
                    continue;
                if (cellValue.dataType === FMR.ConstDataTypes.Object_List) {
                    var listValues = cellValue.Value;
                    for (listIndex = 0; listIndex < listValues.length; listIndex++) {
                        curValue = listValues[listIndex];
                        if (curValue == null || curValue.Value === "" || curValue.isNull)
                            continue;
                        if (curValue.Value.toString() === conditionString)
                            count++;
                    }
                } else {
                    if (cellValue.Value.toString() === conditionString)
                        count++;
                }
            }
        }
    } else if (param1Data.dataType === FMR.ConstDataTypes.Object_List) {
        var listData = param1Data.Value;
        for (listIndex = 0; listIndex < listData.length; listIndex++) {
            curValue = listData[listIndex];
            if (curValue == null || curValue.Value === "" || curValue.isNull)
                continue;
            if (curValue.Value.toString() === conditionString)
                count++;
        }
    } else {
        curValue = param1Data.Value;
        if (!(curValue == null || curValue.Value === "" || curValue.isNull)) {
            if (curValue.Value.toString() === conditionString)
                count++;
        }
    }
    return new AbstractData(count, FMR.ConstDataTypes.Int, false);
};
ExcelDuplicate.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Int;
};

//ExcelIDCard (身份证号转换)
function ExcelIDCard() {
    FormulaFunction.call(this, "IDCard", "转换成18位身份证号", "自定义函数");
}
extend(ExcelIDCard, FormulaFunction);
ExcelIDCard.prototype.callFunction = function(fKey, dataLink, newValue, nodes) {
    var param1Data = nodes[0].getResult(fKey, dataLink, newValue);
    if (param1Data == null || param1Data.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    if (param1Data.isNull || param1Data.Value == null)
        return new AbstractData("", FMR.ConstDataTypes.String, true);
    var dataType = param1Data.dataType;
    if ((dataType != FMR.ConstDataTypes.General && dataType != FMR.ConstDataTypes.String) || param1Data.Value.length <= 0)
        return new AbstractData("", FMR.ConstDataTypes.String, true);
    var resultValue = FMR.getIDCard18(param1Data.Value + "");
    return new AbstractData(resultValue, FMR.ConstDataTypes.String, resultValue == null || resultValue.length <= 0);
};
ExcelDuplicate.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.String;
};

//ExcelIsIDCard (是否是身份证号)
function ExcelIsIDCard() {
    FormulaFunction.call(this, "IsIDCard", "是否是合法身份证号码", "自定义函数");
}
extend(ExcelIsIDCard, FormulaFunction);
ExcelIsIDCard.prototype.callFunction = function (fKey, dataLink, newValue, nodes) {
    var param1Data = nodes[0].getResult(fKey, dataLink, newValue);
    if (param1Data == null || param1Data.dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    if (param1Data.isNull || param1Data.Value == null)
        return new AbstractData(0, FMR.ConstDataTypes.Bool);
    var dataType = param1Data.dataType;
    if ((dataType != FMR.ConstDataTypes.General && dataType != FMR.ConstDataTypes.String) || param1Data.Value.length <= 0)
        return new AbstractData(0, FMR.ConstDataTypes.Bool);
    var resultValue = FMR.isIDCard(param1Data.Value + "");
    return new AbstractData(resultValue ? 1 : 0, FMR.ConstDataTypes.Bool);
};
ExcelIsIDCard.prototype.judgeResultType = function () {
    return FMR.ConstDataTypes.Bool;
};

//#endregion

//#endregion

//#region Excel操作符
//ExcelAssign (=，赋值运算符)
function ExcelAssign() {
    Operator.call(this, "=", "赋值");
}
extend(ExcelAssign, Operator);
ExcelAssign.prototype.isAssign = function () {
    return true;
};
ExcelAssign.prototype.getResult = function (data1, data2) {
    if (data1.Value == null || data2.Value == null || data1.dataType === FMR.ConstDataTypes.Error || data2.dataType === FMR.ConstDataTypes.Error) {
        return new ErrorData();
    }
    return new ErrorData();
};
ExcelAssign.prototype.getResultType = function () {
    return FMR.ConstDataTypes.Void;
};

//ExcelPlus (+，加号)
function ExcelPlus() {
    Operator.call(this, "+", "加上");
}
extend(ExcelPlus, Operator);
ExcelPlus.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var resultTypes = this.getResultType(data1.dataType, data2.dataType);
    if (resultTypes === FMR.ConstDataTypes.Error)
        return new ErrorData();
    if (data1.isNull && data2.isNull) {
        return new AbstractData(0, resultTypes, true);
    }
    var curData1 = FMR.getValueByType(data1.Value, data1.dataType, data1.isNull, FMR.ConstDataTypes.Float);
    var curData2 = FMR.getValueByType(data2.Value, data2.dataType, data2.isNull, FMR.ConstDataTypes.Float);
    if (data1.isNull)
        return data2;
    if (data2.isNull)
        return data1;
    var curDate;
    if (data1.dataType === FMR.ConstDataTypes.Date || data1.dataType === FMR.ConstDataTypes.DateTime) {
        curDate = new Date(curData1);
        if (curDate == "Invalid Date" || isNaN(curDate)) {
            return data2;
        }
        curDate.setDate(curDate.getDate() + Math.floor(curData2));
        if (data1.dataType === FMR.ConstDataTypes.Date)
            return new AbstractData("" + curDate.getFullYear() + "/" + (curDate.getMonth() + 1) + "/" + curDate.getDate(), data1.dataType, false);
        else
            return new AbstractData("" + curDate.getFullYear() + "/" + (curDate.getMonth() + 1) + "/" + curDate.getDate() + " " + curDate.getHours() + ":" + curDate.getMinutes + ":" + curDate.getSeconds(), data1.dataType, false);
    }
    if (data2.dataType === FMR.ConstDataTypes.Date || data2.dataType === FMR.ConstDataTypes.DateTime) {
        curDate = new Date(curData2);
        if (curDate == "Invalid Date" || isNaN(curDate)) {
            return data1;
        }
        curDate.setDate(curDate.getDate() + Math.floor(curData1));
        if (data2.dataType === FMR.ConstDataTypes.Date)
            return new AbstractData("" + curDate.getFullYear() + "/" + (curDate.getMonth() + 1) + "/" + curDate.getDate(), data2.dataType, false);
        else
            return new AbstractData("" + curDate.getFullYear() + "/" + (curDate.getMonth() + 1) + "/" + curDate.getDate() + " " + curDate.getHours() + ":" + curDate.getMinutes + ":" + curDate.getSeconds(), data2.dataType, false);
    }
    if (isNaN(curData1) || isNaN(curData2))
        return new ErrorData();
    var resultValue = curData1.add(curData2);
    switch (resultTypes) {
        case FMR.ConstDataTypes.Int:
            return new AbstractData(resultValue, FMR.ConstDataTypes.Int);
        case FMR.ConstDataTypes.Float:
            return new AbstractData(resultValue, FMR.ConstDataTypes.Float);
        default:
            return new ErrorData();
    }
};
ExcelPlus.prototype.getResultType = function (data1Type, data2Type) {
    switch (data1Type) {
        case FMR.ConstDataTypes.Int:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                    return FMR.ConstDataTypes.Int;
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                    return FMR.ConstDataTypes.Float;
                case FMR.ConstDataTypes.Date:
                case FMR.ConstDataTypes.DateTime:
                    return data2Type;
                case FMR.ConstDataTypes.Object_Array:
                    return FMR.ConstDataTypes.Object_Array;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        case FMR.ConstDataTypes.Currency:
        case FMR.ConstDataTypes.Float:
        case FMR.ConstDataTypes.General:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                    return FMR.ConstDataTypes.Float;
                case FMR.ConstDataTypes.Date:
                case FMR.ConstDataTypes.DateTime:
                    return data2Type;
                case FMR.ConstDataTypes.Object_Array:
                    return FMR.ConstDataTypes.Object_Array;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        case FMR.ConstDataTypes.Date:
        case FMR.ConstDataTypes.DateTime:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                    return data1Type;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        case FMR.ConstDataTypes.Object_Array:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                case FMR.ConstDataTypes.Object_Array:
                    return FMR.ConstDataTypes.Object_Array;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        default:
            return FMR.ConstDataTypes.Error;
    }
};

//ExcelSubtract (-，减号)
function ExcelSubtract() {
    Operator.call(this, "-", "减去");
}
extend(ExcelSubtract, Operator);
ExcelSubtract.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var resultTypes = this.getResultType(data1.dataType, data2.dataType);
    if (resultTypes === FMR.ConstDataTypes.Error)
        return new ErrorData();
    if (data1.isNull && data2.isNull) {
        return new AbstractData(0, resultTypes, true);
    }
    var curData1 = FMR.getValueByType(data1.Value, data1.dataType, data1.isNull, FMR.ConstDataTypes.Float);
    var curData2 = FMR.getValueByType(data2.Value, data2.dataType, data2.isNull, FMR.ConstDataTypes.Float);
    if (data2.isNull)
        return data1;
    var curDate;
    var data1Type = data1.dataType, data2Type = data2.dataType;
    if (data1.dataType === FMR.ConstDataTypes.Date || data1.dataType === FMR.ConstDataTypes.DateTime) {
        curDate = new Date(curData1);
        if (curDate == "Invalid Date" || isNaN(curDate)) {
            return data1;
        }
        if (data1Type === FMR.ConstDataTypes.Date && data2Type === FMR.ConstDataTypes.Date) {
            var curDate2 = new Date(curData2);
            if (curDate2 == "Invalid Date" || isNaN(curDate2)) {
                return data1;
            }
            var oneDay = 24 * 60 * 60 * 1000;
            var dayOffset = (curDate.getTime() - curDate2.getTime()) / oneDay;
            return new AbstractData(dayOffset, FMR.ConstDataTypes.Int, false);
        }
        if (data2Type === FMR.ConstDataTypes.Date || data2Type === FMR.ConstDataTypes.DateTime) {
            return new ErrorData();
        }
        curDate.setDate(curDate.getDate() - Math.ceil(curData2));
        if (data1Type === FMR.ConstDataTypes.Date)
            return new AbstractData("" + curDate.getFullYear() + "/" + (curDate.getMonth() + 1) + "/" + curDate.getDate(), data1Type, false);
        else
            return new AbstractData("" + curDate.getFullYear() + "/" + (curDate.getMonth() + 1) + "/" + curDate.getDate() + " " + curDate.getHours() + ":" + curDate.getMinutes + ":" + curDate.getSeconds(), data1Type, false);
    }
    if (isNaN(curData1) || isNaN(curData2))
        return new ErrorData();
    var resultValue = curData1.subtract(curData2);
    switch (resultTypes) {
        case FMR.ConstDataTypes.Int:
            return new AbstractData(resultValue, FMR.ConstDataTypes.Int);
        case FMR.ConstDataTypes.Float:
            return new AbstractData(resultValue, FMR.ConstDataTypes.Float);
        default:
            return new ErrorData();
    }
};
ExcelSubtract.prototype.getResultType = function (data1Type, data2Type) {
    switch (data1Type) {
        case FMR.ConstDataTypes.Int:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                    return FMR.ConstDataTypes.Int;
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                    return FMR.ConstDataTypes.Float;
                case FMR.ConstDataTypes.Object_Array:
                    return FMR.ConstDataTypes.Object_Array;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        case FMR.ConstDataTypes.Currency:
        case FMR.ConstDataTypes.Float:
        case FMR.ConstDataTypes.General:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                    return FMR.ConstDataTypes.Float;
                case FMR.ConstDataTypes.Object_Array:
                    return FMR.ConstDataTypes.Object_Array;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        case FMR.ConstDataTypes.Date:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                    return data1Type;
                case FMR.ConstDataTypes.Date:
                    return FMR.ConstDataTypes.Int;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        case FMR.ConstDataTypes.DateTime:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                    return data1Type;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        case FMR.ConstDataTypes.Object_Array:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                case FMR.ConstDataTypes.Object_Array:
                    return FMR.ConstDataTypes.Object_Array;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        default:
            return FMR.ConstDataTypes.Error;
    }
};

//ExcelMultiply (*，乘号)
function ExcelMultiply() {
    Operator.call(this, "*", "乘以");
}
extend(ExcelMultiply, Operator);
ExcelMultiply.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var resultTypes = this.getResultType(data1.dataType, data2.dataType);
    if (resultTypes === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var curData1 = FMR.getValueByType(data1.Value, data1.dataType, data1.isNull, FMR.ConstDataTypes.Float);
    var curData2 = FMR.getValueByType(data2.Value, data2.dataType, data2.isNull, FMR.ConstDataTypes.Float);
    if (isNaN(curData1) || isNaN(curData2))
        return new ErrorData();
    if (data1.isNull || data2.isNull) {
        return new AbstractData(0, resultTypes, true);
    }
    var resultValue = curData1.multiply(curData2);
    switch (resultTypes) {
        case FMR.ConstDataTypes.Int:
            return new AbstractData(resultValue, FMR.ConstDataTypes.Int);
        case FMR.ConstDataTypes.Float:
            return new AbstractData(resultValue, FMR.ConstDataTypes.Float);
        default:
            return new ErrorData();
    }
};
ExcelMultiply.prototype.getResultType = function (data1Type, data2Type) {
    switch (data1Type) {
        case FMR.ConstDataTypes.Int:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                    return FMR.ConstDataTypes.Int;
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                    return FMR.ConstDataTypes.Float;
                case FMR.ConstDataTypes.Object_Array:
                    return FMR.ConstDataTypes.Object_Array;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        case FMR.ConstDataTypes.Currency:
        case FMR.ConstDataTypes.Float:
        case FMR.ConstDataTypes.General:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                    return FMR.ConstDataTypes.Float;
                case FMR.ConstDataTypes.Object_Array:
                    return FMR.ConstDataTypes.Object_Array;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        case FMR.ConstDataTypes.Object_Array:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                    return FMR.ConstDataTypes.Float;
                case FMR.ConstDataTypes.Object_Array:
                    return FMR.ConstDataTypes.Object_Array;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        default:
            return FMR.ConstDataTypes.Error;
    }
};

//ExcelDivide (/，除号)
function ExcelDivide() {
    Operator.call(this, "/", "除以");
}
extend(ExcelDivide, Operator);
ExcelDivide.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var resultTypes = this.getResultType(data1.dataType, data2.dataType);
    if (resultTypes === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var curData1 = FMR.getValueByType(data1.Value, data1.dataType, data1.isNull, FMR.ConstDataTypes.Float);
    var curData2 = FMR.getValueByType(data2.Value, data2.dataType, data2.isNull, FMR.ConstDataTypes.Float);
    if (isNaN(curData1) || isNaN(curData2))
        return new ErrorData();
    if (data2.isNull || curData2 === 0)
        return new ErrorData();
    if (data1.isNull) {
        return new AbstractData(0, resultTypes, true);
    }
    var resultValue = curData1.divide(curData2);
    switch (resultTypes) {
        case FMR.ConstDataTypes.Float:
            return new AbstractData(parseFloat(resultValue), FMR.ConstDataTypes.Float);
        default:
            return new ErrorData();
    }
};
ExcelDivide.prototype.getResultType = function (data1Type, data2Type) {
    switch (data1Type) {
        case FMR.ConstDataTypes.Int:
        case FMR.ConstDataTypes.Float:
        case FMR.ConstDataTypes.Currency:
        case FMR.ConstDataTypes.General:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                    return FMR.ConstDataTypes.Float;
                case FMR.ConstDataTypes.Object_Array:
                    return FMR.ConstDataTypes.Object_Array;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        case FMR.ConstDataTypes.Object_Array:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                case FMR.ConstDataTypes.Object_Array:
                    return FMR.ConstDataTypes.Object_Array;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        default:
            return FMR.ConstDataTypes.Error;
    }
};

//ExcelPositizing (+，正号)
function ExcelPositizing() {
    Operator.call(this, "+", "正");
}
extend(ExcelPositizing, Operator);
ExcelPositizing.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var resultTypes = this.getResultType(data1.dataType, data2.dataType);
    if (resultTypes === FMR.ConstDataTypes.Error)
        return new ErrorData();
    return data2;
};
ExcelPositizing.prototype.getResultType = function (data1Type, data2Type) {
    if (data1Type === FMR.ConstDataTypes.Void &&
    (data2Type === FMR.ConstDataTypes.Int || data2Type === FMR.ConstDataTypes.Float
        || data2Type === FMR.ConstDataTypes.Currency || data2Type === FMR.ConstDataTypes.General))
        return data2Type;
    return FMR.ConstDataTypes.Error;
};

//ExcelNegate (-，负号)
function ExcelNegate() {
    Operator.call(this, "-", "负");
}
extend(ExcelNegate, Operator);
ExcelNegate.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var resultTypes = this.getResultType(data1.dataType, data2.dataType);
    if (resultTypes === FMR.ConstDataTypes.Error)
        return new ErrorData();
    if (data2.isNull) {
        return new AbstractData(0, resultTypes, true);
    }
    var curData;
    if (data2.dataType === FMR.ConstDataTypes.General) {
        curData = FMR.getValueByType(data2.Value, data2.dataType, data2.isNull, FMR.ConstDataTypes.Float);
        if (isNaN(curData))
            return new ErrorData();
        return new AbstractData(-curData, FMR.ConstDataTypes.Float);
    }
    curData = FMR.getValueByType(data2.Value, data2.dataType, data2.isNull);
    return new AbstractData(-curData, resultTypes);
};
ExcelNegate.prototype.getResultType = function (data1Type, data2Type) {
    if (data1Type === FMR.ConstDataTypes.Void &&
    (data2Type === FMR.ConstDataTypes.Int || data2Type === FMR.ConstDataTypes.Float
        || data2Type === FMR.ConstDataTypes.Currency || data2Type === FMR.ConstDataTypes.General))
        return data2Type;
    return FMR.ConstDataTypes.Error;
};

//ExcelLink (&，字符串连接号)
function ExcelLink() {
    Operator.call(this, "&", "字符串连接");
}
extend(ExcelLink, Operator);
ExcelLink.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var resultTypes = this.getResultType(data1.dataType, data2.dataType);
    if (resultTypes === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var curData1 = FMR.getStringByType(data1.Value, data1.dataType);
    var curData2 = FMR.getStringByType(data2.Value, data2.dataType);
    var resultData = curData1 + curData2;
    return new AbstractData(resultData, resultTypes);
};
ExcelLink.prototype.getResultType = function (data1Type, data2Type) {
    switch (data1Type) {
        case FMR.ConstDataTypes.Bool:
        case FMR.ConstDataTypes.Int:
        case FMR.ConstDataTypes.Currency:
        case FMR.ConstDataTypes.Float:
        case FMR.ConstDataTypes.String:
        case FMR.ConstDataTypes.General:
        case FMR.ConstDataTypes.Object_Text:
            switch (data2Type) {
                case FMR.ConstDataTypes.Bool:
                case FMR.ConstDataTypes.Int:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.String:
                case FMR.ConstDataTypes.General:
                case FMR.ConstDataTypes.Object_Text:
                    return FMR.ConstDataTypes.String;
            }
            break;
    }
    return FMR.ConstDataTypes.Error;
};

//ExcelPersent (%，百分比号)
function ExcelPersent() {
    Operator.call(this, "%", "取百分数");
}
extend(ExcelPersent, Operator);
ExcelPersent.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var resultTypes = this.getResultType(data1.dataType, data2.dataType);
    if (resultTypes === FMR.ConstDataTypes.Error)
        return new ErrorData();
    if (data1.isNull) {
        return new AbstractData(0, resultTypes, true);
    }
    var curData;
    if (data2.dataType === FMR.ConstDataTypes.General) {
        curData = FMR.getValueByType(data2.Value, data2.dataType, data2.isNull, FMR.ConstDataTypes.Float);
        if (isNaN(curData))
            return new ErrorData();
        return new AbstractData(curData.divide(100.0), FMR.ConstDataTypes.Float);
    }
    curData = FMR.getValueByType(data1.Value, data1.dataType, data1.isNull);
    return new AbstractData(curData.divide(100.0), resultTypes);
};
ExcelPersent.prototype.getResultType = function (data1Type, data2Type) {
    if (data2Type === FMR.ConstDataTypes.Void &&
    (data1Type === FMR.ConstDataTypes.Int || data1Type === FMR.ConstDataTypes.Float
        || data1Type === FMR.ConstDataTypes.Currency || data1Type === FMR.ConstDataTypes.General))
        return FMR.ConstDataTypes.Float;
    return FMR.ConstDataTypes.Error;
};

//ExcelPowerOperator (^，乘方号)
function ExcelPowerOperator() {
    Operator.call(this, "^", "乘方");
}
extend(ExcelPowerOperator, Operator);
ExcelPowerOperator.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var resultTypes = this.getResultType(data1.dataType, data2.dataType);
    if (resultTypes === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var curData1 = FMR.getValueByType(data1.Value, data1.dataType, data1.isNull, FMR.ConstDataTypes.Float);
    var curData2 = FMR.getValueByType(data2.Value, data2.dataType, data2.isNull, FMR.ConstDataTypes.Float);
    if (isNaN(curData1) || isNaN(curData2) || ((data1.isNull || curData1 === 0) && (data2.isNull || curData2 === 0)))
        return new ErrorData();
    if (data1.isNull)
        return new AbstractData(0, resultTypes, true);
    if (data2.isNull)
        return new AbstractData(1, resultTypes, false);
    var resultValue = curData1.power(curData2);
    switch (resultTypes) {
        case FMR.ConstDataTypes.Int:
            return new AbstractData(resultValue, FMR.ConstDataTypes.Int);
        case FMR.ConstDataTypes.Float:
            return new AbstractData(resultValue, FMR.ConstDataTypes.Float);
        default:
            return new ErrorData();
    }
};
ExcelPowerOperator.prototype.getResultType = function (data1Type, data2Type) {
    switch (data1Type) {
        case FMR.ConstDataTypes.Int:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                    return FMR.ConstDataTypes.Int;
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                    return FMR.ConstDataTypes.Float;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        case FMR.ConstDataTypes.Currency:
        case FMR.ConstDataTypes.Float:
        case FMR.ConstDataTypes.General:
            switch (data2Type) {
                case FMR.ConstDataTypes.Int:
                case FMR.ConstDataTypes.Float:
                case FMR.ConstDataTypes.Currency:
                case FMR.ConstDataTypes.General:
                    return FMR.ConstDataTypes.Float;
                default:
                    return FMR.ConstDataTypes.Error;
            }
        default:
            return FMR.ConstDataTypes.Error;
    }
};

// Equal (=)
function ExcelEqual() {
    Operator.call(this, "=", "等于");
}
extend(ExcelEqual, CompareOperator);
ExcelEqual.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var dataType = this.getResultType(data1.dataType, data2.dataType);
    if (dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();

    var resultValue = FMR.compare(data1, data2) === 0;
    return new AbstractData(resultValue ? "1" : "0", FMR.ConstDataTypes.Bool);
};

// ExcelNotEqual (<>)
function ExcelNotEqual() {
    Operator.call(this, "<>", "不等于");
}
extend(ExcelNotEqual, CompareOperator);
ExcelNotEqual.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var dataType = this.getResultType(data1.dataType, data2.dataType);
    if (dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var resultValue = FMR.compare(data1, data2) === 0;
    return new AbstractData(!resultValue ? "1" : "0", FMR.ConstDataTypes.Bool);
};

// ExcelLess (<)
function ExcelLess() {
    Operator.call(this, "<", "小于");
}
extend(ExcelLess, CompareOperator);
ExcelLess.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var dataType = this.getResultType(data1.dataType, data2.dataType);
    if (dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var resultValue = FMR.compare(data1, data2) < 0;
    return new AbstractData(resultValue ? "1" : "0", FMR.ConstDataTypes.Bool);
};

// ExcelLessEqual (<=)
function ExcelLessEqual() {
    Operator.call(this, "<=", "小于等于");
}
extend(ExcelLessEqual, CompareOperator);
ExcelLessEqual.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var dataType = this.getResultType(data1.dataType, data2.dataType);
    if (dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var resultValue = FMR.compare(data1, data2) <= 0;
    return new AbstractData(resultValue ? "1" : "0", FMR.ConstDataTypes.Bool);
};

// ExcelGreater (>)
function ExcelGreater() {
    Operator.call(this, ">", "大于");
}
extend(ExcelGreater, CompareOperator);
ExcelGreater.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var dataType = this.getResultType(data1.dataType, data2.dataType);
    if (dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var resultValue = FMR.compare(data1, data2) > 0;
    return new AbstractData(resultValue ? "1" : "0", FMR.ConstDataTypes.Bool);
};

// ExcelGreaterEqual (>=)
function ExcelGreaterEqual() {
    Operator.call(this, ">=", "大于等于");
}
extend(ExcelGreaterEqual, CompareOperator);
ExcelGreaterEqual.prototype.getResult = function (data1, data2) {
    if (data1 == null || data2 == null)
        return new ErrorData();
    var dataType = this.getResultType(data1.dataType, data2.dataType);
    if (dataType === FMR.ConstDataTypes.Error)
        return new ErrorData();
    var resultValue = FMR.compare(data1, data2) >= 0;
    return new AbstractData(resultValue ? "1" : "0", FMR.ConstDataTypes.Bool);
};

//#endregion

//#region Excel界面指标
function StatisticInfo(statKind, condNode, valueNode) {
    DynamicDataNode.call(this);
    this.StatKind = statKind;
    this.CondNode = condNode;
    this.ValueNode = valueNode;
}
extend(StatisticInfo, Node);
StatisticInfo.prototype.getResult = function (cellValues) {
    switch (this.StatKind) {
        case FMR.StatEnum.STAT_KIND_LIST:
            return cellValues;
        default:
            return null;
    }
};
StatisticInfo.prototype.getResultType = function () {
    switch (this.StatKind) {
        case FMR.StatEnum.STAT_KIND_LIST:
            return FMR.ConstDataTypes.Object_List;
        case FMR.StatEnum.STAT_KIND_COUNT:
            return FMR.ConstDataTypes.Int;
        default:
            return FMR.ConstDataTypes.Float;
    }
};

function FieldDataNode(fieldCode, fieldDataType, fieldTableCode, statisticInfo) {
    DynamicDataNode.call(this);
    this.FieldCode = fieldCode;
    this.FieldTableCode = fieldTableCode;
    this.FieldDataType = fieldDataType;
    this.StatisticInfo = statisticInfo;
}
extend(FieldDataNode, DynamicDataNode);
FieldDataNode.prototype.assignData = function (fKey, dataLink, newValue, setData) {
    if (this.StatisticInfo != null) {
        return new ErrorData();
    }
    var dataLinkId = formulaCache.GetDataLinkByFieldCode(this.FieldTableCode, this.FieldCode);
    if (dataLinkId) {
        var setFieldDataMethod = DynamicNodeFactory.getMethod(DynamicNodeFactory.SetFieldDataMethod);
        if (setFieldDataMethod == null)
            return new ErrorData();
        if (setData.isNull || (setData.dataType === FMR.ConstDataTypes.Error || setData.dataType === FMR.ConstDataTypes.Object_Array))
            setData.Value = "";
        setFieldDataMethod(fKey, dataLinkId, setData.Value);
        return new AbstractData("", FMR.ConstDataTypes.Void);
    }
    return new ErrorData();
};
FieldDataNode.prototype.getResult = function (fKey, dataLink, newValue, getPrevData, getCode) {
    var dataLinkId = formulaCache.GetDataLinkByFieldCode(this.FieldTableCode, this.FieldCode);
    if (dataLinkId) {
        if (this.StatisticInfo != null) {
            var getStatisticCellsMethod = DynamicNodeFactory.getMethod(DynamicNodeFactory.GetStatisticCellsMethod);
            if (getStatisticCellsMethod == null)
                return new ErrorData();
            var cellValues = getStatisticCellsMethod(null, dataLinkId, newValue, dataLink, getCode);
            var absValues = new Array();
            for (var index = 0; index < cellValues.length; index++) {
                absValues.push(new AbstractData(cellValues[index], this.FieldDataType, cellValues[index] == null || cellValues[index] === ""));
            }
            var statisticValues = this.StatisticInfo.getResult(absValues);
            return new AbstractData(statisticValues, this.StatisticInfo.getResultType(), statisticValues == null);
        } else {
            var cellValue;
            if (dataLink != null && dataLink.length > 0 && dataLinkId == dataLink) {
                cellValue = FMR.getValue(newValue, getCode);
                return new AbstractData(cellValue, this.FieldDataType, cellValue == null || cellValue === "");
            }
            var getFieldDataMethod = DynamicNodeFactory.getMethod(DynamicNodeFactory.GetFieldDataMethod);
            if (getFieldDataMethod == null)
                return new ErrorData();
            cellValue = getFieldDataMethod(fKey, dataLinkId, getPrevData, getCode);
            return new AbstractData(cellValue, this.FieldDataType, cellValue == null || cellValue === "");
        }
    }
    else {
        var dataValue = formulaCache.GetDataValueByFieldCode(this.FieldTableCode, this.FieldCode);
        if (dataValue != null)
            return new AbstractData(dataValue, this.FieldDataType, dataValue.length <= 0 ? true : false);
    }
    return new ErrorData();
};
FieldDataNode.prototype.getResultType = function () {
    if (this.StatisticInfo != null) {
        return this.StatisticInfo.getResultType();
    }
    return this.FieldDataType;
};
FieldDataNode.prototype.getShowString = function () {
    throw "Not Supported Exception";
};
FieldDataNode.prototype.isPrevLinkChange = function (dataLink, isFromLineLink) {
    if (!isFromLineLink)
        return false;
    var dataLinkId = formulaCache.GetDataLinkByFieldCode(this.FieldTableCode, this.FieldCode);
    if (dataLinkId && dataLinkId == dataLink) {
        return true;
    }
    return false;
}

function SimpleDataNode(fieldCode, fieldDataType, fieldTableCode) {
    DynamicDataNode.call(this);
    this.FieldCode = fieldCode;
    this.FieldTableCode = fieldTableCode;
    this.FieldDataType = fieldDataType;
}
extend(SimpleDataNode, DynamicDataNode);
SimpleDataNode.prototype.assignData = function (fKey, dataLink, newValue, setData) {
    var dataLinkId = formulaCache.GetDataLinkByFieldCode(this.FieldTableCode, this.FieldCode);
    if (dataLinkId) {
        var setFieldDataMethod = DynamicNodeFactory.getMethod(DynamicNodeFactory.SetFieldDataMethod);
        if (setFieldDataMethod == null)
            return new ErrorData();
        if (setData.isNull || (setData.dataType === FMR.ConstDataTypes.Error || setData.dataType === FMR.ConstDataTypes.Object_Array))
            setData.Value = "";
        setFieldDataMethod(fKey, dataLinkId, setData.Value);
        return new AbstractData("", FMR.ConstDataTypes.Void);
    }
    return new ErrorData();
};
SimpleDataNode.prototype.getResult = function (fKey, dataLink, newValue, getPrevData, getCode) {
    var dataLinkId = formulaCache.GetDataLinkByFieldCode(this.FieldTableCode, this.FieldCode);
    if (dataLinkId) {
        var cellValue;
        if (dataLink != null && dataLink.length > 0 && dataLinkId == dataLink) {
            cellValue = FMR.getValue(newValue, getCode);
            return new AbstractData(cellValue, this.FieldDataType, cellValue == null || cellValue === "");
        }
        var getFieldDataMethod = DynamicNodeFactory.getMethod(DynamicNodeFactory.GetFieldDataMethod);
        if (getFieldDataMethod == null)
            return new ErrorData();
        cellValue = getFieldDataMethod(fKey, dataLinkId, getPrevData, getCode);
        return new AbstractData(cellValue, this.FieldDataType, cellValue == null || cellValue === "");
    }
    else {
        var dataValue = formulaCache.GetDataValueByFieldCode(this.FieldTableCode, this.FieldCode);
        if (dataValue != null)
            return new AbstractData(dataValue, this.FieldDataType, dataValue.length <= 0 ? true : false);
    }
    return new ErrorData();
};
SimpleDataNode.prototype.getResultType = function () {
    return this.FieldDataType;
};
SimpleDataNode.prototype.getShowString = function () {
    throw "Not Supported Exception";
};
SimpleDataNode.prototype.isPrevLinkChange = function (dataLink, isFromLineLink) {
    if (!isFromLineLink)
        return false;
    var dataLinkId = formulaCache.GetDataLinkByFieldCode(this.FieldTableCode, this.FieldCode);
    if (dataLinkId && dataLinkId == dataLink) {
        return true;
    }
    return false;
}

function FieldDataNodeForStat(ownerNode) {
    DynamicDataNode.call(this);
    this.OwnerNode = ownerNode;
}
extend(FieldDataNodeForStat, DynamicDataNode);
FieldDataNodeForStat.prototype.getResult = function (fKey, dataLink, newValue, getPrevData, getCode) {
    return this.OwnerNode.getResult(fKey, dataLink, newValue, getPrevData, getCode);
};
FieldDataNodeForStat.prototype.getResultType = function () {
    return this.OwnerNode.getResultType();
};
FieldDataNodeForStat.prototype.getShowString = function () {
    throw "Not Supported Exception";
};

function Position(row, col, options) {
    this.Row = row;
    this.Col = col;
    this.Options = options;
}

function CellNode(fieldDataNode, formTitle, position, periodSpecification) {
    DynamicDataNode.call(this);
    this.FieldDataNode = fieldDataNode;
    this.FormTitle = formTitle;
    this.Position = position;
    this.PeriodSpecification = periodSpecification;
}
extend(CellNode, DynamicDataNode);
CellNode.prototype.assignData = function (fKey, dataLink, newValue, setData) {
    return this.FieldDataNode.assignData(fKey, dataLink, newValue, setData);
};
CellNode.prototype.getResult = function (fKey, dataLink, newValue, getPrevData, getCode) {
    return this.FieldDataNode.getResult(fKey, dataLink, newValue, getPrevData, getCode);
};
CellNode.prototype.getResultType = function () {
    return this.FieldDataNode.getResultType();
};
CellNode.prototype.getShowString = function (fKey, getPrevData, isLastRow) {
    var dataLinkId;
    var cellString = "";
    if (this.PeriodSpecification != null && this.PeriodSpecification.length > 0) {
        cellString += FMR.getShowCellString(this.Position.Col, this.Position.Row, this.Position.Options, this.FormTitle);
        cellString += "[" + this.PeriodSpecification + "]";
        return cellString;
    }
    dataLinkId = formulaCache.GetDataLinkByFieldCode(this.FieldDataNode.FieldTableCode, this.FieldDataNode.FieldCode);
    if (dataLinkId) {
        var getCellMethod = DynamicNodeFactory.getMethod(DynamicNodeFactory.GetCellByDataLinkWithoutFkeyMethod);
        if (this.FieldDataNode.StatisticInfo != null) {
            if (isLastRow == undefined) {
                var firstCell = FMR.getShowCellStringByInterface(getCellMethod, null, dataLinkId, false, this.FormTitle, this.Position);
                var lastCell = FMR.getShowCellStringByInterface(getCellMethod, null, dataLinkId, true, this.FormTitle, this.Position);
                if (firstCell === lastCell) {
                    cellString += firstCell;
                } else {
                    cellString += firstCell;
                    cellString += ":";
                    cellString += lastCell;
                }
            } else {
                cellString += FMR.getShowCellStringByInterface(getCellMethod, null, dataLinkId, isLastRow, this.FormTitle, this.Position, getPrevData);
            }
        } else {
            cellString += FMR.getShowCellStringByInterface(getCellMethod, fKey, dataLinkId, isLastRow, this.FormTitle, this.Position, getPrevData);
        }
        return cellString;
    } else {
        dataLinkId = formulaCache.GetOtherDataLinkByFieldCode(this.FieldDataNode.FieldTableCode, this.FieldDataNode.FieldCode);
        if (dataLinkId && this.Position != null) {
            cellString += FMR.getShowCellString(this.Position.Col, this.Position.Row, this.Position.Options, this.FormTitle);
            return cellString;
        }
    }
    throw "Can't Get DataLinkId By FieldCode.";
};
CellNode.prototype.isPrevLinkChange = function (dataLink, isFromLineLink) {
    return this.FieldDataNode.isPrevLinkChange(dataLink, isFromLineLink);
};
CellNode.prototype.GetDataLinkId = function () {
    var fieldDataNode = this.FieldDataNode;
    var dataLinkId = formulaCache.GetDataLinkByFieldCode(fieldDataNode.FieldTableCode, fieldDataNode.FieldCode);
    return dataLinkId;
};

function RegionNode(cellNodes, childNodes, colSize, rowSize) {
    DynamicDataNode.call(this);
    this.CellNodes = cellNodes;
    this.ChildNodes = childNodes;
    this.ColSize = colSize;
    this.RowSize = rowSize;
}
extend(RegionNode, Node);
RegionNode.prototype.getResult = function (fKey, dataLink, newValue, getPrevData, getCode) {
    var index, cellNode;
    if (this.ChildNodes != null && this.ChildNodes.length > 0) {
        var resultData = new Array(this.RowSize);
        var length = this.ChildNodes.length;
        var lids = new Array();
        var row, col, rowData;
        if (fKey != null && fKey.length > 0) {
            resultData = this.getArrayData(fKey, dataLink, newValue, length, getCode);
        } else {
            var dataLinkId;
            for (row = 0; row < this.RowSize; row++) {
                rowData = new Array(this.ColSize);
                for (col = 0; col < this.ColSize; col++) {
                    index = row * this.ColSize + col;
                    if (index < length) {
                        cellNode = this.ChildNodes[index];
                        if (cellNode.StatisticInfo == null) {
                            dataLinkId = cellNode.GetDataLinkId();
                            if (dataLinkId) {
                                lids.push(dataLinkId);
                                continue;
                            } else
                                break;
                        } else
                            break;
                    }
                }
            }
            if (lids.length > 0 && lids.length == this.RowSize * this.ColSize) {
                var getValuesByLidsMethod = DynamicNodeFactory.getMethod(DynamicNodeFactory.GetValuesByLidsMethod);
                if (getValuesByLidsMethod == null) {
                    resultData = this.getArrayData(fKey, dataLink, newValue, length, getCode);
                    return new AbstractData(resultData, FMR.ConstDataTypes.Object_Array, false);
                }
                var valueCache = getValuesByLidsMethod(lids, dataLink, newValue, getCode);
                for (row = 0; row < this.RowSize; row++) {
                    rowData = new Array(this.ColSize);
                    for (col = 0; col < this.ColSize; col++) {
                        index = row * this.ColSize + col;
                        if (index < length) {
                            cellNode = this.ChildNodes[index];
                            dataLinkId = cellNode.GetDataLinkId();
                            if (dataLinkId) {
                                var cellValue = valueCache[dataLinkId];
                                rowData[col] = new AbstractData(cellValue, cellNode.FieldDataNode.FieldDataType, cellValue == null || cellValue == "");
                            }
                        }
                    }
                    resultData[row] = rowData;
                }
            } else if (lids.length > 0) {
                resultData = this.getArrayData(fKey, dataLink, newValue, length, getCode);
            }
        }
        return new AbstractData(resultData, FMR.ConstDataTypes.Object_Array, false);
    }
    return new AbstractData(null, FMR.ConstDataTypes.Object_Array, true);
};
RegionNode.prototype.getResultType = function () {
    return FMR.ConstDataTypes.Object_Array;
};
RegionNode.prototype.getShowString = function (fKey) {
    var regionString = "";
    var length = this.CellNodes.length;
    for (var index = 0; index < length; index++) {
        var cellNode = this.CellNodes[index];
        if (index > 0) {
            regionString += ":";
        }

        if (index === length - 1) {
            regionString += cellNode.getShowString(fKey, false, true);
        } else {
            regionString += cellNode.getShowString(fKey, false, false);
        }
    }
    return regionString;
};
RegionNode.prototype.getArrayData = function (fKey, dataLink, newValue, length, getCode) {
    var resultData = new Array(this.RowSize);
    for (var row = 0; row < this.RowSize; row++) {
        var rowData = new Array(this.ColSize);
        for (var col = 0; col < this.ColSize; col++) {
            var index = row * this.ColSize + col;
            if (index < length) {
                var cellNode = this.ChildNodes[index];
                rowData[col] = cellNode.getResult(fKey, dataLink, newValue, false, getCode);
            }
        }
        resultData[row] = rowData;
    }
    return resultData;
}
//#endregion
