$.Class("ItemList", MvcModel, {
	construct: function() {
		this._super().construct.call(this);
	},
	
	Context: {
		ID: 0,
		Name: null,
		MultiSelect: false
    },    

	onEntry: function() {
		this._super().onEntry.call(this);
		
		var self = this;
		document.addEventListener(mui.readyEvt_Jcp, function(){
			// 非App模式下未支持预加载窗口，因此在每次加载时进行初始化
			if(!mui.os.plus){
				self.Context.ID = mui.currentWebview.id;
				self.Context.Name = mui.currentWebview.name;
				self.Context.MultiSelect = mui.currentWebview.multiSelect.toLowerCase() === 'true';
				
				if (self.Context.MultiSelect) {
					$('#itemlist_done').show();
				} else {
					$('#itemlist_done').hide();
				}
				
				self._opener = mui.currentWebview.opener;
				$(".mui-title").text(mui.currentWebview.name);
				self._createList(mui.currentWebview.items, mui.currentWebview.selected);
			}			
		});				
		
		document.addEventListener('onShowItemList', function(event) {
			self.Context.ID = event.detail.id;
			self.Context.Name = event.detail.name;
			self.Context.MultiSelect = event.detail.multiSelect.toLowerCase() === 'true';
			
			if (self.Context.MultiSelect) {
				$('#itemlist_done').show();
			} else {
				$('#itemlist_done').hide();
			}
			
			self._opener = event.detail.opener;
			$(".mui-title").text(event.detail.name);
			self._createList(event.detail.items, event.detail.selected);
		});
		
		function hideItemList() {
			var opener = mui.getWebviewById(self._opener);
			mui.fire(opener, "onHideItemList", {});
		};
		
		if(mui.os.plus){ // 普通浏览器中滑动方向稍微有点倾斜就会触发该事件，调整为只在app中处理
			window.addEventListener("swiperight", hideItemList); 
		}		 
		document.getElementById("itemlist_back").addEventListener('tap', hideItemList);
		
		mui('.mui-bar').on("tap", '#itemlist_done', function() {
			self._onItemSelect();
		});
		
		self._bindEvent();
	},
	
	_bindEvent: function() {
		var self = this;
		mui('.mui-content').on("tap", 'li', function(event) {
			var selected = $('.mui-icon', this).hasClass('item-selected');
			if (self.Context.MultiSelect) {
				$('.mui-icon', this).toggleClass('item-selected');
			} else {
				$('.mui-content .item .mui-icon.item-selected').each(function() {
					$(this).removeClass('item-selected');
				});
				
				$('.mui-icon', this).toggleClass('item-selected');
				self._onItemSelect();
			}
		});
	},
	
	_createList: function(items, selected) {
		if (!items || !items.length) return;
		
		var listStr = '';
		for (var i = 0, len = items.length; i < len; i++) {
			var item = items[i];
			var isSelected = $.inArray(item.Code, selected) >= 0;
			var itemStr = this._generateItemStr(item, isSelected);
			if (!itemStr) continue;
			listStr += itemStr;
		}
		
		$("#itemlist_content").empty().append('<ul class="mui-table-view">' + listStr + '</ul>');
	},
	
	_generateItemStr: function(item, isSelected) {
		if (!item) return null;
		var itemStyle = isSelected ? " item-selected" : '';
		var itemStr = ['<li id="' + item.Code + '" class="mui-table-view-cell item">', '<div class="title"><span>' + item.Title + '</span></div><div class="icon"><span class="mui-icon' + itemStyle + '"></span></div>', '</li>'];
		return itemStr.join("");
	},
	
	_onItemSelect: function() {
		this._getSelectedItems();
		
		var self = this, opener = mui.getWebviewById(self._opener);
		mui.fire(opener, 'onItemSelect', {
		  	id: self.Context.ID,
		  	codes: self._codes,
		  	titles: self._titles
		});
	},
	
	_getSelectedItems: function() {
		var items = $(".mui-content .item .mui-icon.item-selected");
		if (!items) return;
		
		var codeStr = '', titleStr = '';
		items.each(function() {
			var parent = $(this).parent(); 
			var code = parent.parent().attr('id');
			codeStr += (codeStr.length > 0 ? ';' : '') + code;
			var title = $('span', $(this).parent().prev()).text();
			titleStr += (titleStr.length > 0 ? ';' : '') + title;
		});
		
		this._codes = codeStr;
		this._titles = titleStr;
	},

    onDestroy: function() {
        this._super().onDestroy.call(this);
    }
});