$.fn.reverse = [].reverse;
(function($){
	$.widget('jcpmobile.fabmenu', {
		_touchX:{},
		_touchY:{},
        _timeStamp: 0,
        _touchCount: 0,
        _touchPos: { x: 0, y: 0 },
        dragFlag: false,
        _actionBtn: $(".fixed-action-btn"),
        _container: $(".fixed-action-btn").parent(),
        _containerSize: { "width": $(".fixed-action-btn").parent().width() || window.innerWidth, "height": $(".fixed-action-btn").parent().height() || window.innerHeight },
        _containerOffset:$(".fixed-action-btn").parent().offset(),
        _actionBtnOffset:{},               
		options:{
			"Tabmenu": {
				"id":"fab-menu",
				"size":"btn-large",
				"img":"fab-icon-fixed",
				"bgdcolor":"blue",
				"dragFlag":true,
			}
		},
        
        _init: function(){
        	this._doInit();
        },
		
        _create : function() {
            this._createDomHtml();           
            this.initFab();
        },

        _createDomHtml: function(){
			//构造插件html
			var tabmenuHtml = $('<a class="btn-floating ' + this.options.Tabmenu.size + ' ' + this.options.Tabmenu.bgdcolor
							+ '"><span class="fab-icon fab-icon-fixed"></span></a>');
			this.element.append(tabmenuHtml);
			if(this.options.SubTabItems)
			{
				var subtabimgHtml = $('<ul class="btn-list top left"></ul>');
				var imghtml = "";
				if(this.options.SubTabItems.controls) {
					$.each(this.options.SubTabItems.controls,function(index,val) {
						imghtml += '<li id="' + val.id + '"><span class="btn-title '+ val.style + '">'+ val.title +'</span><a class="btn-floating ' + val.color + '"><span class="fab-icon ' + val.img + ' ' + val.style + '"></span></a></li>';
					});
				}
				subtabimgHtml.html(imghtml);
				this.element.append(subtabimgHtml);
			}
        },
		
        _doInit: function(){
            var me = this;
			//初始化参数
			if(this.options.Tabmenu) {
				me.dragFlag = this.options.Tabmenu.dragFlag;
			};
/*			if(this.options.SubTabItems) {
				var items = this.options.Tabmenu;
			}*/
			this._setPosition(this._containerSize.height + this._containerOffset.top - 5 - this._actionBtn.height(), this._containerSize.width + this._containerOffset.left - 5 - this._actionBtn.width());	        
	        this.initFab();
	        this._eventBind();
	        this._actionBtn.show();
        },
        
        _isClick: function (lastTouchEvent, firstTimeStamp, firstPos, touchCount) {
		    if (touchCount != 1) {
		        return false;
		    }
	
		    var tapMaxTime = 250,
	            tapMaxDistance = 5,
	            deltaTime = lastTouchEvent.timeStamp - firstTimeStamp,
	            lastTouch = lastTouchEvent.originalEvent.changedTouches[0],
	            deltaX = lastTouch.pageX - firstPos.x,
	            deltaY = lastTouch.pageY - firstPos.y,
		        distance = Math.sqrt(deltaX * deltaX + deltaY * deltaY);
	
		    if (deltaTime < tapMaxTime && distance < tapMaxDistance) {
		        return true;
		    }
		    return false;
		},
		
		initMovingRegion: function (x, y, width, height) {
		    if (arguments.length < 4) {
		        throw Error("参数错误！");
		    }
	
		    this._containerSize = { "width": width || window.innerWidth, "height": height || window.innerHeight }
		    this._containerOffset = {"top": y, "left": x};
		    this._setPosition(this._containerSize.height + this._containerOffset.top - 5 - this._actionBtn.height(), this._containerSize.width + this._containerOffset.left - 5 - this._actionBtn.width());
		},	
		
		_setPosition: function (top, left){
		    this._actionBtn.css({ "top": top, "left":  left});
		},
		
		setInitPosition: function(top,left){
			this._setPosition(top,left);
		},
		
		setState: function(id, visible, usable) {
			var elem = this.element.find(id);
			if(elem) {
				if(!visible) {
					$("#" + id).hide();
				}else {
					$("#" + id).show();
				}
			}
			return;
		},
		initFab: function(){
	    	this._actionBtn.velocity("stop").velocity({ opacity: "1" }, { duration: 0 }).velocity({ opacity: ".3" }, { duration: 3000, delay: 2000 });
		},
		
		destroy: function() {
            $.FabMenaItems = {};
            this._opsTabItems = {};
            $.Widget.prototype.destroy.apply(this, arguments);
		},
		
		_eventBind: function () {
	        var self = this, mask;
			$(document).on('tap', '.fixed-action-btn',function(){
				if(self.options.Tabmenu.onClick)
				{
					if(self.options.SubTabItems) {
						var $this = $(this);
			            if ($this.hasClass('active') === false) {
		                	mui('.mui-popover.mui-active').popover('toggle');
		                	mask = mui.createMask();
		                	mask.show();
			                self._openFABMenu($this);	            
			            } else {
			                mask.close();
			                //关闭函数
			                if(self.options.SubTabItems.onClose) {
			                	self.options.SubTabItems.onClose();
			                }
			                self._closeFABMenu($this);
			            }
					} else {
						self.options.Tabmenu.onClick();
					}
				} 
				if(!self.options.SubTabItems) {
					//没有子菜单，则需要按钮颜色渐变
					self.initFab();
				}				
			});
			$(document).on('tap', '.fixed-action-btn li', function (e) {
				var me = $(this);
				if(self.options.SubTabItems.onClick){					
					self.options.SubTabItems.onClick(e, me);
				}
			});
	        $(".fixed-action-btn .btn-large").on('touchstart', function (e) {
	            var event = e.originalEvent,
	                touchs = event.touches[0];
	            self._touchX = touchs.clientX;
	            self._touchY = touchs.clientY;
	            if(self.options.Tabmenu.dragFlag) {
	            	//根据传入参数判断是否允许拖拽
	            	self.dragFlag = true;
	            }	            
	            self._timeStamp = e.timeStamp;
	            self._touchPos = { x: touchs.pageX, y: touchs.pageY };
	            self._actionBtnOffset = { "top": parseInt(self._actionBtn.css("top")), "left": parseInt(self._actionBtn.css("left")) };
	            self._touchCount = event.touches.length;
	            self._actionBtn.velocity("stop").velocity({ opacity: "1" }, { duration: 0 });
	        }).on('touchmove', function (e) {
	            if (self.dragFlag) {
	                e.preventDefault();
	                var event = e.originalEvent,
	                    touchs = event.touches[0],
	                    deltaX = self._touchX - touchs.clientX,
	                    deltaY = self._touchY - touchs.clientY,
	                    $this = $('.fixed-action-btn'),
	                    top = self._actionBtnOffset.top - deltaY,
	                    left = self._actionBtnOffset.left - deltaX;
	
	                if ($this.hasClass('active') === true) {
	                    self._closeFABMenu($this);
	                    mask.close();
	                }
	                self._setPosition(Math.min(self._containerSize.height + self._containerOffset.top - 5 - $this.height(), Math.max(self._containerOffset.top + 5, top)), Math.min(self._containerSize.width + self._containerOffset.left - 5 - $this.width(), Math.max(5, left)));
	            }
	        }).on('touchend', function (e) {
	            if(self.options.Tabmenu.dragFlag) {
	            	//根据传入参数判断是否允许拖拽
	            	self.dragFlag = false;
	            }
	            if (!self._actionBtn.hasClass("active") && !self._isClick(e, self._timeStamp, self._touchPos, self._touchCount)) {
	                e.stopPropagation();
	                self.initFab();
	            }
	        });
	        mui('body').on("tap", '.mui-backdrop', function () {
	            if (self._actionBtn.hasClass('active') === true) {
//	                self._closeInviteWindow();
					//关闭函数
					if(self.options.SubTabItems.onClose) {
			            self.options.SubTabItems.onClose();
			        }
	                self._closeFABMenu(self._actionBtn);
	            }
       		});
        },
	    
	    _openFABMenu: function (btn) {
		    var fabIcon = btn.find('.fab-icon-fixed');
		    fabIcon.velocity("stop");
		    $this = btn.addClass('active').velocity("stop").velocity({ opacity: "1" }, { duration: 0 });
			var time = 4, btnArr = $this.find('ul .btn-floating'), topFlag = true;
	
			var showList = function (target) {
			    target.velocity({
			        opacity: "1",
			        scaleX: "1",
			        scaleY: "1",
			        translateY: "0"
			    }, {
			        duration: 4,
			        delay: time
			    });
			    time += 5;
			};
			
			var top = parseInt($this.css("top")),
	            left = parseInt($this.css("left")),
			    boundLineX = this._containerSize.width / 2,
	            boundLineY = this._containerSize.height / 2,
			    btnList = $this.find('.btn-list');
			if (top >= boundLineY) {
			    btnList.removeClass("bottom").addClass("top");
			    topFlag = true;
			}else {
			    btnList.removeClass("top").addClass("bottom");
			    topFlag = false;
			}
			if (left >= boundLineX) {
				btnList.removeClass("right").addClass("left");
			} else {
				btnList.removeClass("left").addClass("right");
			}
	
			if (topFlag) {
			    btnArr.reverse().each(function () {
			        showList($(this))
			    });
			} else {
			    btnArr.each(function () {
			        showList($(this))
			    });
			}
			$this.find('ul').show();
		},

		_closeFABMenu: function (btn) {
		    var time = 0;
			$this = btn;
			$this.removeClass('active');
			$this.find('ul .btn-floating').velocity("stop", true);
			$this.find('ul').hide();
	
			this.initFab();
		},
	});
}(jQuery))
