MSG_Common_AfterDataSave = 'msg_common_afterdatasave';
MSG_PeriodSelector_AfterSelect = 'msg_periodselector_afterselect';
MSG_FilledPeriods_AfterUpdate = 'msg_filledperiods_afterupdate';

window.MyPopPicker = mui.PopPicker.extend({
	hide: function(){ // 重写hide方法，否则界面上会有好多对象未释放
		this._super();
		var self = this;
		setTimeout(function() {
			if(self.panel && self.panel.parentNode){
				self.panel.parentNode.removeChild(self.panel);
			}				
			for (var name in self) {
				self[name] = null;
				delete self[name];
			};
			self.disposed = true;
		}, 300);
	}
});

$.Class("PeriodSelector", MvcBase, {
    construct: function() {
        this._super().construct.call(this);
        window.addListener(MSG_FilledPeriods_AfterUpdate, this.afterUpdateFilled, this);
        window.addListener(MSG_Common_AfterDataSave, this.afterDataSave, this);
    },

    _temPeriodDate: null,
    _billFormFlag: false,
    _currentDom: null,
    _currentPeriod: {
        code: null,
        title: null
    },
    _shareToken: null,
    _periodType: null,
    /*_periodCount
     *APP端有时期列表的标志
     *创建人对应所有的时期列表数量
     *被邀请人对应被邀请的时期列表数量
     *被共享人对应被共享的时期列表数量
     */
    _periodCount: 0,

    _allPeriods: [], //当前用户可见范围内已经被生成的时期对象列表（等价于PC端_periodList）
    _sharedPeriods: [], //被共享时期对象列表
    _timeSegments: [],//当前用户可见范围时间段（被邀请人）
    _entityFilledPeriods: [],//当前选中实体已填报时期标识列表(权限范围内列表)
    _switchPeriods: {
        show: false,
        up: null,
        down: null,
        canUp: false,
        canDown: false
    },
    _markedFilledPeriod_Up: null,
    _markedFilledPeriod_Down: null,
    _hasLoadedPeriods: false,
    _isTaskOwner: false,
    _isOnlyShared: false,
    _selectedEntityExtInfo: null,

    onInit: function(context, status, dom, flag, isTempPeriod) {
        if (!context || context.IsAnonymous || !dom)
            return;

        this._isTaskOwner = status.IsTaskOwner;
        this._currentDom = dom;
        this._billFormFlag = flag;

        this._periodType = context.PeriodType;
        this._periodCount = context.PeriodCount;
        this._selectedEntityExtInfo = context.SelectedEntityExtInfo;
        this._shareToken = context.ShareToken;

        this.onReset(context.Period, context.PeriodTitle, isTempPeriod);

        var self = this;
        self._getPeriodList(function() {
            self._allPeriods = context.AllPeriods;
            self._sharedPeriods = context.SharedPeriods;
            self._timeSegments = context.TimeSegments;
            self._entityFilledPeriods = context.EntityFilledPeriods;

            if (!self._isTaskOwner && (!self._timeSegments || self._timeSegments.length == 0)) {
                self._isOnlyShared = true;
            }else{
            	self._isOnlyShared = false;
            }
            var hasDropDown = self._periodType != "8" || (self._periodType == "8" && self._periodCount > 1);
            if(self._isOnlyShared){
            	hasDropDown = self._sharedPeriods && self._sharedPeriods.length > 1;
            }
            if (hasDropDown) {
//              if (!self._billFormFlag) {
//                  $('#period_current img').show();
//              }
                $('#period_current img').show();
                self._currentDom.off("tap").on("tap", function() {
                    self._bindDomClickEvent();
                });
            }
            if (self._currentDom.css('display') === 'none') self._currentDom.show();

//          if (self._billFormFlag) {
//              self._initInBill();
//          }

            self._updateSwitchPeriods();
        });
    },

    onReset: function(periodCode, periodTitle, isTempPeriod) {
        if (!periodCode || !periodTitle)
            return;

        this._currentPeriod = { code: periodCode, title: periodTitle };
//      if (this._billFormFlag) {
//          this._currentDom && this._currentDom.attr('tagCode', periodCode).attr('tagTitle', periodTitle).text(periodTitle);
//      } else {
//          this._currentDom && this._currentDom.attr('tagCode', periodCode).attr('tagTitle', periodTitle);
//      }
        this._currentDom && this._currentDom.attr('tagCode', periodCode).attr('tagTitle', periodTitle);
        
        if (isTempPeriod) {
            this._temPeriodDate = this._getFullDateStrByPeriodTitle(periodTitle);
        } else {
            this._temPeriodDate = null;
        }
    },
    
    /*
     *上期按钮点击时期
     */
    onSwitchUpPeriod: function () {
        this._switchMarkedFilledPeriod(this._switchPeriods.up);
    },
    
    /*
     *下期按钮点击时期
     */
    onSwitchDownPeriod: function () {
        if (!this._switchPeriods.down) {
        	if (this._periodType == "8")
            	return;
             
        	var oldStr = this._getDateStrByPeriodTitle(this._periodType, this._currentPeriod.title);
        	var old = this._plusDateByDateStr(oldStr);
        	var titleMapStr = this._getDateStrByDate(this._periodType, old);
        	var fullDateStr = this._getFullDateStrByDate(old);
        	this._beforeSelectPeriod(titleMapStr, fullDateStr);
        } else {
            this._switchMarkedFilledPeriod(this._switchPeriods.down);
        }
    },

    getSwitchPeriods: function () {
        return this._switchPeriods;
    },
    
    isTempPeriod: function () {
        return !!this._temPeriodDate;
    },

    _bindDomClickEvent: function () {
        var self = this;
        switch (self._periodType) {
            case "1"://years
                self._loadDatePeriod('year');
                break;
            case "4"://months
                self._loadDatePeriod('month');
                break;
            case "6"://days
                self._loadDatePeriod('date');
                break;
            case "3"://seasons
            case "7"://weeks
            case "8"://custom
                self._loadCustomPeriod();
                break;
            default:
                break;
        }
    },

    _loadDatePeriod: function (type) {
        type = type || 'date';       
        var self = this;
        
        //仅存在被共享的时期列表
        if(self._isOnlyShared){
        	var sharedPicker = new window.MyPopPicker();
        	var tempArr = [];
        	$.each(self._sharedPeriods, function() {
        		tempArr.push({value: this.Code, text: this.Title});
        	});
        	sharedPicker.setData(tempArr);	
        	sharedPicker.pickers[0].setSelectedValue(this._currentPeriod.code)
			sharedPicker.show(function(items) {
				self._selectPeriod(items[0].value, items[0].text);
				sharedPicker.dispose();
			});
        	return;
        }
      
        var initValue = self._getDateStrByPeriodTitle(self._periodType, self._currentPeriod.title);
        var beginYear = 1900;
        if (!self._isTaskOwner) {
            var minBeginDate = self._findMinBeginDate();
            beginYear = minBeginDate.getFullYear();
        }
        var options = '{"type": "' + type + '", "value": "' + initValue + '", "beginYear": "' + beginYear + '", "endYear": "2099"}';
        var optionsJson = JSON.parse(options);
        var dtPicker = new window.MyDtPicker(optionsJson);
        dtPicker.show(function (rs) {
            var fullDateStr = self._getFullDateStrByDtPicker(rs), dateStr = rs.text;
            var curDate = new Date(fullDateStr);
            var isAuthorized = self._isTaskOwner || self._checkDateEnable(curDate);
            
            if(!isAuthorized){
            	mui.toast("当前小伙伴不能填写这一期的数据。");
            	dtPicker.dispose();
            	return;
            }
       
            if(!self._hasEntityVerOfDate(curDate)){
            	var message = '当前小伙伴在这一期不存在，系统将为您选择新小伙伴，是否继续？';
                mui.confirm(message, '操作提示', ["是", "否"], function (e) {
                    if (e.index === 0) {
                        self._beforeSelectPeriod(dateStr, fullDateStr);
                        dtPicker.dispose();
                    } 
                });
                return;
            }
      
            self._beforeSelectPeriod(dateStr, fullDateStr);
            dtPicker.dispose();
           
        });
    },

    _loadCustomPeriod: function () {
        this._loadList();
        mui('#period_list').popover('toggle');//要在请求之后再去展开，此处要更改
    },

    _loadList: function () {
        if (this._hasLoadedPeriods) return;
        
        var self = this;
        mui.showWaiting('时期加载中……');

        var buildItems = function (periodList) {
            var htmlStr = '';
            for (var i = 0, len = periodList.length; i < len; i++) {
                var item = "<li id='" + periodList[i].Code + "' title='" + periodList[i].Title + "' class='mui-table-view-cell'><a href='#'>" + periodList[i].Title + "</a></li>";
                htmlStr += item;
            }

//          if (self._billFormFlag) {
//              var tempLeft = self._currentDom.offset().left + "px";
//              $("#period_list").css("left", tempLeft);
//          }
            $("#period_list ul").append(htmlStr);
            self._setFilledOfCustom();

            mui("#period_list").off('tap', 'li');
            mui("#period_list").on('tap', 'li', function () {
            	var code = this.id, title = this.title;
            	if(!self._checkCustomEnable(code)){
            		mui.toast("当前小伙伴不能填写这一期的数据。");
            		mui('#period_list').popover('toggle');
            		return;
            	}

            	if(!self._hasEntityVerOfCustom(code)){
            		var message = '当前小伙伴在这一期不存在，系统将为您选择新小伙伴，是否继续？';
                	mui.confirm(message, '操作提示', ["是", "否"], function (e) {
                    	if (e.index === 0) {
                        	self._selectPeriod(code, title);
                        	mui('#period_list').popover('toggle');
                    	} 
                	});
                	return;
            	}

            	self._selectPeriod(code, title);	
                mui('#period_list').popover('toggle');
            });
            
            self._hasLoadedPeriods = true;
            mui.closeWaiting();
        };

        if (self._allPeriods && self._allPeriods.length > 0) {
            buildItems(self._allPeriods);
            return;
        }
    },

    /*
     *数据保存后执行的操作
     */
	afterDataSave: function (sender, msg) {
	    var self = this;
	    if (self._periodType !== '8') {
	        if (!self._temPeriodDate) {
	            this.refreshMarkedFilled();
	            return;
	        }

	        var date = self._temPeriodDate;
	        self._onAddPeriod(self._periodType, '', date, function (newPeriod) {
	            if (!newPeriod)
	                return;
	            self._temPeriodDate = null;
	            self._updateSwitchPeriods();   
	        });
	    } else {
	    	this.refreshMarkedFilled();
	    }
	},  

    /*上期、上期
     *1、修改状态变化及切换时对应的参数
     *2、发送消息，更改上下期按钮状态
     */
	_updateSwitchPeriods: function () {
	    this._switchPeriods.show = false;
	    this._switchPeriods.up = null;
	    this._switchPeriods.down = null;
	    this._switchPeriods.canUp = false;
	    this._switchPeriods.canDown = false;

	    if (this._periodType == "8") {
	        this._updateSwitchPeriodsOfCustom();
	    }else{
	    	this._updateSwitchPeriodsOfDate();
	    }
	    window.sendMessage(MSG_FilledPeriods_AfterUpdate, null, this);
	},
    
	_updateSwitchPeriodsOfDate: function () {
	    if (!this._currentPeriod.code)
	        return;

	    var currentPeriod = this._currentPeriod.code;
	    var entityFilledPeriods = this._entityFilledPeriods;

	    this._switchPeriods.show = true;

	    //时期列表中没有被标记填报的时期
	    //无上期，当前时期有数据后才有下期 
	    if (!entityFilledPeriods || entityFilledPeriods.length <= 0) {
	        return;
	    }

	    //存在被标记的时期
	    var listIndex = entityFilledPeriods.indexOf(currentPeriod);
	    //当前时期属于未填报的时期
	    if (listIndex === -1) {
	        //判断当前时期是否可插入已标志填报的时期列表
	        //temp=-1， 则当前时期位于已标志填报时期列表的后面（比已标志的时期大）
	        //temp>=0，temp为当前时期的下期,temp-1为当前时期的上期
	        var temp = -1;
	        for (var i = 0; i < entityFilledPeriods.length; i++) {
	            if (currentPeriod < entityFilledPeriods[i]) {
	                temp = i;
	                break;
	            }
	        }
	        if (temp === -1) {//有上期
	            this._switchPeriods.canUp = true;
	            this._switchPeriods.up = entityFilledPeriods[entityFilledPeriods.length - 1];
	        } else if (temp - 1 >= 0 && temp - 1 <= entityFilledPeriods.length - 1) { //有上期
	            this._switchPeriods.canUp = true;
	            this._switchPeriods.up = entityFilledPeriods[temp - 1];
	        }

	        if (temp === -1) {
	        } else {
	            if (temp >= 0 && temp <= entityFilledPeriods.length - 1) { //有下期
	                this._switchPeriods.canDown = true;
	                this._switchPeriods.down = entityFilledPeriods[temp];
	            } else { //有下期
	            	if(!this._shareToken){
	            	    this._switchPeriods.canDown = true;
	                	this._switchPeriods.down = null;
	            	}
	            }
	        }
	    } else {
	        //listIndex为当前期，listIndex-1为上期，listIndex+1为下期
	        if (listIndex !== 0) {  //有下期
	            this._switchPeriods.canUp = true;
	            this._switchPeriods.up = entityFilledPeriods[listIndex - 1];
	        }
	        if (listIndex >= 0 && listIndex < entityFilledPeriods.length - 1) { //有下期（已填报时期列表中）
	            this._switchPeriods.canDown = true;
	            this._switchPeriods.down = entityFilledPeriods[listIndex + 1];
	        } else {
	        	if(!this._shareToken){
	        	    this._switchPeriods.canDown = true;
	                this._switchPeriods.down = null;
	        	}
	        }
	    }

	    return;
	},

	_updateSwitchPeriodsOfCustom: function () {
	    var currentPeriod = this._currentPeriod.code;
	    var entityFilledPeriods = this._entityFilledPeriods;
	    var allPeriods = this._allPeriods;

	    if (!currentPeriod || !allPeriods || allPeriods.length <= 1) {
	        return;
	    }

        this._switchPeriods.show = true;
        
	    //时期列表中没有被标记填报的时期
	    if (!entityFilledPeriods || entityFilledPeriods.length <= 0) {
	        var tempOrginalIndex = this._findOriginalIndex(currentPeriod, allPeriods);//可能向下, 但一定不能向上
	        if (tempOrginalIndex + 1 <= allPeriods.length - 1) {
	            this._switchPeriods.canDown = true;
	            this._switchPeriods.down = allPeriods[tempOrginalIndex + 1];
	        }
	        return;
	    }

	    //存在被标记的时期
	    var listIndex = entityFilledPeriods.indexOf(currentPeriod);
	    //当前时期属于未填报的时期
	    if (listIndex === -1) {
	        //判断当前时期是否可插入已标志填报的时期列表
	        //temp=-1， 则当前时期位于已标志填报时期列表的后面（比已标志的时期大）
	        //temp>=0，temp为当前时期的下期,temp-1为当前时期的上期
	        var temp = -1;
	        for (var i = 0; i < entityFilledPeriods.length; i++) {
	            if (currentPeriod < entityFilledPeriods[i]) {
	                temp = i;
	                break;
	            }
	        }
	        if (temp === -1) {//有上期
	            this._switchPeriods.canUp = true;
	            this._switchPeriods.up = entityFilledPeriods[entityFilledPeriods.length - 1];
	        } else if (temp - 1 >= 0 && temp - 1 <= entityFilledPeriods.length - 1) { //有上期
	            this._switchPeriods.canUp = true;
	            this._switchPeriods.up = entityFilledPeriods[temp - 1];
	        }

	        if (temp === -1) {
	        } else {
	            if (temp >= 0 && temp <= entityFilledPeriods.length - 1) { //有下期
	                this._switchPeriods.canDown = true;
	                this._switchPeriods.down = entityFilledPeriods[temp];
	            } else { //有下期
	                var originalIndex1 = this._findOriginalIndex(entityFilledPeriods[entityFilledPeriods.length - 1], allPeriods);
	                if (originalIndex1 < allPeriods.length - 1) {
	                    this._switchPeriods.canDown = true;
	                    this._switchPeriods.down = allPeriods[originalIndex1 + 1].Code;
	                }
	            }
	        }
	    } else {
	        //listIndex为当前期，listIndex-1为上期，listIndex+1为下期
	        if (listIndex !== 0) {  //有下期
	            this._switchPeriods.canUp = true;
	            this._switchPeriods.up = entityFilledPeriods[listIndex - 1];
	        }
	        if (listIndex >= 0 && listIndex < entityFilledPeriods.length - 1) { //有下期
	            this._switchPeriods.canDown = true;
	            this._switchPeriods.down = entityFilledPeriods[listIndex + 1];
	        } else {
	            var originalIndex2 = this._findOriginalIndex(entityFilledPeriods[entityFilledPeriods.length - 1], allPeriods);
	            if ((originalIndex2 < allPeriods.length - 1)) { //有下期
	                this._switchPeriods.canDown = true;
	                this._switchPeriods.down = allPeriods[originalIndex2 + 1].Code;
	            }
	        }
	    }

	},

    //完全适用于自定义类型
    //1、被标记填报时期列表中获取最后一个元素；
    //2、获取最后一个元素在原所有时期列表中的索引；
    //3、判断索引值与原所有时期列表长度的关系
	_findOriginalIndex: function (periodCode, allPeriods) {
	    var tempIndex = -1;
	    $.each(allPeriods, function () {
	        ++tempIndex;
	        if (this.Code === periodCode) {
	            return false;
	        }
	    });
	    return tempIndex;
	},
    
    /*BillForm模型
     *初始化
     */
	_initInBill: function () {
	    var self = this;
	    if (self._periodType == "8" && self._periodCount <= 1) return;

	    $("#period-leftswitch-btn").off("tap").on("tap", function (e) {
	        if ($(this).attr("disabled")) {
	            e.preventDefault();
	            return;
	        }
	        self.onSwitchUpPeriod();
	        e.preventDefault();
	    });

	    $("#period-rightswitch-btn").off("tap").on("tap", function (e) {
	        if ($(this).attr("disabled")) {
	            e.preventDefault();
	            return;
	        }
	        self.onSwitchDownPeriod();
	        e.preventDefault();
	    });

	},

    /*BillForm模型
     *接收消息，修改上期下期按钮状态
     */
	afterUpdateFilled: function () {
	    if (this._periodType == "8") {
	        this._setFilledOfCustom();
	    }
	 
	    if (!this._billFormFlag) {
	        return;
	    }

	    this._setBtnState("period-leftswitch-btn", this._switchPeriods.show, this._switchPeriods.canUp);
	    this._setBtnState("period-rightswitch-btn", this._switchPeriods.show, this._switchPeriods.canDown);
	    this._markedFilledPeriod_Up = this._switchPeriods.up;
	    this._markedFilledPeriod_Down = this._switchPeriods.down;
	},
         
    /*BillForm模型
     *设置上期、下期按钮状态
     */
	_setBtnState: function (id, isShow, isEnable) {
	    var btnObj = $("#" + id);
	    if (!btnObj) return;

	    if (isShow) {
	        btnObj.show();
	    } else {
	        btnObj.hide();
	    }

	    if (isEnable) {
	        btnObj.removeAttr("disabled");
	    }
	    else {
	        btnObj.attr("disabled", "disabled");
	    }
	},
    
	_setFilledOfCustom: function () {
	    var perildList = $("#period_list li");
	    if (!perildList || perildList.length <= 0)
	        return;
	    var self = this;
	    $.each(perildList, function () {
	        var $this = $(this);
	        var code = $this.attr("id");
	        if ($.inArray(code, self._entityFilledPeriods) >= 0) {
	            $this.addClass("gg-markedfilled-period");
	        } else {
	            $this.removeClass("gg-markedfilled-period");
	        }
	    });
	},
    
	_selectPeriod: function (periodCode, periodTitle) {
	    if (!periodCode || !periodTitle) return;
	    if (periodCode === this._currentPeriod.code) return;
	    
	    
	    //this._currentPeriod = { code: periodCode, title: periodTitle };
	    //if (this._billFormFlag) {
	    //    this._currentDom.attr('tagCode', periodCode).attr('tagTitle', periodTitle).text(periodTitle);
	    //} else {
	    //    this._currentDom.attr('tagCode', periodCode).attr('tagTitle', periodTitle);
	    //}

	    var isTempPeriod = this.isTempPeriod();
	    window.sendMessage(MSG_PeriodSelector_AfterSelect, { code: periodCode, title: periodTitle, isTemp: isTempPeriod });
	},

	_beforeSelectPeriod: function (titleMapStr, fullDateStr) {
	    if (!titleMapStr || !fullDateStr)
	        return;
	    var self = this;
	    var cacheIndex = self._findCacheOfPeriods(titleMapStr, self._allPeriods);
	    if (cacheIndex !== -1) {
	        self._temPeriodDate = null;
	        var code = self._allPeriods[cacheIndex].Code;
	        var title = self._allPeriods[cacheIndex].Title;
	        self._selectPeriod(code, title);
	    } else {
	        self._dateToPeriod(fullDateStr, function (tempPeriod) {
	            self._temPeriodDate = fullDateStr;
	            self._selectPeriod(tempPeriod.Code, tempPeriod.Title);
	        });
	    }
    },
    
    _findCacheOfSharedPeriods: function (periodCode) {	 
    	var self = this;
	    if (!self._sharedPeriods || self._sharedPeriods.length <= 0 || !periodCode)
	        return -1;
	    
	    var index = -1, temp = -1;
	    $.each(self._sharedPeriods, function () {
	        ++temp;
	        if (this.Code == periodCode) {
	            index = temp;
	            return false;  
	        }
	    });
	    return index;
    },
	
    /*从时期列表中寻找时期
	 *找到则返回对应的元素下标
	 *titleMapStr 和时期标题相匹配的日期字符串（yyyy或yyyy-MM或yyyy-MM-dd）
	 */
	_findCacheOfPeriods: function(titleMapStr, periodList){
		if (!titleMapStr || !periodList || periodList.length <= 0)
	        return -1;
	    var self = this;
	    var index = -1, temp = -1;
	    $.each(periodList, function () {
	        ++temp;
	        if (self._getDateStrByPeriodTitle(self._periodType, this.Title) === titleMapStr) {
	            index = temp;
	            return false;  
	        }
	    });
	    return index;
	},
    
    /*非自定义类型
     *Dtpiker初始化时寻找最小的开始时间
     */
	_findMinBeginDate: function () {
	    var item, beginDate, minDate = null;
	    if (this._timeSegments && this._timeSegments.length > 0) {
	        minDate = new Date(this._timeSegments[0].BeginTime);
	        for (var i = 0; i < this._timeSegments.length; i++) {
	            item = this._timeSegments[i];
	            beginDate = new Date(item.BeginTime);
	            if (beginDate < minDate) {
	                minDate = beginDate;
	            }
	        }
	    }

	    if (this._sharedPeriods && this._sharedPeriods.length > 0) {
	        if (!minDate) {
	            minDate = new Date(this._sharedPeriods[0].BeginTime);
	        }
	        for (var j = 0; j < this._sharedPeriods.length; j++) {
	            item = this._sharedPeriods[j];
	            beginDate = new Date(item.BeginTime);
	            if (beginDate < minDate) {
	                minDate = beginDate;
	            }
	        }
	    }

	    return minDate;
	},
    
    /* 自定义类型
     * 判断用户是否有点击时期的权限
     */
    _checkCustomEnable: function (periodCode) {   
    	return true;
	},
	
	/* 非自定义类型
     * 判断用户是否有点击时期的权限
     * dtpiker中有些日期是不能填写的，但因dtpiker中年、月、日间不能联动，使用此方法暂时解决该问题
     */
	_checkDateEnable: function (curDate) {
		if(!curDate) return false;
	    
        var item, beginDate, endDate;
        for(var i = 0; i < this._timeSegments.length; i++){
        	item = this._timeSegments[i];
            beginDate = new Date(item.BeginTime);
            endDate = new Date(item.EndTime);
            if (new Date(beginDate) <= curDate && curDate <= new Date(endDate)) return true;           
        }
        
        for(var j = 0; j < this._sharedPeriods.length; j++){
        	item = this._sharedPeriods[j];
            beginDate = new Date(item.BeginTime);
            endDate = new Date(item.EndTime);
            if (new Date(beginDate) <= curDate && curDate <= new Date(endDate)) return true;
        }

        return false;
	},
	
	/* 自定义类型
     * 判断某时期下是否有单位版本，即判断切换到某一时期后单位是否发生变化 
     * return true 有单位版本
     */
	_hasEntityVerOfCustom: function(periodCode){
		if (!this._allPeriods ||this._allPeriods.length <= 0 || !periodCode)
		    return false;
	    if (!this._selectedEntityExtInfo)
	        return false;
	   
	    var self = this, flag = false;
	    var beginDate = new Date(self._selectedEntityExtInfo.BeginTime);
	    var endDate = new Date(self._selectedEntityExtInfo.EndTime);
	    
        var curPeriodBegin = null, curPeriodEnd= null;
	    $.each(self._allPeriods, function() {
	    	if(this.Code == self._currentPeriod.code){
	    		curPeriodBegin = this.BeginTime;
	    		curPeriodEnd = this.EndTime;
	    	}
	    });
        $.each(self._allPeriods, function() {
        	if(this.Code == periodCode){
        		if (beginDate <= new Date(this.BeginTime) && new Date(this.EndTime) < endDate) {
        			flag = true;

        			if(!this._isTaskOwner && self._isInSegmentsOfCustom(this.BeginTime, this.EndTime) && !self._isInSegmentsOfCustom(curPeriodBegin, curPeriodEnd)){
				    	flag = false;
					}
						
        		}else{
        			flag = false;
        		}
        		return false;
        	}
        });
        

	    
	    return flag;
	},
	
	/* 非自定义类型
     * 判断某时期下是否有单位版本，即判断切换到某一时期后单位是否发生变化 
     * return true 有单位版本
     */
	_hasEntityVerOfDate: function(curDate){
		if (!curDate) return false;
	    if (!this._selectedEntityExtInfo)
	        return false;

	    var beginDate = new Date(this._selectedEntityExtInfo.BeginTime);
	    var endDate = new Date(this._selectedEntityExtInfo.EndTime);
		if(beginDate <= curDate && curDate < endDate){
			if(!this._isTaskOwner){
				var curPeriodDateStr = this._getFullDateStrByPeriodTitle(this._currentPeriod.title);
				var curPeriodDate = new Date(curPeriodDateStr);
				if(this._isInSegmentsOfDate(curDate) && !this._isInSegmentsOfDate(curPeriodDate)){
					return false;
				}
			}
			
	        return true;
	    }
	    return false;	
	},
	
	_isInSegmentsOfCustom: function(beginTime, endTime){
		if(!beginTime || !endTime) return false;
		var item, beginDate, endDate;
        for(var i = 0; i < this._timeSegments.length; i++){
        	item = this._timeSegments[i];
            beginDate = new Date(item.BeginTime);
            endDate = new Date(item.EndTime);
            if (beginDate <= new Date(beginTime) && new Date(endTime) <= endDate) return true;   
        }
        return false;
	},
	
	_isInSegmentsOfDate: function(curDate){
		if(!curDate) return false;
		var item, beginDate, endDate;
        for(var i = 0; i < this._timeSegments.length; i++){
        	item = this._timeSegments[i];
            beginDate = new Date(item.BeginTime);
            endDate = new Date(item.EndTime);
            if (new Date(beginDate) <= curDate && curDate <= new Date(endDate)) return true;           
        }
        return false;
	},
    /*
     *DtPicker
     *获取日期类型字符串
     *return yyyy-MM-dd 
     */
    _getFullDateStrByDtPicker: function (rs) {
	    if (!rs) return '';

	    if (rs.type == 'date') {
	        return rs.text;
	    }

	    return (rs.y.text + "-"+ rs.m.text + "-" + rs.d.text);
    },
    
    /*
     *PeriodTitle
     *获取日期类型字符串
     *return yyyy-MM-dd
     */
    _getFullDateStrByPeriodTitle: function (title) {
        var dateStr = this._getDateStrByPeriodTitle(this._periodType, title);
        var date = new Date(dateStr);
        var fullDateStr = this._getFullDateStrByDate(date);
        return fullDateStr;
    },

    /*
     *Date
     *获取日期类型字符串
     *return yyyy-MM-dd 
     */
    _getFullDateStrByDate: function (date) {
        if (!date) return '';

        if (this._periodType === "1") {
            return date.getFullYear() + "-01-01";
        }
        if (this._periodType === "4") {
            return (date.getFullYear() + "-" + padStr(date.getMonth() + 1) + "-01");
        }
        return (date.getFullYear() + "-" + padStr(date.getMonth() + 1) + "-" + padStr(date.getDate()));

        function padStr(i) {
            return (i < 10) ? "0" + i : "" + i;
        }
    },
    
    /*
     *PeriodTitle
     *获取日期类型字符串
     *return yyyy或yyyy-MM或yyyy-MM-dd
     */
	_getDateStrByPeriodTitle: function (type, title) {//获取时期类型字符串
	    if (!type || type === '8' || !title) return '';

	    var splitByDash = title.indexOf('-') > 0, year, month, day;
	    if (splitByDash) {
	        var prev = title.indexOf('-'), next = title.indexOf('-', prev + 1);
	        year = title.substr(0, prev);
	        if (type === '1') return year;

	        if (next === -1) next = title.length;
	        month = title.substr(prev + 1, next - prev - 1);
	        month = month.length === 1 ? '0' + month : month;
	        if (type === '4') return year + '-' + month;

	        prev = next, next = title.indexOf('-', next + 1);
	        if (next === -1) next = title.length;

	        day = title.substr(prev + 1, next - prev - 1);
	        day = day.length === 1 ? '0' + day : day;
	        if (type === '6') return year + '-' + month + '-' + day;
	    } else {
	        var yearIndex = title.indexOf('年'), monthIndex = title.indexOf('月'), dayIndex = title.indexOf('日');
	        year = title.substr(0, yearIndex);
	        if (type === '1') return year;

	        month = title.substr(yearIndex + 1, monthIndex - yearIndex - 1);
	        month = month.length === 1 ? '0' + month : month;
	        if (type === '4') return year + '-' + month;

	        day = title.substr(monthIndex + 1, dayIndex - monthIndex - 1);
	        day = day.length === 1 ? '0' + day : day;
	        if (type === '6') return year + '-' + month + '-' + day;
	    }

	    return '';
	},

    /*
     *Date
     *获取日期类型字符串
     *return yyyy或yyyy-MM或yyyy-MM-dd
     */
	_getDateStrByDate: function (type, date) {
	    if (!type || type === '8' || !date) return '';

	    function padStr(i) {
	        return (i < 10) ? "0" + i : "" + i;
	    }

	    var dateStr = '';
	    switch (this._periodType) {
	        case "1"://years
	            dateStr = date.getFullYear();
	            break;
	        case "4"://months
	            dateStr = date.getFullYear() + "-" + padStr(date.getMonth() + 1);
	            break;
	        case "6"://days
	            dateStr = date.getFullYear() + "-" + padStr(date.getMonth() + 1) + "-" + padStr(date.getDate());
	            break;
	        case "8"://custom
	            break;
	        default:
	            break;
	    }
	    return dateStr;
	},
    
	_plusDateByDateStr: function (dateStr) {
	    if (!dateStr)
	        return null;
	    var date = new Date(dateStr);
	    switch (this._periodType) {
	        case "1"://years
	            date.setFullYear(date.getFullYear() + 1);
	            break;
	        case "4"://months
	            date.setMonth(date.getMonth() + 1);
	            break;
	        case "6"://days
	            date.setDate(date.getDate() + 1);
	            break;
	        case "8"://custom
	            break;
	        default:
	            break;
	    }
	    return date;
	},

	_switchMarkedFilledPeriod: function (markedFilledPeriod) {
	    if (!markedFilledPeriod)
	        return;
	    var self = this;
	    var doAction = function () {
	        $.each(self._allPeriods, function () {
	            if (this.Code === markedFilledPeriod) {
	                self._selectPeriod(this.Code, this.Title);
	                self._updateSwitchPeriods();
	                return false;
	            }
	        });
	    };
	    doAction();
	},
    
	_getPageModel: function () {
	    if (this._billFormFlag) {
	        return $.m("BillForm");
	    } else {
	        return $.m("DataInput");
	    }
	},
    
    /*
     * 后台请求
     * 获取各种类型时期列表
     */
	_getPeriodList: function (callback) {
	    var self = this;
	    var pageModel = self._getPageModel();
	    if (!pageModel || pageModel.Context.IsAnonymous)
	        return;
        if(pageModel.Context.AllPeriods && pageModel.Context.AllPeriods.length > 0){
        	callback && callback();
        	return;
        }
        
	    var path = pageModel._getPath($.BaseUrl + 'DataInput/Period/GetPeriodList', true, true);
	    pageModel._action(path, {}, function (data) {
	        if (!data || !data.BoolResult)
	            return;
	        
	        pageModel.Context.AllPeriods = data.PeriodList;
	        pageModel.Context.SharedPeriods = data.SharedPeriods;
	        pageModel.Context.TimeSegments = data.TimeSegments;
	        pageModel.Context.EntityFilledPeriods = data.EntityFilledPeriods;
	           
	        callback && callback();
	    });
	},
    
    /*
     * 后台请求
     * date转换成对应的period
     */
	_dateToPeriod: function (fullDateStr, callback) {
	    var self = this;
	    var pageModel = self._getPageModel();
	    if (!pageModel)
	        return;
	    var path = pageModel._getPath($.BaseUrl + 'DataInput/Period/DateToPeriod');
	    pageModel._action(path, { type: self._periodType, dateTime: fullDateStr }, function (data) {
	        if (!data.BoolResult.Result) {
	            mui.toast(data.BoolResult.Message);
	            return;
	        }

	        callback && callback(data.TempPeriod);
	    });
	},

    /*
     * 后台请求
     * 添加时期
     */
	_onAddPeriod: function (type, title, dateTime, callback) {
	    var self = this;
	    var pageModel = self._getPageModel();
	    if (!pageModel)
	        return;
	    var path = pageModel._getPath($.BaseUrl + 'DataInput/Period/Add');
	    pageModel._action(path, { taskId: pageModel.Context.TaskId, type: type, title: title, dateTime: dateTime }, function (data) {
	        if (!data.BoolResult.Result) {
	            mui.toast(data.BoolResult.Message);
	            return;
	        }
	        var length = pageModel.Context.AllPeriods.length;
	        var filledLength = pageModel.Context.EntityFilledPeriods.length;
	        if (length > 0) {
	            if (pageModel.Context.AllPeriods[0].BeginTime > data.NewPeriod.BeginTime) {//插在最前面
	                pageModel.Context.AllPeriods.splice(0, 0, data.NewPeriod);
	                pageModel.Context.EntityFilledPeriods.splice(0, 0, data.NewPeriod.Code);

	            } else if (pageModel.Context.AllPeriods[length - 1].BeginTime < data.NewPeriod.BeginTime) {//插在最后面
	                pageModel.Context.AllPeriods.splice(length, 0, data.NewPeriod);
	                pageModel.Context.EntityFilledPeriods.splice(filledLength, 0, data.NewPeriod.Code);

	            } else {
	                for (var i = 1; i <= length - 2; i++) {
	                    if (pageModel.Context.AllPeriods[i].BeginTime < data.NewPeriod.BeginTime && pageModel.Context.AllPeriods[i + 1].BeginTime > data.NewPeriod.BeginTime) {
	                        //插空
	                        pageModel.Context.AllPeriods.splice(i + 1, 0, data.NewPeriod);

	                        //当前i值向前寻找，直到在filledList找到匹配的code，方为可插入的位置
	                        var t = i;
	                        while (t >= 0) {
	                            var filledIndex = pageModel.Context.EntityFilledPeriods.indexOf(pageModel.Context.AllPeriods[t].Code);
	                            if (filledIndex == -1) {
	                                t--;
	                            } else {
	                                pageModel.Context.EntityFilledPeriods.splice(filledIndex + 1, 0, data.NewPeriod.Code);
	                                t = -1;
	                            }
	                        }
	                    }
	                }
	                
	            }
	        } else {
	            pageModel.Context.AllPeriods.push(data.NewPeriod);
	            pageModel.Context.EntityFilledPeriods.push(data.NewPeriod.Code);
	        }
	        pageModel.Context.IsTempPeriod = false;
	        callback && callback(data.NewPeriod);
	    });
	},

    /*
     * 后台请求
     * 刷新已填报的时期列表
     */
	refreshMarkedFilled: function () {
	    var self = this;
	    var pageModel = self._getPageModel();
	    if (!pageModel || pageModel.Context.IsAnonymous)
	        return;
        
	    var path = pageModel._getPath($.BaseUrl + "DataInput/Period/GetFilledPeriods", true, true, false);
	    if (pageModel.Context.ShareToken) {
	        path += "&shareToken=" + pageModel.Context.ShareToken;
	    }
	    pageModel._action(path, {}, function (data) {
	        if (data && !data.Message) {
	            pageModel.Context.EntityFilledPeriods = data.EntityFilledPeriods;
	            self._entityFilledPeriods = pageModel.Context.EntityFilledPeriods;
	            
	            self._updateSwitchPeriods();
	        }
	    });
	},
    
	refreshSelectedEntityExtInfo: function (extInfo) {
	    this._selectedEntityExtInfo = extInfo;
	},
    
    onDestroy: function(){
    	this._temPeriodDate = null;
		this._periodType = null;
		this._periodCount = 0;
		this._allPeriods = [];
		this._sharedPeriods = [];
		this._timeSegments = [];
		this._entityFilledPeriods = [];
		this._hasLoadedPeriods = false;
		
		this._isTaskOwner = false;
		this._isOnlyShared = false;
	}
});


