MSG_FilledPeriods_AfterUpdate = 'msg_filledperiods_afterupdate';

$.Class("ToolBar", MvcBase, {
	construct: function(){
		this._super().construct.call(this);
		this._dataInput = $.m("DataInput");
		
		this.addListener(MSG_DataInput_DataStateChanged, this.updateBtnState, this);
		this.addListener(MSG_FilledPeriods_AfterUpdate, this.updatePeriodOpsBtnState, this);
	},
	
	updateBtnState: function(){	
		//保存
		var isModified = this._dataInput.Status.IsModified;
		this._setBtnState("grid-save-btn", true, isModified);
		
		//插行、删行
		var formEditor = this._dataInput.FormEditor;
		var isReadOnly = formEditor.isReadOnly(), isGathering = formEditor.isGathering(), gatherType = formEditor.getGatherType();
		var formKind = formEditor.GridForm.getFormKind(), dataReg = formEditor.GridForm.getDataReg(), regKind = dataReg ? dataReg.RegionKind : 0, isTotalRow = formEditor.isTotalRow();
		this._setBtnState("grid-insertrow-btn", formKind == "row", !isReadOnly && !isTotalRow && regKind === 3 && gatherType === 0);
		this._setBtnState("grid-delrow-btn", formKind == "row", !isReadOnly && !isTotalRow && regKind === 3);
		
		//切换录入模式
		var canSwitch = this._dataInput.Context.BillMode && this._dataInput.Context.BillMode.CanSwitch;
		this._setBtnState("grid-switchmode-btn", canSwitch, canSwitch);
		
		//清空全表
		this._setBtnState("grid-clearall-btn", true, !isReadOnly && !isGathering, true);
		
		//冻结窗格	
		var isFrozen = this._dataInput.GridForm.isFrozen();
		if(isFrozen){
			this._setBottomBtnTitle("解除冻结");
		}else{
			this._setBottomBtnTitle("冻结窗格");
		}
		
		//浮动行数据筛选
		this._setBtnState("grid-filtersort-btn", formKind == "row", formKind == "row");
		
		//分享、评论
		var shareToken = this._dataInput.Context.ShareToken;
		this._setBtnState("grid-share-btn", true, !shareToken);
		this._setBtnState("grid-comment-btn", true, !shareToken);
	},
	
	updatePeriodOpsBtnState: function () {
	    var switchPeriods = this._dataInput.PeriodSelector.getSwitchPeriods();
	    this._setBtnState("periodops-upswitch-btn", switchPeriods.show, switchPeriods.canUp, true);
	    this._setBtnState("periodops-downswitch-btn", switchPeriods.show, switchPeriods.canDown, true);
	    this._dataInput.Context.MarkedFilledPeriod_Up = switchPeriods.up;
	    this._dataInput.Context.MarkedFilledPeriod_Down = switchPeriods.down;    
    },
	
	loadTopBtns: function(){
		var self = this;
		var wrapperObj = $("#grid-edit-wrapper");
		if(wrapperObj.is(":visible")){
			return;
		}else if(wrapperObj.attr("openflag")){
			wrapperObj.show();
			$("#grid-view-wrapper").hide();
			return;
		}
	
		if(self._dataInput.FormEditor.GridForm.getFormKind() == "row"){
			$("#grid-delrow-btn").show();
			$("#grid-insertrow-btn").show();
		}else{
			$("#grid-delrow-btn").hide();
			$("#grid-insertrow-btn").hide();
		}
		
		if(this._dataInput.Context.BillMode && this._dataInput.Context.BillMode.CanSwitch){
			$("#grid-switchmode-btn").show();
		}else{
			$("#grid-switchmode-btn").hide();
		}

		//更改各按钮的能动状态
		
		//绑定各按钮的点击事件
		$("#grid-save-btn").off("tap").on("tap", function(e){
			if($(this).attr("disabled")){
				self._inputerTextFocus();
				e.preventDefault();
				return;
			}
			//关闭查找功能
			if($("#findandreplace") && $("#findandreplace").is(":visible")){
				self.hideFindtool();
			}
			self._bindSaveBtnEvent();
			e.preventDefault();
		});
		$("#grid-insertrow-btn").off("tap").on("tap", function(e){
			if($(this).attr("disabled")){
				self._inputerTextFocus();
				e.preventDefault();
				return;
			}
			self._bindInsertRowEvent("before", "row");
			e.preventDefault();
		});
		$("#grid-delrow-btn").off("tap").on("tap", function(e){
			if($(this).attr("disabled")){
				self._inputerTextFocus();
				e.preventDefault();
				return;
			}
			self._bindDelRowEvent();
			e.preventDefault();
		});
		$("#grid-switchmode-btn").off("tap").on("tap", function(e){
			if($(this).attr("disabled")){
				e.preventDefault();
				return;
			}
			self._bindSwitchModeEvent();
			e.preventDefault();
		});
		$("#grid-cancel-btn").off("tap").on("tap", function(e){
			if($(this).attr("disabled")){
				e.preventDefault();
				return;
			}
			self._bindCancelBtnEvent();
			e.preventDefault();
			//隐藏输入框，弹出工具栏
			if($("#grid-input-wrapper") && $("#grid-input-wrapper").is(":visible")){
				self.hideKeyboard();
				$("#gridinputer-text").blur();
			}
			//关闭查找功能
			if($("#findandreplace") && $("#findandreplace").is(":visible")){
				self.hideFindtool();
			}
		});
		wrapperObj.attr("openflag", "true");
		wrapperObj.show();
		$("#grid-view-wrapper").hide();
		
	},
	
	loadBottomBtns: function(){
		var toolbarObj = $("#toolbar-list");
		if(toolbarObj.is(":visible")){
			return;
		}else if(toolbarObj.attr("openflag")){
			toolbarObj.show();
			return;
		}
		
		var self = this;
		if(self._dataInput.GridForm.getFormKind() != "row" && self._dataInput.GridForm.getFormKind() != "col"){
			$("#grid-filtersort-btn").hide();
		}
		
		$("#toolbar-list").off("touchmove").on("touchmove", function(e){
			e.stopPropagation();
		});
		$("#toolbar-list-returnbtn").off("touchstart").on("touchstart", function(e){
			self.hideBottomBtns();
			e.preventDefault();
		});
		//分享 评论 针对进入任务的人员判断其可用状态 如某人是被共享的 那么他无法再共享给其他人 
		//其显隐状态以后再控制		
		//按钮状态是通过表单类型控制 还是聚焦单元格所在的区域（pc）端控制？
		
		$("#grid-filtersort-btn").off("tap").on("tap", function(e){
			if($(this).attr("disabled")){
				e.preventDefault();
				return;
			}
			self._bindFilterSortBtnEvent();
			e.preventDefault();
		});
		$("#grid-search-btn").off("tap").on("tap", function(e){
			if($(this).attr("disabled")){
				e.preventDefault();
				return;
			}
			self._bindDirectSaveBtnEvent();
			self._bindSearchBtnEvent();			
			e.preventDefault();
		});
		$("#grid-freeze-btn").off("tap").on("tap", function(e){
			if($(this).attr("disabled")){
				e.preventDefault();
				return;
			}
			self._bindFreezeBtnEvent();
			e.preventDefault();
		});
		$("#grid-clearall-btn").off("tap").on("tap", function(e){
			if($(this).attr("disabled")){
				e.preventDefault();
				return;
			}
			self._bindClearAllBtnEvent();
			e.preventDefault();
		});
		$("#grid-share-btn").off("tap").on("tap", function(e){
			if($(this).attr("disabled")){
				e.preventDefault();
				return;
			}
			self._bindShareBtnEvent();
			e.preventDefault();
		});
		$("#grid-comment-btn").off("tap").on("tap", function(e){
			if($(this).attr("disabled")){
				e.preventDefault();
				return;
			}
			self._bindCommentBtnEvent();
			e.preventDefault();
		});	
		$("#periodops-upswitch-btn").off("tap").on("tap", function(e){
			if($(this).attr("disabled")){
				e.preventDefault();
				return;
			}
		    self._dataInput.PeriodSelector.onSwitchUpPeriod();
			e.preventDefault();
		});	
		$("#periodops-downswitch-btn").off("tap").on("tap", function(e){
			if($(this).attr("disabled")){
				e.preventDefault();
				return;
			}
			self._dataInput.PeriodSelector.onSwitchDownPeriod();
			e.preventDefault();
		});	
		toolbarObj.attr("openflag", "true");
		toolbarObj.show();
	},
	
	hideTopBtns: function(){
		$("#grid-view-wrapper").show();
		$("#grid-edit-wrapper").hide();
	},
	
    hideBottomBtns: function(){
    	$("#toolbar-list").hide();
    },
    
    hideKeyboard: function(){
    	$("#grid-input-wrapper").hide();
    	$("#grid-input-wrapper #gridinputer-text").val("");
		$("#form_ctrl").show();
    },
    
    hideFindtool: function(){
    	//关闭时重新初始化
			$("#findtext").val('');
			$("#replacetext").val('');
			$("#matchcomplete").prop("checked",false);
			$("#casesensitive").prop("checked",false);
			
			$("#findandreplace-title-replace").removeClass("select");
			$("#findandreplace-title-find").addClass("select");
			
			$("#replacetext").hide();
			$("#findandreplace-btn-replace").hide();
			$("#findandreplace-btn-replaceAll").hide();
			
			$("#findandreplace-btn-up").addClass("find-btn-select");
			$("#findandreplace-btn ul>li").removeClass("replace-btn-select")
			$("#findandreplace").hide();
    },
    switchBillMode: function() {
    	var canSwitch = this._dataInput.Context.BillMode && this._dataInput.Context.BillMode.CanSwitch;
    	if (!canSwitch) {
    		mui.toast('当前表单不支持按卡片模式录入。');
    		return;
    	}
    	
    	this._bindSwitchModeEvent();
    },
    
    _inputerTextFocus: function(){
    	var text = $("#gridinputer-text");
		text.focus();
		setTimeout(function() {
			text.focus();
		}, 150);
	},

    _setBottomBtnTitle: function(id, newTitle){
    	$("#"+ id +" .mui-media-body").text(newTitle);
    },
    
    _setBtnState: function(id, isShow, isEnable, isBottomBtn){
    	var btnObj = $("#" + id);
    	if(!btnObj) return;
    	
    	if(isShow){
    		btnObj.show();
    	}else{
    		btnObj.hide();
    	}
    	
    	if(isEnable){
    		btnObj.removeAttr("disabled");
    		if(isBottomBtn){
    			btnObj.removeClass("gg-button-disabled");
    		}
    	}
    	else{
    		btnObj.attr("disabled", "disabled");
    		if(isBottomBtn){
    			btnObj.addClass("gg-button-disabled");
    		}
    	}
    },
    
	_bindSaveBtnEvent: function(){
		this._dataInput.FormEditor.saveFormData();//最好在保存成功后，执行回调函数，然后把编辑状态对应的工具条隐藏
	},
	
	_bindCancelBtnEvent: function(){
		var self = this;
		if(self._dataInput.Status.IsModified){
			var btnArray = ['保存', '取消'];
			mui.confirm('是否保存对表单的修改？', '保存', btnArray, function(e){
				if(e.index == 0){
					self._dataInput.FormEditor.saveFormData();
				}else{
					self._dataInput._loadFormData();
					self._dataInput.GridForm.closeEditor();
					$("#grid-edit-wrapper").hide();
					$("#grid-view-wrapper").show();
				}
			});
		}else{
			self._dataInput.GridForm.closeEditor();
			$("#grid-edit-wrapper").hide();
			$("#grid-view-wrapper").show();
		}
	},
	
	_bindDirectSaveBtnEvent: function(){
		//强制关闭编辑框，并保存已修改内容
		var self = this;
//		if(self._dataInput.Status.IsModified){	
//			self._dataInput.FormEditor.saveFormData();
//		}
		self._dataInput.GridForm.closeEditor();
		$("#grid-edit-wrapper").hide();
		$("#grid-view-wrapper").show();				
	},
	
	_bindInsertRowEvent: function(position, type){
		var isInsertAfter = position && position === "after";
        var isColumn = type && type === "col";
        this._dataInput.GridForm.onInsert(0, isInsertAfter, isColumn);
	},
	
	_bindDelRowEvent: function(){
		this._dataInput.GridForm.onDelete();
	},
	
	_bindSwitchModeEvent: function(){
        var self = this;
		if(self._dataInput.Status.IsModified){
			self._dataInput.FormEditor.saveFormData(true, function(){
				self._dataInput.enterBillMode(true);
			});
		}else{
			self._dataInput.enterBillMode(true);
		}
	},

	_bindFilterSortBtnEvent: function(){
		mui.toast("正在开发中，敬请期待！");
	},
	
	//查找与替换
	_bindSearchBtnEvent: function(){
//		mui.toast("正在开发中，敬请期待！");
		var self = this;		
		$("#toolbar-list").hide();
		$("#findandreplace-extendmenu").hide();					
		$("#findandreplace").show();
		$("#findandreplace-title-close").off("tap").on("tap", function(e){			
			//关闭时重新初始化
			$("#findtext").val('');
			$("#replacetext").val('');
			$("#matchcomplete").prop("checked",false);
			$("#casesensitive").prop("checked",false);
			
			$("#findandreplace-title-replace").removeClass("select");
			$("#findandreplace-title-find").addClass("select");
			
			$("#replacetext").hide();
			$("#findandreplace-btn-replace").hide();
			$("#findandreplace-btn-replaceAll").hide();
			
			$("#findandreplace-btn-up").addClass("find-btn-select");
			$("#findandreplace-btn ul>li").removeClass("replace-btn-select")
			$("#findandreplace").hide();
			
			var height = window.innerHeight - $("#datainput_header").height() - $("#form_ctrl").height();
            var width = window.innerWidth;
			self._dataInput._grid && self._dataInput._grid.setSize(width, height);
		});
		$("#findandreplace-title-extendmenu").off("tap").on("tap", function(e){
			var findmenuObj = $("#findandreplace-extendmenu");
			if(findmenuObj.is(":visible")){
				findmenuObj.hide();
				$("#findandreplace-title-extendmenu").removeClass("gg-search-icon-kz-up").addClass("gg-search-icon-kz-down");
				return;
			}else{
				findmenuObj.show();
				$("#findandreplace-title-extendmenu").removeClass("gg-search-icon-kz-down").addClass("gg-search-icon-kz-up");
				return;
			}
		});
		$("#findandreplace-title-find").off("tap").on("tap", function(e){
			$("#findandreplace-title-replace").removeClass("select");
			$("#findandreplace-title-find").addClass("select");
			$("#replacetext").hide();
			$("#findandreplace-btn-replace").hide();
			$("#findandreplace-btn-replaceAll").hide();
			$("#findandreplace-btn-up").addClass("find-btn-select");
			$("#findandreplace-btn ul>li").removeClass("replace-btn-select");
			
		});
		$("#findandreplace-title-replace").off("tap").on("tap", function(e){
			$("#findandreplace-title-find").removeClass("select");
			$("#findandreplace-title-replace").addClass("select");
			$("#findandreplace-btn-up").removeClass("find-btn-select");
			$("#findandreplace-btn ul>li").addClass("replace-btn-select");
			
			$("#replacetext").show();
			$("#findandreplace-btn-replace").show();
			$("#findandreplace-btn-replaceAll").show();
						
			self.loadTopBtns();
		});				
		
		$("#findandreplace-btn-up").off("tap").on("tap", function(e) {
			var pattern = $("#findtext").val();
            var matchWhole = $("#matchcomplete").prop("checked");
            var caseIgnore = $("#casesensitive").prop("checked");
            var gridmodel = self._dataInput._grid.grid.gridModel;
            var findResult = self._findpreNextSymbol(gridmodel, pattern, matchWhole, caseIgnore);
            if (findResult == -1) {
                mui.toast("待查找字符串为空。");
            } else if (findResult > 0) {
                mui.toast('未找到匹配项');
            } else if (findResult == 0) {
                //_showSearchStatusMsg();
                //_hideMsg();
            }
		});
		$("#findandreplace-btn-down").off("tap").on("tap", function(e) {
			var height = window.innerHeight - $("#datainput_header").height() - $("#findandreplace").height();
            var width = window.innerWidth;
			self._dataInput._grid && self._dataInput._grid.setSize(width, height);
			
			var pattern = $("#findtext").val();
            var matchWhole = $("#matchcomplete").prop("checked");
            var caseIgnore = $("#casesensitive").prop("checked");
            var gridmodel = self._dataInput._grid.grid.gridModel;
            var findResult = self._findNextSymbol(gridmodel, pattern, matchWhole, caseIgnore);
            if (findResult == -1) {
                mui.toast("待查找字符串为空。");
            } else if (findResult > 0) {
               mui.toast('未找到匹配项');
            } else if (findResult == 0) {
                //_showSearchStatusMsg();
                //_hideMsg();
            }
		});
		$("#findandreplace-btn-replace").off("tap").on("tap", function(e) {
			var pattern = $("#findtext").val();
            var targetText = $("#replacetext").val();
            var matchWhole = $("#matchcomplete").prop("checked");
            var caseIgnore = $("#casesensitive").prop("checked");
            var gridmodel = self._dataInput._grid.grid.gridModel;
            var result = self._replace(gridmodel, pattern, targetText, matchWhole, caseIgnore);
            if (result == 1) {
				mui.toast("未找到匹配项或单元格只读");
            }
		});
		$("#findandreplace-btn-replaceAll").off("tap").on("tap", function(e) {
			var pattern = $("#findtext").val();
            var targetText = $("#replacetext").val();
            var matchWhole = $("#matchcomplete").prop("checked");
            var caseIgnore = $("#casesensitive").prop("checked");
            var gridmodel = self._dataInput._grid.grid.gridModel;
            var replacedCount = self._replaceAll(gridmodel, pattern, targetText, matchWhole, caseIgnore);
            mui.toast("完成 " + replacedCount + " 处替换。");
		});
		
		$("#findtext").off("keydown").on("keydown", function(e){//点击键盘enter键时
			var pattern = $("#findtext").val();
            var matchWhole = $("#matchcomplete").prop("checked");
            var caseIgnore = $("#casesensitive").prop("checked");
            var gridmodel = self._dataInput._grid.grid.gridModel;
			if(13 == e.keyCode || 9 == e.keyCode){
				var height = window.innerHeight - $("#datainput_header").height() - $("#findandreplace").height();
            	var width = window.innerWidth;
				self._dataInput._grid && self._dataInput._grid.setSize(width, height);
				
	       		e.preventDefault();
	       		var findResult = self._findNextSymbol(gridmodel, pattern, matchWhole, caseIgnore);
	            if (findResult == -1) {
	                mui.toast("待查找字符串为空。");
	            } else if (findResult > 0) {
	               mui.toast('未找到匹配项');
	            } else if (findResult == 0) {
	                //_showSearchStatusMsg();
	                //_hideMsg();
	            }
			}
		});
		$("#replacetext").off("keydown").on("keydown", function(e){//点击键盘enter键时
			var pattern = $("#findtext").val();
            var targetText = $("#replacetext").val();
            var matchWhole = $("#matchcomplete").prop("checked");
            var caseIgnore = $("#casesensitive").prop("checked");
            var gridmodel = self._dataInput._grid.grid.gridModel;
			if(13 == e.keyCode || 9 == e.keyCode){
				var height = window.innerHeight - $("#datainput_header").height() - $("#findandreplace").height();
            	var width = window.innerWidth;
				self._dataInput._grid && self._dataInput._grid.setSize(width, height);
			
	       		var result = self._replace(gridmodel, pattern, targetText, matchWhole, caseIgnore);
	            if (result == 1) {
					mui.toast("未找到匹配项或单元格只读");
	            }
			}
		});
	},
	_findpreNextSymbol:function(gridModel, pattern, matchWhole, caseignore){
		if (pattern == null || pattern == "") {
                return -1;
            }
        var grid = gridModel.gridData;
        var colIndex = 0;
        var rowIndex = 0;
        var currentCell = grid.getCurrentCell();
        if (currentCell && currentCell.cell != null) {
            colIndex = currentCell.cell.colIndex;
            rowIndex = currentCell.cell.rowIndex;
        }
        var colCount = grid.getColCount();
        var rowCount = grid.getRowCount();			
        for (var col = colIndex - 1; col > 0; col--) {
            var gridCell = grid.getCell(col, rowIndex);
            var roCell = new RO.GridHtml5.Cell(gridCell, gridModel);
            var mergeInfo = roCell.getMergedInfo();
            if (mergeInfo != null)
                continue; //跳过合并单元格.				
            var cellText = this._getCellText(roCell);
            if (cellText == null) continue;
            if(!caseignore)
            {
            	cellText = cellText.toString().toLowerCase();
            	pattern = pattern.toLowerCase();
            }
            if (!matchWhole && cellText.indexOf(pattern) >= 0) {               	
                grid.setCurrentCell(col, rowIndex);
                grid.select({ x: col, y: rowIndex, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                return 0;
            } else if (matchWhole && cellText == pattern) {
                grid.setCurrentCell(col, rowIndex);
                grid.select({ x: col, y: rowIndex, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                return 0;
            }
        }

        for (var row = rowIndex - 1; row > 0; row--) {
            for (var col = colCount - 1; col > 0; col--) {
                if (col < colIndex || row < rowIndex) {
                    var gridCell = grid.getCell(col, row);
                    var roCell = new RO.GridHtml5.Cell(gridCell, gridModel);
                    var mergeInfo = roCell.getMergedInfo();
                    if (mergeInfo != null)
                        continue; //跳过合并单元格.

                    var cellText = this._getCellText(roCell);
                    if (cellText == null) continue;
					if(!caseignore)
		            {
		            	cellText = cellText.toString().toLowerCase();
		            	pattern = pattern.toLowerCase();
		            }
                    if (!matchWhole && cellText.indexOf(pattern) >= 0) {
                        grid.setCurrentCell(col, row);
                        grid.select({ x: col, y: row, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                        return 0;
                    } else if (matchWhole && cellText == pattern) {
                        grid.setCurrentCell(col, row);
                        grid.select({ x: col, y: row, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                        return 0;
                    }
                }
            }
        }
        mui.toast("已至文档首部，将从尾开始搜索");
        for (var row = rowCount - 1; row > rowIndex; row--) {
            for (var col = colCount - 1; col > 0; col--) {            	
                var gridCell = grid.getCell(col, row);
                var roCell = new RO.GridHtml5.Cell(gridCell, gridModel);
                var mergeInfo = roCell.getMergedInfo();
                if (mergeInfo != null)
                    continue; //跳过合并单元格.

                var cellText = this._getCellText(roCell);
                if (cellText == null) continue;
				if(!caseignore)
	            {
	            	cellText = cellText.toString().toLowerCase();
	            	pattern = pattern.toLowerCase();
	            }
                if (!matchWhole && cellText.indexOf(pattern) >= 0) {
                    grid.setCurrentCell(col, row);
                    grid.select({ x: col, y: row, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                    return 0;
                } else if (matchWhole && cellText == pattern) {
                    grid.setCurrentCell(col, row);
                    grid.select({ x: col, y: row, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                    return 0;
                }
            }
        }
        for (var col = colCount - 1; col >= colIndex; col--) {
            var gridCell = grid.getCell(col, rowIndex);
            var roCell = new RO.GridHtml5.Cell(gridCell, gridModel);
            var mergeInfo = roCell.getMergedInfo();
            if (mergeInfo != null)
                continue; //跳过合并单元格.				
            var cellText = this._getCellText(roCell);
            if (cellText == null) continue;
            if(!caseignore)
            {
            	cellText = cellText.toString().toLowerCase();
            	pattern = pattern.toLowerCase();
            }
            if (!matchWhole && cellText.indexOf(pattern) >= 0) { 
            	if(col == colIndex)
            		mui.toast("没有其他匹配项");
                grid.setCurrentCell(col, rowIndex);
                grid.select({ x: col, y: rowIndex, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                return 0;
            } else if (matchWhole && cellText == pattern) {
            	if(col == colIndex)
            		mui.toast("没有其他匹配项");
                grid.setCurrentCell(col, rowIndex);
                grid.select({ x: col, y: rowIndex, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                return 0;
            }
            if(col == colIndex)
            	return 1;
        }
       /* var cell0 = grid.getCell(rowCount - 1, colCount - 1);
        var roCell0 = new RO.GridHtml5.Cell(cell0, gridModel);
        grid.setCurrentCell(rowCount - 1, colCount - 1);
        grid.select({ x: rowCount - 1, y: colCount - 1, width: roCell0.getColSpan(), height: roCell0.getRowSpan() }, false);*/
        return 1;
	},
	_findNextSymbol:function(gridModel, pattern, matchWhole, caseignore) {
        if (pattern == null || pattern == "") {
            return -1;
        }
        var grid = gridModel.gridData;
        var colIndex = 0;
        var rowIndex = 0;
        var currentCell = grid.getCurrentCell();
        if (currentCell && currentCell.cell != null) {
            colIndex = currentCell.cell.colIndex;
            rowIndex = currentCell.cell.rowIndex;
        }
        var colCount = grid.getColCount();
        var rowCount = grid.getRowCount();			
        for (var col = colIndex + 1; col < colCount; col++) {
            var gridCell = grid.getCell(col, rowIndex);
            var roCell = new RO.GridHtml5.Cell(gridCell, gridModel);
            var mergeInfo = roCell.getMergedInfo();
            if (mergeInfo != null)
                continue; //跳过合并单元格.				
            var cellText = this._getCellText(roCell);
            if (cellText == null) continue;
            if(!caseignore)
            {
            	cellText = cellText.toString().toLowerCase();
            	pattern = pattern.toLowerCase();
            }
            if (!matchWhole && cellText.indexOf(pattern) >= 0) {               	
                grid.setCurrentCell(col, rowIndex);
                grid.select({ x: col, y: rowIndex, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                return 0;
            } else if (matchWhole && cellText == pattern) {
                grid.setCurrentCell(col, rowIndex);
                grid.select({ x: col, y: rowIndex, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                return 0;
            }
        }       
        for (var row = rowIndex + 1; row < rowCount; row++) {
            for (var col = 1; col < colCount; col++) {
                if (col > colIndex || row > rowIndex) {
                    var gridCell = grid.getCell(col, row);
                    var roCell = new RO.GridHtml5.Cell(gridCell, gridModel);
                    var mergeInfo = roCell.getMergedInfo();
                    if (mergeInfo != null)
                        continue; //跳过合并单元格.

                    var cellText = this._getCellText(roCell);
                    if (cellText == null) continue;
					if(!caseignore)
		            {
		            	cellText = cellText.toString().toLowerCase();
		            	pattern = pattern.toLowerCase();
		            }
                    if (!matchWhole && cellText.indexOf(pattern) >= 0) {
                        grid.setCurrentCell(col, row);
                        grid.select({ x: col, y: row, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                        return 0;
                    } else if (matchWhole && cellText == pattern) {
                        grid.setCurrentCell(col, row);
                        grid.select({ x: col, y: row, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                        return 0;
                    }
                }
            }
        }
        mui.toast("已至文档尾部，将从头开始搜索");
		for (var row = 1; row < rowIndex; row++) {
            for (var col = 1; col < colCount; col++) {
                var gridCell = grid.getCell(col, row);
                var roCell = new RO.GridHtml5.Cell(gridCell, gridModel);
                var mergeInfo = roCell.getMergedInfo();
                if (mergeInfo != null)
                    continue; //跳过合并单元格.

                var cellText = this._getCellText(roCell);
                if (cellText == null) continue;
				if(!caseignore)
	            {
	            	//区分大小写则转化成小写
	            	cellText = cellText.toString().toLowerCase();
	            	pattern = pattern.toLowerCase();
	            }
                if (!matchWhole && cellText.indexOf(pattern) >= 0) {
                    grid.setCurrentCell(col, row);
                    grid.select({ x: col, y: row, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                    return 0;
                } else if (matchWhole && cellText == pattern) {
                    grid.setCurrentCell(col, row);
                    grid.select({ x: col, y: row, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                    return 0;
                }

            }
        }
		for (var col = 1; col <= colIndex; col++) {
            var gridCell = grid.getCell(col, rowIndex);
            var roCell = new RO.GridHtml5.Cell(gridCell, gridModel);
            var mergeInfo = roCell.getMergedInfo();
            if (mergeInfo != null)
                continue; //跳过合并单元格.				
            var cellText = this._getCellText(roCell);
            if (cellText == null) continue;
            if(!caseignore)
            {
            	cellText = cellText.toString().toLowerCase();
            	pattern = pattern.toLowerCase();
            }
            if (!matchWhole && cellText.indexOf(pattern) >= 0) {
            	if(col == colIndex)
            		mui.toast("没有其他匹配项");
                grid.setCurrentCell(col, rowIndex);
                grid.select({ x: col, y: rowIndex, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                return 0;
            } else if (matchWhole && cellText == pattern) {
            	if(col == colIndex)
            		mui.toast("没有其他匹配项");
                grid.setCurrentCell(col, rowIndex);
                grid.select({ x: col, y: rowIndex, width: roCell.getColSpan(), height: roCell.getRowSpan() }, false);
                return 0;
            }
            if(col == colIndex)
            	return 1;
        }
        /*var cell0 = grid.getCell(1, 1);
        var roCell0 = new RO.GridHtml5.Cell(cell0, gridModel);
        grid.setCurrentCell(1, 1);
        grid.select({ x: 1, y: 1, width: roCell0.getColSpan(), height: roCell0.getRowSpan() }, false);*/
        return 1;
    },
    _replace:function (gridModel, pattern, targetText, matchWhole, caseignore) {
        var grid = gridModel.gridData;
        var issuccess = 0;
		var colIndex = 0;
        var rowIndex = 0;
        var currentCell = grid.getCurrentCell();
        if (currentCell && currentCell.cell != null) {
            colIndex = currentCell.cell.colIndex;
            rowIndex = currentCell.cell.rowIndex;
        }            
        var colCount = grid.getColCount();
        var rowCount = grid.getRowCount();
			
		var roCell = new RO.GridHtml5.Cell(currentCell, gridModel);			
        var cellText = this._getCellText(roCell);
        var caseFlag = "gm";
        var cellTextLowcase = cellText;
        if (cellText != null){  
        	if(!caseignore)
            {
            	cellTextLowcase = cellText.toString().toLowerCase();
            	pattern = pattern.toLowerCase();
            	caseFlag = "gim";
            }
	        if (!matchWhole && cellTextLowcase.indexOf(pattern) >= 0) {
	            var finalStr = cellText.replace(new RegExp(pattern, caseFlag), targetText);
	            var modify = this._setCellValue(gridModel, roCell, finalStr);	            
	            if(modify) 
	            {
		            var changeValues = [];
		            changeValues.push({ row: rowIndex, col: colIndex, oldValue: cellText, newValue: finalStr, fKey: roCell.getDataRowAttr(RO.Enum.FloatRowKey) });
		            $(gridModel.entry).trigger(RO.Enum.Event.valuechange, { "changeValues": changeValues });
	            }else {
	            	mui.toast('单元格不可编辑');
	            }	            
	            this._findNextSymbol(gridModel, pattern, matchWhole, caseignore);
	            return 0;
	        } else if (matchWhole && cellTextLowcase == pattern) {
	            var modify = this._setCellValue(gridModel, roCell, finalStr);
	            if(modify)
	            {
		            var changeValues = [];
		            changeValues.push({ row: rowIndex, col: colIndex, oldValue: cellText, newValue: targetText, fKey: roCell.getDataRowAttr(RO.Enum.FloatRowKey) });
		            $(gridModel.entry).trigger(RO.Enum.Event.valuechange, { "changeValues": changeValues });
	            } else {
	            	mui.toast('单元格不可编辑');
	            }
	            this._findNextSymbol(gridModel, pattern, matchWhole, caseignore);
	            return 0;
	        }
        }
		issuccess = this._findNextSymbol(gridModel, pattern, matchWhole, caseignore);
		if(issuccess != 0) return 1;
		return 0;
    },
	_replaceAll:function (gridModel, pattern, targetText, matchWhole, caseignore) {
        var grid = gridModel.gridData;
        var changeValues = [];
        var modified = false;
        var replacedCount = 0;
        var colCount = grid.getColCount();
        var rowCount = grid.getRowCount();
		
        for (var row = 1; row < rowCount; row++) {
            for (var col = 1; col < colCount; col++) {
                var gridCell = grid.getCell(col, row);
                var roCell = new RO.GridHtml5.Cell(gridCell, gridModel);
                var mergeInfo = roCell.getMergedInfo();
                if (mergeInfo != null)
                    continue; //跳过合并单元格.
                var cellText = this._getCellText(roCell);
                if (cellText == null) continue;
                var caseFlag = "gm";
        		var cellTextLowcase = cellText;
        		if(!caseignore)
	            {
	            	cellTextLowcase = cellText.toString().toLowerCase();
	            	pattern = pattern.toLowerCase();
	            	caseFlag = "gim";
	            }
                if (!matchWhole && cellTextLowcase.indexOf(pattern) >= 0) {
	                var finalStr = cellText.replace(new RegExp(pattern, caseFlag), targetText);
	                modified = this._setCellValue(gridModel, roCell, finalStr);
	                if (modified)
	                {
	                    changeValues.push({ row: row, col: col, oldValue: cellText, newValue: finalStr, fKey: roCell.getDataRowAttr(RO.Enum.FloatRowKey) });
	                    replacedCount++;
	                }
                } else if (matchWhole && cellTextLowcase == pattern) {
                    modified = this._setCellValue(gridModel, roCell, finalStr);
                    if (modified)
                    {
                        changeValues.push({ row: row, col: col, oldValue: cellText, newValue: pattern, fKey: roCell.getDataRowAttr(RO.Enum.FloatRowKey) });
                        replacedCount++;
                    }
                }
            }
        }    
        if (changeValues.length > 0) {
            $(gridModel.entry).trigger(RO.Enum.Event.valuechange, { "changeValues": changeValues });
        }
        return replacedCount;
    },		
	_getCellText:function (roCell) {
        var cellText;
        var isEnum = roCell.getAttrByName(RO.Enum.EnumID);
        if (isEnum && isEnum > 0) {
            cellText = roCell.getShowText();
        } else {
            cellText = roCell.getEditText() || roCell.getShowText();
        }
        if (cellText != null)
            return cellText.toString();
        else
            return null;
    },
    _setCellValue: function(gridModel, roCell, inputText) {
        var modified;
        var isEnum = roCell.getAttrByName(RO.Enum.EnumID);
        if (isEnum && isEnum > 0) {
            modified = gridModel.setValue(roCell, "", inputText, true, true);
        } else {
            modified = gridModel.setValue(roCell, inputText, inputText, true, true);
        }
        return modified;
    },
	_bindFreezeBtnEvent: function(){
		mui.toast("正在开发中，敬请期待！");
	},
	_bindClearAllBtnEvent: function(){
		var self = this;
		var btnArray = ['确定', '取消'];
		mui.confirm('清掉的数据将无法恢复，确定要执行吗？', '清空全表', btnArray, function(e){
			if(e.index == 0){
				self._dataInput.FormEditor.emptyFormData();
			}
		});
	},
	_bindShareBtnEvent: function(){
		mui.toast("正在开发中，敬请期待！");
	},
	_bindCommentBtnEvent: function(){
		mui.toast("正在开发中，敬请期待！");
	},
	
	onDestroy: function(){
		this._super().onDestroy.call(this);
		this.removeListener(MSG_DataInput_DataStateChanged, this.updateBtnState, this);
	}
});


RO.GridAdapter.extend(RO.GridAdapter, {//双击单元格弹出
	mobileInputEditor: function(data){
		if(mui.os.ios || !mui.os.plus){
			this._doInputEditor(data);
			return;
		}
		
		var self = this;
		var hasKeybord = document.activeElement.tagName == 'TEXTAREA' || document.activeElement.tagName == 'INPUT' // 用焦点是否在文本框上来判断当前是否有键盘
		var clientData = data.cell.cell.getClientData();
		var dT = clientData[RO.Enum.DataType];
		
		// 根据单元格类型弹出不同的键盘：由于input不支持文本类型需要的多行显示，textare又不支持通过设置type来指定不同键盘
		// 因此在调用弹出键盘的逻辑(_doInputEditor)前通过判断单元格类型，动态改变输入框来达到目的
		// 正常来说调用完changeKeyboard方法后直接调用_doInputEditor即可（安卓app下确实没问题），但ios这么直接处理键盘会闪动，切换单元格卡顿
		var changeKeyboard = function(type) {
			$("#gridinputer-text").remove();
			if(type === "number"){
				$("#grid-input-wrapper").prepend('<input id="gridinputer-text" type="number" style="padding: 10px 7px;" ></input>');
			} else {
				$("#grid-input-wrapper").prepend('<textarea rows="1" id="gridinputer-text" style="padding: 10px 7px;"></textarea>');
			}
		}
		
//		if(hasKeybord) { // 当前点击时键盘已经是弹出状态
//			if (dT == '2' || dT == '3') { // 当前类型为浮点或者整数
//				if(self._mobileInputTextType !== "number") { // 上一次不是数值需要切换为数字键盘
//					changeKeyboard("number");
//				}
//			} else { // 当前类型为文本类型
//				if(self._mobileInputTextType !== "text") { // 上一次不是文本类型需要切换为文本类型					
//					changeKeyboard("text");
//				}
//			}			
//		} else {
//			if (dT == '2' || dT == '3'){
//				// 浮点或者整数
//				changeKeyboard("number");		
//			} else {
//				changeKeyboard("text");
//			}
//		}		
		
		if (dT == '2' || dT == '3'){
			// 浮点或者整数
			changeKeyboard("number");		
		} else {
			changeKeyboard("text");
		}
		self._doInputEditor(data);
		// 记下本次点击时的键盘类型，供下次再点击时判断使用
		//self._mobileInputTextType = (dT == '2' || dT == '3') ? "number" : "text";
	},
	
	_doInputEditor:function(data){
		var self = this;
		
		var textObjFocus = function(){
			var textObj = $("#gridinputer-text"); 
			textObj.focus();
			setTimeout(function() {
				textObj.focus();
			}, 150);
		};
		
		var setTextObjVal = function(hasFocus){
			var inputObj = $("#gridinputer-text");
			var curCell = self.getCurrentCell();
			if(curCell && curCell.getCanEdit()){
				if(hasFocus){
					inputObj.focus();
				}
				var showText = curCell.getEditText();
				if(curCell.attr("dt") === "3" || curCell.attr("dt") === "2"){//整数、数值、浮点类型去除千分位
					showText = showText.replace(/[,]/gi, '');
				}
				if(/(iPhone|iPad|iPod|iOS)/i.test(navigator.userAgent)){
					if(!showText){
						showText = " ";
					}else{
						showText = " " + showText;
					}
				}
				inputObj.val(showText);
			}	
		};
			
		$("#gridinputer-text").off("input").on("input", function(){//文本框输入值时
			var curCell = self.getCurrentCell();
			if(curCell && curCell.getCanEdit()){
				var temp = $.trim($(this).val());
				curCell.setValue(temp, temp,undefined,undefined,undefined,true);
			}
		}).off("keydown").on("keydown", function(e){//点击键盘enter键时
			if(13 == e.keyCode || 9 == e.keyCode){
	       		e.preventDefault();	 
	       		
	       		var curCell = self.getCurrentCell();
	       		var colIndex = curCell.getColIndex(), rowIndex = curCell.getRowIndex();
	       		self.doKeyDirection(RO.Enum.EnterDirection.DOWN);
	       		curCell = self.getCurrentCell();
	       		var newColIndex = curCell.getColIndex(), newRowIndex = curCell.getRowIndex();
	       		//doKeyDirection有可能不会定位到下一个单元格，所以增加判断，假如单元格未变化的话，不需要太设置键盘焦点
	       		if (newColIndex != colIndex || newRowIndex != rowIndex){	       			
		       		$.m("DataInput").GridForm.openEditor();
		       		setTextObjVal(true);
	       		}
	     	}
		});
			
       	$(".gridinputer-right").off("touchstart").on("touchstart", function(e){
        	//解决长按“Tab”按钮，导致键盘关闭的问题；
	    	e.preventDefault();	    	
       	}).off("touchmove").on("touchmove", function(e){
	    	e.preventDefault();	
       	}).off("touchend").on("touchend", function(e){        	
	    	e.preventDefault();
	    	
	    	var curCell = self.getCurrentCell();
	       	var colIndex = curCell.getColIndex(), rowIndex = curCell.getRowIndex();
	        self.doKeyDirection(RO.Enum.EnterDirection.RIGHT);
	        curCell = self.getCurrentCell();
	       	var newColIndex = curCell.getColIndex(), newRowIndex = curCell.getRowIndex();
	       	//doKeyDirection有可能不会定位到下一个单元格，所以增加判断，假如单元格未变化的话，不需要太设置键盘焦点
	       	if (newColIndex != colIndex || newRowIndex != rowIndex){	    
		        $.m("DataInput").GridForm.openEditor();
		        setTextObjVal();
	        }
        });

        $("#grid-input-wrapper").show();
        textObjFocus();
        setTextObjVal();
	}
});
