$.Class("TaskList", MvcModel, {
	TaskType: {
		Create: "1",
		Perform: "2",
		RecentVisit: "3",
		MyCollection: "4",
	},

	ImgUrlMap2Pic: {
		"gg-taskcell-icon01": "pic01.png",
		"gg-taskcell-icon02": "pic02.png",
		"gg-taskcell-icon03": "pic03.png",
		"gg-taskcell-icon04": "pic04.png",
		"gg-taskcell-icon05": "pic05.png",
		"gg-taskcell-icon06": "pic07.png",
		"gg-taskcell-icon07": "pic06.png",
		"gg-taskcell-icon08": "pic01.png",
		"gg-taskcell-icon09": "pic06.png",
	},
	
	_datainputView: null,
	_searchView: null,
	_datainputViewReady: false,
	_searchViewReady: false,
	_isRefreshing: false,
	
	_showExperienceTask: false,
	
	construct: function() {
		this._super().construct.call(this);
	},
	onEntry: function() {
		var me = this;
		me._showExperienceTask = false;
		me.currentGroup = me.TaskType.RecentVisit;
		this._super().onEntry.call(this);		
		
		mui.init({
			pullRefresh: {
				container: '#taskListId',
				down: {
					callback: pulldownRefresh
				}
			}
		});
		function pulldownRefresh() {
			me._isRefreshing = true;
			var tag = me.currentGroup;			
			var url = $.BaseUrl + "MyAccount/Home/GetTaskListByGroupRemote";
			$.doAction(url, {
				"tag": tag
			}, function(result) {
				me._isRefreshing = false;
				var tasksHtml = [];
				if($(".fixed-action-btn").children().length == 0) {
					me._initFabmenu();
				}
				if (result && result.length > 0) {
					for (var i = 0; i < result.length; i++) {
						var task = result[i];
						var taskHtml = me._generateTaskHtml(task);
						tasksHtml.push(taskHtml);
					}
				} else if(tag == "3") {
					var url = $.BaseUrl + "MyAccount/Home/GetTaskDefineById";
					$.doAction(url, {
						"taskId": $.ExperienceTaskId
					}, function(result) {			
						if( result != "false") {
							var task = result;
							task.isReleased = true;
							task.taskType = '0';
							task.creater = '';
							var taskHtml = me._generateTaskHtml(task);
							tasksHtml.push(taskHtml);
							$("#noTaskTips").hide();
							$("#taskListId").show();
							$("#taskContainer").html(tasksHtml.join(""));
							mui("#taskListId").pullRefresh().scrollTo(0, 0, 1);
							me._initAfterTaskShow();
							me._showExperienceTask = true;
							mui('#taskListId').pullRefresh().endPulldownToRefresh(); //refresh completed
						}
					});
				} 
				$("#noTaskTips").hide();
				$("#taskListId").show();					
				$("#taskContainer").html(tasksHtml.join(""));
				mui('#taskListId').pullRefresh().endPulldownToRefresh(); //refresh completed
			}, true, function(xhr, type, errorThrown){
				$(".fixed-action-btn").hide();
				me._isRefreshing = false;
				mui('#taskListId').pullRefresh().endPulldownToRefresh();
			});
		};
		
		mui.plusReady(function() {
			me._initBeforeAction();
			me._loadTasks(me.currentGroup, true);							
			me._dealTapTaskEvent();
			me._dealTapTaskGroupEvent();
			me._dealHideTaskGroupEvent();			
			
			/*setTimeout(function(){
				me._initFabmenu();
			},0);*/
			var popover = document.getElementById("topPopover")
			window.addEventListener('touchstart', function(e) { // 处理触摸屏幕时便隐藏popover
				if (popover && popover.style.display && popover.style.display != "none") {
					var dealHide = true;
					for (var target = e.target; target && target !== document; target = target.parentNode) {
						if (target === popover) {
							dealHide = false; // 事件从popover元素内部触发则不处理
							break;
						}
					}
					if (dealHide) {
						mui("#topPopover").popover("hide");
					}
				}
			}, false);
	
			window.addEventListener("hideparent", function(e) {
				if (popover && popover.style.display && popover.style.display != "none") {
					mui("#topPopover").popover("hide");
				}
			}, false);
	
			window.addEventListener("popover", function(event) {				
				var show = event.detail.show;				
				if (show === true) {
					var topPopover = $("#topPopover");
					var width = (me.entry.width() - 150) / 2;
					topPopover.css("top", document.body.scrollTop);
					topPopover.css("left", width);
					mui("#topPopover").popover("show");
				} else {
					if (popover && popover.style.display && popover.style.display != "none") {
						mui("#topPopover").popover("hide");
					}
				}
			});
				
			window.addEventListener("onSearch", function(){
				if (popover && popover.style.display && popover.style.display != "none") {
					mui("#topPopover").popover("hide");
				}
				if(!me._searchViewReady){
					return;
				}
				mui.openWindow({
					url: 'taskportal/search.html',
					id: 'taskportal/search.html',
					show: {
						aniShow: 'pop-in'
					},
					styles: {
						popGesture: 'hide'
					},
					waiting: {
						autoShow: false
					}
				});
			});
			
			window.addEventListener("setExperTask", function(e) {
				me._showExperienceTask = e.detail.IsExperied;
			});
		});
		
		$('#taskContainer').on('tap','.survey-task-delete', function(event) {
			var elem = this;
			var div = elem.parentNode;
			var btnArray = ['确认', '取消'];
			mui.confirm('确认删除该任务吗？', '提示', btnArray, function(e) {
				if (e.index == 0) {
					mui.showWaiting('正在删除...');
					var taskId = $(div).next().attr("taskid");
					me._deleteSurveyTask(taskId, div.parentNode);
				}else {
					setTimeout(function() {
						mui.swipeoutClose(div.parentNode);
					}, 0);
				} 
			});
		});
		
		$('#taskContainer').on('tap','.survey-task-modify', function(event) {
			var elem = this;
			var taskId = $(this.parentNode).next().attr("taskid");
			me._modifySurveyTask(taskId);
			setTimeout(function() {
				mui.swipeoutClose(elem.parentNode.parentNode);
			}, 0);
		});
	},

	_initAfterTaskShow: function(){
		var me = this;
		if(me.flag){
			return;
		}
		setTimeout(function(){			
			me._searchView = mui.preload({url: 'taskportal/search.html', id: 'taskportal/search.html'});
			me._searchView.hide();
			me._searchView.addEventListener("loaded", function(){
				me._searchViewReady = true;
			});			
		}, 0);			
		me.flag = true;
	},
	
	_initFabmenu: function(){
		var tabmenu = {
			"id":"fab-menu",
			"size":"btn-large",
			"img":"fab-icon-fixed",
			"bgdcolor":"blue",
			"dragFlag":false,
			onClick: this.onFabMenuTapped
		};
		$(".fixed-action-btn").fabmenu({"Tabmenu": tabmenu});
		$(".fixed-action-btn").fabmenu("initMovingRegion",0, $(".mui-bar").height(), window.innerWidth, window.innerHeight - $(".mui-bar").height());
		$(".fixed-action-btn").fabmenu("setInitPosition", window.innerHeight - $(".mui-bar").height() - $(".fixed-action-btn").width() - 5, window.innerWidth - $(".fixed-action-btn").width() - 5);
		//$(".fixed-action-btn").hide();
	},
	
	_initBeforeAction: function(){
		var me = this;
		setTimeout(function(){
			me._datainputView = mui.preload({url: 'datainput/index.html', id: 'datainput'});
			me._datainputView.hide();
			me._datainputView.addEventListener("loaded", function(){
				me._datainputViewReady = true;
			});
			var main = plus.webview.getLaunchWebview(); // 首页数据准备好后开始预加载隐藏的窗口
			mui.fire(main, "dataReady");
		}, 0);
		
	},

	_deleteSurveyTask: function(taskId, elem) {
		var url = $.BaseUrl + "MyAccount/Task/DelTaskByIds";
		
		$.doAction(url, {ids: taskId}, function(delIds) {
				if (!delIds.message) {
	                var delCount = delIds.del.length;
	                var notDelCount = delIds.notDel.length;
	                if (notDelCount && notDelCount > 0) {
	                    var titles = [];
	                    for (var i = 0; i < delIds.notDel.length; i++) {
	                        titles.push(delIds.notDel[i], 1);
	                    }
	                    mui.toast(titles.join(";") + " 没有删除权限");
	                } else {
						elem.parentNode.removeChild(elem);
	                }
	            } else {
	                mui.toast(delIds.message);
	            }
	            mui.closeWaiting();
		});
	},
	
	_modifySurveyTask: function(taskId) {
		mui.openWindow({
				url: '_www/tasks/businessmodel/designbillform.html',
				id: 'designbillform',
				createNew: true,
				waiting: {
					autoShow: true,
					title: '正在加载数据……'
				},
				extras: {
					_taskId: taskId
				}
			});	
	},
	
	_goToDatainput: function(taskId, creater, taskType, isexpTask){
		var me = this;
		mui.openWindow({
			url: 'datainput/index.html',
			id: 'datainput',
			waiting: {
				autoShow: true,
				title: '正在加载数据……'
			}
		});					
		me._datainputView.hide();
		plus.nativeUI.showWaiting('正在加载数据……');
		mui.fire(me._datainputView, "datainputshow", {
			taskId: taskId,
			creater: creater,
			taskType: taskType,
			IsExperTask: isexpTask
		});	
				
	},
	
	_goToTotalResult: function(taskId, creater, taskType, isExperTask) {
		var url = $.BaseUrl + 'DataInput/Home/Init_PeriodAndEntity?_taskId_=' + taskId;
		var self = this;
		$.doAction(url, {taskId: taskId}, function(result) {
			if(result.errorMsg && result.errorMsg.length > 0) { 
				mui.toast(result.errorMsg);
				return;
			} else {
				if(!result.IsLeafNode){
					mui.openWindow({
						url:'_www/tasks/businessmodel/billformresultheader.html',
						id:'billformresultheader.html',
						createNew: true,
						show: {
							autoShow: true
						},
						waiting: {
							autoShow: true,
							title:'正在加载数据...'
						}
					});
					var intervals = setInterval(function(){
						var targetView = mui.getWebviewById('billformtotalresult.html');
						if(targetView) {
							mui.fire(targetView, 'datashow', {
								taskId: taskId,
							    taskType: taskType,
							    selectedEntityExtInfo: result.SelectedEntityExtInfo,
						        entityKey: result.SelectedKey,
						        formId: result.SelectedForm,
						        shareToken: result.InitShareId,
						        isLeafNode: result.IsLeafNode,         
						        periodCount: result.PeriodCount,
						        period: result.PeriodCode,
						        periodTitle: result.PeriodTitle,
						        periodType: result.PeriodType,
						        isTempPeriod: result.IsTempPeriod
							});
							clearInterval(intervals);
						}
					},2000);																
				} else {
					self._goToDatainput(taskId, creater, taskType, isExperTask);
				}
			}
		});		
	},
	
	// 处理点击任务
	_dealTapTaskEvent: function() {
		var me = this;
		mui("#taskContainer").on("tap", 'li > a', function(e) {
			if(me._isRefreshing){
				mui.toast("正在刷新数据，请稍后再试。");
				return;
			}
			var elem = this;
			var taskId = this.getAttribute('taskId');
			var creater = this.getAttribute('creater');
			var taskType = this.getAttribute('taskType');
			var isExperTask = me._showExperienceTask;
			
			var isReleased = this.getAttribute('releaseState');
			if(isReleased == 'true') {				
				if(taskType == '1') {
					//如果是手机建模的任务,则进入结果查看界面。
					mui.showWaiting('正在加载数据……');
					me._goToTotalResult(taskId, creater, taskType, isExperTask);
				}else {
					me._goToDatainput(taskId, creater, taskType, isExperTask);
				}
				
			} else {
/*				var btnArray = ['确定', '取消'];
				mui.confirm('该任务尚未发布，是否继续修改？', '提示', btnArray, function(e) {
					if (e.index == 0) {*/
						me._modifySurveyTask(taskId);
/*					}
				});*/
			}			
		});
	},

	_dealTapTaskGroupEvent: function() {
		var me = this;
		mui("#topPopover").on("tap", 'a', function(e) {
			var tag = this.getAttribute('tag');
			var parentPage = plus.webview.getWebviewById("tasks/portaltab-subpage-taskheader.html");
			mui.fire(parentPage, "titlechange", {
				title: this.innerHTML
			});
			mui("#topPopover").popover("hide");
			me._loadTasks(tag);
			me.currentGroup = tag;
		});
	},

	// 弹出窗隐藏后事件
	_dealHideTaskGroupEvent: function() {
		mui('body').on('hidden', '.mui-popover', function(e) { // 弹出窗隐藏时			
			var parentPage = plus.webview.getWebviewById("tasks/portaltab-subpage-taskheader.html");
			mui.fire(parentPage, "hidePopover");
		});
	},

	_loadTasks: function(tag, isFirst) {		
		var url = $.BaseUrl + "MyAccount/Home/GetTaskListByGroupRemote";
		var me = this;
	
		$.doAction(url, {
			"tag": tag
		}, function(result) {
			var tasksHtml = [];
			if(isFirst){
				me._initFabButton();
			}
			me._initFabmenu();
			
			if (result && result.length > 0) {
				for (var i = 0; i < result.length; i++) {
					var task = result[i];
					var taskHtml = me._generateTaskHtml(task);
					tasksHtml.push(taskHtml);
				}
				$("#noTaskTips").hide();
				$("#taskListId").show();

				$("#taskContainer").html(tasksHtml.join(""));
				mui("#taskListId").pullRefresh().scrollTo(0, 0, 1);
				me._initAfterTaskShow();
				plus.nativeUI.closeWaiting();
				plus.navigator.closeSplashscreen();
			} else if(tag == "3") {
				var url = $.BaseUrl + "MyAccount/Home/GetTaskDefineById";
				$.doAction(url, {
					"taskId": $.ExperienceTaskId
				}, function(result) {			
					if( result != "false") {
						var task = result;	
						task.isReleased = true;
						task.taskType = '0';
						task.creater = '';
						var taskHtml = me._generateTaskHtml(task);
						tasksHtml.push(taskHtml);
						$("#noTaskTips").hide();
						$("#taskListId").show();
						$("#taskContainer").html(tasksHtml.join(""));
						mui("#taskListId").pullRefresh().scrollTo(0, 0, 1);
						me._initAfterTaskShow();
						me._showExperienceTask = true;
						plus.nativeUI.closeWaiting();
						plus.navigator.closeSplashscreen();
					}
				});	
			} else {
				$("#noTaskTips").hide();
				$("#taskListId").show();					
				$("#taskContainer").html(tasksHtml.join(""));
				mui('#taskListId').pullRefresh().endPulldownToRefresh(); //refresh completed
			}
		}, true, function(){
			//me._initAfterTaskShow();
			$(".fixed-action-btn").hide();
			plus.nativeUI.closeWaiting();
			plus.navigator.closeSplashscreen();
		});
	},
	
	_initFabButton: function(){
		var url = $.BaseUrl + "MyAccount/Home/GetTaskListByGroupRemote";
		var me = this;
		
		// 没有我创建的任务时才显示浮动按钮
		$.doAction(url, {
			"tag": "1"
		}, function(result) {
			if(!result || result.length == 0){
				$(".fixed-action-btn").show();
			}
		}, true, function(){

		});
	},

	_generateTaskHtml: function(task) {
		var pic;
		var imgUrl = task.imgUrl;
		if (imgUrl && this.ImgUrlMap2Pic[imgUrl]) {
			pic = this.ImgUrlMap2Pic[imgUrl];
		} else {
			pic = 'pic0' + Math.ceil(Math.random() * 7) + '.png';
		}
		var curUserId = localStorage.getItem("currentUserId");
		var delBtnHtml = '';
		if(task.creater == curUserId) {
			//我创建的支持删除、修改
			if(task.taskType == '0') {
				//PC端创建的任务只支持删除，不支持修改
				delBtnHtml = '<div class="mui-slider-right mui-disabled"><a class="mui-btn mui-btn-red survey-task-delete">删除</a></div>';
			} else {
				delBtnHtml = '<div class="mui-slider-right mui-disabled"><a class="mui-btn mui-btn-red survey-task-delete">删除</a><a class="mui-btn mui-btn-yellow survey-task-modify">修改</a></div>';
			}
			
		}
		var taskHtml = ['<li class="mui-table-view-cell mui-media">', delBtnHtml,
			'<a class="mui-navigate-right mui-slider-handle" taskId="' + task.id + '"taskType="' + task.taskType + '" creater="' + task.creater + '" releaseState="' + task.isReleased + '">',
			'<img class="mui-media-object mui-pull-left" src="taskportal/images/' + pic + '">',
			'<div class="mui-media-body mui-ellipsis">',
			task.title,
			'<p class="mui-ellipsis">',
			'创建人：' + task.createrName,
			'</p>',
			'</div>',
			'</a>',
			'</li>',
		];
		return taskHtml.join("");
	},
	
	onFabMenuTapped: function() {
		mui.openWindow({
			url: '_www/tasks/businessmodel/designbillform.html',
			id: 'designbillform',
			waiting: {
				autoShow: true,
				title: '正在加载数据……'
			}
		});	
	},
});
